#include	"AjcInternal.h"

#define	INST_ID			0x902256B4
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//**************************************************************************************************************//
//																												//
//	tQ؁i`uk؁j																						//
//																												//
//**************************************************************************************************************//

#define		AVL_ENTER	if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AVL_LEAVE	if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	int SubInsNode (HAJCAVL pW, PAJCAVLNODE *pp);
static	int SubInsDataNode(HAJCAVL pW, PAJCAVLNODE *pp);
static	int	SubDelNode (HAJCAVL pW, PAJCAVLNODE *pa, PAJCAVLNODE *pp);
static	VO	SubDelAllNodes(HAJCAVL pW, PAJCAVLNODE *pp);
static	VO	SubEnumNodesUpSeq  (HAJCAVL pW, PAJCAVLNODE p);
static	VO	SubEnumNodesDownSeq(HAJCAVL pW, PAJCAVLNODE p);
static	VO	LeftRotate (PAJCAVLNODE *pp);
static	VO	RightRotate(PAJCAVLNODE *pp);
static	int	KeyComp(HAJCAVL pW, UX k1, UX k2);


//==============================================================================================================//
//	`ukCX^X̐																					//
//																												//
//	@	F	cbp 	- R[obNp^																	//
//				cbComp	- L[r֐iL[l̂܂ܔrꍇ́Amtkkj								//
//				cbNtcDelNodeData - 폜m[hf[^ʒmpR[obNisv́Amtkkj						//
//																												//
//	߂l	F	NULL - njiCX^Xnhj															//
//				NULL - G[																					//
//==============================================================================================================//
AJCEXPORT	HAJCAVL	WINAPI	AjcAvlCreate(UX		cbp,
										 int   (CALLBACK *cbComp)(UX key1, UX key2, UX cbp),
										 VO    (CALLBACK *cbNtcDelNodeData)(UX key, VOP pNodeData, UI len, UI nest, UX cbp))
{
	HAJCAVL	pW;

	if ((pW = (HAJCAVL)AJCMEM(sizeof(AJCAVL))) != NULL) {
		memset(pW, 0, sizeof *pW);
		pW->InstID	= INST_ID;
		pW->pRoot	= NULL;
		pW->cbp 	= cbp;
		pW->cbComp	= cbComp;
		pW->cbNtcDel= cbNtcDelNodeData;
	}
	return pW;
}

//==============================================================================================================//
//	`ukCX^X̍폜																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvlDelete(HAJCAVL pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->w_nest = 0;
		SubDelAllNodes(pW, &pW->pRoot);
		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvlEnableMultiThread(HAJCAVL pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	R[obNp^̐ݒ																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				cbp 	- R[obNp^																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcAvlSetCbp(HAJCAVL pW, UX cbp)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->cbp		= cbp;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	m[h}																									//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key 	  - L[																				//
//				pNodeData - }m[hf[^̃AhX														//
//				len 	  - }m[hf[^̃oCgiO`UTTRTj									//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - L[̃m[h^m[h蓖Ďs^p^G[							//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI AjcAvlInsNode 	(HAJCAVL pW, UX key, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (len <= 65535) {
			pW->w_key	= key;
			pW->w_pData = pNodeData;
			pW->w_len	= len;
			pW->w_rsu	= TRUE;
			pW->w_nest	= 0;

			SubInsNode(pW, &pW->pRoot);

			rc = pW->w_rsu;
		}
		AVL_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static int SubInsNode(HAJCAVL pW, PAJCAVLNODE *pp)
{
	int			deltaH = 0;
	PAJCAVLNODE	p = *pp;

	if (pW->w_rsu == TRUE) {

		if (p == NULL) {
			if ((*pp = p = (PAJCAVLNODE)AJCMEM(sizeof(AJCAVLNODE) + pW->w_len)) != NULL) {
				if (pW->w_pData && pW->w_len) {
					memcpy(p + 1, pW->w_pData, pW->w_len);
				}
				p->key = pW->w_key;
				p->bal = 0;
				p->len = (UW)(pW->w_len);
				p->l = p->r = NULL;
				deltaH = 1;
				pW->NodeCount++;
			}
			else {
				pW->w_rsu = FALSE;
			}
		}
		else {
			switch (KeyComp(pW, pW->w_key, p->key)) {
				case 1:
					if (SubInsNode(pW, &p->r)) {
						p->bal++;
						if (p->bal == 1) 
							deltaH = 1;
						else if (p->bal == 2) {
							if (p->r->bal == -1)
								RightRotate(&p->r);
							LeftRotate(pp);
						}
					}
					break;

				case -1:
					if (SubInsNode(pW, &p->l)) {
						p->bal--;
						if (p->bal == -1)
							deltaH = 1;
						else if (p->bal == -2) {
							if (p->l->bal == 1)
								LeftRotate(&p->l);
							RightRotate(pp);
						}
					}
					break;

				default:
					pW->w_rsu = FALSE;
					break;
			}
		}
	}
	return deltaH;
}
//==============================================================================================================//
//	f[^m[h}if[^̃AhXL[Ƃm[h}j													//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pNodeData - }m[hf[^̃AhX														//
//				len 	  - }m[hf[^̃oCgiO`UTTRTj									//
//																												//
//	߂l	F	NULL	- L[lim[hf[^̃AhXj														//
//				NULL	- m[h蓖Ďs^p^G[												//
//==============================================================================================================//
AJCEXPORT UX WINAPI AjcAvlInsDataNode 	(HAJCAVL pW, C_VOP pNodeData, UI len)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pNodeData != NULL && len <= 65535) {
			pW->w_len = len;
			if (pW->w_pNode = (PAJCAVLNODE)AJCMEM(sizeof(AJCAVLNODE) + pW->w_len)) {
				pW->w_key	= (UX)(pW->w_pNode + 1);
				memcpy((VOP)pW->w_key, pNodeData, len);
				pW->w_pData = pNodeData;
				pW->w_rsu	= TRUE;
				pW->w_nest	= 0;

				SubInsDataNode(pW, &pW->pRoot);

				if (pW->w_rsu) rc = pW->w_key;
				else		   free((VOP)pW->w_pNode);
			}
		}
		AVL_LEAVE
	}

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static int SubInsDataNode(HAJCAVL pW, PAJCAVLNODE *pp)
{
	int			deltaH = 0;
	PAJCAVLNODE	p = *pp;

	if (pW->w_rsu == TRUE) {

		if (p == NULL) {
			*pp = p = (PAJCAVLNODE)pW->w_pNode;
			p->key = pW->w_key;
			p->bal = 0;
			p->len = (UW)(pW->w_len);
			p->l   = p->r = NULL;
			deltaH = 1;
			pW->NodeCount++;
		}
		else {
			switch (KeyComp(pW, (UX)pW->w_key, p->key)) {
				case 1:
					if (SubInsDataNode(pW, &p->r)) {
						p->bal++;
						if (p->bal == 1) 
							deltaH = 1;
						else if (p->bal == 2) {
							if (p->r->bal == -1)
								RightRotate(&p->r);
							LeftRotate(pp);
						}
					}
					break;

				case -1:
					if (SubInsDataNode(pW, &p->l)) {
						p->bal--;
						if (p->bal == -1)
							deltaH = 1;
						else if (p->bal == -2) {
							if (p->l->bal == 1)
								LeftRotate(&p->l);
							RightRotate(pp);
						}
					}
					break;

				default:
					pW->w_rsu = FALSE;
					break;
			}
		}
	}
	return deltaH;
}

//==============================================================================================================//
//	m[h擾im[hj																					//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key 	  - m[h̃L[																//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - w肳ꂽL[Ȃ																//
//==============================================================================================================//
AJCEXPORT int WINAPI AjcAvlGetNodeByKey 	(HAJCAVL pW, UX key, VOP pBuf, UI lBuf)
{
	int			rc = -1;
	PAJCAVLNODE	p;
	int			comp_rsu;
	UI			nest = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pW->pRoot) {
			p = pW->pRoot;
			while ((comp_rsu = KeyComp(pW, key, p->key)) != 0) {
				if (comp_rsu < 0) p = p->l;
				else			  p = p->r;
				if (p == NULL) break;
				nest++;
			}
			if (p != NULL) {
				if (pBuf   != NULL) memcpy(pBuf, p + 1, __min(p->len, lBuf));
				rc = p->len;
			}
		}
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h|C^擾im[hj																			//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key 	  - m[h̃L[																//
//				pLen	  - m[hf[^̃oCgi[obt@̃AhXisv͂mtkkj	//
//																												//
//	߂l	F	NULL - njiYm[hEf[^ւ̃|C^j													//
//				NULL - w肳ꂽL[Ȃ^p^G[											//
//==============================================================================================================//
AJCEXPORT VOP WINAPI AjcAvlGetNodePtr	  (HAJCAVL pW, UX key, UIP pLen)
{
	VOP			rc = NULL;
	PAJCAVLNODE	p;
	int			comp_rsu;
	UI			nest = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pW->pRoot) {
			p = pW->pRoot;
			while ((comp_rsu = KeyComp(pW, key, p->key)) != 0) {
				if (comp_rsu < 0) p = p->l;
				else			  p = p->r;
				if (p == NULL) break;
				nest++;
			}
			if (p != NULL) {
				if (pLen   != NULL) *pLen = p->len;
				rc = (p + 1);
			}
		}
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h̃L[l擾																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pNode	  - m[hEf[^ւ̃|C^															//
//																												//
//	߂l	F	m[h̃L[l																					//
//==============================================================================================================//
AJCEXPORT UX WINAPI AjcAvlGetNodeKey	  (HAJCAVL pW, C_VOP pNode)
{
	UX		rc = -1;
	PAJCAVLNODE	pHd = (PAJCAVLNODE)pNode;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		pHd = (PAJCAVLNODE)pNode;		//	m[hf[^AhX
		pHd--;							//	m[hwb_AhX
		rc = pHd->key;
		AVL_LEAVE
	}
	return rc;
}


//==============================================================================================================//
//	擪m[h擾																								//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey	  - 擪m[h̃L[li[obt@̃AhXisv͂mtkkj					//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - m[hȂ																				//
//==============================================================================================================//
AJCEXPORT int WINAPI AjcAvlGetTopNode	  (HAJCAVL pW, UXP pKey, VOP pBuf, UI lBuf)
{
	int			rc = -1;
	PAJCAVLNODE	p;
	UI			nest = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pW->pRoot) {
			p = pW->pRoot;
			while (p->l != NULL) {
				p = p->l;
				nest++;
			}
			if (pKey   != NULL) *pKey	= p->key;
			if (pBuf   != NULL) memcpy(pBuf, p + 1, __min(p->len, lBuf));
			rc = p->len;
		}
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	ŏIm[h擾																								//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pKey	  - 擪m[h̃L[li[obt@̃AhXisv͂mtkkj					//
//				pBuf	  - m[hf[^i[obt@̃AhXisv͂mtkkj				//
//				lBuf	  - m[hf[^i[obt@̃oCg									//
//																												//
//	߂l	F	-1 - njiYm[hEf[^̃oCgj														//
//				-1 - m[hȂ																				//
//==============================================================================================================//
AJCEXPORT int WINAPI AjcAvlGetLastNode	   (HAJCAVL pW, UXP pKey, VOP pBuf, UI lBuf)
{
	int			rc = -1;
	PAJCAVLNODE	p;
	UI			nest = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pW->pRoot) {
			p = pW->pRoot;
			while (p->r != NULL) {
				p = p->r;
				nest++;
			}
			if (pKey   != NULL) *pKey	= p->key;
			if (pBuf   != NULL) memcpy(pBuf, p + 1, __min(p->len, lBuf));
			rc = p->len;
		}
		AVL_LEAVE
	}
	return rc;
}

//==============================================================================================================//
//	m[hu																									//
//																												//
//	@	F	pW		  	- CX^Xnh																//
//				key 	  	- L[																				//
//				pNodeData	- uVm[hf[^̃AhX													//
//				len 	 	- uVm[hf[^̃oCgiO`UTTRTj								//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - w肳ꂽL[Ȃ^m[h蓖Ďs^p^G[					//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI AjcAvlRepNode 	(HAJCAVL pW, UX key, C_VOP pNodeData, UI len)
{
	BOOL		rc = FALSE;
	PAJCAVLNODE	p, q;
	PAJCAVLNODE	*psv;
	int			comp_rsu;
	UI			nest = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pW->pRoot) {
			psv = &pW->pRoot; p = pW->pRoot;
			while ((comp_rsu = KeyComp(pW, key, p->key)) != 0) {
				if (comp_rsu < 0) {psv = &p->l; p = p->l;}
				else			  {psv = &p->r; p = p->r;}
				if (p == NULL) break;
				nest++;
			}
			if (p != NULL) {
				if (p->len == len) {
					if (pW->cbNtcDel) pW->cbNtcDel(p->key, p + 1, p->len, nest + 1, pW->cbp);
					memcpy(p + 1, pNodeData, len);
					rc = TRUE;
				}
				else {
					if (q = (PAJCAVLNODE)AJCMEM(sizeof(AJCAVLNODE) + len)) {
						if (pW->cbNtcDel) pW->cbNtcDel(p->key, p + 1, p->len, nest + 1, pW->cbp);
						memcpy(q	, p 	   , sizeof(AJCAVLNODE));
						memcpy(q + 1, pNodeData, len			   );
						*psv = q;
						free(p);	
						rc = TRUE;
					}
				}
			}
		}
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	m[h}^u																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key		  - um[h̃L[l																//
//				pNodeData - um[hf[^̃AhX														//
//				len		  - um[hf[^̃oCg														//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - m[h蓖Ďs^p^G[												//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI AjcAvlInsOrRepNode(HAJCAVL pW, UX key, C_VOP pNodeData, UI len)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pNodeData != NULL) {
			if (AjcAvlGetNodePtr(pW, key, NULL) == NULL) {
				rc = AjcAvlInsNode(pW, key, pNodeData, len);
			}
			else {
				rc = AjcAvlRepNode(pW, key, pNodeData, len);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	m[h폜																									//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				key 	  - 폜m[h̃L[																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - w肳ꂽL[̃m[hȂ^p^G[									//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI AjcAvlDelNode 	(HAJCAVL pW, UX key)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		pW->w_key  = key;
		pW->w_rsu  = FALSE;
		pW->w_nest = 0;
		SubDelNode(pW, &pW->pRoot, &pW->pRoot);
		rc = pW->w_rsu;
		AVL_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	int	SubDelNode(HAJCAVL pW, PAJCAVLNODE *pa, PAJCAVLNODE *pp)
{
	PAJCAVLNODE		p = *pp;
	int				deltaH = 0;

	pW->w_nest++;

	if (p != NULL) {
		switch (KeyComp(pW, pW->w_key, p->key)) {
			case -1:
				if (SubDelNode(pW, &p, &p->l)) {
					p->bal++;
					if (p->bal == 0)
						deltaH = 1;
					else if (p->bal == 2) {
						if (p->r->bal == -1) 
							RightRotate(&p->r);
						LeftRotate(pp);
						if ((*pp)->bal == 0)
							deltaH = 1;
					}
				}
				break;

			case 1:
				if (SubDelNode(pW, &p, &p->r)) {
					p->bal--;
					if (p->bal == 0)
						deltaH = 1;
					else if (p->bal == -2) {
						if (p->l->bal == 1)
							LeftRotate(&p->l);
						RightRotate(pp);
						if ((*pp)->bal == 0) 
							deltaH = 1;
					}
				}
				break;

			default:
				if (p->r == NULL) {
					if (pW->cbNtcDel) pW->cbNtcDel(p->key, p + 1, p->len, pW->w_nest, pW->cbp);
					*pp = p->l;
					pW->NodeCount--;
					free(p);
					pW->w_rsu = TRUE;
					return 1;
				}
				else if (p->l == NULL) {
					if (pW->cbNtcDel) pW->cbNtcDel(p->key, p + 1, p->len, pW->w_nest, pW->cbp);
					*pp = p->r;
					pW->NodeCount--;
					free(p);
					pW->w_rsu = TRUE;
					return 1;
				}
				else {
					pW->s = p;
					pW->q = p->l;
					while (pW->q->r != NULL) {
						pW->s = pW->q;
						pW->q = pW->q->r;
					}

					if (*pa != p) {
						if ((*pa)->l == p) (*pa)->l = pW->q;
						else			   (*pa)->r = pW->q;
					}
					else {
						*pa = pW->q;
					}
					if		(pW->s->l == pW->q) pW->s->l = p;
					else						pW->s->r = p;

					pW->w = p->l;	p->l   = pW->q->l;	 pW->q->l	= pW->w;
					pW->w = p->r;	p->r   = pW->q->r;	 pW->q->r	= pW->w;
					pW->b = p->bal; p->bal = pW->q->bal; pW->q->bal = pW->b;

					p = pW->q;
					if (SubDelNode(pW, &p, &p->l)) {
						p->bal++;
						if (p->bal == 0)
							deltaH= 1;
						else if (p->bal == 2) {
							if (p->r->bal == -1) 
								RightRotate(&p->r);
							LeftRotate(pp);
							if ((*pp)->bal == 0)
								deltaH = 1;
						}
					}
				}
				break;
		}
	}

	pW->w_nest--;

	return deltaH;
}
//==============================================================================================================//
//	Sm[h폜																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - p^G[																			//
//==============================================================================================================//
AJCEXPORT BOOL WINAPI AjcAvlDelAllNodes (HAJCAVL pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		pW->w_nest = 0;
		SubDelAllNodes(pW, &pW->pRoot);
		pW->NodeCount = 0;
		AVL_LEAVE
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubDelAllNodes(HAJCAVL pW, PAJCAVLNODE *pp)  // pa=Parent, pb=child //
{
	pW->w_nest++;
	if (*pp != NULL) {
		SubDelAllNodes(pW, &(*pp)->l);
		SubDelAllNodes(pW, &(*pp)->r);
		if (pW->cbNtcDel) pW->cbNtcDel((*pp)->key, (*pp) + 1, (*pp)->len, pW->w_nest, pW->cbp);
		free(*pp);
		*pp = NULL;
	}
	pW->w_nest--;
}
//==============================================================================================================//
//	m[h}																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pStr	  - }镶̃AhX															//
//																												//
//	߂l	F	O - njiL[lm[hf[^ij̃AhXj											//
//				O - L[̃m[h^m[h蓖Ďs^p^G[							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlInsStrNodeA	  (HAJCAVL pW, C_BCP pStr)
{
	UX		rc = 0;
	UX		len;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pStr != NULL && (len = strlen(pStr)) <= 65534) {
			pW->w_len = (UI)(len + 1);
			if (pW->w_pNode = (PAJCAVLNODE)AJCMEM(sizeof(AJCAVLNODE) + pW->w_len)) {
				pW->w_key	= (UX)(pW->w_pNode + 1);
				strcpy((BCP)pW->w_key, pStr);
				pW->w_pData = (BCP)pStr;
				pW->w_rsu	= TRUE;
				pW->w_nest	= 0;

				SubInsDataNode(pW, &pW->pRoot);

				if (pW->w_rsu) rc = pW->w_key;
				else		   free((VOP)pW->w_pNode);
			}
		}
		AVL_LEAVE
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlInsStrNodeW	  (HAJCAVL pW, C_WCP pStr)
{
	UX		rc = 0;
	UX		len;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pStr != NULL && (len = wcslen(pStr)) <= 32766) {
			pW->w_len = (UI)((len + 1) * 2);
			if (pW->w_pNode = (PAJCAVLNODE)AJCMEM(sizeof(AJCAVLNODE) + pW->w_len)) {
				pW->w_key	= (UX)(pW->w_pNode + 1);
				wcscpy((WCP)pW->w_key, pStr);
				pW->w_rsu	= TRUE;
				pW->w_nest	= 0;
				SubInsDataNode(pW, &pW->pRoot);
				if (pW->w_rsu) rc = pW->w_key;
				else		   free((VOP)pW->w_pNode);
			}
		}
		AVL_LEAVE
	}

	return rc;
}
//==============================================================================================================//
//	m[h擾																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pStr	  - L[f[^ij̃AhX														//
//																												//
//	߂l	F	O - njiL[lm[hf[^ij̃AhXj											//
//				O - L[̃m[hȂ^m[h蓖Ďs^p^G[							//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlGetStrNodeA(HAJCAVL pW, C_BCP pStr)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			rc = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlGetStrNodeW(HAJCAVL pW, C_WCP pStr)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			rc = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL);
		}
	}
	return rc;
}
//==============================================================================================================//
//	m[h}^擾																						//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pStr	  - 擾m[h̃L[f[^ij̃AhX										//
//																												//
//	߂l	F	O - njiL[lm[hf[^ij̃AhXj											//
//				O - m[h蓖Ďs^p^G[													//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlInsOrGetStrNodeA(HAJCAVL pW, C_BCP pStr)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			if ((rc = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL)) == 0) {
				rc = AjcAvlInsStrNodeA(pW, pStr);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlInsOrGetStrNodeW(HAJCAVL pW, C_WCP pStr)
{
	UX		rc = 0;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			if ((rc = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL)) == 0) {
				rc = AjcAvlInsStrNodeW(pW, pStr);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	m[h폜																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				pStr	  - }^擾镶̃AhX														//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - Ym[h^m[h蓖Ďs^p^G[								//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlDelStrNodeA(HAJCAVL pW, C_BCP pStr)
{
	UX		rc = 0;
	UX		key;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			if ((key = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL)) != 0) {
				rc = AjcAvlDelNode(pW, key);
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT UX WINAPI AjcAvlDelStrNodeW(HAJCAVL pW, C_WCP pStr)
{
	UX		rc = 0;
	UX		key;

	if (IS_MY_INST(pW)) {
		if (pStr != NULL) {
			if ((key = (UX)AjcAvlGetNodePtr(pW, (UX)pStr, NULL)) != 0) {
				rc = AjcAvlDelNode(pW, key);
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	m[h擾																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	m[hip^G[́AOԂj														//
//==============================================================================================================//
AJCEXPORT UI WINAPI AjcAvlGetCount(HAJCAVL pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->NodeCount;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT UI WINAPI AjcAvlNumber(HAJCAVL pW)
{
	return AjcAvlGetCount(pW);
}


//==============================================================================================================//
//	Sm[h擾																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				cbNtcNode	 - 擾m[hʒmR[obN֐isv͂mtkkj						//
//				fDownSeq	 - FALSE:CTRUE:~															//
//																												//
//	߂l	F	m[hiG[́AOԂj																//
//==============================================================================================================//
AJCEXPORT UI WINAPI AjcAvlEnumNodes (HAJCAVL pW, AJCAVL_CBNTC cbNtcNode, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (cbNtcNode) {
			pW->w_cb   = cbNtcNode;
			pW->w_nest = 0;
			pW->w_cont = TRUE;
			pW->w_cbp  = pW->cbp;
			if (!fDownSeq) {
				SubEnumNodesUpSeq  (pW, pW->pRoot);
			}
			else {
				SubEnumNodesDownSeq(pW, pW->pRoot);
			}
		}
		rc = pW->NodeCount;
		AVL_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubEnumNodesUpSeq(HAJCAVL pW, PAJCAVLNODE p)
{
	if (pW->w_cont) {
		pW->w_nest++;
		if (p != NULL) {
			SubEnumNodesUpSeq(pW, p->l);
			if (pW->w_cont) {
				pW->w_cont = pW->w_cb(p->key, p + 1, p->len, pW->w_nest, pW->w_cbp);
			}
			SubEnumNodesUpSeq(pW, p->r);
		}
		pW->w_nest--;
	}
}
//--------------------------------------------------------------------------------------------------------------//
static	VO	SubEnumNodesDownSeq(HAJCAVL pW, PAJCAVLNODE p)
{
	if (pW->w_cont) {
		pW->w_nest++;
		if (p != NULL) {
			SubEnumNodesDownSeq(pW, p->r);
			if (pW->w_cont) {
				pW->w_cont = pW->w_cb(p->key, p + 1, p->len, pW->w_nest, pW->w_cbp);
			}
			SubEnumNodesDownSeq(pW, p->l);
		}
		pW->w_nest--;
	}
}

//==============================================================================================================//
//	Sm[h擾iR[obNp^wj																	//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				cbp			 - R[obNp^																//
//				cbNtcNode	 - 擾m[hʒmR[obN֐isv͂mtkkj						//
//				fDownSeq	 - FALSE:CTRUE:~															//
//																												//
//	߂l	F	m[h																						//
//==============================================================================================================//
AJCEXPORT UI   WINAPI AjcAvlEnumNodesEx (HAJCAVL pW, UX cbp, AJCAVL_CBNTC cbNtcNode, BOOL fDownSeq)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (cbNtcNode) {
			pW->w_cb   = cbNtcNode;
			pW->w_nest = 0;
			pW->w_cont = TRUE;
			pW->w_cbp  = cbp;
			if (!fDownSeq) {
				SubEnumNodesUpSeq  (pW, pW->pRoot);
			}
			else {
				SubEnumNodesDownSeq(pW, pW->pRoot);
			}
		}
		rc = pW->NodeCount;
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z񐶐																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pNum		- zvfi[obt@̃AhXisvNULL)								//
//				fDownSeq	- FALSE:CTRUE:~																//
//																												//
//	߂l	F	NULL : Sm[hւ̃|C^z̐擪AhX													//
//				NULL : G[																					//
//==============================================================================================================//
typedef struct {
	UI			ix;
	PAJCAVLPTR	pArr;
} CBP_CREATE_PTR_ARR, *PCBP_CREATE_PTR_ARR;
//--------------------------------------------------------------------------------------------------------------//
static	BOOL CALLBACK cbAvlCreatePtrArr(UX key, VOP pNodeData, UI len, UI nest, UX cbp)
{
	PCBP_CREATE_PTR_ARR	pCbp = (PCBP_CREATE_PTR_ARR)cbp;
	pCbp->pArr[pCbp->ix].key	= key;
	pCbp->pArr[pCbp->ix].pNode	= (VOP)pNodeData;
	pCbp->pArr[pCbp->ix].len	= len;
	pCbp->ix++;
	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	PCAJCAVLPTR	WINAPI	AjcAvlCreatePtrArr (HAJCAVL pW, UIP pNum, BOOL fDownSeq)
{
	PCAJCAVLPTR			rc = NULL;
	CBP_CREATE_PTR_ARR	Cbp;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		Cbp.ix = 0;
		if (Cbp.pArr  =  (PAJCAVLPTR)AJCMEM(sizeof(AJCAVLPTR) * (pW->NodeCount + 1))) {
			memset((VOP)Cbp.pArr, 0,		sizeof(AJCAVLPTR) * (pW->NodeCount + 1));
			AjcAvlEnumNodesEx(pW, (UX)&Cbp, cbAvlCreatePtrArr, fDownSeq);
			if (pNum != NULL) *pNum = Cbp.ix;
			rc = Cbp.pArr;
		}
		AVL_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Sm[hւ̃|C^z																				//
//																												//
//	@	F	pW			- CX^Xnh																//
//				ppArr		- Sm[hւ̃|C^z̐擪AhX											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - s																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcAvlReleasePtrArr(HAJCAVL pW, PCAJCAVLPTR pArr)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AVL_ENTER
		if (pArr != NULL) free((VOP)pArr);
		AVL_LEAVE
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	`ukc[]																							//
//--------------------------------------------------------------------------------------------------------------//
static VO LeftRotate(PAJCAVLNODE *pp)
{
	PAJCAVLNODE	p = *pp;
	PAJCAVLNODE	r;

	*pp = r = p->r;
	p->r = r->l;
	r->l = p;
	p->bal--;
	if (r->bal > 0)
		p->bal -= r->bal;
	r->bal--;
	if (p->bal < 0)
		r->bal += p->bal;
}
//--------------------------------------------------------------------------------------------------------------//
//	`ukc[E]																							//
//--------------------------------------------------------------------------------------------------------------//
static VO RightRotate(PAJCAVLNODE *pp)
{
	PAJCAVLNODE	p = *pp;
	PAJCAVLNODE	l;

	*pp = l = p->l;
	p->l = l->r;
	l->r = p;
	p->bal++;
	if (l->bal < 0) 
		p->bal -= l->bal;
	l->bal++;
	if (p->bal > 0) 
		l->bal += p->bal;
}
//--------------------------------------------------------------------------------------------------------------//
//	L[r																									//
//--------------------------------------------------------------------------------------------------------------//
static int KeyComp(HAJCAVL pW, UX k1, UX k2)
{
	int		rc;

	if (pW->cbComp) {
		rc = pW->cbComp(k1, k2, pW->cbp);
		if		(rc < 0) rc = -1;
		else if (rc > 0) rc =  1;
		else			 rc =  0;
	}
	else {
		if		(k1 < k2) rc = -1;
		else if (k1 > k2) rc =	1;
		else			  rc =	0;
	}
	return rc;
}

