#include	"AjcInternal.h"

#define	INST_ID			0xB567DA28
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)

//**************************************************************************************************************//
//																												//
//	b^b{{̎啪																					//
//																												//
//**************************************************************************************************************//

//--------------------------------------------------------------------------------------------------------------//
//	\e[u																								//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	EAJCTKCODE	tkn;
	C_WCP		pStr;
	UI			len;
	BOOL		fCPP;
} AJCTKTABLE;

static	const AJCTKTABLE CtkRsvTbl[] = {
	{	EAJCTK_RSV_ASM		,	L"asm"				,  3, FALSE},
	{	EAJCTK_RSV_AUTO		,	L"auto"				,  4, FALSE},
	{	EAJCTK_RSV_BREAK	,	L"break"			,  5, FALSE},
	{	EAJCTK_RSV_CASE		,	L"case"				,  4, FALSE},
	{	EAJCTK_RSV_CATCH	,	L"catch"			,  5, TRUE },
	{	EAJCTK_RSV_CHAR		,	L"char"				,  4, FALSE},
	{	EAJCTK_RSV_CLASS	,	L"class"			,  5, TRUE },
	{	EAJCTK_RSV_CONST	,	L"const"			,  5, FALSE},
	{	EAJCTK_RSV_CONCAST	,	L"const_cast"		, 10, TRUE },
	{	EAJCTK_RSV_CONTINUE	,	L"continue"			,  8, FALSE},
	{	EAJCTK_RSV_DEFAULT	,	L"default"			,  7, FALSE},
	{	EAJCTK_RSV_DEFINE	,	L"define"			,  6, FALSE},
	{	EAJCTK_RSV_DEFINED	,	L"defined"			,  7, FALSE},
	{	EAJCTK_RSV_DELETE	,	L"delete"			,  6, TRUE },
	{	EAJCTK_RSV_DO		,	L"do"				,  2, FALSE},
	{	EAJCTK_RSV_DOUBLE	,	L"double"			,  6, FALSE},
	{	EAJCTK_RSV_DYNCAST	,	L"dynamic_cast"		, 12, TRUE },
	{	EAJCTK_RSV_ELIF		,	L"elif"				,  4, FALSE},
	{	EAJCTK_RSV_ELSE		,	L"else"				,  4, FALSE},
	{	EAJCTK_RSV_ENDIF	,	L"endif"			,  5, FALSE},
	{	EAJCTK_RSV_ENUM		,	L"enum"				,  4, FALSE},
	{	EAJCTK_RSV_EXTERN	,	L"extern"			,  6, FALSE},
	{	EAJCTK_RSV_FLOAT	,	L"float"			,  5, FALSE},
	{	EAJCTK_RSV_FOR		,	L"for"				,  3, FALSE},
	{	EAJCTK_RSV_FRIEND	,	L"friend"			,  6, TRUE },
	{	EAJCTK_RSV_GOTO		,	L"goto"				,  4, FALSE},
	{	EAJCTK_RSV_IF		,	L"if"				,  2, FALSE},
	{	EAJCTK_RSV_IFDEF	,	L"ifdef"			,  5, FALSE},
	{	EAJCTK_RSV_IFNDEF	,	L"ifndef"			,  6, FALSE},
	{	EAJCTK_RSV_INCLUDE	,	L"include"			,  7, FALSE},
	{	EAJCTK_RSV_INLINE	,	L"inline"			,  6, FALSE},
	{	EAJCTK_RSV_INT		,	L"int"				,  3, FALSE},
	{	EAJCTK_RSV_LONG		,	L"long"				,  4, FALSE},
	{	EAJCTK_RSV_NEW		,	L"new"				,  3, TRUE },
	{	EAJCTK_RSV_OPERATOR	,	L"operator"			,  8, TRUE },
	{	EAJCTK_RSV_PRAGMA	,	L"pragma"			,  6, FALSE},
	{	EAJCTK_RSV_PRIVATE	,	L"private"			,  7, TRUE },
	{	EAJCTK_RSV_PROTECTED,	L"protected"		,  9, TRUE },
	{	EAJCTK_RSV_PUBLIC	,	L"public"			,  6, TRUE },
	{	EAJCTK_RSV_REGISTER	,	L"register"			,  8, FALSE},
	{	EAJCTK_RSV_REICAST	,	L"reinterpret_cast"	, 16, TRUE },
	{	EAJCTK_RSV_RETURN	,	L"return"			,  6, FALSE},
	{	EAJCTK_RSV_SHORT	,	L"short"			,  5, FALSE},
	{	EAJCTK_RSV_SIGNED	,	L"signed"			,  6, FALSE},
	{	EAJCTK_RSV_SIZEOF	,	L"sizeof"			,  6, FALSE},
	{	EAJCTK_RSV_STATIC	,	L"static"			,  6, FALSE},
	{	EAJCTK_RSV_STACAST	,	L"static_cast"		, 11, TRUE },
	{	EAJCTK_RSV_STRUCT	,	L"struct"			,  6, FALSE},
	{	EAJCTK_RSV_SWITCH	,	L"switch"			,  6, FALSE},
	{	EAJCTK_RSV_TEMPLATE	,	L"template"			,  8, TRUE },
	{	EAJCTK_RSV_THIS		,	L"this"				,  4, TRUE },
	{	EAJCTK_RSV_THROW	,	L"throw"			,  5, TRUE },
	{	EAJCTK_RSV_TRY		,	L"try"				,  3, TRUE },
	{	EAJCTK_RSV_TYPEDEF	,	L"typedef"			,  7, FALSE},
	{	EAJCTK_RSV_UNDEF	,	L"undef"			,  5, FALSE},
	{	EAJCTK_RSV_UNION	,	L"union"			,  5, FALSE},
	{	EAJCTK_RSV_UNSIGNED	,	L"unsigned"			,  8, FALSE},
	{	EAJCTK_RSV_VIRTUAL	,	L"virtual"			,  7, TRUE },
	{	EAJCTK_RSV_VOID		,	L"void"				,  4, FALSE},
	{	EAJCTK_RSV_VOLATILE	,	L"volatile"			,  8, FALSE},
	{	EAJCTK_RSV_WCHAR_T	,	L"wchar_t"			,  7, FALSE},
	{	EAJCTK_RSV_WHILE	,	L"while"			,  5, FALSE}
};

#define	MAX_RSVTBL	((sizeof CtkRsvTbl) / (sizeof CtkRsvTbl[0]))
#define	AJCTKRSV_MAXLEN	16

//--------------------------------------------------------------------------------------------------------------//
//	f~^e[u																							//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	EAJCTKCODE	tkn;
	C_WCP		pStr;
	UI			lStr;
	BOOL		fCPP;
} AJCTKDLMTABLE;

static	const AJCTKDLMTABLE CtkDlmTbl[] = {
	{	EAJCTK_DLM_LSPART		,	L"("	, 1 , FALSE},
	{	EAJCTK_DLM_LMPART		,	L"{"	, 1 , FALSE},
	{	EAJCTK_DLM_LLPART		,	L"["	, 1 , FALSE},
	{	EAJCTK_DLM_RSPART		,	L")"	, 1 , FALSE},
	{	EAJCTK_DLM_RMPART		,	L"}"	, 1 , FALSE},
	{	EAJCTK_DLM_RLPART		,	L"]"	, 1 , FALSE},

	{	EAJCTK_DLM_SCOPE		,	L"::"	, 2 , TRUE },
	{	EAJCTK_DLM_IDDOT		,	L".*"	, 2 , TRUE },
	{	EAJCTK_DLM_IDARROW		,	L"->*"	, 3 , TRUE },

	{	EAJCTK_DLM_LAND			,	L"&&"	, 2 , FALSE},
	{	EAJCTK_DLM_LOR			,	L"||"	, 2 , FALSE},

	{	EAJCTK_DLM_ARROW		,	L"->"	, 2 , FALSE},
	{	EAJCTK_DLM_QUEST		,	L"?"	, 1 , FALSE},
	{	EAJCTK_DLM_COLON		,	L":"	, 1 , FALSE},
	{	EAJCTK_DLM_SEMICOL		,	L";"	, 1 , FALSE},
	{	EAJCTK_DLM_COMMA		,	L","	, 1 , FALSE},
	{	EAJCTK_DLM_VARG			,	L"..."	, 3 , FALSE},
	{	EAJCTK_DLM_DOT			,	L"."	, 1 , FALSE},

	{	EAJCTK_DLM_SHREQ		,	L">>="	, 3 , FALSE},
	{	EAJCTK_DLM_SHLEQ		,	L"<<="	, 3 , FALSE},
	{	EAJCTK_DLM_SHR			,	L">>"	, 2 , FALSE},
	{	EAJCTK_DLM_SHL			,	L"<<"	, 2 , FALSE},

	{	EAJCTK_DLM_EQEQ			,	L"=="	, 2 , FALSE},
	{	EAJCTK_DLM_NOTEQ		,	L"!="	, 2 , FALSE},
	{	EAJCTK_DLM_LOEQ			,	L"<="	, 2 , FALSE},
	{	EAJCTK_DLM_HIEQ			,	L">="	, 2 , FALSE},
	{	EAJCTK_DLM_LO			,	L"<"	, 1 , FALSE},
	{	EAJCTK_DLM_HI			,	L">"	, 1 , FALSE},

	{	EAJCTK_DLM_PLUSEQ		,	L"+="	, 2 , FALSE},
	{	EAJCTK_DLM_MINUSEQ		,	L"-="	, 2 , FALSE},
	{	EAJCTK_DLM_MULTEQ		,	L"*="	, 2 , FALSE},
	{	EAJCTK_DLM_DIVEQ		,	L"/="	, 2 , FALSE},
	{	EAJCTK_DLM_MODEQ		,	L"%="	, 2 , FALSE},
	{	EAJCTK_DLM_ANDEQ		,	L"&="	, 2 , FALSE},
	{	EAJCTK_DLM_OREQ			,	L"|="	, 2 , FALSE},
	{	EAJCTK_DLM_XOREQ		,	L"^="	, 2 , FALSE},

	{	EAJCTK_DLM_SHARP2		,	L"##"	, 2 , FALSE},
	{	EAJCTK_DLM_PLUS2		,	L"++"	, 2 , FALSE},
	{	EAJCTK_DLM_MINUS2		,	L"--"	, 2 , FALSE},

	{	EAJCTK_DLM_SHARP		,	L"#"	, 1 , FALSE},
	{	EAJCTK_DLM_PLUS			,	L"+"	, 1 , FALSE},
	{	EAJCTK_DLM_MINUS		,	L"-"	, 1 , FALSE},
	{	EAJCTK_DLM_MULT			,	L"*"	, 1 , FALSE},
	{	EAJCTK_DLM_DIV			,	L"/"	, 1 , FALSE},
	{	EAJCTK_DLM_MOD			,	L"%"	, 1 , FALSE},
	{	EAJCTK_DLM_AND			,	L"&"	, 1 , FALSE},
	{	EAJCTK_DLM_OR			,	L"|"	, 1 , FALSE},
	{	EAJCTK_DLM_XOR			,	L"^"	, 1 , FALSE},
	{	EAJCTK_DLM_EQ			,	L"="	, 1 , FALSE},
	{	EAJCTK_DLM_NOT			,	L"~"	, 1 , FALSE},
	{	EAJCTK_DLM_LNOT			,	L"!"	, 1 , FALSE}
};
#define	MAX_DLMTBL	((sizeof CtkDlmTbl) / (sizeof CtkDlmTbl[0]))

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubGetToken(HAJCTK pW, WCP pStrBuf, UI lStrBuf);
static	UI		gtkSymbol(HAJCTK pW);
static	UI		gtkHexa(HAJCTK pW);
static	UI		gtkDecimal(HAJCTK pW);
static	UI		gtkOctal(HAJCTK pW);
static	UI		gtkString(HAJCTK pW);
static	UI		gtkDelimiter(HAJCTK pW);
static	UI		gtkComment(HAJCTK pW);
static	UI		gtkIncPath(HAJCTK pW);
static	UI		SubChkCommentEnd(HAJCTK pW, WCP pe);
static	UI		SubChkLineEnd(WCP pe);
static	UI		gtkSpace(HAJCTK pW);
static	UI		gtkEndOfLine(HAJCTK pW);
static	UI		gtkLineCont(HAJCTK pW);
static	UI		gtkSuffix(HAJCTK pW, WCP pe);
static	BOOL	SetTknStr(HAJCTK pW, WCP pTkn, UI lTkn, WCP pStrBuf, UI lStrBuf);
static	VO		SetPreproTokenHist(HAJCTK pW);
static	BOOL	ReadLineIfEol(HAJCTK pW);

//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	flag	  - @\tO(AJCTKFLG_XXXXX)															//
//				cbGetLine - Ps[hpR[obN֐̃AhX												//
//				xp		  - R[obNp^																//
//																												//
//	߂l	F	NULL : CX^Xnh																	//
//				NULL : G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCTK	WINAPI	AjcCtkCreateA  (UI flag, PCBAJCTKA cbGetLine, UX xp)
{
	HAJCTK	pW = NULL;

//	if (cbGetLine != NULL) {	// R[obNŐݒ肷ꍇ̂ŁANULL̓`FbNȂ
		if (pW = (HAJCTK)AJCMEM(sizeof(AJCTK))) {
			memset(pW, 0, sizeof(AJCTK));
			pW->lLineBuf = 1024;
			if ((flag & AJCTKFLG_LBF_MASK) != 0) {
				pW->lLineBuf *= ((((flag & AJCTKFLG_LBF_MASK) >> 24) & 0xFF));
			}
			if (pW->pLineBuf = (WCP)AJCMEM(pW->lLineBuf * 2)) {
				memset(pW->pLineBuf, 0, pW->lLineBuf * 2);
				pW->InstID	 = INST_ID;
				pW->flag	 = flag;
				pW->pLine	 = pW->pLineBuf;
				pW->xp		 = xp;
				pW->u.cbCtkA = cbGetLine;
			}
			else {
				free(pW);
				pW = NULL;
			}
		}
//	}

	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCTK	WINAPI	AjcCtkCreateW  (UI flag, PCBAJCTKW cbGetLine, UX xp)
{
	HAJCTK	pW = NULL;

//	if (cbGetLine != NULL) {	// R[obNŐݒ肷ꍇ̂ŁANULL̓`FbNȂ
		if (pW = (HAJCTK)AJCMEM(sizeof(AJCTK))) {
			memset(pW, 0, sizeof(AJCTK));
			pW->lLineBuf = 1024;
			if ((flag & AJCTKFLG_LBF_MASK) != 0) {
				pW->lLineBuf *= ((((flag & AJCTKFLG_LBF_MASK) >> 24) & 0xFF));
			}
			if (pW->pLineBuf = (WCP)AJCMEM(pW->lLineBuf * 2)) {
				memset(pW->pLineBuf, 0, pW->lLineBuf * 2);
				pW->InstID	 = INST_ID;
				pW->flag	 = flag;
				pW->pLine	 = pW->pLineBuf;
				pW->xp		 = xp;
				pW->u.cbCtkW = cbGetLine;
				pW->fUnicode = TRUE;
			}
			else {
				free(pW);
				pW = NULL;
			}
		}
//	}

	return pW;
}
//==============================================================================================================//
//	ZbgiCX^X̏Ԃɖ߂j																	//
//																												//
//	@	F	pW		  - CX^Xnh																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcCtkReset	 (HAJCTK pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->tkn			 = (EAJCTKCODE)0;
		pW->suffix		 = (EAJCTKSUF)0;
		pW->ctkf		 = 0;
		pW->err			 = 0;
		pW->lno			 = 0;
		pW->loc			 = 0;
		pW->len			 = 0;
		pW->pLineBuf[0]  = 0;
		pW->pLine		 = pW->pLineBuf;
		pW->PpHistIx	 = 0;
		memset(pW->PpHist, 0, sizeof pW->PpHist);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R[obNݒ																							//
//																												//
//	@	F	pW		  - CX^Xnh																//
//				cbGetLine - Ps[hpR[obN֐̃AhX												//
//				xp		  - R[obNp^																//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackA	 (HAJCTK pW, PCBAJCTKA cbGetLine, UX xp)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && cbGetLine != NULL) {
		pW->xp		 = xp;
		pW->u.cbCtkA = cbGetLine;
		rc = TRUE;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackW	 (HAJCTK pW, PCBAJCTKW cbGetLine, UX xp)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW) && cbGetLine != NULL) {
		pW->xp		 = xp;
		pW->u.cbCtkW = cbGetLine;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	R[obNp^ݒ																					//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				xp		- R[obNp^																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcCtkSetCallBackParam	 (HAJCTK pW, UX xp)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->xp	= xp;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcCtkDelete   (HAJCTK pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		if (pW->pLineBuf != NULL) free(pW->pLineBuf);
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	@\tOݒ																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				flag	- @\tO(AJCTKFLG_XXXXX)															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcCtkSetFlag	(HAJCTK pW, UI flag)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		pW->flag = flag;
	}
	return rc;
}
//==============================================================================================================//
//	@\tO擾																								//
//																												//
//	@	F	pW		- CX^Xnh																	//
//				flag	- @\tO(AJCTKFLG_XXXXX)															//
//																												//
//	߂l	F	TRUE  - 																					//
//				FALSE - G[																					//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcCtkGetFlag	(HAJCTK pW)
{
	UI	rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->flag;
	}
	return rc;
}
//==============================================================================================================//
//	g[N擾ifdsoj																			//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pStrBuf  - g[Ni[obt@̃AhX											//
//				lStrBuf  - g[Ni[obt@̃oCg^									//
//																												//
//	߂l	F	TRUE  - Lȃg[N																		//
//				FALSE - dne^[N蓖Ďs														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkGetTokenA(HAJCTK pW, BCP pStrBuf, UI lStrBuf)
{
	BOOL	rc = FALSE;
	WCP		pTmp;

	if (pStrBuf != NULL) {
		if (pTmp = (WCP)AJCMEM(lStrBuf * 2)) {
			*pTmp = 0;
			if (rc = AjcCtkGetTokenW(pW, pTmp, lStrBuf)) {
				WideCharToMultiByte(CP_ACP, 0, pTmp, -1, pStrBuf, lStrBuf, NULL, NULL);
				pStrBuf[lStrBuf - 1] = 0;
			}
			free(pTmp);
		}
		else if (IS_MY_INST(pW)) {
			pW->err |= AJCTKERR_MEMALLOC;
		}
	}
	else {
		rc = AjcCtkGetTokenW(pW, NULL, 0);
	}

	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkGetTokenW(HAJCTK pW, WCP pStrBuf, UI lStrBuf)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		pW->err = AJCTKERR_OK;
		//	g[N擾
		if (!(pW->ctkf & AJCTKF_ISLASTPEEK)) {						//	ÓuCtkGetTokenvH
			rc = SubGetToken(pW, pStrBuf, lStrBuf);					//		̃g[N擾
		}
		else {														//	ÓuCtkPeekTokenvH
			if (!(pW->ctkf & AJCTKF_EOF)) {							//		dneȊOH
				SetTknStr(pW, &pW->pLineBuf[pW->loc],				//			g[Ni[
							 pW->len, pStrBuf, lStrBuf);
			}
			else {													//		dneH
				if (pStrBuf != NULL && lStrBuf >= 1) *pStrBuf = 0;	//			g[N = ""
				rc = FALSE;
			}
		}
		pW->ctkf &= ~AJCTKF_ISLASTPEEK;								//	ÓuCtkGetTokenv̎|Aݒ	
	}
	else {
		rc = FALSE;
	}

	return rc;
}
//==============================================================================================================//
//	g[N擾ioddjoȂj																		//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pStrBuf  - g[Ni[obt@̃AhX											//
//				lStrBuf  - g[Ni[obt@̃oCg^									//
//																												//
//	߂l	F	TRUE  - Lȃg[N																		//
//				FALSE - dne^[N蓖Ďs														//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkPeekTokenA(HAJCTK pW, BCP pStrBuf, UI lStrBuf)
{
	BOOL	rc	 = FALSE;
	WCP		pTmp = NULL;

	if (pStrBuf != NULL && lStrBuf != 0) {
		if (pTmp = (WCP)AJCMEM(lStrBuf * 2)) {
			*pTmp = 0;
			if (rc = AjcCtkPeekTokenW(pW, pTmp, lStrBuf)) {
				WideCharToMultiByte(CP_ACP, 0, pTmp, -1, pStrBuf, lStrBuf, NULL, NULL);
				pStrBuf[lStrBuf - 1] = 0;
			}
			free(pTmp);
		}
		else if (IS_MY_INST(pW)) {
			pW->err |= AJCTKERR_MEMALLOC;
		}
	}
	else {
		rc = AjcCtkPeekTokenW(pW, NULL, 0);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcCtkPeekTokenW(HAJCTK pW, WCP pStrBuf, UI lStrBuf)
{
	BOOL	rc = TRUE;

	if (IS_MY_INST(pW)) {
		if (!(pW->ctkf & AJCTKF_ISLASTPEEK)) {						//	ÓuCtkGetTokenvH	
			rc = SubGetToken(pW, pStrBuf, lStrBuf);					//		̃g[N擾
		}
		else {														//	ÓuCtkPeekTokenvH
			if (!(pW->ctkf & AJCTKF_EOF)) {							//		dneȊOH
				SetTknStr(pW, &pW->pLineBuf[pW->loc],				//			g[Ni[
							 pW->len, pStrBuf, lStrBuf);
			}
			else {													//		dneH
				if (pStrBuf != NULL && lStrBuf >= 1) *pStrBuf = 0;	//			g[N = ""
				rc = FALSE;
			}
		}
		pW->ctkf |= AJCTKF_ISLASTPEEK;								//	ÓuCtkPeekTokenv̎|Aݒ
	}
	else rc = FALSE;

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	g[N擾																								//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pStrBuf  - g[Ni[obt@̃AhX											//
//				lStrBuf  - g[Ni[obt@̃oCg^									//
//																												//
//	߂l	F	TRUE  - Lȃg[N																		//
//				FALSE - dne																					//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SubGetToken(HAJCTK pW, WCP pStrBuf, UI lStrBuf)
{
	BOOL	rc = TRUE;
	UI		len;

	//----- 喈̏񏉊 -----//
	pW->ctkf &= ~(AJCTKF_PPTOP | AJCTKF_MACNAME | AJCTKF_MACWITHARG | AJCTKF_MACARG | AJCTKF_MACBODY | AJCTKF_WIDECHAR);
	pW->suffix = EAJCTKSUF_NONE;
	pW->err = AJCTKERR_OK;

	do {
		if (!ReadLineIfEol(pW)) {rc = FALSE; break;}

		if ((pW->flag & AJCTKFLG_INCSPACE ) != 0) {
			do {
				if ((len = gtkIncPath  (pW)) != 0) break;
				if ((len = gtkComment  (pW)) != 0) break;
				if ((len = gtkSpace    (pW)) != 0) break;
				if ((len = gtkEndOfLine(pW)) != 0) break;
				if ((len = gtkLineCont (pW)) != 0) break;
				if ((len = gtkString   (pW)) != 0) break;		//	ChiL"" / L''jʂ̂߁AV{ɉ
				if ((len = gtkSymbol   (pW)) != 0) break;
				if ((len = gtkHexa	   (pW)) != 0) break;
				if ((len = gtkDecimal  (pW)) != 0) break;
				if ((len = gtkOctal    (pW)) != 0) break;
				len = gtkDelimiter(pW);
			} while (0);
			pW->loc = ((UI)((UX)pW->pLine - (UX)pW->pLineBuf)) / 2;
			SetTknStr(pW, pW->pLine, len, pStrBuf, lStrBuf);
			pW->pLine += len;
			pW->len = len;
		}
		else {
			if ((len = gtkIncPath(pW)) == 0) {
				do {
					do {
						if ((len = gtkComment  (pW)) != 0) break;
						if ((len = gtkSpace    (pW)) != 0) break;
						if ((len = gtkEndOfLine(pW)) != 0) break;
						if ((len = gtkLineCont (pW)) != 0) break;
					} while (0);
					pW->pLine += len;
					if (!ReadLineIfEol(pW)) {rc = FALSE; goto sgt_exit;}
				} while (len != 0);
				do {
					if ((len = gtkString   (pW)) != 0) break;		//	ChiL"" / L''jʂ̂߁AV{ɉ
					if ((len = gtkSymbol   (pW)) != 0) break;
					if ((len = gtkHexa	   (pW)) != 0) break;
					if ((len = gtkDecimal  (pW)) != 0) break;
					if ((len = gtkOctal    (pW)) != 0) break;
					len = gtkDelimiter(pW);
				} while (0);
			}
			pW->loc = ((UI)((UX)pW->pLine - (UX)pW->pLineBuf)) / 2;
			SetTknStr(pW, pW->pLine, len, pStrBuf, lStrBuf);
			pW->pLine += len;
			pW->len = len;
		}
		//----- g[N̎ɋ󔒂tOݒ ---//
		if (*pW->pLine == L' ' || *pW->pLine == L'\t' ) pW->ctkf |=  AJCTKF_NXTSPC;
		else											pW->ctkf &= ~AJCTKF_NXTSPC;
		//----- }N^{fBtO -----------------//
		if ((pW->ctkf & AJCTKF_PREPRO) != 0) {					//	vvZXH
			if (pW->ctkf & AJCTKF_SRHMACARGEND) {				//		}N I[H
				pW->ctkf |= AJCTKF_MACARG;						//			}NOZbg
			}
			else if (pW->ctkf & AJCTKF_FINDMACARGEND) {			//		}N IoԁH
				pW->ctkf &= ~AJCTKF_FINDMACARGEND;				//			}NIoԉ
				pW->ctkf |=  AJCTKF_SRHMACBODY;					//			}N{fB
			}
			//	}N{fBtOZbg
			else if (pW->ctkf & AJCTKF_SRHMACBODY) {			//		}N{fBH
				pW->ctkf |= AJCTKF_MACBODY;						//			}N{fBtOZbg
			}
		}

	} while(0);
sgt_exit:;
	return rc;
}
//**************************************************************************************************************//
//	g[N͊֐Q																							//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	0 - g[N̒ioCgj																//
//				0 - YȂg[N																		//
//**************************************************************************************************************//
//--------------------------------------------------------------------------------------------------------------//
//	V{ip^A_o[j																				//
//--------------------------------------------------------------------------------------------------------------//
#define	GTK_SYMCHAR(P, F)	if		((pW->flag & AJCTKFLG_INCSYM_MBSTR) && AjcIsBigCharW(P)) {					\
								fSymChar = TRUE;  fRsv = FALSE;													\
								if (MAjcIsLeadW(*P) && MAjcIsTrailW(*(P + 1))) cl = 2;							\
								else										   cl = 1;							\
							}																					\
							else if ((pW->flag & AJCTKFLG_INCSYM_DOLLAR) && *P == L'$') {						\
								fSymChar = TRUE;  cl = 1;  fRsv = FALSE;										\
							}																					\
							else if ((pW->flag & AJCTKFLG_INCSYM_ATMARK) && *P == L'@') {						\
								fSymChar = TRUE;  cl = 1;  fRsv = FALSE;										\
							}																					\
							else if (*P == L'_' || F(*P)) {														\
								fSymChar = TRUE;  cl = 1;														\
							}																					\
							else fSymChar = FALSE

//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkSymbol(HAJCTK pW)
{
	UI		len = 0;					//	V{̒
	BOOL	fSymChar;					//	V{\tO
	UI		cl;							//	V{\̒i1 or 2)
	BOOL	fRsv = TRUE;				//	\ꌟtO
	UI		i, r, l;					//	\ꌟ[N
	SI		cmp;						//	E
	WCP		pe;							//	V{̒̕AhX
	WC		tkn[AJCTKRSV_MAXLEN + 1];	//	\obt@

	GTK_SYMCHAR(pW->pLine, MAjcAscIsAlphaW);
	if (fSymChar) {
		//----- g[No -----------//
		pW->tkn = EAJCTK_USR_NAME;
		pe	= pW->pLine + cl;
		len =			  cl;

		GTK_SYMCHAR(pe, MAjcAscIsAlNumW);
		while (fSymChar) {
			pe	+= cl;
			len += cl;
			GTK_SYMCHAR(pe, MAjcAscIsAlNumW);
		}
		//----- |[g(P3.12)f --//
		if (pW->flag & AJCTKFLG_DOTSYMBOL) {
			UI		dl = len;
			WCP		pd = pe;
			if (*pd == L'.') {
				pd++; dl++;
				if (MAjcAscIsDigitW(*pd)) {
					do {
						pd++; dl++;
					} while(MAjcAscIsDigitW(*pd));
					pe	= pd;
					len = dl;
				}
			}
		}
		//----- g[NR[hݒ -----//
		if (len <= AJCTKRSV_MAXLEN && fRsv) {
			wcsncpy(tkn, pW->pLine, len);
			tkn[len] = 0;
			l=0; r=MAX_RSVTBL-1;
			while (l < r) {
				i = (l + r) / 2;
				cmp = wcscmp(CtkRsvTbl[i].pStr, tkn);
				if		(cmp == 0) {
					if ((pW->flag & AJCTKFLG_CPLUSPLUS) != 0 || !CtkRsvTbl[i].fCPP) {
						pW->tkn = CtkRsvTbl[i].tkn;
					}
					goto stk_exit;
				}
				else if (cmp < 0) l = i + 1;
				else			  r = i;
			}
			if (wcscmp(CtkRsvTbl[l].pStr, tkn) == 0) {
				if ((pW->flag & AJCTKFLG_CPLUSPLUS) != 0 || !CtkRsvTbl[l].fCPP) {
					pW->tkn = CtkRsvTbl[l].tkn;
				}
			}
stk_exit:;
		}
		//----- }N`FbN ---------//
		if ((pW->ctkf & AJCTKF_PREPRO) != 0) {					//	vvZXH
			//	}N`FbN
			if (pW->PpHistIx == 2						&&		//		g[NQ		
				pW->PpHist[0] == EAJCTK_DLM_SHARP		&&		//		擪"#"			
				pW->PpHist[1] == EAJCTK_RSV_DEFINE) {			//		Qԁ"define" H
				pW->ctkf |= AJCTKF_MACNAME;						//			u}Nv
				if (*pe == L'(') {								//			}N̒ "(" it}NjH
					pW->ctkf |= AJCTKF_MACWITHARG;				//				ut}Nv
					pW->ctkf |= AJCTKF_SRHMACARGTOP;			//				}N擪 '(' 
				}
				else {											//			}N̒ '(' ȊOHi}NjH
					pW->ctkf |= AJCTKF_FINDMACARGEND;			//				ɈI[mZbgA}N{fBƂ
				}
			}
		}
		//----- ۾ İݗݒ --//
		SetPreproTokenHist(pW);
		//----- stONA[ -----//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	PUii'O' / 'EEEH'j																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkHexa(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe;

	//	擪uOv
	if (wcsnicmp(pW->pLine, L"0x", 2) == 0) {
		pW->tkn = EAJCTK_VAL_HEXA;
		pe	= pW->pLine + 2;
		len = 2;
		if (MAjcAscIsXDigitW(*pe)) {
			while (MAjcAscIsXDigitW(*pe)) {
				pe++; len++;
			}
			len += gtkSuffix(pW, pe);
		}
		else {
			pW->err |= AJCTKERR_INVALID_HEXADECIMAL;
		}
		//----- ۾ İݗݒ --//
		SetPreproTokenHist(pW);
		//----- stONA[ -----//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	//	uHv
	else if (pW->flag & AJCTKFLG_ASMHEX) {
		pe	= pW->pLine;
		len = 0;
		while (MAjcIsXDigitW(*pe)) {
			pe++; len++;
		}
		//	uHvȂ΁Ag[Nݒ
		if (*pe == L'H' || *pe == L'h') {
			pe++; len++;
			pW->tkn = EAJCTK_VAL_HEXA_H;
			//----- }N{fBtO -----//
			if ((pW->ctkf & AJCTKF_PREPRO) != 0) {					//	vvZXH
				//	}N{fBtOZbg
				if (pW->ctkf & AJCTKF_SRHMACBODY) {					//		}N{fBH
					pW->ctkf |= AJCTKF_MACBODY;						//			}N{fBtOڂ
				}
			}
			//----- ۾ İݗݒ --//
			SetPreproTokenHist(pW);
			//----- stONA[ -----//
			pW->ctkf &= ~AJCTKF_TOL;
		}
		//	uHvȊOȂ΁Ag[Ns
		else len = 0;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	POi^i or {hbgj																	//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkDecimal(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe;

	if (MAjcAscIsDigitW(*pW->pLine) || (*pW->pLine == '.' && MAjcAscIsDigitW(*(pW->pLine + 1)))) {
		pW->tkn = EAJCTK_VAL_DECIMAL;
		pe	= pW->pLine;
		len = 0;
		while (MAjcAscIsDigitW(*pe)) {
			pe++; len++;
		}
		if (*pe == L'.') {
			pW->tkn = EAJCTK_VAL_REAL;
			pe++; len++;
			while (MAjcAscIsDigitW(*pe)) {
				pe++; len++;
			}
		}
		if (*pe == L'E' || *pe == L'e') {
			pW->tkn = EAJCTK_VAL_REAL;
			pe++; len++;
			if (*pe == L'+' || *pe == L'-') {
				pe++; len++;
			}
			if (MAjcAscIsDigitW(*pe)) {
				while (MAjcAscIsDigitW(*pe)) {
					pe++; len++;
				}
			}
			else {
				pW->err |= AJCTKERR_INVALID_REALNUMBER;
			}
		}
		if (pW->err == 0) {
			len += gtkSuffix(pW, pe);
		}
		//----- ۾ İݗݒ --//
		SetPreproTokenHist(pW);
		//----- stONA[ -----//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	Wii'O'j																							//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkOctal(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe;

	if (*pW->pLine == L'0') {
		pW->tkn = EAJCTK_VAL_OCTAL;
		pe	= pW->pLine + 1;
		len = 1;
		while (MAjcAscIsDigitW(*pe)) {
			if (*pe >= L'8') {
				pW->err |= AJCTKERR_INVALID_OCTALNUMBER;
			}
			pe++; len++;
		}
		len += gtkSuffix(pW, pe);
		//----- ۾ İݗݒ --//
		SetPreproTokenHist(pW);
		//----- stONA[ -----//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	i " , ' , L" or L' j																				//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkString(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe;
	WC		c;

	if ((*pW->pLine == L'"' || *pW->pLine == L'\'') ||
			 (*pW->pLine == L'L' && (*(pW->pLine + 1) == L'"' || *(pW->pLine + 1) == L'\''))) {
		if (*pW->pLine == L'L') {
			pW->ctkf |= AJCTKF_WIDECHAR;
			pW->pLine++;
		}
		if (*pW->pLine == L'"') pW->tkn = EAJCTK_STR_QUOTE;
		else					pW->tkn = EAJCTK_STR_APOST;
		c	= *pW->pLine;
		pe	= pW->pLine + 1;
		len = 1;
		while (*pe != 0  &&  *pe != c) {
			//	A|XgtB(')ň͂܂ꂽ́AGXP[X(\)FȂꍇ
			if (pW->tkn == EAJCTK_STR_APOST && (pW->flag & AJCTKFLG_APOST_NOESC)) {
				pe++; len++;
			}
			//	GXP[X(\)Fꍇ
			else {
				if (*pe == L'\\') {
					pe++; len++;
					if (*pe != 0) {
						pe++; len++;
					}
				}
				else {
					pe++; len++;
				}
			}
		}
		if (*pe == c) {pe++; len++;}
		else		  {pW->err |= AJCTKERR_LFINSTR;}
		//----- ۾ İݗݒ --//
		SetPreproTokenHist(pW);
		//----- stONA[ -----//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	f~^																									//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkDelimiter(HAJCTK pW)
{
	UI		len = 0;
	UI		i;
	WCP		pe = pW->pLine;

	for (i=0; i<MAX_DLMTBL; i++) {
		if (wcsncmp(CtkDlmTbl[i].pStr, pW->pLine, CtkDlmTbl[i].lStr) == 0 &&
			 ((pW->flag & AJCTKFLG_CPLUSPLUS) != 0 || !CtkDlmTbl[i].fCPP)) {
			break;
		}
	}
	if (i < MAX_DLMTBL) {
		len = CtkDlmTbl[i].lStr;
		pe	= pW->pLine + len;
		pW->tkn = CtkDlmTbl[i].tkn;
	}
	else {
		len = 1;
		pe	= pW->pLine + 1;
		pW->tkn  = EAJCTK_DLM_UNKNOWN;
		pW->err |= AJCTKERR_INVALID_DELIMITER;
	}
	//----- vvZXJn`FbN -----//
	if ((pW->ctkf & AJCTKF_PREPRO) == 0	&&				//	vvZXO	
		(pW->ctkf & AJCTKF_TOL	 ) != 0	&&				//	s				
		pW->tkn == EAJCTK_DLM_SHARP) {					//	'#' H
		pW->ctkf = (AJCTKF_PREPRO | AJCTKF_PPTOP);		//		uvvZX擪vݒ

		pW->PpHistIx = 0;								//		vvZXEg[NJE^ NA[	
	}
	//----- }NJn^I`FbN -//
	if (pW->ctkf & AJCTKF_PREPRO) {
		//	}N`FbN
		if (pW->PpHistIx >= 2						&&		//		g[NQ		
			pW->PpHist[0] == EAJCTK_DLM_SHARP		&&		//		擪"#"			
			pW->PpHist[1] == EAJCTK_RSV_DEFINE) {			//		Qԁ"define" H
			if (pW->ctkf & AJCTKF_SRHMACARGTOP) {			//			}N擪 '(' ԁH
				if (pW->tkn == EAJCTK_DLM_LSPART) {			//				g[N "(" H
					pW->ctkf |=  AJCTKF_MACARG;				//					tOi}NjZbg
					pW->ctkf &= ~AJCTKF_SRHMACARGTOP;		//					}N擪 '(' ԉ
					pW->ctkf |=  AJCTKF_SRHMACARGEND;		//					}NI[ ')' ԃZbg
				}
			}
			else if (pW->ctkf & AJCTKF_SRHMACARGEND) {		//			}NI[ ')' ԁH
				if (pW->tkn == EAJCTK_DLM_RSPART) {			//				g[N ")" H
					pW->ctkf |=  AJCTKF_MACARG;				//					}NOZbg
					pW->ctkf &= ~AJCTKF_SRHMACARGEND;		//					}NI[ ')' ԉ
					pW->ctkf |=  AJCTKF_FINDMACARGEND;		//					}N{fBԃZbg
				}
			}
		}
	}
	//----- ۾ İݗݒ --------//
	SetPreproTokenHist(pW);
	//----- stONA[ -----------//
	pW->ctkf &= ~AJCTKF_TOL;

	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	#include <path>  upathv																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkIncPath(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe = pW->pLine;

	if ((pW->ctkf & AJCTKF_INCOMMENT) == 0	&&		//	RgO			
		(pW->ctkf & AJCTKF_PREPRO) != 0		&&		//	vvZX		
		pW->PpHistIx == 3					&&		//	g[NR		
		pW->PpHist[0] == EAJCTK_DLM_SHARP	&&		//	擪"#"			
		pW->PpHist[1] == EAJCTK_RSV_INCLUDE	&&		//	Qԁ"include" 	
		pW->PpHist[2] == EAJCTK_DLM_LO) {			//	Rԁ"<" H

		pW->tkn  = EAJCTK_PATHNAME;

		while (*pe != L'>' && *pe != L'\r' && *pe != L'\n' && *pe != 0) {
			pe++;
			len++;
		}

		//----- ۾ İݗݒ --------//
		SetPreproTokenHist(pW);
		//----- stONA[ -----------//
		pW->ctkf &= ~AJCTKF_TOL;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	Rg																									//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkComment(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe = pW->pLine;

	if ((pW->ctkf & AJCTKF_INCOMMENT) != 0) {
		pW->tkn = EAJCTK_COMMENT;
		len = SubChkCommentEnd(pW, pe);
	}
	else if (wcsncmp(pe, L"/*", 2) == 0) {
		pW->tkn   = EAJCTK_COMMENT;
		pW->ctkf |= AJCTKF_INCOMMENT;
		pe	+= 2;
		len += 2;
		len += SubChkCommentEnd(pW, pe);
	}
	else if (wcsncmp(pe, L"//", 2) == 0) {
		pW->tkn   = EAJCTK_LINECOMMENT;
		pe	+= 2;
		len += 2;
		len += SubChkLineEnd(pe);
	}

	return len;
}
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubChkCommentEnd(HAJCTK pW, WCP pe)
{
	UI		len = 0;

	while (*pe != L'\r' && *pe != L'\n' && *pe != 0 && wcsncmp(pe, L"*/", 2) != 0) {
		pe++;
		len++;
	}
	if (wcsncmp(pe, L"*/", 2) == 0) {
		pe	+= 2;
		len += 2;
		pW->ctkf &= ~AJCTKF_INCOMMENT;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubChkLineEnd(WCP pe)
{
	UI		len = 0;

	while (*pe != L'\r' && *pe != L'\n' && *pe != 0) {
		pe++;
		len++;
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//																											//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkSpace(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe = pW->pLine;

	if (*pe == L' ' || *pe == L'\t') {
		pW->tkn = EAJCTK_SPACE;
		while (*pe == L' ' || *pe == L'\t') {
			pe++;
			len++;
		}
	}

	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	s																										//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkEndOfLine(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe = pW->pLine;

	if (*pe == L'\r' || *pe == L'\n') {
		pW->tkn = EAJCTK_EOL;
		while (*pe == L'\r' || *pe == L'\n') {
			pe++;
			len++;
		}
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	spLij																							//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkLineCont(HAJCTK pW)
{
	UI		len = 0;
	WCP		pe = pW->pLine;
	WCP		pn = pe + 1;

	if (*pe == L'\\' && (*pn == L'\r' || *pn == L'\n' || *pn == 0)) {
		pW->ctkf |= AJCTKF_LCONT;
		pW->tkn = EAJCTK_LINECONT;
		len = 1;
	}

	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	l萔̃TtBNXE`FbN																				//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pe		 - lg[N̒̃AhX															//
//																												//
//	߂l	F	0 - TtBNX̒ioCgj																//
//				0 - TtBNXȂ																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI	gtkSuffix(HAJCTK pW, WCP pe)
{
	UI		len;
	WCP		ps;

	//----- ̃TtBNXE`FbN -----//
	if (pW->tkn == EAJCTK_VAL_DECIMAL || pW->tkn == EAJCTK_VAL_HEXA || pW->tkn == EAJCTK_VAL_OCTAL) {
		ps = pe;
		for (len=0; MAjcAscIsAlphaW(*pe); len++, pe++);
		if (len != 0) {
			if		(len == 3 && wcsnicmp(ps, L"ULL", 3) == 0) {		//	ULL	
				pW->suffix = EAJCTKSUF_ULL;
			}
			else if (len == 2 && wcsnicmp(ps, L"LL", 2) == 0) {			//	LL
				pW->suffix = EAJCTKSUF_LL;
			}
			else if (len == 2 && (wcsnicmp(ps, L"UL", 2) == 0  ||		//	UL / LU
								  wcsnicmp(ps, L"LU", 2) == 0)) {
				pW->suffix = EAJCTKSUF_UL;
			}
			else if (len == 1 && (*ps == L'L' || *ps == L'l')) {		//	L
				pW->suffix = EAJCTKSUF_L;
			}
			else {														//	̑
				pW->err |= AJCTKERR_INVALID_SUFFIX;
			}
		}
	}
	//----- ̃TtBNXE`FbN -----//
	else if (pW->tkn == EAJCTK_VAL_REAL) {
		ps = pe;
		for (len=0; MAjcAscIsAlphaW(*pe); len++, pe++);
		if (len != 0) {
			if		(len == 1 && (*ps == L'F' || *ps == L'f')) {		//	F
				pW->suffix = EAJCTKSUF_FLOAT;
			}
			else if (len == 1 && (*ps == L'D' || *ps == L'd')) {		//	D
				pW->suffix = EAJCTKSUF_DOUBLE;
			}
			else if (len == 1 && (*ps == L'L' || *ps == L'l')) {		//	L
				pW->suffix = EAJCTKSUF_LDOUBLE;
			}
			else {														//	̑
				pW->err |= AJCTKERR_INVALID_SUFFIX;
			}
		}
	}
	return len;
}
//--------------------------------------------------------------------------------------------------------------//
//	g[Nobt@Ɋi[																				//
//																												//
//	@	F	pTkn	 - g[N̐擪AhX																//
//				lTkn	 - g[ÑoCg																	//
//				pStrBuf  - g[Ni[obt@̃AhX											//
//				lStrBuf  - g[Ni[obt@̃oCg											//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - obt@I[o[																		//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	SetTknStr(HAJCTK pW, WCP pTkn, UI lTkn, WCP pStrBuf, UI lStrBuf)
{
	BOOL	rc = TRUE;

	do {
		if (pStrBuf == NULL   ) {pW->err |= AJCTKERR_NULLPTR;	break;}
		if (lStrBuf == 0	  ) {pW->err |= AJCTKERR_ZEROSIZE;	break;}

		if (lTkn < lStrBuf) {
			wcsncpy(pStrBuf, pTkn, lTkn);
			*(pStrBuf + lTkn) = 0;
			rc = TRUE;	
		}
		else {
			wcsncpy(pStrBuf, pTkn, lStrBuf - 1);
			*(pStrBuf + (lStrBuf - 1)) = 0;
			pW->ctkf |= AJCTKERR_BUFOVER;
			rc = FALSE;
		}
	} while(0);

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	vvZX̃g[Nݒ																				//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - dne																					//
//--------------------------------------------------------------------------------------------------------------//
static	VO	SetPreproTokenHist(HAJCTK pW)
{
	if ((pW->ctkf & AJCTKF_PREPRO) != 0) {
		if (pW->PpHistIx < AJCTKMAX_PPHIST) {
			pW->PpHist[pW->PpHistIx] = pW->tkn;
		}
		pW->PpHistIx++;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//	sȂ΂Ps[h																						//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	TRUE  - nj																					//
//				FALSE - dne^[N蓖Ďs														//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	ReadLineIfEol(HAJCTK pW)
{
	BOOL	rc = TRUE;
	BCP		pTmpBuf = NULL;

	if (!(pW->ctkf & AJCTKF_EOF)) {	//	dneoH
		if (*pW->pLine == 0) {		//	sH
			do {
				//----- Ch -----------------------------------------------------------------------------//
				if (pW->fUnicode) {
					if (pW->u.cbCtkW != NULL && pW->u.cbCtkW(pW->pLineBuf, pW->lLineBuf, pW->xp)) {	//	Ps[hCdneȊOH
						pW->pLineBuf[pW->lLineBuf - 1] = 0;											//		ɋIɏI[ݒ
						if (!(pW->ctkf & AJCTKF_LCONT)) {											//		spLijȂ
							pW->ctkf &= ~AJCTKF_PREPRO;												//			uvvZXOv
						}
						pW->ctkf &= ~AJCTKF_LCONT;													//		uspLov׸޸ر
						pW->ctkf |= AJCTKF_TOL;														//		usv
						pW->pLine = pW->pLineBuf;													//		s|C^
						pW->lno++;																	//		sԍXV
					}
					else {																			//	dneH
						pW->ctkf &= ~AJCTKF_USER;													//		[UʒmtONA[
						pW->ctkf |= AJCTKF_EOF;														//		udnevtOݒ
						pW->tkn   = EAJCTK_EOF;														//		g[NR[hݒ
						if (pW->ctkf & AJCTKF_INCOMMENT) {											//		Rg͕ĂȂH
							pW->err |= AJCTKERR_EOFINCOMMENT;										//			G[tOݒ
						}
						rc = FALSE;																	//		߂ldne
						break;
					}
				}
				else {
				//----- oCg -----------------------------------------------------------------------------//
					if (pTmpBuf = (BCP)AJCMEM(pW->lLineBuf * 2)) {									//ChAꎞoCgobt@mېH
						memset(pTmpBuf, 0, pW->lLineBuf * 2);
						if (pW->u.cbCtkA != NULL && pW->u.cbCtkA(pTmpBuf, pW->lLineBuf, pW->xp)) {	//	Ps[hCdneȊOH
							pTmpBuf[pW->lLineBuf * 2 - 1] = 0;										//		ɋIɏI[ݒ
							MultiByteToWideChar(CP_ACP, 0, pTmpBuf, -1,								//		ChoCgϊ
									 pW->pLineBuf, pW->lLineBuf);									//		E
							if (!(pW->ctkf & AJCTKF_LCONT)) {										//		spLijȂ
								pW->ctkf &= ~AJCTKF_PREPRO;											//			uvvZXOv
							}
							pW->ctkf &= ~AJCTKF_LCONT;												//		uspLov׸޸ر
							pW->ctkf |=  AJCTKF_TOL;												//		usv
							pW->pLine = pW->pLineBuf;												//		s|C^
							pW->lno++;																//		sԍXV
						}
						else{																		//	dneH
							pW->ctkf &= ~AJCTKF_USER;												//		[UʒmtONA[
							pW->ctkf |= AJCTKF_EOF;													//		udnevtOݒ
							pW->tkn   = EAJCTK_EOF;													//		g[NR[hݒ
							if (pW->ctkf & AJCTKF_INCOMMENT) {										//		Rg͕ĂȂH
								pW->err |= AJCTKERR_EOFINCOMMENT;									//			G[tOݒ
							}
							rc = FALSE;																//		߂ldne
							break;
						}
					}
					else {																			//Chobt@mێsH
						pW->err |= AJCTKERR_MEMALLOC;
						rc = FALSE;
						break;
					}
				}
			} while (pW->pLineBuf[0] == 0);

			if (pTmpBuf != NULL) free(pTmpBuf);
		}
	}
	else {							//	dneoρH
		rc = FALSE;					//		߂ldne
	}
	return rc;
}
//==============================================================================================================//
//	g[N擾																							//
//																												//
//	@	F	tkn 	 - g[NR[h																		//
//																												//
//	߂l	F	NULL - g[ÑAhX																//
//				NULL - sȃg[NR[h																	//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_BCP	WINAPI	AjcCtkGetTokenStringA(EAJCTKCODE tkn)
{
	static	BC	buf[32];
	C_BCP	rc = buf;

	if		(tkn >= EAJCTK_RSV_MINCODE && tkn <= EAJCTK_RSV_MAXCODE) {
		WideCharToMultiByte(CP_ACP, 0, CtkRsvTbl[tkn - EAJCTK_RSV_MINCODE].pStr, -1, buf, AJCTSIZE(buf), NULL, NULL);
	}
	else if (tkn >= EAJCTK_DLM_MINCODE && tkn <= EAJCTK_DLM_MAXCODE) {
		WideCharToMultiByte(CP_ACP, 0, CtkDlmTbl[tkn - EAJCTK_DLM_MINCODE].pStr, -1, buf, AJCTSIZE(buf), NULL, NULL);
	}
	else {
		rc = NULL;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	C_WCP	WINAPI	AjcCtkGetTokenStringW(EAJCTKCODE tkn)
{
	C_WCP	rc;

	if		(tkn >= EAJCTK_RSV_MINCODE && tkn <= EAJCTK_RSV_MAXCODE) {
		rc = CtkRsvTbl[tkn - EAJCTK_RSV_MINCODE].pStr;
	}
	else if (tkn >= EAJCTK_DLM_MINCODE && tkn <= EAJCTK_DLM_MAXCODE) {
		rc = CtkDlmTbl[tkn - EAJCTK_DLM_MINCODE].pStr;
	}
	else {
		rc = NULL;
	}
	return rc;
}
//==============================================================================================================//
//	g[Ňʒu擾ibsjQknb}Nj															//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	g[Ňʒu																				//
//																												//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenLocationA(HAJCTK pW)
{
	UI		rc = 0;
	UI		ix = 0;

	if (IS_MY_INST(pW)) {
		rc = WideCharToMultiByte(CP_ACP, 0, pW->pLineBuf, pW->loc, NULL, 0, NULL, NULL);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenLocationW(HAJCTK pW)
{
	UI		rc = 0;

	if (IS_MY_INST(pW)) {
		rc = pW->loc;
	}
	return rc;
}

//==============================================================================================================//
//	s`alg[Ňʒu擾ibsjQonr}Nj											//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				TabStep  - s`aXebv																		//
//																												//
//	߂l	F	g[Ňʒu																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenPositionA(HAJCTK pW, UI TabStep)
{
	UI		rc = 0;
	UI		ix = 0;
	BCP		pTmp = NULL;

	if (IS_MY_INST(pW)) {
		if (pTmp = (BCP)AJCMEM(pW->lLineBuf * 2)) {
			memset(pTmp, 0, pW->lLineBuf * 2);
			WideCharToMultiByte(CP_ACP, 0, pW->pLineBuf, pW->loc, pTmp, pW->lLineBuf * 2, NULL, NULL);
			while (ix < pW->lLineBuf * 2 && pTmp[ix] != 0) {
				if (pTmp[ix] == '\t') {
					if (TabStep != 0) {
						rc += TabStep;
						rc -= (rc % TabStep);
					}
					ix++;
				}
				else {
					if (_ismbblead(pTmp[ix])) {ix += 2; rc += 2;}
					else					  {ix++;	rc++;	}
				}
			}
			free(pTmp);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcCtkGetTokenPositionW(HAJCTK pW, UI TabStep)
{
	UI		rc = 0;
	UI		ix = 0;

	if (IS_MY_INST(pW)) {
		while (ix < pW->loc) {
			if (pW->pLineBuf[ix] == L'\t') {
				if (TabStep != 0) {
					rc += TabStep;
					rc -= (rc % TabStep);
				}
				ix++;
			}
			else {
				if (MAjcIsLeadW(pW->pLineBuf[ix])) ix += 2;
				else							   ix++;
				rc++;
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	CX^X̃Rs[擾																					//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//																												//
//	߂l	F	NULL : iRs[ꂽCX^Xnhj												//
//				NULL : G[																					//
//																												//
//	@l	F	nh(hDup)gpꍇÃnh(hCtk)̑ƂȂ܂B						//
//				Ⴆ΁AAjcCtkGetToken(hDupEE)sꍇÃnhōŌɎ擾g[N̎		//
//			@g[N擾܂B																			//
//				̃nhiCX^Xj͍XV܂̂ŁAAjcCtkGetToken(hCtkEE)́Aiʏʂj		//
//			@ŌɎs AjcCtkGetToken(hCtk) ̎̃g[N擾܂B									//
//				Rs[ꂽCX^Xnh́AAjcCtkDelete(hDup)ɂȂ΂Ȃ܂B			//
//==============================================================================================================//
AJCEXPORT	HAJCTK	WINAPI	AjcCtkGetReplicatedHandle(HAJCTK pW)
{
	HAJCTK	rc = NULL;
	UX		loc;

	if (IS_MY_INST(pW)) {
		do {
			//	CX^X蓖
			if ((rc 		  = (HAJCTK)AJCMEM(sizeof(AJCTK))) == NULL) {break;}
			//	CX^XփCX^Xf[^Rs[
			memcpy(rc, pW, sizeof(AJCTK));
			//	CX^X̍sobt@蓖
			if ((rc->pLineBuf = (WCP   )AJCMEM(rc->lLineBuf * 2)) == NULL) {free(rc); rc = NULL; break;}
			//	CX^X̍sobt@|C^ݒ
			loc = ((UX)pW->pLine - (UX)pW->pLineBuf) / 2;
			rc->pLine = rc->pLineBuf + loc;
			//	CX^X̍sobt@փf[^Rs[
			memcpy(rc->pLineBuf, pW->pLineBuf, pW->lLineBuf * 2);
		} while(0);
	}
	return rc;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//##############################################################################################################//
//--------------------------------------------------------------------------------------------------------------//
//	݂̃g[N擾																						//
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	EAJCTKCODE	WINAPI	AjcCtkGetCurToken		(HAJCTK pW)					{return AJCTK_TOKEN	(pW);			}
AJCEXPORT	EAJCTKSUF	WINAPI	AjcCtkGetCurSuffix		(HAJCTK pW)					{return AJCTK_SUFFIX(pW);			}
AJCEXPORT	UI			WINAPI	AjcCtkGetCurFlag		(HAJCTK pW)					{return AJCTK_FLAG	(pW);			}
AJCEXPORT	UI			WINAPI	AjcCtkGetCurLineNumber	(HAJCTK pW)					{return AJCTK_LINE	(pW);			}
AJCEXPORT	UI			WINAPI	AjcCtkGetCurPosition	(HAJCTK pW, UI TabWidth)	{return AJCTK_POS	(pW, TabWidth);	}
AJCEXPORT	UI			WINAPI	AjcCtkGetCurError		(HAJCTK pW)					{return AJCTK_ERROR	(pW);			}

AJCEXPORT	BOOL		WINAPI	AjcCtkIsUsrSym			(EAJCTKCODE tkn)			{return AJCTKIS_USRSYM	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsRsvSym			(EAJCTKCODE tkn)			{return AJCTKIS_RSVSYM	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsValue			(EAJCTKCODE tkn)			{return AJCTKIS_VALUE 	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsString			(EAJCTKCODE tkn)			{return AJCTKIS_STRING	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsPathName		(EAJCTKCODE tkn)			{return AJCTKIS_PATHNAME(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsDelimit			(EAJCTKCODE tkn)			{return AJCTKIS_DELIMIT	(tkn);		}

AJCEXPORT	BOOL		WINAPI	AjcCtkIsSymbol			(EAJCTKCODE tkn)			{return AJCTKIS_SYMBOL	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsValSym			(EAJCTKCODE tkn)			{return AJCTKIS_VALSYM	(tkn);		}
AJCEXPORT	BOOL		WINAPI	AjcCtkIsSpace			(EAJCTKCODE tkn)			{return AJCTKIS_SPACE	(tkn);		}

