#include	"AjcInternal.h"

//==============================================================================================================//
//	Function	:	1970/1/1 00:00:00̒ʎZbVXe^Cɕϊ											//
//																												//
//	Argument	:	Time1970 - 1970/1/1 00:00:00̒ʎZb													//
//					pStime	 - ϊVXe^Ci[obt@̃AhX								//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - s																				//
//==============================================================================================================//
//----- e̓e[u -------------------------------------------------------------------------------------//
//									  1	  2	  3	  4	  5	  6	  7	  8	  9	  10  11  12							//
static	const UB DaysTable[13] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
//----- 邤N}N -------------------------------------------------------------------------------------//
#define		ISURU(Y)	(((Y % 4) == 0 && (Y % 100) != 0) || (Y % 400) == 0)
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcTime1970ToSysTime(UI Time1970, LPSYSTEMTIME pStime)
{
	BOOL	rc = FALSE;
	UI		days = Time1970 / 86400;
	UI		y = 1970;
	UI		u = ISURU(y);
	UI		m;

	if (pStime != NULL) {
		pStime->wDayOfWeek = (UB)((days + 4) % 7);

		while (days >= (365 + u)) {
			days -= (365 + u);
			y++;
			u = ISURU(y);
		}
		for (m=1;
			days >=	 (UL)(DaysTable[m] + (m==2 ? u : 0)) && m < 12;
			days -= (DaysTable[m] + (m==2 ? u : 0)), m++);

		pStime->wYear		  = (UW)y;
		pStime->wMonth		  = (UB)m;
		pStime->wDay		  = (UB)(days + 1);
		pStime->wDayOfWeek	  = (((Time1970 / (24 * 60 * 60)) + 4) % 7);
		pStime->wHour		  = (UB)((Time1970 % 86400) / 3600);
		pStime->wMinute		  = (UB)((Time1970 %  3600) / 60);
		pStime->wSecond		  = (UB)( Time1970 %	60);
		pStime->wMilliseconds = 0;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	VXe^C1970/1/1 00:00:00̒ʎZbɕϊ											//
//																												//
//	Argument	:	pStime		- VXe^C																//
//																												//
//	Return		:	-1 - 1970/1/1 00:00:00̒ʎZb														//
//					-1 - G[																				//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcSysTimeToTime1970(const SYSTEMTIME *pStime)
{
	UI		ftime = -1;
	UI		m;

	if (pStime != NULL) {
		ftime = ((((pStime->wYear - 1970) * 365) + ((pStime->wYear - 1969) / 4)) * 86400);
		if (pStime->wYear > 2100) 
			ftime -= 86400;
		for (m=1; m<pStime->wMonth; m++) 
			ftime += ((DaysTable[m] + (m==2 ? ISURU(pStime->wYear) : 0)) * 86400);
		ftime += (pStime->wDay - 1) * 86400;
		ftime += (pStime->wHour * 3600);
		ftime += (pStime->wMinute * 60);
		ftime += pStime->wSecond;
	}
	return ftime;
}
//==============================================================================================================//
//	Function	:	VXe^C[J^Cɕϊ														//
//																												//
//	Argument	:	pStime	 - VXe^C																	//
//					pLTime	 - [J^Ci[obt@̃AhX										//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - s																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcSysTimeToLocalTime(const SYSTEMTIME *pStime, LPSYSTEMTIME pLtime)
{
	BOOL		rc = FALSE;
	FILETIME	sft, lft;

	if (pStime != NULL && pLtime != NULL) {
		if (SystemTimeToFileTime(pStime, &sft)) {
			FileTimeToLocalFileTime(&sft, &lft);
			FileTimeToSystemTime(&lft, pLtime);
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	wbi߂i邢͖߂j߂												//
//																												//
//	Argument	:	pStime	 - XVΏێ																		//
//					pLTime	 - XV̎i[obt@̃AhX											//
//					Second	 - XVbi߂ꍇ͕j														//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - s																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcTimeUpdate(const SYSTEMTIME *pStime, LPSYSTEMTIME pUpdated, int Second)
{
	BOOL	rc = FALSE;
	union {FILETIME ft;	 __int64 tm;} u;

	if (pStime != NULL && pUpdated != NULL) {
		SystemTimeToFileTime(pStime, &u.ft);
		u.tm += ((__int64)Second * (__int64)10000000);
		FileTimeToSystemTime(&u.ft, pUpdated);
		rc = TRUE;
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	t擾																				//
//																												//
//	Argument	:	pStime	 - t^																	//
//																												//
//	Return		:	NULL - t̃AhX																//
//					NULL - G[																				//
//==============================================================================================================//
__declspec(thread) static BC DateStrA[64] = {0};
__declspec(thread) static WC DateStrW[64] = {0};
__declspec(thread) static BC TimeStrA[64] = {0};
__declspec(thread) static WC TimeStrW[64] = {0};

//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcDateStrA(const SYSTEMTIME *pStime)
{
	BCP		rc = NULL;
	BC		sd[16];
	BC		id[16];

	if (pStime != NULL) {
		if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_SDATE, sd, sizeof sd) == 0) strcpy(sd, "/");
		if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_IDATE, id, sizeof id) == 0) id[0] = 2;

		switch (id[0]) {
			case '0':  AjcSnPrintFA(DateStrA, 64, "%02d%s%02d%s%4d", pStime->wMonth, sd, pStime->wDay  , sd, pStime->wYear); break;
			case '1':  AjcSnPrintFA(DateStrA, 64, "%02d%s%02d%s%4d", pStime->wDay  , sd, pStime->wMonth, sd, pStime->wYear); break;
			default:   AjcSnPrintFA(DateStrA, 64, "%4d%s%02d%s%02d", pStime->wYear , sd, pStime->wMonth, sd, pStime->wDay ); break;
		}
		rc = DateStrA;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcDateStrW(const SYSTEMTIME *pStime)
{
	WCP		rc = NULL;
	WC		sd[16];
	WC		id[16];

	if (pStime != NULL) {
		if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_SDATE, sd, sizeof sd) == 0) wcscpy(sd, L"/");
		if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_IDATE, id, sizeof id) == 0) id[0] = 2;

		switch (id[0]) {
			case L'0':	AjcSnPrintFW(DateStrW, 64, L"%02d%s%02d%s%4d", pStime->wMonth, sd, pStime->wDay	 , sd, pStime->wYear); break;
			case L'1':	AjcSnPrintFW(DateStrW, 64, L"%02d%s%02d%s%4d", pStime->wDay	 , sd, pStime->wMonth, sd, pStime->wYear); break;
			default:	AjcSnPrintFW(DateStrW, 64, L"%4d%s%02d%s%02d", pStime->wYear , sd, pStime->wMonth, sd, pStime->wDay ); break;
		}
		rc = DateStrW;
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	擾																				//
//																												//
//	Argument	:	pStime	 - t^																	//
//																												//
//	Return		:	NULL - ̃AhX																//
//					NULL - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcTimeStrA(const SYSTEMTIME *pStime, BOOL fMilliseconds)
{
	BCP		rc = NULL;
	BC		st[16];

	if (pStime != NULL) {
		if (GetLocaleInfoA(LOCALE_USER_DEFAULT, LOCALE_STIME, st, sizeof st) == 0) strcpy(st, ":");

		if (fMilliseconds) {
			AjcSnPrintFA(TimeStrA, 64, "%02d%s%02d%s%02d.%03d", pStime->wHour, st, pStime->wMinute, st, pStime->wSecond, pStime->wMilliseconds);
		}
		else {
			AjcSnPrintFA(TimeStrA, 64, "%02d%s%02d%s%02d", pStime->wHour, st, pStime->wMinute, st, pStime->wSecond);
		}
		rc = TimeStrA;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcTimeStrW(const SYSTEMTIME *pStime, BOOL fMilliseconds)
{
	WCP		rc = NULL;
	WC		st[16];

	if (pStime != NULL) {
		if (GetLocaleInfoW(LOCALE_USER_DEFAULT, LOCALE_STIME, st, sizeof st) == 0) wcscpy(st, L":");

		if (fMilliseconds) {
			AjcSnPrintFW(TimeStrW, 64, L"%02d%s%02d%s%02d.%03d", pStime->wHour, st, pStime->wMinute, st, pStime->wSecond, pStime->wMilliseconds);
		}
		else {
			AjcSnPrintFW(TimeStrW, 64, L"%02d%s%02d%s%02d", pStime->wHour, st, pStime->wMinute, st, pStime->wSecond);
		}
		rc = TimeStrW;
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	t񂩂SYSTEMTIME\̂̓tݒ												//
//																												//
//	Argument	:	pDateText	 - teLXg̃AhXiex. g2022/12/23hj									//
//					pSt 		 - tݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		 - teLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateFromTextA			(C_BCP pDateText, LPSYSTEMTIME pSt, BCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetDateFromTextExA(pDateText, pSt, pNext, AJCOPT4(AJCDATEFLAG_, YYMMDD, ADJUST, SETDEF, SETDOW), '/');
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateFromTextW			(C_WCP pDateText, LPSYSTEMTIME pSt, WCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetDateFromTextExW(pDateText, pSt, pNext, AJCOPT4(AJCDATEFLAG_, YYMMDD, ADJUST, SETDEF, SETDOW), L'/');
	return rc;
}

//==============================================================================================================//
//	Function	:	t񂩂SYSTEMTIME\̂̓tݒigŁj									//
//																												//
//	Argument	:	pDateText	- teLXg̃AhXiex. g2022/12/23hj									//
//					pSt 		- tݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		- teLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//					flag		- tO																		//
//					dlm			- N̋؂蕶iOw莞́A'/' j									//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- [N -------------------------------------------------------------------------------------------------//
typedef struct {
	C_WCP			pTxt;					//	̓eLXg|C^
	UI				flag;					//	tO
	WC				dlm;					//	tL
	UW				yy, mm, dd, dow;		//	o͏iNCjj
} WKSETDATE, *PWKSETDATE;
//----- ؂蕶XLbv -------------------------------------------------------------------------------------//
static BOOL SubSkipDlmD(PWKSETDATE pW)
{
	BOOL	rc = FALSE;

	//	؂蕶Ȃ΃XLbv
	if (*pW->pTxt == pW->dlm) {
		pW->pTxt++;
		rc = TRUE;
	}
	//	󔒁^I[ȂΉȂ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		rc = TRUE;
	}
	return rc;
}
//----- Nݒ -------------------------------------------------------------------------------------------------//
static BOOL SubSetYear(PWKSETDATE pW)
{
	BOOL	rc = FALSE;

	//	 Ȃ΁uNvݒ
	if (MAjcIsDigitW(*pW->pTxt)) {
		int		stl  = 0;
		C_WCP	pTmp = pW->pTxt;
		//	`FbN
		while (MAjcIsDigitW(*pTmp)) {
			pTmp++;
			stl++;
		}
		if (stl == 2 || stl == 4) {
			//	uNvݒ
			pW->yy = _wtoi(pW->pTxt);
			if		(pW->yy >=	0 && pW->yy <= 69) pW->yy += 2000;
			else if (pW->yy >= 70 && pW->yy <= 99) pW->yy += 1900;
			//	XLbv
			pW->pTxt += stl;
			rc = TRUE;
		}
	}
	//	 "****" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"****", 4) == 0 && *(pW->pTxt + 4) != L'*') {
		pW->pTxt += 4;
		rc = TRUE;
	}
	//	 "**" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"**"  , 2) == 0 && *(pW->pTxt + 2) != L'*') {
		pW->pTxt += 2;
		rc = TRUE;
	}
	//	 󔒁^I[  AJCDATEFLAG_SETDEFwȂ΃ftHglݒ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		if (pW->flag & AJCDATEFLAG_SETDEF) {
			pW->yy = 2000;
		}
		rc = TRUE;
	}
	return rc;
}
//----- ݒ -------------------------------------------------------------------------------------------------//
static BOOL SubSetMonth(PWKSETDATE pW)
{
	BOOL	rc = FALSE;

	//	 Ȃ΁uvݒ
	if (MAjcIsDigitW(*pW->pTxt)) {
		int		stl  = 0;
		C_WCP		pTmp = pW->pTxt;
		//	`FbN
		while (MAjcIsDigitW(*pTmp)) {
			pTmp++;
			stl++;
		}
		if (stl == 2) {
			//	uvݒ
			pW->mm = _wtoi(pW->pTxt);
			//	XLbv`FbN
			pW->pTxt += stl;
			rc = TRUE;
		}
	}
	//	 "**" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"**", 2) == 0) {
		pW->pTxt += 2;
		rc = TRUE;
	}
	//	 󔒁^I[  AJCDATEFLAG_SETDEFwȂ΃ftHglݒ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		if (pW->flag & AJCDATEFLAG_SETDEF) {
			pW->mm = 1;
		}
		rc = TRUE;
	}
	return rc;
}
//----- ݒ -------------------------------------------------------------------------------------------------//
static BOOL SubSetDay(PWKSETDATE pW)
{
	BOOL	rc = FALSE;

	//	 Ȃ΁uvݒ
	if (MAjcIsDigitW(*pW->pTxt)) {
		int		stl  = 0;
		C_WCP	pTmp = pW->pTxt;
		//	`FbN
		while (MAjcIsDigitW(*pTmp)) {
			pTmp++;
			stl++;
		}
		if (stl == 2) {
			//	uvݒ
			pW->dd = _wtoi(pW->pTxt);
			//	XLbv`FbN
			pW->pTxt += stl;
			rc = TRUE;
		}
	}
	//	 "**" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"**", 2) == 0) {
		pW->pTxt += 2;
		rc = TRUE;
	}
	//	 󔒁^I[  AJCDATEFLAG_SETDEFwȂ΃ftHglݒ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		if (pW->flag & AJCDATEFLAG_SETDEF) {
			pW->dd = 1;
		}
		rc = TRUE;
	}
	return rc;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateFromTextExA			(C_BCP pDateText, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm)
{
	BOOL	rc = FALSE;
	WCP		pTxtW = NULL;
	int		lTxtW;
	WCP		pNxtW;

	if (pDateText != NULL && pSt != NULL) {
		lTxtW = AjcByteCharToWideChar(pDateText, NULL, 0);
		if (pTxtW = AjcTAlloc(lTxtW)) {
			AjcByteCharToWideChar(pDateText, pTxtW, lTxtW);
			rc = AjcSetDateFromTextExW(pTxtW, pSt, &pNxtW, flag, dlm);
			if (pNext != NULL) {
				UX	wcl = ((UX)pNxtW - (UX)pTxtW) / 2;
				UI	bcl = WideCharToMultiByte(CP_ACP, 0, pTxtW, (UI)wcl, NULL, 0, NULL, NULL);
				*pNext = (BCP)(pDateText + bcl);
			}
		}
		if (pTxtW != NULL) free(pTxtW);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateFromTextExW			(C_WCP pDateText, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm)
{
	BOOL		rc = FALSE;
	WKSETDATE	wrk;

	if (pDateText != NULL && pSt != NULL && !MAjcIsAlNum(dlm) && !MAjcIsBlank(dlm) && dlm != L'*') {
		//	ftHg؂蕶ݒ
		if (dlm == 0) dlm = L'/';
		//	[Nݒ
		wrk.pTxt = pDateText;
		wrk.flag = flag;
		wrk.dlm  = dlm;
		wrk.yy	 = pSt->wYear;
		wrk.mm	 = pSt->wMonth;
		wrk.dd	 = pSt->wDay;
		wrk.dow  = pSt->wDayOfWeek;
		//	擪󔒃XLbv
		while (MAjcIsBlankW(*wrk.pTxt)) {
			wrk.pTxt++;
		}
		//	Nݒ
		switch (flag& AJCDATEFLAG_FORM) {
			case AJCDATEFLAG_YYMMDD:
				if (!(rc = SubSetYear (&wrk))) break;		//	uNvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetMonth(&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetDay  (&wrk))) break;		//	uvݒ
				break;

			case AJCDATEFLAG_MMDDYY:
				if (!(rc = SubSetMonth(&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetDay  (&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetYear (&wrk))) break;		//	uNvݒ
				break;

			case AJCDATEFLAG_DDMMYY:
				if (!(rc = SubSetDay  (&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetMonth(&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetYear (&wrk))) break;		//	uNvݒ
				break;

			case AJCDATEFLAG_MMYYDD:
				if (!(rc = SubSetMonth(&wrk))) break;		//	uvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetYear (&wrk))) break;		//	uNvݒ
				if (!(rc = SubSkipDlmD(&wrk))) break;		//	 ؂蕶XLbv
				if (!(rc = SubSetDay  (&wrk))) break;		//	uvݒ
				break;

			default:
				rc = FALSE;
				break;
		}
	}

	if (rc) {
		//	N␳
		if (wrk.flag & AJCDATEFLAG_ADJUST) {
			if (wrk.yy < 1970) wrk.yy = 1970;
			if (wrk.yy > 2105) wrk.yy = 2105;
			if (wrk.mm <	1) wrk.mm = 1;
			if (wrk.mm >   12) wrk.mm = 12;
			if (wrk.dd <	1) wrk.dd = 1;
			if (wrk.dd >   31) wrk.dd = 31;
			if (wrk.mm == 2) {
				if (ISURU(wrk.yy)) {
					if (wrk.dd > 29) wrk.dd = 29;
				}
				else {
					if (wrk.dd > 28) wrk.dd = 28;
				}
			}
			else if (wrk.mm == 4 || wrk.mm == 6 || wrk.mm == 9 || wrk.mm == 11) {
				if (wrk.dd > 30) wrk.dd = 30;
			}
		}
		//	jݒ
		if (wrk.flag & AJCDATEFLAG_SETDOW) {
			UI			sec1970;
			SYSTEMTIME	st = {0};
			st.wYear  = wrk.yy;
			st.wMonth = wrk.mm;
			st.wDay   = wrk.dd;
			sec1970 = AjcSysTimeToTime1970(&st);
			sec1970 /= (24 * 60 * 60);
			wrk.dow = ((sec1970 + 4) % 7);
		}
		//	߂SYSTEMTIME\̐ݒ
		pSt->wYear		= wrk.yy;
		pSt->wMonth 	= wrk.mm;
		pSt->wDay		= wrk.dd;
		pSt->wDayOfWeek = wrk.dow;
	}
	//	߂|C^ݒ
	if (pNext != NULL) {
		*pNext = (WCP)wrk.pTxt;
	}

	return rc;
}

//==============================================================================================================//
//	Function	:	񂩂SYSTEMTIME\̂̎ݒ												//
//																												//
//	Argument	:	pTimeText	- eLXg̃AhXiex. g13:23:51.345hj								//
//					pSt 		- ݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		- eLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetTimeFromTextA			(C_BCP pTimeText, LPSYSTEMTIME pSt, BCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetTimeFromTextExA(pTimeText, pSt, pNext, AJCOPT2(AJCTIMEFLAG_, ADJUST, SETDEF), ':', '.');
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetTimeFromTextW			(C_WCP pTimeText, LPSYSTEMTIME pSt, WCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetTimeFromTextExW(pTimeText, pSt, pNext, AJCOPT2(AJCTIMEFLAG_, ADJUST, SETDEF), L':', L'.');
	return rc;
}

//==============================================================================================================//
//	Function	:	񂩂SYSTEMTIME\̂̎ݒigŁj									//
//																												//
//	Argument	:	pTimeText	- eLXg̃AhXiex. g13:23:51.345hj								//
//					pSt 		- ݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		- eLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//					dlm			- b̋؂蕶iOw莞́A':' j									//
//					dms			- b̋؂蕶iOw莞́A'.' j									//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- [N -------------------------------------------------------------------------------------------------//
typedef struct {
	C_WCP			pTxt;					//	̓eLXg|C^
	UI				flag;					//	tO
	WC				dlm;					//	L
	WC				dms;					//	~bL
	UW				hh, mm, ss, ms;			//	o͏ibC~bj
} WKSETTIME, *PWKSETTIME;
//----- ؂蕶(:)XLbv ----------------------------------------------------------------------------------//
static BOOL SubSkipDlmT(PWKSETTIME pW)
{
	BOOL	rc = FALSE;

	//	؂蕶Ȃ΃XLbv
	if (*pW->pTxt == pW->dlm) {
		pW->pTxt++;
		rc = TRUE;
	}
	//	~b؂蕶^󔒁^I[^ȂΉȂ
	else if (*pW->pTxt == pW->dms || MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		rc = TRUE;
	}
	return rc;
}
//----- ؂蕶(.)XLbv ----------------------------------------------------------------------------------//
static BOOL SubSkipDlmP(PWKSETTIME pW)
{
	BOOL	rc = FALSE;

	//	؂蕶Ȃ΃XLbv
	if (*pW->pTxt == pW->dms) {
		pW->pTxt++;
		rc = TRUE;
	}
	//	󔒁^I[^ȂΉȂ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		rc = TRUE;
	}
	return rc;
}
//----- //bݒ -------------------------------------------------------------------------------------------//
static BOOL SubSetHHMMSS(PWKSETTIME pW, UWP pVal)
{
	BOOL	rc = FALSE;

	//	 Ȃ΁u//bvݒ
	if (MAjcIsDigitW(*pW->pTxt)) {
		int		stl  = 0;
		C_WCP	pTmp = pW->pTxt;
		//	`FbN
		while (MAjcIsDigitW(*pTmp)) {
			pTmp++;
			stl++;
		}
		if (stl == 2) {
			//	u//bvݒ
			*pVal = _wtoi(pW->pTxt);
			//	XLbv
			pW->pTxt += stl;
			rc = TRUE;
		}
	}
	//	 "**" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"**"  , 2) == 0 && *(pW->pTxt + 2) != L'*') {
		pW->pTxt += 2;
		rc = TRUE;
	}
	//	 ~b؂蕶^󔒁^I[  AJCDATEFLAG_SETDEFwȂ΃ftHglݒ
	else if (*pW->pTxt == pW->dms || MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		if (pW->flag & AJCTIMEFLAG_SETDEF) {
			*pVal = 0;
		}
		rc = TRUE;
	}
	return rc;
}
//----- ~bݒ ---------------------------------------------------------------------------------------------//
static BOOL SubSetMS(PWKSETTIME pW)
{
	BOOL	rc = FALSE;

	//	 Ȃ΁u~bvݒ
	if (MAjcIsDigitW(*pW->pTxt)) {
		int		stl  = 0;
		C_WCP	pTmp = pW->pTxt;
		//	`FbN
		while (MAjcIsDigitW(*pTmp)) {
			pTmp++;
			stl++;
		}
		if (stl == 3) {
			//	u~bvݒ
			pW->ms = _wtoi(pW->pTxt);
			//	XLbv
			pW->pTxt += stl;
			rc = TRUE;
		}
	}
	//	 "***" Ȃ΁AȂi\̂֐ݒ肵Ȃj
	else if (wcsncmp(pW->pTxt, L"**+"  , 3) == 0 && *(pW->pTxt + 3) != L'*') {
		pW->pTxt += 3;
		rc = TRUE;
	}
	//	 󔒁^I[  AJCDATEFLAG_SETDEFwȂ΃ftHglݒ
	else if (MAjcIsBlankW(*pW->pTxt) || *pW->pTxt == 0) {
		if (pW->flag & AJCTIMEFLAG_SETDEF) {
			pW->ms = 0;
		}
		rc = TRUE;
	}
	return rc;
}
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetTimeFromTextExA			(C_BCP pTimeText, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm, BC dms)
{
	BOOL	rc = FALSE;
	WCP		pTxtW = NULL;
	int		lTxtW;
	WCP		pNxtW;

	if (pTimeText != NULL && pSt != NULL) {
		lTxtW = AjcByteCharToWideChar(pTimeText, NULL, 0);
		if (pTxtW = AjcTAlloc(lTxtW)) {
			AjcByteCharToWideChar(pTimeText, pTxtW, lTxtW);
			rc = AjcSetTimeFromTextExW(pTxtW, pSt, &pNxtW, flag, dlm, dms);
			if (pNext != NULL) {
				UX	wcl = ((UX)pNxtW - (UX)pTxtW) / 2;
				UI	bcl = WideCharToMultiByte(CP_ACP, 0, pTxtW, (UI)wcl, NULL, 0, NULL, NULL);
				*pNext = (BCP)(pTimeText + bcl);
			}
		}
		if (pTxtW != NULL) free(pTxtW);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetTimeFromTextExW			(C_WCP pTimeText, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm, WC dms)
{
	BOOL		rc = FALSE;
	WKSETTIME	wrk;

	if (pTimeText != NULL && pSt != NULL && !MAjcIsAlNum(dlm) && !MAjcIsBlank(dlm) && dlm != L'*') {
		//	ftHg؂蕶ݒ
		if (dlm == 0) dlm = L':';
		if (dms == 0) dms = L'.';
		//	[Nݒ
		wrk.pTxt = pTimeText;
		wrk.flag = flag;
		wrk.dlm  = dlm;
		wrk.dms  = dms;
		wrk.hh	 = pSt->wHour;
		wrk.mm	 = pSt->wMinute;
		wrk.ss	 = pSt->wSecond;
		wrk.ms	 = pSt->wMilliseconds;
		//	擪󔒃XLbv
		while (MAjcIsBlankW(*wrk.pTxt)) {
			wrk.pTxt++;
		}
		//	bC~bݒ
		do {
			if (!(rc = SubSetHHMMSS(&wrk, &wrk.hh))) break;		//	uvݒ
			if (!(rc = SubSkipDlmT (&wrk		 ))) break;		//	 ؂蕶(:)XLbv
			if (!(rc = SubSetHHMMSS(&wrk, &wrk.mm))) break;		//	uvݒ
			if (!(rc = SubSkipDlmT (&wrk		 ))) break;		//	 ؂蕶(:)XLbv
			if (!(rc = SubSetHHMMSS(&wrk, &wrk.ss))) break;		//	ubvݒ
			if (!(rc = SubSkipDlmP (&wrk		 ))) break;		//	 ؂蕶(.)XLbv
			if (!(rc = SubSetMS    (&wrk		 ))) break;		//	u~bvݒ
		} while (0);
	}
	if (rc) {
		//	bC~b␳
		if (wrk.flag & AJCTIMEFLAG_ADJUST) {
			if (wrk.hh <   0) wrk.hh = 1;
			if (wrk.hh >  23) wrk.hh = 12;
			if (wrk.mm <   0) wrk.mm = 0;
			if (wrk.mm >  59) wrk.mm = 59;
			if (wrk.ss <   0) wrk.ss = 0;
			if (wrk.ss >  59) wrk.ss = 59;
			if (wrk.ms <   0) wrk.ss = 0;
			if (wrk.ms > 999) wrk.ss = 999;
		}
		//	߂SYSTEMTIME\̐ݒ
		pSt->wHour		   = wrk.hh;
		pSt->wMinute 	   = wrk.mm;
		pSt->wSecond	   = wrk.ss;
		pSt->wMilliseconds = wrk.ms;
	}
	//	߂|C^ݒ
	if (pNext != NULL) {
		*pNext = (WCP)wrk.pTxt;
	}

	return rc;
}

//==============================================================================================================//
//	Function	:	񂩂SYSTEMTIME\̂̓ݒ												//
//																												//
//	Argument	:	pText		- eLXg̃AhXiex. g2022/12/23	13:23:51hj						//
//					pSt 		- ݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		- eLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateAndTimeFromTextA 	(C_BCP pText, LPSYSTEMTIME pSt, BCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetDateAndTimeFromTextExA(pText, pSt, pNext, AJCOPT4(AJCDATEFLAG_, YYMMDD, ADJUST, SETDEF, SETDOW) | AJCOPT2(AJCTIMEFLAG_, ADJUST, SETDEF), '/', ':', '.');
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateAndTimeFromTextW 	(C_WCP pText, LPSYSTEMTIME pSt, WCP *pNext)
{
	BOOL	rc = FALSE;
	rc = AjcSetDateAndTimeFromTextExW(pText, pSt, pNext, AJCOPT4(AJCDATEFLAG_, YYMMDD, ADJUST, SETDEF, SETDOW) | AJCOPT2(AJCTIMEFLAG_, ADJUST, SETDEF), L'/', L':', L'.');
	return rc;
}

//==============================================================================================================//
//	Function	:	񂩂SYSTEMTIME\̂̓ݒigŁj									//
//																												//
//	Argument	:	pText		- eLXg̃AhXiex. g2022/12/23	13:23:51hj						//
//					pSt 		- ݒ肷SYSTEMTIME\̂̃AhX									//
//					pNext		- eLXg̒̃AhXi[|C^ϐ̃AhXisvNULLj	//
//					flag		- tO																		//
//					dlm_d		- N̋؂蕶iOw莞́A'/' j									//
//					dlm_t		- b̋؂蕶iOw莞́A':' j									//
//					dms			- ~bŐ؂LiOw莞́A'.' j								//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateAndTimeFromTextExA	(C_BCP pText, LPSYSTEMTIME pSt, BCP *pNext, UI flag, BC dlm_d, BC dlm_t, BC dms)
{
	BOOL	rc = FALSE;
	WCP		pTxtW = NULL;
	int		lTxtW;
	WCP		pNxtW;

	if (pText != NULL && pSt != NULL) {
		lTxtW = AjcByteCharToWideChar(pText, NULL, 0);
		if (pTxtW = AjcTAlloc(lTxtW)) {
			AjcByteCharToWideChar(pText, pTxtW, lTxtW);
			rc = AjcSetDateAndTimeFromTextExW(pTxtW, pSt, &pNxtW, flag, dlm_d, dlm_t, dms);
			if (pNext != NULL) {
				UX	wcl = ((UX)pNxtW - (UX)pTxtW) / 2;
				UI	bcl = WideCharToMultiByte(CP_ACP, 0, pTxtW, (UI)wcl, NULL, 0, NULL, NULL);
				*pNext = (BCP)(pText + bcl);
			}
		}
		if (pTxtW != NULL) free(pTxtW);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL WINAPI	AjcSetDateAndTimeFromTextExW	(C_WCP pText, LPSYSTEMTIME pSt, WCP *pNext, UI flag, WC dlm_d, WC dlm_t, WC dms)
{
	BOOL	rc = FALSE;
	WCP		pTmp;

	if (rc = AjcSetDateFromTextExW(pText, pSt, &pTmp, flag, dlm_d)) {
		rc = AjcSetTimeFromTextExW(pTmp , pSt, pNext, flag, dlm_t, dms);
	}
	else {
		if (pNext != NULL) {
			*pNext = pTmp;
		}
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	_ȓtƎ擾																	//
//																												//
//	Argument	:	pSt	- _ȓݒ肷SYSTEMTIME\̂̃AhX								//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcGetRandomDateAndTime (LPSYSTEMTIME pSt, LPSYSTEMTIME pStSrt, LPSYSTEMTIME pStEnd)
{
	BOOL		rc = FALSE;
	SYSTEMTIME	st, RndSrt, RndEnd;
	ULL			rndmax = (ULL)RAND_MAX * (ULL)RAND_MAX;
	ULL			rnd, trg;
	ULL			sec, secSrt, secEnd;
	ULL			ms , msSrt , msEnd;

	if (pSt != NULL) {
		//	JnCIݒ
		if (pStEnd != NULL) memcpy(&RndEnd, pStEnd, sizeof(SYSTEMTIME));
		else				{
			GetLocalTime(&RndEnd);
			RndEnd.wHour		 = 23;
			RndEnd.wMinute		 = 59;
			RndEnd.wSecond		 = 59;
			RndEnd.wMilliseconds = 999;
		}
		if (pStSrt != NULL) memcpy(&RndSrt, pStSrt, sizeof(SYSTEMTIME));
		else {
			sec  = AjcSysTimeToTime1970(&RndEnd);
			sec -= (365 * 24 * 60 * 60);
			AjcTime1970ToSysTime((UI)sec, &RndSrt);
			RndSrt.wHour		 = 0;
			RndSrt.wMinute		 = 0;
			RndSrt.wSecond		 = 0;
			RndSrt.wMilliseconds = 0;
		}
		//	͈̓`FbN
		secSrt = AjcSysTimeToTime1970(&RndSrt);
		secEnd = AjcSysTimeToTime1970(&RndEnd);
		if (secSrt <= secEnd) {
			//	Jnibjݒ
			memset(&st, 0, sizeof st);
			st.wYear  = RndSrt.wYear;
			st.wMonth = RndSrt.wMonth;
			st.wDay   = RndSrt.wDay;
			secSrt	  = AjcSysTimeToTime1970(&st);
			//	Iibjݒ
			memset(&st, 0, sizeof st);
			st.wYear   = RndEnd.wYear;
			st.wMonth  = RndEnd.wMonth;
			st.wDay    = RndEnd.wDay;
			st.wHour   = 23;
			st.wMinute = 59;
			st.wSecond = 59;
			secEnd	  = AjcSysTimeToTime1970(&st);
			//	Jn`I̕bZo
			sec = secEnd - secSrt;
			//	_ȓtZo
			rnd = (UX)rand() * (UX)rand();
			trg = sec * rnd / rndmax;
			trg += secSrt;
			AjcTime1970ToSysTime((UI)trg, &st);
			pSt->wYear		= st.wYear;
			pSt->wMonth 	= st.wMonth;
			pSt->wDay		= st.wDay;
			pSt->wDayOfWeek = st.wDayOfWeek;
			//	Jn(ms)ݒ
			msSrt = ((ULL)RndSrt.wHour * 60 * 60 * 1000) + ((ULL)RndSrt.wMinute * 60 * 1000) + ((ULL)RndSrt.wSecond * 1000) + (ULL)RndSrt.wMilliseconds;
			msEnd = ((ULL)RndEnd.wHour * 60 * 60 * 1000) + ((ULL)RndEnd.wMinute * 60 * 1000) + ((ULL)RndEnd.wSecond * 1000) + (ULL)RndEnd.wMilliseconds;
			//	Jn`Ĩ~bZo
			msSrt %= (24 * 60 * 60 * 1000);
			msEnd %= (24 * 60 * 60 * 1000);
			ms = msEnd - msSrt;
			//	_ȎZo
			rnd  = (ULL)rand() * (ULL)rand();
			trg  = ms * rnd / rndmax;
			trg += msSrt;
			pSt->wHour		   = (UW)(trg / (60 * 60 * 1000));	trg %= (60 * 60 * 1000);
			pSt->wMinute	   = (UW)(trg / (	  60 * 1000));	trg %= (	 60 * 1000);
			pSt->wSecond	   = (UW)(trg / (		   1000));	trg %= (		  1000);
			pSt->wMilliseconds = (UW)(trg					);
		}
	}
	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//

//==============================================================================================================//
//	1970/1/1 00:00:00̒ʎZbɕϊ	i߂lFALSE : G[j										//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcMsilTime1970ToSysTime(UI Time1970, UIP pYear, UIP pMonth, UIP pDay, UIP pHour, UIP pMinute, UIP pSecond)
{
	BOOL		rc = FALSE;
	SYSTEMTIME	st;

	if (rc = AjcTime1970ToSysTime(Time1970, &st)) {
		*pYear	 = st.wYear;
		*pMonth	 = st.wMonth;
		*pDay	 = st.wDay;
		*pHour	 = st.wHour;
		*pMinute = st.wMinute;
		*pSecond = st.wSecond;
	}
	return rc;
}
//==============================================================================================================//
//	1970/1/1 00:00:00̒ʎZbɕϊ	i߂l-1 : G[j											//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcMsilSysTimeToTime1970(UI Year, UI Month, UI Day, UI Hour, UI Minute, UI Second)
{
	UI			rc = -1;
	SYSTEMTIME	st;

	memset(&st, 0, sizeof st);
	st.wYear	 = Year;
	st.wMonth	 = Month;
	st.wDay		 = Day;
	st.wHour	 = Hour;
	st.wMinute	 = Minute;
	st.wSecond	 = Second;
	rc = AjcSysTimeToTime1970(&st);

	return rc;
}

//==============================================================================================================//
//	tsb[J^Cɕϊ		i߂lFALSE : G[j											//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcMsilSysTimeToLocalTime(UIP pYear, UIP pMonth, UIP pDay, UIP pHour, UIP pMinute, UIP pSecond)
{
	BOOL		rc = FALSE;
	SYSTEMTIME	st, lt;

	memset(&st, 0, sizeof st);
	memset(&lt, 0, sizeof lt);

	st.wYear	 = *pYear;
	st.wMonth	 = *pMonth;
	st.wDay		 = *pDay;
	st.wHour	 = *pHour;
	st.wMinute	 = *pMinute;
	st.wSecond	 = *pSecond;

	if (rc = AjcSysTimeToLocalTime(&st, &lt)) {
		*pYear	 = lt.wYear;
		*pMonth	 = lt.wMonth;
		*pDay	 = lt.wDay;
		*pHour	 = lt.wHour;
		*pMinute = lt.wMinute;
		*pSecond = lt.wSecond;
	}
	return rc;
}

