#include	"AjcInternal.h"

//==============================================================================================================//
//	Function	:	}`j^Ŝ̋`̎擾														//
//																												//
//	Argument	:	pRect - }`j^Ŝ̋`i[obt@̃AhXisvNULL)			//
//																												//
//	Return		:	j^																					//
//==============================================================================================================//
AJCEXPORT	UI		WINAPI	AjcGetMonitorsRect(LPRECT pRect)
{
	UI				rc = 0;
	int				i;
	RECT			r;
	AJCMONITORSINFO	MonInfo;

	AjcGetMonitorsInfo(&MonInfo);
	if (MonInfo.nMon != 0) {
		r.left	 = INT_MAX;
		r.right  = INT_MIN;
		r.top	  = INT_MAX;
		r.bottom = INT_MIN;
		for (i = 0; i < MonInfo.nMon ; i++) {
			r.left	 = __min(r.left   , MonInfo.rcMon[i].left  );
			r.right  = __max(r.right  , MonInfo.rcMon[i].right );
			r.top	 = __min(r.top	  , MonInfo.rcMon[i].top   );
			r.bottom = __max(r.bottom , MonInfo.rcMon[i].bottom);
		}
		rc = MonInfo.nMon;
	}
	if (pRect != NULL) {
		memcpy(pRect, &r, sizeof(RECT));
	}
	return rc;
}

//==============================================================================================================//
//	Function	:	ej^`̎擾																	//
//																												//
//	Argument	:	pMonInfo - ej^`i[obt@̃AhX										//
//																												//
//	Return		:	j^																					//
//==============================================================================================================//
//	fBXvBʒm
static	BOOL CALLBACK cbAgmiEnumDisplay(HMONITOR hMon, HDC hdcMon, LPRECT prcMon, LPARAM lParam)
{
	BOOL				rc = TRUE;
	PAJCMONITORSINFO	pMonInfo = (PAJCMONITORSINFO)lParam;
	HMONITOR			hMonitor = NULL;
	MONITORINFOEX		MonitorInfoEx;
	POINT				pt;

	if (pMonInfo->nMon < AJCMAX_MONITORS) {
		memcpy(&pMonInfo->rcMon[pMonInfo->nMon], prcMon, sizeof(RECT));
		pt.x = (prcMon->left + prcMon->right) / 2;
		pt.y = (prcMon->top + prcMon->bottom) / 2;
		hMonitor = MonitorFromPoint(pt, MONITOR_DEFAULTTONEAREST);
		memset(&MonitorInfoEx, 0, sizeof MonitorInfoEx);
		MonitorInfoEx.cbSize = sizeof(MonitorInfoEx);
		GetMonitorInfo(hMonitor, (LPMONITORINFO)&MonitorInfoEx);
		memcpy(&pMonInfo->rcWork[pMonInfo->nMon], &MonitorInfoEx.rcWork, sizeof(RECT));
		pMonInfo->nMon++;
		rc = TRUE;
	}
	else {
		rc = FALSE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcGetMonitorsInfo(PAJCMONITORSINFO pMonInfo)
{
	int				nDisplay = 0;

	//----- j^擾 ---------------------------------------------------------------//
	nDisplay = GetSystemMetrics(SM_CMONITORS);

	if (pMonInfo != NULL) {
		//----- [NNA[ ---------------------------------------------------------//
		memset(pMonInfo, 0, sizeof(AJCMONITORSINFO));
		//----- SfBXvC̋`ݒ -----------------------------------------//
		EnumDisplayMonitors(NULL, NULL, cbAgmiEnumDisplay, (LPARAM)pMonInfo);
	}
	return	nDisplay;
}
//==============================================================================================================//
//	Function	:	vC}j^`̎擾															//
//																												//
//	Argument	:	pMonInfo - vC}j^`i[obt@̃AhX			isvNULL)		//
//					pRcWork  - vC}j^Ɨ̈`i[obt@̃AhX	isvNULL)		//
//																												//
//	Return		:	j^																					//
//==============================================================================================================//
//	R[obNp^
typedef struct {
	BOOL	rc;
	LPRECT	pRcMon;
	LPRECT	pRcWork;
} CBAGPMI, *PCBAGPMI;
//	fBXvBʒm
static	BOOL CALLBACK cbAgpmiEnumDisplay(HMONITOR hMon, HDC hdcMon, LPRECT prcMon, LPARAM lParam)
{
	BOOL				rc = TRUE;
	PCBAGPMI			pCbp = (PCBAGPMI)lParam;
	HMONITOR			hMonitor = NULL;
	MONITORINFOEX		MonitorInfoEx;
	POINT				pt;

	pt.x = (prcMon->left + prcMon->right) / 2;
	pt.y = (prcMon->top + prcMon->bottom) / 2;
	hMonitor = MonitorFromPoint(pt, MONITOR_DEFAULTTONEAREST);
	memset(&MonitorInfoEx, 0, sizeof MonitorInfoEx);
	MonitorInfoEx.cbSize = sizeof(MonitorInfoEx);
	GetMonitorInfo(hMonitor, (LPMONITORINFO)&MonitorInfoEx);
	if (MonitorInfoEx.dwFlags == MONITORINFOF_PRIMARY) {
		pCbp->rc = TRUE;
		if (pCbp->pRcMon  != NULL) memcpy(pCbp->pRcMon , &MonitorInfoEx.rcMonitor, sizeof(RECT));
		if (pCbp->pRcWork != NULL) memcpy(pCbp->pRcWork, &MonitorInfoEx.rcWork	 , sizeof(RECT));
		rc = FALSE;
	}
	else rc = TRUE;

	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcGetPrimaryMonitorInfo(LPRECT pRcMon, LPRECT pRcWork)
{
	CBAGPMI	cbp;

	//	vC}fBXvC̋`
	cbp.rc		= FALSE;
	cbp.pRcMon	= pRcMon;
	cbp.pRcWork = pRcWork;
	EnumDisplayMonitors(NULL, NULL, cbAgpmiEnumDisplay, (LPARAM)&cbp);

	return	cbp.rc;
}
//==============================================================================================================//
//	Function	:	|Cg郂j^`̎擾														//
//																												//
//	Argument	:	x, y	- |Cg																		//
//					pRcMon	- j^̋`i[obt@̃AhX		isvNULLj				//
//					prcWork - [NAA̋`i[obt@̃AhXisvNULLj				//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[^̃j^ɂĂȂ											//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcGetMonitorInfoOfPoint(int x,int y,  LPRECT pRcMon, LPRECT pRcWork)
{
	BOOL			rc = FALSE;
	UI				i, nMon;
	AJCMONITORSINFO	ifMon;

	//	ej^`擾
	nMon = AjcGetMonitorsInfo(&ifMon);
	//	郂j^
	for (i = 0; i < nMon; i++) {
		if (x >= ifMon.rcMon[i].left && x < ifMon.rcMon[i].right &&
			y >= ifMon.rcMon[i].top  && y < ifMon.rcMon[i].bottom) {
			if (pRcMon	!= NULL) memcpy(pRcMon , &ifMon.rcMon [i], sizeof(RECT));
			if (pRcWork != NULL) memcpy(pRcWork, &ifMon.rcWork[i], sizeof(RECT));
			rc = TRUE;
			break;
		}
	}
	//	ǂ̃j^ɂȂꍇ́AvC}j^̋`ݒ
	if (rc == FALSE) {
		AjcGetPrimaryMonitorInfo(pRcMon, pRcWork);
	}
	return rc;
}
//==============================================================================================================//
//	Function	:	ECh郂j^`̎擾														//
//																												//
//	Argument	:	hwnd	- EChnh																	//
//					pRcMon	- j^̋`i[obt@̃AhX										//
//					prcWork - [NAA̋`i[obt@̃AhX								//
//																												//
//	Return		:	TRUE  - 																				//
//					FALSE - G[^̃j^ɂĂȂ											//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcGetMonitorInfoOfWindow(HWND hwnd, LPRECT pRcMon, LPRECT pRcWork)
{
	BOOL			rc = FALSE;
	UI				i, nMon;
	AJCMONITORSINFO	ifMon;
	RECT			rcWnd;
	UI				sq;
	UI				sqMax = 0;
	UI				ixMax = -1;

	if (IsWindow(hwnd)) {
		//	ej^`擾
		nMon = AjcGetMonitorsInfo(&ifMon);
		//	ECh`擾
		AjcGetWindowNormalRect(hwnd, &rcWnd);
		//	郂j^
		for (i = 0; i < nMon; i++) {
			sq = AjcGetDupRect(&rcWnd, &ifMon.rcMon[i], NULL);
			if (sqMax < sq) {
				sqMax = sq;
				ixMax = i;
			}
		}
		if (ixMax != -1) {
			if (pRcMon	!= NULL) memcpy(pRcMon , &ifMon.rcMon [ixMax], sizeof(RECT));
			if (pRcWork != NULL) memcpy(pRcWork, &ifMon.rcWork[ixMax], sizeof(RECT));
			rc = TRUE;
		}
	}
	//	ǂ̃j^ɂȂ^G[̏ꍇ́AvC}j^̋`ݒ
	if (rc == FALSE) {
		AjcGetPrimaryMonitorInfo(pRcMon, pRcWork);
	}

	return rc;
}
//==============================================================================================================//
//	Function	:	ECh郂j^Ɏ܂悤ȃECh擾										//
//																												//
//	Argument	:	hwnd	- EChnh																	//
//					pPoint	- EChړ̈ʒui[obt@̃AhXisvNULL)					//
//					pSize	- ECh̕ύXTCYi[obt@̃AhXisvNULL)					//
//					pFlag	- EChύXIvVisvNULL)												//
//																												//
//	Return		:	TRUE  - EChj^𒴂Ă														//
//					FALSE - ECh̓j^Ɏ܂Ă													//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcGetWndInfoToFitOnMonitor(HWND hwnd, LPPOINT pPoint, LPSIZE pSize, UIP pFlag)
{
	BOOL	rc = FALSE;
	RECT	rcM;
	int		cxM, cyM;
	RECT	r;
	int		x, y, cx, cy;
	int		op = (SWP_NOSIZE | SWP_NOMOVE);

	if (IsWindow(hwnd)) {
		//	j^`擾
		AjcGetMonitorInfoOfWindow(hwnd, NULL, &rcM);
		cxM = rcM.right - rcM.left;
		cyM = rcM.bottom - rcM.top;
		//	ECh`擾
		GetWindowRect(hwnd, &r);
		x  = r.left;
		y  = r.top;
		cx = r.right - r.left;
		cy = r.bottom - r.top;
		//	EChTCYj^TCY傫ꍇ́AEChTCYύX
		if (cx > cxM || cy > cyM) {
			cx = __min(cx, cxM);
			cy = __min(cy, cyM);
			op &= ~SWP_NOSIZE;
		}
		//	ECh̍E[^㉺[j^𒴂ꍇ́AEChʒuύX
		if (x < rcM.left || y < rcM.top || x + cx >= rcM.right || y + cy >= rcM.bottom) {
			if (x      <  rcM.left  ) x = rcM.left;
			if (y      <  rcM.top   ) x = rcM.top;
			if (x + cx >= rcM.right ) x = (rcM.right  - cx);
			if (y + cy >= rcM.bottom) y = (rcM.bottom - cy);
			op &= ~SWP_NOMOVE;
		}
		//	EChʒuCTCYԂ
		if (op != (SWP_NOSIZE | SWP_NOMOVE)) {
			if (pPoint != NULL) {pPoint->x = x;  pPoint->y = y; }
			if (pSize  != NULL) {pSize->cx = cx; pSize->cy = cy;}
			if (pFlag  != NULL) {*pFlag = op;}
			rc = TRUE;
		}
	}
	return rc;
}
