#include	"AjcInternal.h"

//**************************************************************************************************************//
//																												//
//	Oobt@																								//
//																												//
//**************************************************************************************************************//


#define	INST_ID			0xBD659FA6
#define	IS_MY_INST(P)	(P != NULL && P->InstID == INST_ID)


//==============================================================================================================//
//	}N																									//
//==============================================================================================================//
//----- Oobt@CfNXXV ---------------------------------------------------------------------------//
#define		UPD_RINGIDX(_ix_, _len_, _siz_)	_ix_ += _len_;	if (_ix_ >= _siz_) _ix_ -= _siz_

//----- r -----------------------------------------------------------------------------------------------//
#define		AJCRNG_ENTER	if (pW->fMultiThread) EnterCriticalSection(&pW->cs);
#define		AJCRNG_LEAVE	if (pW->fMultiThread) LeaveCriticalSection(&pW->cs);

//==============================================================================================================//
//	Tu֐																								//
//==============================================================================================================//
static	UI	SubPutData	   (HAJCRNG pW, C_VOP pDat, UI lDat);
static	UI	SubPutDataEx   (HAJCRNG pW, C_VOP pDat, UI lDat);
static	UI	SubGetData	   (HAJCRNG pW, VOP pBuf, UI lDat);
static	UI	SubPeekData    (HAJCRNG pW, VOP pBuf, UI lDat);
static	VO	FreeAllQue	   (LPAJCRNG pW);
static	UI	GetRingDataSize(UI six, UI eix, UI RingBufSize, UIP plDat);
static	UI	GetRingFreeSize(UI six, UI eix, UI RingBufSize, UIP plDat);

//==============================================================================================================//
//	Oobt@ECX^X																			//
//																												//
//	@	F	pStaticBuf- X^eBbNȃOobt@̃AhXisvNULL)								//
//				lStaticBuf- X^eBbNȃOobt@̃oCgiQȏCpStaticBuf=NULL͕svj			//
//				ChunkSize - Oobt@`ÑoCg													//
//																												//
//	߂l	F	mtkk - iCX^Xnhj														//
//				mtkk - G[																				//
//==============================================================================================================//
AJCEXPORT	HAJCRNG	WINAPI	AjcRngCreate	 (VOP pStaticBuf, UI lStaticBuf, UI ChunkSize)
{
	HAJCRNG	pW = NULL;

	if (pStaticBuf == NULL	||	lStaticBuf >= 2) {
		if ((pW = (HAJCRNG)AJCMEM(sizeof(AJCRNG))) != NULL) {
			memset(pW, 0, sizeof *pW);
			pW->InstID	   = INST_ID;							//	CX^Xʂhc
			pW->DataSize   = 0;									//	Oobt@Ɋi[Ăf[^̃oCg
			pW->pStaticBuf = pStaticBuf;						//	X^eBbNȃOobt@̃AhX
			pW->lStaticBuf = lStaticBuf;						//	X^eBbNȃOobt@̃oCg
			pW->stSix = pW->stEix = 0;							//	X^eBbNEOobt@ECfNX
			pW->pQTop	= 0;									//	擪L[f[^ւ̃|C^
			pW->pQEnd	= 0;									//	L[f[^ւ̃|C^
			pW->pQBfr	= 0;									//	L[̒OL[f[^ւ̃|C^

			pW->siz		= (ChunkSize >= (AJCRNGQUE_HEADER_SIZE + 2) ? ChunkSize - AJCRNGQUE_HEADER_SIZE : 0);
			pW->fMultiThread = FALSE;
		}
	}

	return pW;
}
//==============================================================================================================//
//	Oobt@ECX^X																			//
//																												//
//	@	F	pW		  - CX^Xnh																//
//																												//
//	߂l	F	Ȃ																							//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcRngDelete(HAJCRNG pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AjcRngPurge(pW);
		if (pW->fMultiThread) {
			DeleteCriticalSection(&pW->cs);
		}
		free(pW);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	}`Xbh̋^֎~																					//
//																												//
//	@	F	pW		- CX^X[ÑAhX															//
//				fEnable - FALSE : }`Xbh֎~															//
//						  TRUE	: }`Xbh															//
//																												//
//	߂l	F	Ő^֎~																			//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcRngEnableMultiThread(HAJCRNG pW, BOOL fEnable)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		rc = pW->fMultiThread;
		if (fEnable) {
			if (!pW->fMultiThread) {
				InitializeCriticalSection(&pW->cs);
				pW->fMultiThread = TRUE;
			}
		}
		else {
			if (pW->fMultiThread) {
				pW->fMultiThread = FALSE;
				DeleteCriticalSection(&pW->cs);
			}
		}
	}
	return rc;
}

//==============================================================================================================//
//	Oobt@փf[^i[ii[Ȃꍇ́Ai[ł镪i[j								//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pDat - i[f[^̃AhX																	//
//				lDat - i[f[^̃oCg																	//
//																												//
//	߂l	F	ۂɊi[ꂽf[^oCg																	//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcRngPutData	 (HAJCRNG pW, C_VOP pDat, UI lDat)
{
	UI	rc = 0;
	UI	i, fre;
	UI	len[2];

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCRNG_ENTER
		//--- X^eBbNOobt@փf[^i[ ----------------------//
		if (pW->pStaticBuf != NULL) {
			fre = GetRingFreeSize(pW->stSix, pW->stEix, pW->lStaticBuf, len);
			if (fre != 0) {
				for (i=0; i<2 && lDat && len[i]; i++) {
					if (len[i] >= lDat) {
						memcpy(&pW->pStaticBuf[pW->stEix], pDat, lDat);
						((C_UBP)pDat) += lDat;
						UPD_RINGIDX(pW->stEix, lDat, pW->lStaticBuf);
						pW->DataSize += lDat;
						rc			 += lDat;
						lDat		  = 0;
					}
					else {
						memcpy(&pW->pStaticBuf[pW->stEix], pDat, len[i]);
						((C_UBP)pDat) += len[i];
						UPD_RINGIDX(pW->stEix, len[i], pW->lStaticBuf);
						pW->DataSize  += len[i];
						rc			  += len[i];
						lDat		  -= len[i];
					}
				}
			}
		}
		//--- cf[^Oobt@L[֊i[ ------------------------//
		if (lDat != 0) {
			if (pW->siz != 0) {
				rc += SubPutData(pW, pDat, lDat);
			}
		}
		AJCRNG_LEAVE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@L[փf[^i[ii[Ȃꍇ́Ai[ł镪i[j							//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pDat - i[f[^̃AhX																	//
//				lDat - i[f[^̃oCg																	//
//																												//
//	߂l	F	ۂɊi[ꂽf[^oCg																	//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubPutData	  (HAJCRNG pW, C_VOP pDat, UI lDat)
{
	UI			rc = 0;
	PAJCRNGQUE	pQue;
	UI			fre;
	UI			i;
	UI			len[2];

	do {
		if (lDat == 0) {
			break;
		}

		//----- Oobt@L[΁A1mۂ ---------------------------------------------------//
		if (pW->pQTop == 0) {
			if ((pW->pQTop = (PAJCRNGQUE)AJCMEM(AJCRNGQUE_HEADER_SIZE + pW->siz)) != 0) {
				pQue = pW->pQTop;
				pQue->pNxt = NULL;
				pQue->six  = pQue->eix = 0;
				pW->pQEnd  = pW->pQTop;
			}
			else {
				break;
			}
		}
		//----- ɃOobt@L[݂ꍇ́AL蓖Ă ---------------------------------//
		else {
			pQue = pW->pQEnd;
		}
		//----- Oobt@Ƀf[^i[ -----------------------------------------------------------------//
		fre = GetRingFreeSize(pQue->six, pQue->eix, pW->siz, len);
		for (i=0; i<2 && lDat && len[i]; i++) {
			if (len[i] >= lDat) {
				memcpy(&pQue->dat[pQue->eix], pDat, lDat);
				((C_UBP)pDat)		+= lDat;
				UPD_RINGIDX(pQue->eix, lDat, pW->siz);
				pW->DataSize		+= lDat;
				rc					+= lDat;
				lDat = 0;
			}
			else {
				memcpy(&pQue->dat[pQue->eix], pDat, len[i]);
				((C_UBP)pDat)		+= len[i];
				UPD_RINGIDX(pQue->eix, len[i], pW->siz);
				pW->DataSize		+= len[i];
				rc					+= len[i];
				lDat				-= len[i];
			}
		}
		//----- Sf[^Oobt@Ɏ܂ꍇ́AI ---------------------------------------------//
		if (lDat == 0) {
			break;
		}
		//----- ci[f[^ꍇ́AL[gȂAf[^i[ -------------------------------//
		while (lDat) {
			if ((pQue = (PAJCRNGQUE)AJCMEM(AJCRNGQUE_HEADER_SIZE + pW->siz)) != NULL) {
				//----- VL[Gg -----------------------------------------------------------//
				pQue->pNxt = NULL;
				pQue->six  = pQue->eix = 0;
				//----- VL[Gg𖖔֒ǉ -----------------------------------------------------------//
				pW->pQEnd->pNxt = pQue;
				pW->pQBfr		= pW->pQEnd;
				pW->pQEnd		= pQue;
				//----- i[f[^VL[Gg֊i[ -----------------------------------------------------//
				pQue->eix = __min(pW->siz - 1, lDat);
				memcpy(pQue->dat, pDat, pQue->eix);
				((UBP)pDat) += pQue->eix;
				lDat		-= pQue->eix;
				//----- Sf[^TCYXV ---------------------------------------------------------------------//
				pW->DataSize += pQue->eix;
				rc			 += pQue->eix;
			}
			else {
				break;
			}
		}

	} while(0);

	return (rc);
}
//==============================================================================================================//
//	Oobt@փf[^i[ii[Ȃꍇ́AׂĊi[Ȃj										//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pDat	 - i[f[^̃AhX																//
//				lDat	 - i[f[^̃oCg																//
//																												//
//	߂l	F	ۂɊi[ꂽf[^oCg																	//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcRngPutDataEx  (HAJCRNG pW, C_VOP pDat, UI lDat)
{
	UI	rc = 0;
	UI	SvSix, SvEix;
	UL	SvDataSize;
	UI	i, fre, sdl;
	UI	len[2];

	if (IS_MY_INST(pW) && pDat != NULL) {
		AJCRNG_ENTER
		//--- X^eBbNOobt@ޔ --------------------------//
		SvSix	   = pW->stSix;
		SvEix	   = pW->stEix;
		SvDataSize = pW->DataSize;
		//--- X^eBbNOobt@փf[^i[ ----------------------//
		if (pW->pStaticBuf != NULL) {
			fre = GetRingFreeSize(pW->stSix, pW->stEix, pW->lStaticBuf, len);
			if (fre != 0) {
				for (i=0; i<2 && lDat && len[i]; i++) {
					if (len[i] >= lDat) {
						memcpy(&pW->pStaticBuf[pW->stEix], pDat, lDat);
						((C_UBP)pDat) += lDat;
						UPD_RINGIDX(pW->stEix, lDat, pW->lStaticBuf);
						pW->DataSize += lDat;
						rc			 += lDat;
						lDat		  = 0;
					}
					else {
						memcpy(&pW->pStaticBuf[pW->stEix], pDat, len[i]);
						((C_UBP)pDat) += len[i];
						UPD_RINGIDX(pW->stEix, len[i], pW->lStaticBuf);
						pW->DataSize  += len[i];
						rc			  += len[i];
						lDat		  -= len[i];
					}
				}
			}
		}
		//--- cf[^Oobt@L[֊i[ ------------------------//
		if (lDat != 0) {
			sdl = SubPutDataEx(pW, pDat, lDat);
			if (sdl == 0) {
				 pW->stSix	  = SvSix;
				 pW->stEix	  = SvEix;
				 pW->DataSize = SvDataSize;
			}
			else {
				rc += sdl;
			}
		}
		AJCRNG_LEAVE
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@L[փf[^i[ii[Ȃꍇ́ASĊi[Ȃj									//
//																												//
//	@	F	pW		 - CX^Xnh																	//
//				pDat	 - i[f[^̃AhX																//
//				lDat	 - i[f[^̃oCg																//
//																												//
//	߂l	F	ۂɊi[ꂽf[^oCg																	//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubPutDataEx  (HAJCRNG pW, C_VOP pDat, UI lDat)
{
	UI	rc;

	UL				DataSize;
	PAJCRNGQUE		pQTop;
	PAJCRNGQUE		pQEnd;
	PAJCRNGQUE		pQBfr;
	UI				six, eix;
	PAJCRNGQUE		pQue;
	PAJCRNGQUE		pNxt;
	PAJCRNGQUE		mp;

	DataSize = pW->DataSize;				//		L[\ޔ
	pQTop	 = pW->pQTop;					//		E
	pQEnd	 = pW->pQEnd;					//		E
	pQBfr	 = pW->pQBfr;					//		E
	if (pQEnd != 0) {						//		L[H
		pQue = pQEnd;						//			Oobt@ޔ
		six = pQue->six;					//			E
		eix = pQue->eix;					//			E
	}
	rc = SubPutData(pW, pDat, lDat);		//		f[^i[
	if (rc != lDat) {						//		i[ȂH
		if (pQEnd != 0) {					//			L[f[^H
			pQue = pQEnd;					//				ǉ̐擪L[|C^ݒ
			mp	 = pQue->pNxt;				//				E
		}
		else {								//			L[ȂH
			mp = NULL;						//				ǉ̐擪L[|C^OiǉL[Ȃj
		}
		while (mp != NULL) {				//			ǉꂽ̑SL[Gg [v
			pQue = mp;						//				L[Gg
			pNxt = pQue->pNxt;				//				̃L[|C^擾
			free(mp);						//				E
			mp = pNxt;						//				̃L[|C^ݒ
		}
		pW->DataSize = DataSize;			//			L[\ɖ߂
		pW->pQTop	 = pQTop;				//			E
		pW->pQEnd	 = pQEnd;				//			E
		pW->pQBfr	 = pQBfr;				//			E
		if (pQEnd != 0) {					//			L[H
			pQue = pQEnd;					//				L[
			pQue->pNxt = 0;					//				̃L[ւ̃|C^O
			pQue->six = six;				//				Oobt@ɖ߂
			pQue->eix = eix;				//				E
		}
		rc = 0;								//			߂lii[ς݃oCgjO
	}

	return rc;
}
//==============================================================================================================//
//	Oobt@f[^oiAAamtkk̏ꍇ́Aǂ݂j							//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pBuf - of[^i[obt@̃AhX												//
//				lBuf - of[^i[obt@̃TCYioCgj									//
//																												//
//	߂l	F	of[^̃oCg																		//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcRngGetData	(HAJCRNG pW, VOP pBuf, UI lBuf)
{
	UI		rc = 0;
	UI		i, dtl, gtl;
	UI		len[2];

	if (IS_MY_INST(pW)) {
		AJCRNG_ENTER
		//--- X^eBbNOobt@f[^o ---//
		if (pW->pStaticBuf != NULL) {
			dtl  = GetRingDataSize(pW->stSix, pW->stEix, pW->lStaticBuf, len);
			if (dtl != 0) {
				for (i=0; i<2 && lBuf && len[i]; i++) {
					if (len[i] >= lBuf) {
						if (pBuf != NULL) {
							memcpy(pBuf, &pW->pStaticBuf[pW->stSix], lBuf);
							((UB*)pBuf) 	+= lBuf;
						}
						UPD_RINGIDX(pW->stSix, lBuf, pW->lStaticBuf);
						pW->DataSize		-= lBuf;
						rc					+= lBuf;
						lBuf				 = 0;
					}
					else {
						if (pBuf != NULL) {
							memcpy(pBuf, &pW->pStaticBuf[pW->stSix], len[i]);
							((UB*)pBuf) 	+= len[i];
						}
						UPD_RINGIDX(pW->stSix, len[i], pW->lStaticBuf);
						pW->DataSize		-= len[i];
						rc					+= len[i];
						lBuf				-= len[i];
					}
				}
			}
		}
		//--- cf[^Oobt@L[o -----//
		if (lBuf != 0  &&  pW->pQTop != 0) {
			rc += SubGetData(pW, pBuf, lBuf);
		}
		//--- X^eBbNOobt@[ -----------------//
		if (pW->pStaticBuf != NULL	&&	pW->pQTop != 0) {
			dtl = GetRingFreeSize(pW->stSix, pW->stEix, pW->lStaticBuf, len);
			if (dtl != 0) {
				for (i=0; i<2 && dtl && len[i]; i++) {
					if (len[i] >= dtl) {
						gtl = SubGetData(pW, &pW->pStaticBuf[pW->stEix], dtl);
						UPD_RINGIDX(pW->stEix, gtl, pW->lStaticBuf);
						pW->DataSize += gtl;
						dtl 		  = 0;
					}
					else {
						gtl = SubGetData(pW, &pW->pStaticBuf[pW->stEix], len[i]);
						UPD_RINGIDX(pW->stEix, gtl, pW->lStaticBuf);
						pW->DataSize  += gtl;
						dtl 		  -= gtl;
						if (gtl < len[i]) break;
					}
				}
			}
		}
		AJCRNG_LEAVE
	}
	return (rc);
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@L[f[^oiAAamtkk̏ꍇ́Aǂ݂j				//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pBuf - of[^i[obt@̃AhX												//
//				lBuf - of[^i[obt@̃TCYioCgj									//
//																												//
//	߂l	F	of[^̃oCg																		//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubGetData	 (HAJCRNG pW, VOP pBuf, UI lBuf)
{
	UI				rc = 0;
	PAJCRNGQUE		pQue;
	UI				i, sdl;
	UI				len[2];

	while (lBuf  &&  pW->pQTop) {
		//----- 擪L[Ggݒ	------------------------------------------------------------------------//
		pQue = pW->pQTop;
		//----- 擪L[Ggf[^o ---------------------------------------------------------//
		sdl  = GetRingDataSize(pQue->six, pQue->eix, pW->siz, len);
		for (i=0; i<2 && lBuf && len[i]; i++) {
			if (len[i] >= lBuf) {
				if (pBuf != NULL) {
					memcpy(pBuf, &pQue->dat[pQue->six], lBuf);
					((UB*)pBuf) 	+= lBuf;
				}
				UPD_RINGIDX(pQue->six, lBuf, pW->siz);
				pW->DataSize		-= lBuf;
				rc					+= lBuf;
				lBuf				 = 0;
			}
			else {
				if (pBuf != NULL) {
					memcpy(pBuf, &pQue->dat[pQue->six], len[i]);
					((UB*)pBuf) 	+= len[i];
				}
				UPD_RINGIDX(pQue->six, len[i], pW->siz);
				pW->DataSize		-= len[i];
				rc					+= len[i];
				lBuf				-= len[i];
			}
		}
		//----- 擪L[GgȂ΁AL[폜 -----------------------------------------------//
		if (pQue->six == pQue->eix) {
			pW->pQTop = pQue->pNxt;
			if		(pW->pQTop == pW->pQEnd) {
				pW->pQBfr = NULL;
			}
			else if (pW->pQTop == NULL) {
				pW->pQEnd = NULL;
			}
			free(pQue);
		}
	}

	return (rc);
}

//==============================================================================================================//
//	Oobt@擪̃f[^`																		//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pBuf - `f[^i[obt@̃AhX												//
//				lBuf - `f[^i[obt@̃TCYioCgj									//
//																												//
//	߂l	F	ۂɊi[f[^̃oCg																	//
//==============================================================================================================//
AJCEXPORT	UI	WINAPI	AjcRngPeekData	 (HAJCRNG pW, VOP pBuf, UI lBuf)
{
	UI		rc = 0;
	UI		i, dtl, six;
	UI		len[2];

	if (IS_MY_INST(pW) && pBuf != NULL) {
		AJCRNG_ENTER
		//--- X^eBbNOobt@f[^ǂݏo ---//
		if (pW->pStaticBuf != NULL) {
			dtl  = GetRingDataSize(pW->stSix, pW->stEix, pW->lStaticBuf, len);
			if (dtl != 0) {
				six = pW->stSix;
				for (i=0; i<2 && lBuf && len[i]; i++) {
					if (len[i] >= lBuf) {
						memcpy(pBuf, &pW->pStaticBuf[six], lBuf);
						((UB*)pBuf) 		+= lBuf;
						UPD_RINGIDX(six 	 , lBuf, pW->lStaticBuf);
						rc					+= lBuf;
						lBuf				 = 0;
					}
					else {
						memcpy(pBuf, &pW->pStaticBuf[six], len[i]);
						((UB*)pBuf) 		+= len[i];
						UPD_RINGIDX(six 	 , len[i], pW->lStaticBuf);
						rc					+= len[i];
						lBuf				-= len[i];
					}
				}
			}
		}
		//--- cf[^Oobt@L[ǂݏo -----//
		if (lBuf != 0  &&  pW->pQTop != 0) {
			rc += SubPeekData(pW, pBuf, lBuf);
		}
		AJCRNG_LEAVE
	}
	return (rc);
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@L[擪̃f[^`																	//
//																												//
//	@	F	pW	 - CX^Xnh																		//
//				pBuf - `f[^i[obt@̃AhX												//
//				lBuf - `f[^i[obt@̃TCYioCgj									//
//																												//
//	߂l	F	ۂɊi[f[^̃oCg																	//
//--------------------------------------------------------------------------------------------------------------//
static	UI	SubPeekData   (HAJCRNG pW, VOP pBuf, UI lBuf)
{
	UI				rc = 0;
	PAJCRNGQUE		pQue;
	UI				i, sdl;
	UI				len[2];
	PAJCRNGQUE		pQTop	 = pW->pQTop;
	PAJCRNGQUE		pQEnd	 = pW->pQEnd;
	UL				DataSize = pW->DataSize;
	UI				six;

	while (lBuf  &&  pQTop) {
		//----- 擪L[GgAhXݒ -----------------------------------------------------------------//
		pQue = pQTop;
		//----- 擪L[Ggf[^ǂ -------------------------------------------------------------//
		six  = pQue->six;
		sdl  = GetRingDataSize(pQue->six, pQue->eix, pW->siz, len);
		for (i=0; i<2 && lBuf && len[i]; i++) {
			if (len[i] >= lBuf) {
				memcpy(pBuf, &pQue->dat[six], lBuf);
				((UB*)pBuf) 		+= lBuf;
				UPD_RINGIDX(six 	 , lBuf, pW->siz);
				DataSize			-= lBuf;
				rc					+= lBuf;
				lBuf				 = 0;
			}
			else {
				memcpy(pBuf, &pQue->dat[six], len[i]);
				((UB*)pBuf) 		+= len[i];
				UPD_RINGIDX(six 	 , len[i], pW->siz);
				DataSize			-= len[i];
				rc					+= len[i];
				lBuf				-= len[i];
			}
		}
		//----- ̃L[Ggݒ -------------------------------------------------------------------------//
		if ((pQTop = pQue->pNxt) == NULL) {
			pQEnd = NULL;
		}
	}

	return (rc);
}

//==============================================================================================================//
//	Oobt@Ɋi[Ăf[^̃oCg擾													//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Oobt@Ɋi[Ăf[^̃oCg													//
//==============================================================================================================//
AJCEXPORT	UL		WINAPI	AjcRngGetDataSize(HAJCRNG pW)
{
	UL	rc = 0;

	if (IS_MY_INST(pW)) {
		AJCRNG_ENTER
		rc = pW->DataSize;
		AJCRNG_LEAVE
	}
	return rc;
}
//==============================================================================================================//
//	Oobt@Ɋi[ĂSf[^j															//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	TRUE  - OK																						//
//				FALSE - Error																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcRngPurge 	 (HAJCRNG pW)
{
	BOOL	rc = FALSE;

	if (IS_MY_INST(pW)) {
		AJCRNG_ENTER
		pW->stSix = pW->stEix = 0;
		FreeAllQue(pW);
		pW->DataSize = 0;
		AJCRNG_LEAVE
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	SL[f[^J																					//
//																												//
//	@	F	pW		- CX^Xnh																	//
//																												//
//	߂l	F	Ȃ																							//
//--------------------------------------------------------------------------------------------------------------//
static	VO	FreeAllQue(LPAJCRNG pW)
{
	PAJCRNGQUE	mp, pNxt;

	mp = pW->pQTop;
	while (mp != NULL) {
		pNxt = mp->pNxt;
		free(mp);
		mp = pNxt;
	}
	pW->pQTop = pW->pQEnd = pW->pQBfr = NULL;
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@Ɋi[Ăf[^oCg𓾂														//
//																												//
//	@	F	six, eix	- Oobt@̃f[^CfNX													//
//				RingBufSize - Oobt@TCY																//
//				plDat		- oCgi[z̃AhX													//
//						  	  len[0]=PstubÑoCgC len[1] = QndubÑoCg		//
//																												//
//	߂l	F	Oobt@Ɋi[Ăf[^̑oCg												//
//--------------------------------------------------------------------------------------------------------------//
static	UI	GetRingDataSize(UI six, UI eix, UI RingBufSize, UIP plDat)
{
	UI	rc;

	if (six == eix) {
		*plDat++ = 0;
		*plDat	 = 0;
		rc		 = 0;
	}
	else if (six < eix) {
		*plDat++ = rc = eix - six;
		*plDat	 = 0;
	}
	else {
		*plDat++ = rc = RingBufSize - six;
		*plDat	 = eix;
		rc		+= eix;
	}
	return(rc);
}
//--------------------------------------------------------------------------------------------------------------//
//	Oobt@̋f[^oCg𓾂																	//
//																												//
//	@	F	six, eix	- Oobt@̃f[^CfNX													//
//				RingBufSize - Oobt@TCY																//
//				plDat		- oCgi[z̃AhX													//
//							  len[0]=Pst󃁃ubÑoCgC len[1] = Qnd󃁃ubÑoCg	//
//																												//
//	߂l	F	Oobt@̑oCg																	//
//--------------------------------------------------------------------------------------------------------------//
static	UI	GetRingFreeSize(UI six, UI eix, UI RingBufSize, UIP plDat)
{
	UI	rc;

	if (six <= eix) {
		if (six == 0) {
			*plDat++ = rc = (RingBufSize - eix - 1);
			*plDat	 = 0;
		}
		else {
			*plDat++ = rc = RingBufSize - eix;
			*plDat	 = six - 1;
			rc		+= *plDat;
		}
	}
	else {
		*plDat++ = rc = (six - eix - 1);
		*plDat	 = 0;
	}
	return(rc);
}
