#include	"AjcInternal.h"



//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	cbp			- CX^Xnh																//
//																												//
//	߂l	F	NULL : iCX^Xnhj															//
//				NULL : s																					//
//==============================================================================================================//
AJCEXPORT	HAJCSPD	WINAPI	AjcSpdCreate(UI seed)
{
	HAJCSPD		pW = NULL;
	int			rnd;

	if (pW = (HAJCSPD)AJCMEM(sizeof(AJCSPD))) {
		memset(pW, 0, sizeof(AJCSPD));
		pW->param.vCent.x = 0.0;
		pW->param.vCent.y = 0.0;
		pW->param.vCent.z = 0.0;
		pW->param.radius  = 1.0;
		pW->param.noise   = 3.0;
		pW->param.xrot	  = 0.5;;
		pW->param.yrot	  = 0.5;
		pW->param.pitch   = 8.0;

		//	n񏉊
		if (seed != 0) {
			srand(seed);
		}

		//	]
		rnd = rand(); pW->vAxis.x = (rnd & 1) ? rnd : -rnd;
		rnd = rand(); pW->vAxis.y = (rnd & 1) ? rnd : -rnd;
		rnd = rand(); pW->vAxis.z = (rnd & 1) ? rnd : -rnd;
		AjcV3dNormal(&pW->vAxis, &pW->vAxis);
		AjcV3dMult	(&pW->vAxis, pW->param.radius, &pW->vAxis);

		//	vbg_
		rnd = rand(); pW->vPt.x = (rnd & 1) ? rnd : -rnd;
		rnd = rand(); pW->vPt.y	= (rnd & 1) ? rnd : -rnd;
		rnd = rand(); pW->vPt.z	= (rnd & 1) ? rnd : -rnd;
		AjcV3dNormal(&pW->vPt, &pW->vPt);
		AjcV3dMult	(&pW->vPt, pW->param.radius, &pW->vPt);

		pW->cnt 	= 0;
	}
	return pW;
}
//==============================================================================================================//
//	CX^X																							//
//																												//
//	@	F	pW			 - CX^Xnh																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcSpdDelete(HAJCSPD pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		free(pW);
		rc = TRUE;
	}

	return rc;
}
//==============================================================================================================//
//	p^ݒ																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pParam		 - p^̃AhX																//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcSpdSetParam(HAJCSPD pW, PCAJCSPD_PARAM pParam)
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		//	p^l
		memcpy(&pW->param, pParam, sizeof(AJCSPD_PARAM));

		//	]
		AjcV3dNormal(&pW->vAxis, &pW->vAxis);
		AjcV3dMult	(&pW->vAxis, pW->param.radius, &pW->vAxis);

		//	vbg_
		AjcV3dNormal(&pW->vPt, &pW->vPt);
		AjcV3dMult	(&pW->vPt, pW->param.radius, &pW->vPt);
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	p^擾																								//
//																												//
//	@	F	pW			 - CX^Xnh																//
//				pParam		 - p^i[obt@̃AhX												//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcSpdGetParam(HAJCSPD pW, PAJCSPD_PARAM  pBuf)
{
	BOOL	rc = FALSE;

	if (pW != NULL) {
		memcpy(pBuf, &pW->param, sizeof(AJCSPD_PARAM));
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	Z																										//
//																												//
//	@	F	pW			- CX^Xnh																//
//				pBuf		- Zʂi[obt@̃AhX												//
//																												//
//	߂l	F	TRUE  : 																					//
//				FALSE : s																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcSpdCalc(HAJCSPD pW, double *x, double *y, double *z)
{
	BOOL		rc = FALSE;
	AJC3DVEC	v;

	if (rc = AjcSpdCalcV(pW, &v)) {
		if (x != NULL) *x = v.x;
		if (y != NULL) *y = v.y;
		if (z != NULL) *z = v.z;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL	WINAPI	AjcSpdCalcV(HAJCSPD pW, PAJC3DVEC pBuf)
{
	BOOL		rc = FALSE;
	int			rnd;
	double		t, r, dl;

	if (pW != NULL) {
		//	mCYaZo
		rnd = rand();
		dl	= (pW->param.radius * pW->param.noise / 100.0) * ((double)rnd / (double)RAND_MAX);
		if (rnd & 1) r = pW->param.radius - dl;
		else		 r = pW->param.radius + dl;

		//	vbg_Zo
		AjcV3dNormal(&pW->vPt, pBuf);
		AjcV3dMult	(pBuf, r, pBuf);

		//	SʒuZ
		AjcV3dAdd(pBuf, &pW->param.vCent, pBuf);

		//	̃vbg_Zo
		if (pW->cnt < 900) {
			//	]wɉ]
			if (pW->param.xrot != 0.0) {
				t = pW->param.xrot * (double)rand() / (double)RAND_MAX;
				AjcV3dRotateX(&pW->vAxis, t, &pW->vAxis);
			}
			//	]xɉ]
			if (pW->param.xrot != 0.0) {
				t = pW->param.yrot * (double)rand() / (double)RAND_MAX;
				AjcV3dRotateY(&pW->vAxis, t, &pW->vAxis);
			}
			//	vbg_]ɉ]
			t = pW->param.pitch * (double)rand() / (double)RAND_MAX;
			AjcV3dRotateAny(&pW->vPt, t, &pW->vAxis, &pW->vPt);
			//	a𐳋K̒ɒ
			AjcV3dNormal(&pW->vPt, &pW->vPt);
			AjcV3dMult	(&pW->vPt, pW->param.radius, &pW->vPt);
		}

		//	JE^XV
		if (pW->cnt++ >= 1000) {
			pW->cnt = 0;
		}

		rc = TRUE;
	}
	return rc;
}
