#include	"AjcInternal.h"

#define	INST_ID		0x617BCC05

//--------------------------------------------------------------------------------------------------------------//
//	t@C|C^																							//
//--------------------------------------------------------------------------------------------------------------//
typedef union {
	struct {UL l, h;}	s;
	ULL					ull;
} FPOINT, *PFPOINT;

//--------------------------------------------------------------------------------------------------------------//
//	s																									//
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	UI		stl;			//	ϊsR[h̃oCg
	BC		strA[4];		//	ϊsR[h̃oCg
	WC		strW[4];		//	ϊsR[hUNICODE
} LFINFO, *PLFINFO;
typedef const LFINFO *PCLFINFO;

//--------------------------------------------------------------------------------------------------------------//
//	anl																										//
//--------------------------------------------------------------------------------------------------------------//
static	const BC	bom_utf8   [3] = {0xEF, 0xBB, 0xBF};
static	const BC	bom_utf16le[2] = {0xFF, 0xFE};
static	const BC	bom_utf16be[2] = {0xFE, 0xFF};

//--------------------------------------------------------------------------------------------------------------//
//	ŌɃI[vt@C̃eLXgGR[hޔ															//
//--------------------------------------------------------------------------------------------------------------//
__declspec(thread) static	EAJCTEC LastOpenedTec = AJCTEC_MBC;

//--------------------------------------------------------------------------------------------------------------//
//	Tu֐																								//
//--------------------------------------------------------------------------------------------------------------//
static	HAJCFILE	SubFOpenW		(C_WCP pPath, EAJCTEC tec,			  HANDLE hF);
static	HAJCFILE	SubFCreateW		(C_WCP pPath, EAJCTEC tec, BOOL fBOM, HANDLE hF);
static	BCP			SubFGetSByLineA	(HAJCFILE pW, BCP pBuf, UI lBuf);
static	BCP			SubFGetSByCharA	(HAJCFILE pW, BCP pBuf, UI lBuf);
static	WCP			SubFGetSByLineW	(HAJCFILE pW, WCP pBuf, UI lBuf);
static	WCP			SubFGetSByCharW	(HAJCFILE pW, WCP pBuf, UI lBuf);

static	UI			RevedWideCharToMultiByte(C_WCP pUni, UI lUni, BCP pMbc, UI lMbc);
static	EAJCTEC		SetTecByAuto  (HAJCFILE pW);

//	ǂݏopTu֐
static	VO			SetLfCode(HAJCFILE pW);

static	BOOL		GetLineA(HAJCFILE pW, BCP pBuf, UI lBuf);
static	BOOL		GetLineW(HAJCFILE pW, WCP pBuf, UI lBuf);

static	BOOL		SearchLFA(HAJCFILE pW, UI limit, UIP plLf, UIP plCtl);
static	BOOL		SearchLFW(HAJCFILE pW, UI limit, UIP plLf, UIP plCtl);

static	BOOL		SetToLineBufA(HAJCFILE pW, C_BCP pMbc, UI lMbc, BCP pBuf, UI lBuf);
static	BOOL		SetToLineBufW(HAJCFILE pW, C_WCP pUni, UI lUni, WCP pBuf, UI lBuf);


static	UI			CheckLFA(HAJCFILE pW, C_BCP pTxt, ULL lTxt, PLFINFO pLfInfo);
static	UI			CheckLFW(HAJCFILE pW, C_WCP pTxt, ULL lTxt, PLFINFO pLfInfo, BOOL fBE);

static	UI			ReadCharFromByteFile	(HAJCFILE pW, BC buf[8], UI bfl, BOOL *pfLF);
static	UI			ReadCharFromUnicodeFile	(HAJCFILE pW, WC buf[8], UI bfl, BOOL *pfLF);

static	UI			SetByteCharToBufA		(HAJCFILE pW, C_BCP pInp, UI lInp, BCP pBuf, UI lBuf);
static	UI			SetByteCharToBufW		(HAJCFILE pW, C_BCP pInp, UI lInp, WCP pBuf, UI lBuf);

static	UI			SetUnicodeCharToBufA	(HAJCFILE pW, C_WCP pInp, UI lInp, BCP pBuf, UI lBuf);
static	UI			SetUnicodeCharToBufW	(HAJCFILE pW, C_WCP pInp, UI lInp, WCP pBuf, UI lBuf);

static	VOP			GetFilePtrByBufA(HAJCFILE pW, ULLP pFIx);
static	VOP			GetFilePtrByBufW(HAJCFILE pW, ULLP pFIx);

//	񏑂ݗpTu֐
static	BOOL		PutDataA	(HAJCFILE pW, C_BCP pDat, UI lDat);
static	BOOL		PutDataW	(HAJCFILE pW, C_WCP pDat, UI lDat);

static	BOOL		FlushBuf	(HAJCFILE pW);
static	VO			WriteBOM	(HAJCFILE pW);

static	BOOL		WriteMbcA	(HAJCFILE pW, C_BCP pTxt, UI lTxt);
static	BOOL		WriteMbcW	(HAJCFILE pW, C_WCP pTxt, UI lTxt);

static	BOOL		WriteUtf8A	(HAJCFILE pW, C_BCP pTxt, UI lTxt);
static	BOOL		WriteUtf8W	(HAJCFILE pW, C_WCP pTxt, UI lTxt);

static	BOOL		WriteEucA	(HAJCFILE pW, C_BCP pTxt, UI lTxt);
static	BOOL		WriteEucW	(HAJCFILE pW, C_WCP pTxt, UI lTxt);

static	BOOL		WriteUniA	(HAJCFILE pW, C_BCP pTxt, UI lTxt, BOOL fBE);
static	BOOL		WriteUniW	(HAJCFILE pW, C_WCP pTxt, UI lTxt, BOOL fBE);


//==============================================================================================================//
//	̓eLXgt@CI[v																				//
//																												//
//	@	F	pPath	-	t@CpX																		//
//				tec		-	eLXgGR[h																//
//																												//
//	߂l	F	 NULLFnjieLXgt@CANZXnhj												//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFOpenA	(C_BCP pPath, EAJCTEC tec)
{
	HAJCFILE	pW = NULL;
	WC			path[MAX_PATH];

	if (pPath != NULL) {
		MultiByteToWideChar(CP_ACP, 0, pPath, -1, path, MAX_PATH);
		path[MAX_PATH - 1] = 0;
		pW = AjcFOpenW(path, tec);
	}
	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFOpenW	(C_WCP pPath, EAJCTEC tec)
{
	HAJCFILE	pW	 = NULL;

	do {
		//	pXw`FbN
		if (pPath == NULL) break;
		//	t@CI[v
		pW = SubFOpenW(pPath, tec, NULL);
	} while(0);

	return	pW;
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	HAJCFILE	SubFOpenW	(C_WCP pPath, EAJCTEC tec, HANDLE hF)
{
	HAJCFILE	pW	 = NULL;
	BOOL		fErr = FALSE;
	UL			hword = 0;
	UL			ftype = FILE_TYPE_UNKNOWN;
	BCP			pBom;

	do {
		//	GR[hʃ`FbN
		if (!MAJCTEC_VALID(tec)) tec = AJCTEC_AUTO;
		//	CX^X[N
		if ((pW = (HAJCFILE)AJCMEM(sizeof(AJCFILE))) == NULL) break;
		memset(pW, 0, sizeof(AJCFILE));
		pW->iid 	 = INST_ID;
		//	s[h
		pW->LfCnv = AJCFLF_CRLF_TO_LF;
		//	t@CI[v
		if (hF == NULL) {
			if ((pW->hFile = CreateFileW(pPath, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) {
				break;
			}
		}
		else {
			pW->hFile = hF;
		}
		//	t@C͂̎|Aݒ
		pW->fInp = TRUE;
		//	t@C^Cv擾
		ftype = GetFileType(pW->hFile);
		if (ftype == FILE_TYPE_UNKNOWN && GetLastError() != NO_ERROR) {
			break;
		}
		//	fBXNt@CȂ΁Aanl`FbNƎ
		if (ftype == FILE_TYPE_DISK) {
			union {
				struct	{UI lo, hi;} s;
				ULL					 ull;
			} u;
			//	t@CTCYݒ
			u.ull = 0;
			u.s.lo	= GetFileSize(pW->hFile, &u.s.hi);
			pW->FSizeA = u.ull;
			pW->FSizeW = pW->FSizeA / 2;
			//	t@C}bsOIuWFNg
			if ((pW->hMap = CreateFileMapping(pW->hFile, 0, PAGE_READONLY, 0, 0, NULL)) == NULL) {
				break;
			}
			//	t@C}bsO
			if ((pW->pInpTop.vop = (VOP)MapViewOfFile(pW->hMap, FILE_MAP_READ, 0, 0, 0)) == NULL) {
				break;
			}
			//	BOM`FbN
			pBom = pW->pInpTop.bcp;
			if		(pW->FSizeA >= (sizeof bom_utf8   ) && memcmp(pBom, bom_utf8   , sizeof bom_utf8   ) == 0) {	//	UTF-8
				tec 		  = AJCTEC_UTF_8;
				pW->fExistBOM = TRUE;
				pW->FIx 	  = 3;
				pW->pInp.bcp  = pW->pInpTop.bcp + 3;
			}
			else if (pW->FSizeA >= (sizeof bom_utf16le) && memcmp(pBom, bom_utf16le, sizeof bom_utf16le) == 0) {	//	UTF-16LE
				tec 		  = AJCTEC_UTF_16LE;
				pW->fExistBOM = TRUE;
				pW->FIx 	  = 1;
				pW->pInp.wcp  = pW->pInpTop.wcp + 1;
			}
			else if (pW->FSizeA >= (sizeof bom_utf16be) && memcmp(pBom, bom_utf16be, sizeof bom_utf16be) == 0) {	//	UTF-16BE
				tec 		  = AJCTEC_UTF_16BE;
				pW->fExistBOM = TRUE;
				pW->FIx 	  = 1;
				pW->pInp.wcp  = pW->pInpTop.wcp + 1;
			}
			else {																									//	anlȂ
				//	t@C|C^擪ɐݒ
				pW->FIx 	  = 0;
				pW->pInp.bcp  = pW->pInpTop.bcp;
				//	eLXgGR[hʐݒ
				if (tec == AJCTEC_AUTO) {
					tec = SetTecByAuto(pW);
				}
			}
			//	eLXgGR[hݒ
			pW->tec 	= tec;
			//	ŌɃI[vt@C̃eLXgGR[hޔ
			LastOpenedTec = tec;
			//	sݒ
			SetLfCode(pW);
		}
		//	fBXNt@CȊOȂ΃G[
		else {
			break;
		}

	} while(0);

	//	G[Ȃ΁A\[X
	if (pW != NULL) {
		if (pW->hFile		== INVALID_HANDLE_VALUE ||
			pW->hMap		== NULL 				||
			pW->pInpTop.vop == NULL) {
			if (pW->hMap  != NULL				 ) CloseHandle(pW->hMap);
			if (pW->hFile != INVALID_HANDLE_VALUE) CloseHandle(pW->hFile);
			free(pW);
			pW = NULL;
		}
	}
	return	pW;
}
//==============================================================================================================//
//	I[vσt@C̃nhgpăCX^X														//
//																												//
//	@	F	hFile	-	I[vσt@C̃nh														//
//				tec		-	eLXgGR[hʁiAJCTEC_AUTO͎wsj										//
//																												//
//	߂l	F	 NULLFnjieLXgt@CANZXnhj												//
//				 NULLFG[																					//
//==============================================================================================================//
AJCEXPORT	HAJCFILE	WINAPI	AjcFAttachOpened	(HANDLE hFile, EAJCTEC tec)
{
	HAJCFILE	pW = NULL;

	pW = SubFOpenW(NULL, tec, hFile);

	return	pW;
}
//==============================================================================================================//
//																										//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pBuf	-	ǂݏoeLXgi[obt@̃AhX										//
//				lBuf	-	ǂݏoeLXgi[obt@̕iI[(0x00)܂ށj				//
//																												//
//	߂l	F	NULL Fnjĩ͕AhX( = pBuf )j													//
//				NULL Fdne^G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcFGetSA	(HAJCFILE pW, BCP pBuf, UI lBuf)
{
	return AjcFGetSExA(pW, pBuf, lBuf, 0, NULL);
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcFGetSW	(HAJCFILE pW, WCP pBuf, UI lBuf)
{
	return AjcFGetSExW(pW, pBuf, lBuf, 0, NULL);
}
//==============================================================================================================//
//	́igj																							//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pBuf	-	ǂݏoeLXgi[obt@̃AhX										//
//				lBuf	-	ǂݏoeLXgi[obt@̕iI[(0x00)܂ށj				//
//				cbp		-	R[obNp^																//
//				cbNtcRPos - ǂݏoσoCgʒu^ʒu ʒmpR[obN֐isvNULLj				//
//																												//
//	߂l	F	NULL Fnjĩ͕AhX( = pBuf )j													//
//				NULL Fdne^G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BCP		WINAPI	AjcFGetSExA	(HAJCFILE pW, BCP pBuf, UI lBuf, UX cbp, BOOL (CALLBACK *cbNtcRPos)(ULL pos, UX cbp))
{
	BCP		rc = NULL;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp && pBuf != NULL && lBuf >= 3) {
		//	R[obN֐ݒ
		pW->cbNtcRPos = cbNtcRPos;
		//	obt@ɎceLXgꍇ́Aobt@ʒuɑΉt@C|C^ݒ
		if (pW->ixBuf < pW->BufChars) {
			//	obt@̓ǂݏoς݃f[^t@C|C^ݒ
			pW->pInp.vop = GetFilePtrByBufA(pW, &pW->FIx);
			//	ǂݏoobt@
			pW->BufChars = pW->ixBuf = 0;
		}
		//	eLXgǂݏo
		if (!AjcFEof(pW)) {		//	Not EOF?
			//	s̔FH
			if (pW->LfCnv != AJCFLF_NONE) {
				if ((rc = SubFGetSByLineA(pW, pBuf, lBuf)) == NULL || *rc == 0) {	//	sPʂœǂݏoCsH
					 rc = SubFGetSByCharA(pW, pBuf, lBuf);							//		Pʂœǂݏo
				}
			}
			//	s̔FȂH
			else {
				BCP		rsu;
				BCP		pRem = pBuf;
				int		lRem = lBuf;
				int		stl;
				//	Ps^Pǂݏo
				if ((rsu = SubFGetSByLineA(pW, pRem, lRem)) == NULL || *rsu == 0) {	//	sPʂœǂݏoCsH
					rsu = SubFGetSByCharA(pW, pRem, lRem);							//		Pʂœǂݏo
				}
				//	ǂݏoȂ΁Aobt@t܂Ōp
				if (rc = rsu) {
					//	ǂݏoeLXgobt@|C^Cobt@XV
					stl = (int)strlen(pRem);
					pRem += stl;
					lRem -= stl;
					//	obt@ɋ󂫂  IdneȂΌpēǂݏo
					while (lRem > 0 && rsu != NULL && *rsu != 0) {
						//	Ps^Pǂݏo
						if ((rsu = SubFGetSByLineA(pW, pRem, lRem)) == NULL || *rsu == 0) {	//	sPʂœǂݏoCsH
							rsu = SubFGetSByCharA(pW, pRem, lRem);							//		Pʂœǂݏo
						}
						//	ǂݏoeLXgobt@|C^Cobt@XV
						if (rsu != NULL) {
							stl = (int)strlen(pRem);
							pRem += stl;
							lRem -= stl;
						}
					}
				}
			}
		}
	}
	return rc;
}
//- - - Ps͂gC - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	BCP		SubFGetSByLineA	(HAJCFILE pW, BCP pBuf, UI lBuf)
{
	BCP		rc = NULL;

	if (GetLineA(pW, pBuf, lBuf)) {
		//	R[obNȂ΁A߂lIdne
		if (pW->cbNtcRPos == NULL) {
			rc = pBuf;
		}
		//	R[obNLȂ΁A߂lR[obN̎wɏ]
		else {
			if (pW->cbNtcRPos(pW->FIx, pW->cbp)) rc = pBuf;	//	ǂݏop
			else								 rc = NULL;	//	ǂݏo~idneԂj
		}
	}

	return rc;
}
//- - - Pɓ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	BCP		SubFGetSByCharA	(HAJCFILE pW, BCP pBuf, UI lBuf)
{
	BCP		rc	 = NULL;		//	߂l
	BOOL	fEnd = FALSE;		//	ItO
	UI		lStr = 0;			//	ǂݏooCg^[hJE^
	UI		lOut;				//	obt@ɐݒ肵̃oCg

	if (!AjcFEof(pW)) {
		rc = pBuf;				//	߂l
		lBuf--;					//	I[Z
		while (lBuf != 0 && !fEnd) {
			switch (pW->tec) {
				//	oCgt@Cǂݏo
				case AJCTEC_MBC:	case AJCTEC_UTF_8:	case AJCTEC_EUC_J:
				{	UI		lInp;
					BC		cInp[8];
					if ((lInp = ReadCharFromByteFile(pW, cInp, 8, &fEnd)) != 0) {
						if ((lOut = SetByteCharToBufA(pW, cInp, lInp, pBuf, lBuf)) != 0) {
							pBuf += lOut;
							lBuf -= lOut;
							lStr += lOut;
						}
						else {						//	obt@t
							pW->pInp.bcp -= lInp;	//		Pobt@|C^,t@C|C^߂
							pW->FIx 	 -= lInp;
							fEnd = TRUE;
						}
					}
					else {							//	dneɒBH
						if (lStr == 0) rc = NULL;	//		ǂݏof[^΁A߂ldne
						fEnd = TRUE;
					}
					break;
				}
				//	Cht@Cǂݏo
				case AJCTEC_UTF_16LE:	case AJCTEC_UTF_16BE:
				{	UI		lInp;
					WC		cInp[8];
					if ((lInp = ReadCharFromUnicodeFile(pW, cInp, 8, &fEnd)) != 0) {
						if ((lOut = SetUnicodeCharToBufA(pW, cInp, lInp, pBuf, lBuf)) != 0) {
							pBuf += lOut;
							lBuf -= lOut;
							lStr += lOut;
						}
						else {						//	obt@t
							pW->pInp.wcp -= lInp;	//		Pobt@|C^,t@C|C^߂
							pW->FIx 	 -= lInp;
							fEnd = TRUE;
						}
					}
					else {							//	dneɒBH
						if (lStr == 0) rc = NULL;	//		ǂݏof[^΁A߂ldne
						fEnd = TRUE;
					}
					break;
				}
			}
			//	͍ς݃oCgʒuʒm
			if (pW->cbNtcRPos != NULL) {
				//	R[obN̒~w`FbN
				if (!pW->cbNtcRPos(pW->FIx, pW->cbp)) {
					rc = NULL;		//	߂ldne
					break;			//	ǂݏo~
				}
			}
		}
		//	I[ݒ
		if (rc != NULL) *pBuf = 0;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WCP		WINAPI	AjcFGetSExW	(HAJCFILE pW, WCP pBuf, UI lBuf, UX cbp, BOOL (CALLBACK *cbNtcRPos)(ULL pos, UX cbp))
{
	WCP		rc = NULL;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp && pBuf != NULL && lBuf >= 3) {
		//	R[obN֐ݒ
		pW->cbNtcRPos = cbNtcRPos;
		//	obt@ɎceLXgꍇ́Aobt@ʒuɑΉt@C|C^ݒ
		if (pW->ixBuf < pW->BufChars) {
			//	obt@̓ǂݏoς݃f[^t@C|C^ݒ
			pW->pInp.vop = GetFilePtrByBufW(pW, &pW->FIx);
			//	ǂݏoobt@
			pW->BufChars = pW->ixBuf = 0;
		}
		//	eLXgǂݏo
		if (!AjcFEof(pW)) {		//	Not EOF?
			//	s̔FH
			if (pW->LfCnv != AJCFLF_NONE) {
				if ((rc = SubFGetSByLineW(pW, pBuf, lBuf)) == NULL || *rc == 0) {	//	sPʂœǂݏoCsH
					 rc = SubFGetSByCharW(pW, pBuf, lBuf);							//		Pʂœǂݏo
				}
			}
			//	s̔FȂH
			else {
				WCP		rsu;
				WCP		pRem = pBuf;
				int		lRem = lBuf;
				int		stl;
				//	Ps^Pǂݏo
				if ((rsu = SubFGetSByLineW(pW, pRem, lRem)) == NULL || *rsu == 0) {	//	sPʂœǂݏoCsH
					rsu = SubFGetSByCharW(pW, pRem, lRem);							//		Pʂœǂݏo
				}
				//	ǂݏoȂ΁Aobt@t܂Ōp
				if (rc = rsu) {
					//	ǂݏoeLXgobt@|C^Cobt@XV
					stl = (int)wcslen(pRem);
					pRem += stl;
					lRem -= stl;
					//	obt@ɋ󂫂  IdneȂΌpēǂݏo
					while (lRem > 0 && rsu != NULL && *rsu != 0) {
						//	Ps^Pǂݏo
						if ((rsu = SubFGetSByLineW(pW, pRem, lRem)) == NULL || *rsu == 0) {	//	sPʂœǂݏoCsH
							rsu = SubFGetSByCharW(pW, pRem, lRem);							//		Pʂœǂݏo
						}
						//	ǂݏoeLXgobt@|C^Cobt@XV
						if (rsu != NULL) {
							stl = (int)wcslen(pRem);
							pRem += stl;
							lRem -= stl;
						}
					}
				}
			}
		}
	}
	return rc;
}
//- - - Ps͂gC - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	WCP		SubFGetSByLineW	(HAJCFILE pW, WCP pBuf, UI lBuf)
{
	WCP		rc = NULL;

	if (GetLineW(pW, pBuf, lBuf)) {
		//	R[obNȂ΁A߂lIdne
		if (pW->cbNtcRPos == NULL) {
			rc = pBuf;
		}
		//	R[obNLȂ΁A߂lR[obN̎wɏ]
		else {
			if (pW->cbNtcRPos(pW->FIx, pW->cbp)) rc = pBuf;	//	ǂݏop
			else								 rc = NULL;	//	ǂݏo~idneԂj
		}
	}

	return rc;
}
//- - - Pɓ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -//
static	WCP		SubFGetSByCharW	(HAJCFILE pW, WCP pBuf, UI lBuf)
{
	WCP		rc = NULL;
	BOOL	fEnd = FALSE;
	UI		lStr = 0;			//	ǂݏooCg^[hJE^
	UI		lOut;				//	obt@ɐݒ肵̃[h

	if (!AjcFEof(pW)) {
		rc = pBuf;				//	߂l
		lBuf--;					//	I[Z
		while (lBuf != 0 && !fEnd) {
			switch (pW->tec) {
				//	oCgt@Cǂݏo
				case AJCTEC_MBC:	case AJCTEC_UTF_8:	case AJCTEC_EUC_J:
				{	int		lInp;
					BC		cInp[8];
					if ((lInp = ReadCharFromByteFile(pW, cInp, 8, &fEnd)) != 0) {
						if ((lOut = SetByteCharToBufW(pW, cInp, lInp, pBuf, lBuf)) != 0) {
							pBuf += lOut;
							lBuf -= lOut;
							lStr += lOut;
						}
						else {						//	obt@t
							pW->pInp.bcp -= lInp;	//		Pobt@|C^,t@C|C^߂
							pW->FIx 	 -= lInp;
							fEnd = TRUE;
						}
					}
					else {							//	dneɒBH
						if (lStr == 0) rc = NULL;	//		ǂݏof[^΁A߂ldne
						fEnd = TRUE;
					}
					break;
				}
				//	Cht@Cǂݏo
				case AJCTEC_UTF_16LE:	case AJCTEC_UTF_16BE:
				{	int		lInp;
					WC		cInp[8];
					if ((lInp = ReadCharFromUnicodeFile(pW, cInp, 8, &fEnd)) != 0) {
						if ((lOut = SetUnicodeCharToBufW(pW, cInp, lInp, pBuf, lBuf)) != 0) {
							pBuf += lOut;
							lBuf -= lOut;
							lStr += lOut;
						}
						else {						//	obt@t
							pW->pInp.wcp -= lInp;	//		Pobt@|C^,t@C|C^߂
							pW->FIx 	 -= lInp;
							fEnd = TRUE;
						}
					}
					else {							//	dneɒBH
						if (lStr == 0) rc = NULL;	//		ǂݏof[^΁A߂ldne
						fEnd = TRUE;
					}
					break;
				}
			}
			//	͍ςݕʒuʒm
			if (pW->cbNtcRPos != NULL) {
				//	R[obN̒~w`FbN
				if (!pW->cbNtcRPos(pW->FIx, pW->cbp)) {
					rc	 = NULL;			//	߂ldne
					fEnd = TRUE;
				}
			}
		}
		//	I[ݒ
		if (rc != NULL) *pBuf = 0;
	}
	return rc;
}

//==============================================================================================================//
//	P																									//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	 -1 FnjiR[hj																		//
//				 -1 Fdne^G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI			WINAPI	AjcFGetCodeA	(HAJCFILE pW)
{
	UI		rc = -1;
	UI		rsu;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		//	obt@̍ŌɓǂݏooCgA}`oCgPoCgڂȂΕ̐擪ɖ߂
		if (pW->ixBuf < pW->BufChars) {
			if (pW->ixBuf >= 1 && MAjcMbsBTypeA(pW->buf.mbc, pW->ixBuf - 1) == _MBC_LEAD) {
				pW->ixBuf--;
			}
		}
		//	P
		if ((rsu = AjcFGetCA(pW)) != -1) {					//	PoCǵCdneȊOH
			if (MAjcIsLeadA((BC)rsu)) {						//		SpPځH
				union {
					BC	bc[2];
					UW	uw;
				} u;
				u.bc[0] = (BC)rsu;							//			SpPڐݒ
				if ((rsu = AjcFGetCA(pW)) != -1) {			//			oCǵCdneȊOH
					u.bc[1] = (BC)rsu;						//				SpQoCgڐݒ
					rc = u.uw;								//				߂lSpR[h
				}
			}
			else if (rsu != (UB)-1) {						//		oCgH
				rc = (UB)rsu;								//			߂loCgR[h
			}
		}
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	UI		WINAPI	AjcFGetCodeW	(HAJCFILE pW)
{
	UI		rc = -1;
	UI		rsu;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		//	obt@̍Ōɓǂݏo[hATQ[gP[hڂȂΕ̐擪ɖ߂
		if (pW->ixBuf < pW->BufChars) {
			if (pW->ixBuf >= 1 && MAjcIsLeadW(pW->buf.uni[pW->ixBuf - 1])) {
				pW->ixBuf--;
			}
		}
		//	P
		if ((rsu = AjcFGetCW(pW)) != (WC)-1) {				//	P[h́CdneȊOH
			if (MAjcIsLeadW((WC)rsu)) {						//		TQ[gP[hځH
				WC		wc[2];
				wc[0] = (WC)rsu;							//			TQ[gP[hڐݒ
				if ((rsu = AjcFGetCW(pW)) != (WC)-1) {		//			[h́CdneȊOH
					wc[1] = (WC)rsu;						//				TQ[gQ[hڐݒ
					rc = AjcTextToCodePoint(wc);			//				߂lTQ[g̃R[h|Cg
				}
			}
			else if (rsu != (UW)-1) {						//		TQ[gH
				rc = (WC)rsu;								//			߂lTQ[g̃R[h|Cg
			}
		}
	}
	return	rc;
}
//==============================================================================================================//
//	PoCg^P[h																						//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	 -1 FnjiPoCg^P[hf[^j														//
//				 -1 Fdne^G[																			//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BC			WINAPI	AjcFGetCA	(HAJCFILE pW)
{
	BC		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) {
			rc = pW->buf.mbc[pW->ixBuf++];
		}
		else {
			pW->BufFIx = pW->FIx;
			if (SubFGetSByCharA(pW, pW->buf.mbc, AJCTF_MAX_BUFA)) {
				pW->ixBuf = 0;
				if (pW->BufChars = (UI)strlen(pW->buf.mbc)) {
					rc = (BC)pW->buf.mbc[pW->ixBuf++];
				}
			}
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	WC			WINAPI	AjcFGetCW	(HAJCFILE pW)
{
	WC		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) {
			rc = pW->buf.uni[pW->ixBuf++];
		}
		else {
			pW->BufFIx = pW->FIx;
			if (SubFGetSByCharW(pW, pW->buf.uni, AJCTF_MAX_BUFW)) {
				pW->ixBuf = 0;
				if (pW->BufChars = (UI)wcslen(pW->buf.uni)) {
					rc = (WC)pW->buf.uni[pW->ixBuf++];
				}
			}
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@Cǂݏo|Cg擾																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	 -1 F݂̃t@CǂݏoʒuioCgʒu^ʒuj										//
//				 -1 FG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFGetPointA(HAJCFILE pW)
{
	ULL		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) GetFilePtrByBufA(pW, &rc);
		else						  rc = pW->FIx;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFGetPointW(HAJCFILE pW)
{
	ULL		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) GetFilePtrByBufW(pW, &rc);
		else						  rc = pW->FIx;
	}
	return rc;
}
//==============================================================================================================//
//	t@CǂݏooCg|Cg擾																			//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	 -1 F݂̃t@CǂݏoʒuioCgʒu^ʒuj										//
//				 -1 FG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFGetBytePointA(HAJCFILE pW)
{
	ULL		rc = -1;

	if ((rc = AjcFGetPointA(pW)) != -1) {
		if (pW->tec == AJCTEC_UTF_16LE || pW->tec == AJCTEC_UTF_16BE) {
			rc *= 2;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFGetBytePointW(HAJCFILE pW)
{
	ULL		rc = -1;

	if ((rc = AjcFGetPointW(pW)) != -1) {
		if (pW->tec == AJCTEC_UTF_16LE || pW->tec == AJCTEC_UTF_16BE) {
			rc *= 2;
		}
	}
	return rc;
}
//==============================================================================================================//
//	t@Cǂݏo|Cgݒ																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				point	-	ݒ肷t@CǂݏoʒuioCgʒu^ʒuj								//
//																												//
//	߂l	F	TRUE F																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFSetPoint(HAJCFILE pW, ULL point)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->tec == AJCTEC_MBC || pW->tec == AJCTEC_UTF_8 || pW->tec == AJCTEC_EUC_J) {
			point 		 = __min(pW->FSizeA, point);
			pW->FIx 	 = point;
			pW->pInp.bcp = pW->pInpTop.bcp + point;
		}
		else {
			point 		 = __min(pW->FSizeW, point);
			pW->FIx 	 = point;
			pW->pInp.wcp = pW->pInpTop.wcp + point;
		}
		pW->BufChars = 0;
		pW->ixBuf	 = 0;
		rc = TRUE;
	}
	return rc;
}
//==============================================================================================================//
//	t@Cǂݏo|Cgޔ																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	 -1 Fޔt@C̓ǂݏoʒuioCgʒu^ʒuj									//
//				 -1 FG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFSavePointA(HAJCFILE pW)
{
	ULL		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) {
			pW->Sv_pInp.vop = GetFilePtrByBufA(pW, &pW->Sv_FIx);
		}
		else {
			pW->Sv_pInp.vop = pW->pInp.vop;
			pW->Sv_FIx	= pW->FIx;
		}
		rc = pW->Sv_FIx;
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	ULL		WINAPI	AjcFSavePointW(HAJCFILE pW)
{
	ULL		rc = -1;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->ixBuf < pW->BufChars) {
			pW->Sv_pInp.vop = GetFilePtrByBufW(pW, &pW->Sv_FIx);
		}
		else {
			pW->Sv_pInp.vop = pW->pInp.vop;
			pW->Sv_FIx	= pW->FIx;
		}
		rc = pW->Sv_FIx;
	}
	return rc;
}
//==============================================================================================================//
//	t@Cǂݏo|Cg																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFRecvPoint(HAJCFILE pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		if (pW->Sv_pInp.vop != NULL) {
			pW->FIx 	 = pW->Sv_FIx;
			pW->pInp.vop = pW->Sv_pInp.vop;
			pW->BufChars = 0;
			pW->ixBuf	 = 0;
			rc = TRUE;
		}
	}
	return rc;
}

//==============================================================================================================//
//	t@Cdne`FbN																						//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE Fdne																					//
//				FALSEFdneȊO																				//
//==============================================================================================================//
AJCEXPORT	BOOL	WINAPI	AjcFEof(HAJCFILE pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && pW->fInp) {
		switch (pW->tec) {
			case AJCTEC_MBC:
			case AJCTEC_UTF_8:
			case AJCTEC_EUC_J:
				rc = (pW->FIx >= pW->FSizeA);
				break;

			case AJCTEC_UTF_16LE:
			case AJCTEC_UTF_16BE:
				rc = (pW->FIx >= pW->FSizeW);
				break;
		}
	}
	return rc;
}
//==============================================================================================================//
//	o̓eLXgt@C																					//
//																												//
//	@	F	pPath	-	t@CpX																		//
//				tec		-	eLXgGR[h																//
//				fBOM	-	BOMo̓tO																		//
//																												//
//	߂l	F	 NULLFnjieLXgt@CANZXnhj												//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFCreateA	(C_BCP pPath, EAJCTEC tec, BOOL fBOM)
{
	HAJCFILE	pW = NULL;
	WC			path[MAX_PATH];

	if (pPath != NULL) {
		MultiByteToWideChar(CP_ACP, 0, pPath, -1, path, MAX_PATH);
		path[MAX_PATH - 1] = 0;
		pW = AjcFCreateW(path, tec, fBOM);
	}
	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFCreateW	(C_WCP pPath, EAJCTEC tec, BOOL fBOM)
{
	HAJCFILE	pW = NULL;

	do {
		//	pXw`FbN
		if (pPath == NULL) break;
		//	t@C
		pW = SubFCreateW(pPath, tec, fBOM, NULL);
	} while(0);

	return	pW;
}
//----- ʃTu -----------------------------------------------------------------------------------------------//
static	HAJCFILE	SubFCreateW	(C_WCP pPath, EAJCTEC tec, BOOL fBOM, HANDLE hF)
{
	HAJCFILE	pW = NULL;
	UL			HiWord = 0;

	do {
		//	GR[hʃ`FbN
		if (!MAJCTEC_VALID(tec)) tec = AJCTEC_AUTO;
		//	AUTȌꍇAŌɃI[veLXgGR[hݒ
		if (tec == AJCTEC_AUTO) {
			tec = LastOpenedTec;
		}
		//	CX^X[N
		if ((pW 		 = (HAJCFILE)AJCMEM(sizeof(AJCFILE))) == NULL) break;
		memset(pW, 0, sizeof(AJCFILE));
		//	CX^X[N
		pW->iid 	= INST_ID;
		//	s[h
		pW->LfCnv = AJCFLF_LF_TO_CRLF;
		//	eLXgGR[hݒ
		pW->tec 	= tec;
		//	t@Co̓[h̎|Aݒ
		pW->fInp	= FALSE;
		//	anlo̓[hݒ
		pW->fBomOut	= fBOM;
		//	o̓eLXg[oCg^[[hȂ̎|ݒ
		pW->SvOutC	= 0;
		//	eLXgobt@TCY
		pW->lFmtBuf = 2048;
		//	t@CnhwȂ΁At@C
		if (hF == NULL || hF == INVALID_HANDLE_VALUE) {
			if (pPath == NULL || (pW->hFile = CreateFileW(pPath, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE) {
				free(pW);
				pW = NULL;
				break;
			}
		}
		//	t@CnhwȂ΁Anhݒ
		else {
			//	t@Cnhݒ
			pW->hFile = hF;
			//	t@C|C^擪ȊOȂ΁Aanlo͎
			HiWord = 0;
			if (SetFilePointer(hF, 0, &HiWord, FILE_CURRENT) != 0 || HiWord != 0) {
				pW->fBomOut = FALSE;
			}
		}
	} while(0);

	return	pW;
}
//==============================================================================================================//
//	ǋL[hŃt@C																					//
//																												//
//	@	F	pPath	-	t@CpX																		//
//				tec		-	eLXgGR[h																//
//				fBOM	-	BOMo̓tO																		//
//																												//
//	߂l	F	 NULLFnjieLXgt@CANZXnhj												//
//				 NULLFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFAppendA	(C_BCP pPath, EAJCTEC tec, BOOL fBOM)
{
	HAJCFILE	pW = NULL;
	WC			path[MAX_PATH];

	if (pPath != NULL) {
		MultiByteToWideChar(CP_ACP, 0, pPath, -1, path, MAX_PATH);
		path[MAX_PATH - 1] = 0;
		pW = AjcFAppendW(path, tec, fBOM);
	}
	return pW;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	HAJCFILE	WINAPI	AjcFAppendW	(C_WCP pPath, EAJCTEC tec, BOOL fBOM)
{
	HAJCFILE	pW	   = NULL;
	HANDLE		hFile  = INVALID_HANDLE_VALUE;

	if (pPath != NULL) {
		//	t@C݂ꍇ́At@C݃[hŃI[v
		if (AjcPathIsFile(pPath)) {
			//	GR[hݒȂ΁At@CGR[hݒ
			if (tec == AJCTEC_AUTO) {
				ULL	fsz = 0;
				//	t@CTCY擾
				fsz = AjcGetFileSize(pPath);
				//	t@CTCYO΂ȁAŌɃI[vt@C̃GR[hݒ
				if (fsz == 0) {
					tec = LastOpenedTec;
				}
				//	t@CTCYOȂ΁At@C̓eGR[h`FbN
				else {
					HAJCFILE	hF = NULL;
					if ((hF = AjcFOpen(pPath, AJCTEC_AUTO)) != NULL) {
						tec = AjcFGetTec(hF);
						AjcFClose(hF);
					}
					else {
						tec = LastOpenedTec;
					}
				}
			}
			if ((hFile = CreateFileW(pPath, GENERIC_WRITE, 0, NULL, OPEN_EXISTING, 0, NULL)) != INVALID_HANDLE_VALUE) {
				UL lo = 0;
				SL hi = 0;
				//	t@C|C^𖖔ɐݒ
				SetFilePointer(hFile, 0, &hi, FILE_END);
				if (GetLastError() == NO_ERROR) {
					//	σt@C̃nhgpăCX^X
					pW = AjcFAttachCreated(hFile, tec, fBOM);
				}
				else {
					CloseHandle(hFile);
				}
			}
		}
		//	t@C݂Ȃꍇ́At@CVɐ
		else {
			pW = AjcFCreateW(pPath, tec, fBOM);
		}
	}
	return pW;
}

//==============================================================================================================//
//	σt@C̃nhgpăCX^X															//
//																												//
//	@	F	hFile	-	σt@C̃nh															//
//				tec		-	eLXgGR[h																//
//				fBOM	-	BOMo̓tO																		//
//																												//
//	߂l	F	 NULLFnjieLXgt@CANZXnhj												//
//				 NULLFG[																					//
//==============================================================================================================//
AJCEXPORT	HAJCFILE	WINAPI	AjcFAttachCreated	(HANDLE hFile, EAJCTEC tec, BOOL fBOM)
{
	return SubFCreateW(NULL, tec, fBOM, hFile);
}

//==============================================================================================================//
//	o																									//
//																												//
//	@	F	hFile	-	eLXgt@CANZXnh													//
//				pText	-	o͂镶̃AhX															//
//				lText	-	o͂镶̃oCg^i|PFZoj									//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutSA	(HAJCFILE pW, C_BCP pText, UI lText)
{
	BOOL		rc = TRUE;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pText != NULL && lText != 0) {
		WriteBOM(pW);	//	anlo
		switch (pW->tec) {
			case AJCTEC_MBC:		rc = WriteMbcA 	(pW, pText, lText);			break;
			case AJCTEC_UTF_8:		rc = WriteUtf8A	(pW, pText, lText);			break;
			case AJCTEC_EUC_J:		rc = WriteEucA	(pW, pText, lText);			break;
			case AJCTEC_UTF_16LE:	rc = WriteUniA	(pW, pText, lText, FALSE);	break;
			case AJCTEC_UTF_16BE:	rc = WriteUniA	(pW, pText, lText, TRUE);	break;
		}
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutSW	(HAJCFILE pW, C_WCP pText, UI lText)
{
	BOOL	rc = TRUE;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pText != NULL && lText != 0) {
		WriteBOM(pW);	//	anlo
		switch (pW->tec) {
			case AJCTEC_MBC:		rc = WriteMbcW	(pW, pText, lText);			break;
			case AJCTEC_UTF_8:		rc = WriteUtf8W	(pW, pText, lText);			break;
			case AJCTEC_EUC_J:		rc = WriteEucW	(pW, pText, lText);			break;
			case AJCTEC_UTF_16LE:	rc = WriteUniW	(pW, pText, lText, FALSE);	break;
			case AJCTEC_UTF_16BE:	rc = WriteUniW	(pW, pText, lText, TRUE);	break;
		}
	}
	return	rc;
}

//==============================================================================================================//
//	PoCg^P[ho																						//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				c		-	o͂oCg^[hf[^														//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutCA	(HAJCFILE pW, BC c)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp) {
		//	anlo
		WriteBOM(pW);
		//	}`oCgPڑޔH
		if (pW->SvOutC != 0) {
			BC		mbc[2];
			mbc[0] = (BC)((UB)pW->SvOutC);
			mbc[1] = c;
			pW->SvOutC = 0;
			rc = AjcFPutSA(pW, mbc, 2);
		}
		//	}`oCgPڑޔȂH
		else {
			if (MAjcIsLeadA(c)) {			//	}`oCgPoCgځH
				pW->SvOutC = c;
				rc = TRUE;
			}
			else {							//	PoCgH
				rc = AjcFPutSA(pW, &c, 1);
			}
		}
		rc = TRUE;
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutCW	(HAJCFILE pW, WC c)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp) {
		//	anlo
		WriteBOM(pW);
		//	TQ[gyAPڑޔH
		if (pW->SvOutC != 0) {
			WC		mwc[2];
			mwc[0] = (WC)pW->SvOutC;
			mwc[1] = c;
			pW->SvOutC = 0;
			rc = AjcFPutSW(pW, mwc, 2);
		}
		//	TQ[gyAPڑޔȂH
		else {
			if (MAjcIsLeadW(c)) {			//	TQ[gyAP[hځH
				pW->SvOutC = c;
				rc = TRUE;
			}
			else {							//	P[hH
				rc = AjcFPutSW(pW, &c, 1);
			}
		}
	}
	return	rc;
}


//==============================================================================================================//
//	Po																									//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				c		-	o͂镶																		//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutCodeA	(HAJCFILE pW, UI c)
{
	BOOL	rc = FALSE;
	union {
		BC	mbc[2];
		UW	uw;
	} u;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp) {
		//	anlo
		WriteBOM(pW);
		//	o
		u.uw = (UW)c;
		rc = AjcFPutSA(pW, u.mbc, 2);
	}
	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPutCodeW	(HAJCFILE pW, UI c)
{
	BOOL	rc = FALSE;
	WC		uni[4] = {0};

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp) {
		//	anlo
		WriteBOM(pW);
		//	o
		AjcCodePointToText(c, uni);
		rc = AjcFPutSW(pW, uni, -1);
	}
	return	rc;
}

//==============================================================================================================//
//	óiόp^wj																		//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pFmt	-																				//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPrintFA	(HAJCFILE pW, C_BCP pFmt, ...)
{
	int		rc = 0;
	va_list vls;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pFmt != NULL) {
		//	o
		va_start(vls, pFmt);
		rc = AjcFVPrintFA(pW, pFmt, vls);
		va_end	(vls);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFPrintFW	(HAJCFILE pW, C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pFmt != NULL) {
		//	o
		va_start(vls, pFmt);
		rc = AjcFVPrintFW(pW, pFmt, vls);
		va_end	(vls);
	}
	return rc;
}
//==============================================================================================================//
//	óiόp^̃|C^wj																//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pFmt	-																				//
//				vls		-	ό̐擪|C^															//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFVPrintFA	(HAJCFILE pW, C_BCP pFmt, va_list vls)
{
	int		rc = 0;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pFmt != NULL) {
		//	obt@m
		if (pW->pFmtBuf.bcp == NULL) {
			pW->pFmtBuf.bcp = (BCP)AJCMEM(pW->lFmtBuf * 2);	// obt@̓ChŊm
		}
		//	쐬Ct@Co
		if (pW->pFmtBuf.bcp != NULL) {
			//	쐬
			pW->pFmtBuf.bcp[pW->lFmtBuf - 1] = 0;
			_vsnprintf(pW->pFmtBuf.bcp, pW->lFmtBuf, pFmt, vls);
			if (pW->pFmtBuf.bcp[pW->lFmtBuf - 1] == 0) {
				rc = TRUE;
			}
			else {
				pW->pFmtBuf.bcp[pW->lFmtBuf - 1] = 0;
				rc = FALSE;
			}
			//	t@C
			rc &= AjcFPutSA(pW, pW->pFmtBuf.bcp, -1);
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFVPrintFW	(HAJCFILE pW, C_WCP pFmt, va_list vls)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && !pW->fInp && pFmt != NULL) {
		//	obt@m
		if (pW->pFmtBuf.wcp == NULL) {
			pW->pFmtBuf.wcp = (WCP)AJCMEM(pW->lFmtBuf * 2);
		}
		//	쐬Ct@Co
		if (pW->pFmtBuf.wcp != NULL) {
			//	쐬
			pW->pFmtBuf.wcp[pW->lFmtBuf - 1] = 0;
			_vsnwprintf(pW->pFmtBuf.wcp, pW->lFmtBuf, pFmt, vls);
			if (pW->pFmtBuf.wcp[pW->lFmtBuf - 1] == 0) {
				rc = TRUE;
			}
			else {
				pW->pFmtBuf.wcp[pW->lFmtBuf - 1] = 0;
				rc = FALSE;
			}
			//	t@C
			rc &= AjcFPutSW(pW, pW->pFmtBuf.wcp, -1);
		}
	}
	return rc;
}

//==============================================================================================================//
//	eLXgt@CN[Y																					//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFClose	(HAJCFILE pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID) {
		//	o̓f[^tbV
		FlushBuf(pW);
		//	\[X
		if (pW->pFmtBuf.bcp != NULL 			   ) free(pW->pFmtBuf.bcp);
		if (pW->pInpTop.vop	!= NULL 			   ) UnmapViewOfFile(pW->pInpTop.vop);
		if (pW->hMap		!= NULL 			   ) CloseHandle	(pW->hMap		);
		if (pW->hFile		!= INVALID_HANDLE_VALUE) CloseHandle	(pW->hFile		);
		free(pW);
		rc = TRUE;
	}
	return	rc;
}
//==============================================================================================================//
//	eLXgt@CN[YȂŃCX^X															//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFDetach	(HAJCFILE pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID) {
		//	o̓f[^tbV
		FlushBuf(pW);
		//	\[XiVXẽt@Cnh͏j
		if (pW->pFmtBuf.bcp != NULL) free(pW->pFmtBuf.bcp);
		if (pW->pInpTop.vop	!= NULL) UnmapViewOfFile(pW->pInpTop.vop);
		if (pW->hMap		!= NULL) CloseHandle	(pW->hMap		);
		free(pW);
		rc = TRUE;
	}
	return	rc;
}
//==============================================================================================================//
//	sR[hϊ[hݒ																					//
//																												//
//	@	F	pW			-	eLXgt@CANZXnh												//
//				InpLfMode	- 	͉s[h																	//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcFSetLfConv (HAJCFILE  pW, AJCFLFCONV mode)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID) {
		if (mode >= AJCFLFCONV_MIN && mode <= AJCFLFCONV_MAX) {
			//	sR[hϊ[hݒ
			pW->LfCnv = mode;
			//	sݒ
			SetLfCode(pW);
			//	߂lnj
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	sR[hϊ[h擾																					//
//																												//
//	@	F	pW			-	eLXgt@CANZXnh												//
//				InpLfMode	- 	͉s[h																	//
//																												//
//	߂l	F	 0 F͉s[h																			//
//				 0 FG[																					//
//==============================================================================================================//
AJCEXPORT	AJCFLFCONV	WINAPI	AjcFGetLfConv (HAJCFILE  pW)
{
	AJCFLFCONV	rc = 0;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->LfCnv;
	}
	return rc;
}


//==============================================================================================================//
//	o͉s[hݒ																							//
//																												//
//	@	F	pW			-	eLXgt@CANZXnh												//
//				InpLfMode	- 	͉s[h																	//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFG[																					//
//==============================================================================================================//
AJCEXPORT	BOOL			WINAPI	AjcFSetOutLfMode	(HAJCFILE pW, AJCFLFCONV mode)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID) {
		if (mode >= AJCFOLF_MIN && mode <= AJCFOLF_MAX) {
			pW->LfCnv = mode;
			rc = TRUE;
		}
	}
	return rc;
}
//==============================================================================================================//
//	o͉s[h擾																							//
//																												//
//	@	F	pW			-	eLXgt@CANZXnh												//
//																												//
//	߂l	F	 0 Fo͉s[h																			//
//				 0 FG[																					//
//==============================================================================================================//
AJCEXPORT	AJCFLFCONV	WINAPI	AjcFGetOutLfMode	(HAJCFILE pW)
{
	AJCFLFCONV	rc = 0;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->LfCnv;
	}
	return rc;
}


//==============================================================================================================//
//	eLXgGR[hʎ擾																					//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	eLXgGR[h																			//
//==============================================================================================================//
AJCEXPORT	EAJCTEC		WINAPI	AjcFGetTec	(HAJCFILE pW)
{
	EAJCTEC		rc = AJCTEC_ERROR;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->tec;
	}
	return	rc;
}
//==============================================================================================================//
//	̓t@ĈanlL̎擾																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE  - ̓t@Cɂanl																//
//				FALSE - ̓t@CɂanlȂ																//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFGetBOM	(HAJCFILE pW)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->fExistBOM;
	}
	return	rc;
}
//==============================================================================================================//
//	t@Co͎ʎ擾																						//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	TRUE  - ̓[h																				//
//				FALSE - o̓[h																				//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFIsModeInput(HAJCFILE pW)
{
	BOOL		rc = TRUE;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->fInp;
	}
	return	rc;
}
//==============================================================================================================//
//	obt@TCYݒ																				//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				len 	-	obt@iPUȏj													//
//																												//
//	߂l	F	eLXgGR[h																			//
//==============================================================================================================//
AJCEXPORT	BOOL		WINAPI	AjcFSetFmtLen	(HAJCFILE pW, UI len)
{
	BOOL	rc = FALSE;

	if (pW != NULL && pW->iid == INST_ID && len >= 16) {
		if (pW->pFmtBuf.bcp != NULL || len != pW->lFmtBuf) {
			//	Õobt@
			if (pW->pFmtBuf.bcp == NULL) free(pW->pFmtBuf.bcp);
			//	obt@m
			if ((pW->pFmtBuf.bcp = (BCP)AJCMEM(len * 2)) != NULL) {	// obt@̓ChŊm
				pW->lFmtBuf = len;
				rc = TRUE;
			}
		}
	}
	return	rc;
}

//==============================================================================================================//
//	nh擾																								//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//																												//
//	߂l	F	NULL : t@Cnh																		//
//==============================================================================================================//
AJCEXPORT	HANDLE		WINAPI	AjcFGetFileHandle	(HAJCFILE pW)
{
	HANDLE	rc = NULL;

	if (pW != NULL && pW->iid == INST_ID) {
		rc = pW->hFile;
	}
	return	rc;
}

//==============================================================================================================//
//	GR[hʐݒ_CAO																				//
//																												//
//	@	F	hOwner	-	I[i[EChnh -----------------------------------isvNULL)			//
//				pTitle	-	^Cg ---------------------------------------------isvNULL)			//
//				hIcon	-	ACRnh -------------------------------------------isvNULL)			//
//				pInpTec	-	̓eLXgR[hobt@̃AhX -------------------isvNULL)			//
//				pOutTec	-	o̓eLXgR[hobt@̃AhX -------------------isvNULL)			//
//				pOutBom	-	o̓eLXgt@Cւ̂anlo̓tOobt@̃AhX -isvNULL)			//
//																												//
//	߂l	F	TRUE Fnj																						//
//				FALSEFLZ																				//
//==============================================================================================================//
AJC_DLGPROC_DEF(SetTec);
#define	WM_SHOWGRAY		WM_APP + 100
//--------------------------------------------------------------------------------------------------------------//
typedef struct {
	BOOL		fUni;
	C_VOP		pTitle;
	HICON		hIcon;
	PEAJCTEC	pInpTec;
	PEAJCTEC	pOutTec;
	BOOL		*pOutBom;
} CBP_SET_TEC, *PCBP_SET_TEC;
//----- oCg ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFTecDialogA(HWND hOwner, C_BCP pTitle, HICON hIcon, PEAJCTEC pInpTec, PEAJCTEC pOutTec, BOOL *pOutBom)
{
	BOOL	rc = FALSE;
	CBP_SET_TEC	cbp;

	cbp.fUni	= FALSE;
	cbp.pTitle	= (C_VOP)pTitle;
	cbp.hIcon	= hIcon;
	cbp.pInpTec = pInpTec;
	cbp.pOutTec = pOutTec;
	cbp.pOutBom = pOutBom;
	if (DialogBoxParam(hDllInst, MAKEINTRESOURCE(IDD_SET_TEC), hOwner, AJC_DLGPROC_NAME(SetTec), (LPARAM)&cbp) == IDOK) {
		rc = TRUE;
	}

	return	rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
AJCEXPORT	BOOL		WINAPI	AjcFTecDialogW(HWND hOwner, C_WCP pTitle, HICON hIcon, PEAJCTEC pInpTec, PEAJCTEC pOutTec, BOOL *pOutBom)
{
	BOOL	rc = FALSE;
	CBP_SET_TEC	cbp;

	cbp.fUni	= TRUE;
	cbp.pTitle	= (C_VOP)pTitle;
	cbp.hIcon	= hIcon;
	cbp.pInpTec = pInpTec;
	cbp.pOutTec = pOutTec;
	cbp.pOutBom = pOutBom;
	if (DialogBoxParam(hDllInst, MAKEINTRESOURCE(IDD_SET_TEC), hOwner, AJC_DLGPROC_NAME(SetTec), (LPARAM)&cbp) == IDOK) {
		rc = TRUE;
	}

	return	rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	GR[hʐݒ_CAOvV[W																	//
//--------------------------------------------------------------------------------------------------------------//
//----- _CAO ---------------------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, WM_INITDIALOG )
{
	PCBP_SET_TEC	pW = (PCBP_SET_TEC)lParam;

	//	_CAOp[NAhXݒ
	SetProp(hDlg, L"AjcSetTec", (HANDLE)lParam);

	//	^Cgݒ
	if (pW->pTitle != NULL) {
		if (pW->fUni) SetWindowTextW(hDlg, (C_WCP)pW->pTitle);
		else		  SetWindowTextA(hDlg, (C_BCP)pW->pTitle);
	}
	else  SetWindowText(hDlg, LNGSEL(L"eLXgEGR[hݒ", L"Set Text encoding"));

	//	ACRݒ
	if (pW->hIcon != NULL) {
		SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)pW->hIcon);
	}
	//	peLXg
	AjcSetDlgItemStr(hDlg, IDC_GRP_I_ENC, LNGSEL(L"̓t@C GR[h" 	, L"Input File Encoding"	));
	AjcSetDlgItemStr(hDlg, IDC_RBT_I_MBC, szMyMbc													 );

	AjcSetDlgItemStr(hDlg, IDC_GRP_O_ENC, LNGSEL(L"o̓t@C GR[h" 	, L"Output File Encoding"));
	AjcSetDlgItemStr(hDlg, IDC_RBT_O_MBC, szMyMbc													 );
	AjcSetDlgItemStr(hDlg, IDC_CHK_O_BOM, LNGSEL(L"anl쐬"			, L"Output BOM"			));

	AjcSetDlgItemStr(hDlg, IDOK    , LNGSEL(L"nj" 	 , L"OK"	));
	AjcSetDlgItemStr(hDlg, IDCANCEL, LNGSEL(L"LZ", L"Cancel"));

	if (AjcGetLangId() != AJCLID_JPN) {
		ShowWindow(GetDlgItem(hDlg, IDC_RBT_I_EUC), SW_HIDE);
		ShowWindow(GetDlgItem(hDlg, IDC_RBT_O_EUC), SW_HIDE);
	}

	//	WI{^O[v
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_INPTEC));
	AjcSbcRadioBtns(GetDlgItem(hDlg, IDC_GRP_OUTTEC));

	//	̓GR[hl\
	if (pW->pInpTec != NULL) {
		switch (*pW->pInpTec) {
			default:
			case AJCTEC_MBC:		AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 0);	break;
			case AJCTEC_UTF_8:		AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 1);	break;
			case AJCTEC_EUC_J:		AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 2);	break;
			case AJCTEC_UTF_16LE:	AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 3);	break;
			case AJCTEC_UTF_16BE:	AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 4);	break;
			case AJCTEC_AUTO:		AjcSetDlgItemUInt(hDlg, IDC_GRP_INPTEC, 5);	break;
		}
	}
	else {
		AjcEnableDlgGroup(hDlg, IDC_GRP_I_ENC, FALSE, FALSE);
	}

	//	o̓GR[hl\
	if (pW->pOutTec != NULL) {
		switch (*pW->pOutTec) {
			default:
			case AJCTEC_MBC:		AjcSetDlgItemUInt(hDlg, IDC_GRP_OUTTEC, 0);	break;
			case AJCTEC_UTF_8:		AjcSetDlgItemUInt(hDlg, IDC_GRP_OUTTEC, 1);	break;
			case AJCTEC_EUC_J:		AjcSetDlgItemUInt(hDlg, IDC_GRP_OUTTEC, 2);	break;
			case AJCTEC_UTF_16LE:	AjcSetDlgItemUInt(hDlg, IDC_GRP_OUTTEC, 3);	break;
			case AJCTEC_UTF_16BE:	AjcSetDlgItemUInt(hDlg, IDC_GRP_OUTTEC, 4);	break;
		}
	}

	//	o͂anll\
	if (pW->pOutBom != NULL) {
		AjcSetDlgItemChk(hDlg, IDC_CHK_O_BOM, *pW->pOutBom != FALSE);
	}

	//	O[\
	SendMessage(hDlg, WM_SHOWGRAY, 0, 0);

	return TRUE;
}
//----- _CAÕO[\ -----------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, WM_SHOWGRAY )
{
	PCBP_SET_TEC	pW = (PCBP_SET_TEC)GetProp(hDlg, L"AjcSetTec");

	//	͐ݒO[
	if (pW->pInpTec != NULL) {
		AjcEnableDlgGroup(hDlg, IDC_GRP_I_ENC, TRUE , TRUE );
	}
	else {
		AjcEnableDlgGroup(hDlg, IDC_GRP_I_ENC, FALSE, FALSE);
	}

	//	o͐ݒO[
	if (pW->pOutTec == NULL && pW->pOutBom == NULL) {					//	o͂dmb and anlH
		AjcEnableDlgGroup(hDlg, IDC_GRP_O_ENC, FALSE, FALSE);
	}
	else {																//	o͂dmb or anlH
		AjcEnableDlgGroup(hDlg, IDC_GRP_O_ENC, TRUE , TRUE );
		if		(pW->pOutTec == NULL) {									//		o͂dmbH
			AjcEnableDlgGroup(hDlg, IDC_GRP_OUTTEC, FALSE, FALSE);		//			o̓GR[hݒO[
		}
		else if (pW->pOutBom == NULL) {									//		o͂anlH
			AjcEnableDlgItem(hDlg, IDC_CHK_O_BOM, FALSE);				//			o͂anlO[
		}
		else {															//		o͂dmb and anlLH
			if (AjcGetDlgItemChk(hDlg, IDC_RBT_O_UTF8)	||				//			UTF-8 or UTF-16 `FbNH
				AjcGetDlgItemChk(hDlg, IDC_RBT_O_U16LE) ||				//			E
				AjcGetDlgItemChk(hDlg, IDC_RBT_O_U16BE)) {				//			E
				AjcEnableDlgItem(hDlg, IDC_CHK_O_BOM, TRUE);			//				o͂anlO[
			}
			else {														//			UTF-8 and UTF-16 `FbNH
				AjcEnableDlgItem(hDlg, IDC_CHK_O_BOM, FALSE);			//				o͂anlO[
			}
		}
	}
	return TRUE;
}

//----- LZ{^ ---------------------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, IDCANCEL )
{
	PCBP_SET_TEC	pW = (PCBP_SET_TEC)GetProp(hDlg, L"AjcSetTec");

	EndDialog(hDlg, IDCANCEL);

	return TRUE;
}

//----- nj{^ ---------------------------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, IDOK	 )
{
	PCBP_SET_TEC	pW = (PCBP_SET_TEC)GetProp(hDlg, L"AjcSetTec");

	if (pW->pInpTec != NULL) {
		switch (AjcGetDlgItemUInt(hDlg, IDC_GRP_INPTEC)) {
			case 0: *pW->pInpTec = AJCTEC_MBC;		break;
			case 1: *pW->pInpTec = AJCTEC_UTF_8;	break;
			case 2: *pW->pInpTec = AJCTEC_EUC_J;	break;
			case 3: *pW->pInpTec = AJCTEC_UTF_16LE;	break;
			case 4: *pW->pInpTec = AJCTEC_UTF_16BE;	break;
			case 5: *pW->pInpTec = AJCTEC_AUTO;		break;
		}
	}
	if (pW->pOutTec != NULL) {
		switch (AjcGetDlgItemUInt(hDlg, IDC_GRP_OUTTEC)) {
			case 0: *pW->pOutTec = AJCTEC_MBC;		break;
			case 1: *pW->pOutTec = AJCTEC_UTF_8;	break;
			case 2: *pW->pOutTec = AJCTEC_EUC_J;	break;
			case 3: *pW->pOutTec = AJCTEC_UTF_16LE;	break;
			case 4: *pW->pOutTec = AJCTEC_UTF_16BE;	break;
		}
	}
	if (pW->pOutBom != NULL) {
		*pW->pOutBom = AjcGetDlgItemChk(hDlg, IDC_CHK_O_BOM);
	}
	EndDialog(hDlg, IDOK);

	return TRUE;
}
//----- ̓GR[hݒ -------------------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, IDC_GRP_INPTEC )
{
	//	O[\
	SendMessage(hDlg, WM_SHOWGRAY, 0, 0);

	return TRUE;
}
//----- o̓GR[hݒ -------------------------------------------------------------------------------------//
AJC_DLGPROC(SetTec, IDC_GRP_OUTTEC )
{
	//	O[\
	SendMessage(hDlg, WM_SHOWGRAY, 0, 0);

	return TRUE;
}
//--------------------------------------------------------------------------------------------------------------//
AJC_DLGMAP_DEF(SetTec)
	AJC_DLGMAP_MSG(SetTec, WM_INITDIALOG	)
	AJC_DLGMAP_MSG(SetTec, WM_SHOWGRAY		)

	AJC_DLGMAP_CMD(SetTec, IDOK				)
	AJC_DLGMAP_CMD(SetTec, IDCANCEL			)
	AJC_DLGMAP_CMD(SetTec, IDC_GRP_INPTEC	)
	AJC_DLGMAP_CMD(SetTec, IDC_GRP_OUTTEC	)
AJC_DLGMAP_END



//--------------------------------------------------------------------------------------------------------------//
//	jR[hirbOGfBAjPiP`Q[hjj}`oCgɕϊ								//
//																												//
//	߂l	F	}`oCg̃oCg																		//
//--------------------------------------------------------------------------------------------------------------//
static	UI		RevedWideCharToMultiByte(C_WCP pUni, UI lUni, BCP pMbc, UI lMbc)
{
	UI		rc	 = 0;
	UI		i;
	WC		tmp[8] = {0};

	for (i = 0; i < lUni && i < AJCTSIZE(tmp); i++) {
		tmp[i] = (WC)AjcExcWord(pUni[i]);
	}
	rc = WideCharToMultiByte(CP_ACP, 0, tmp, lUni, pMbc, lMbc, NULL, NULL);

	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//	t@CǂݏoăeLXgGR[h肷															//
//																												//
//	߂l	F	eLXgGR[h																			//
//--------------------------------------------------------------------------------------------------------------//
#define	STBA_BUFSIZE	16384
static EAJCTEC SetTecByAuto(HAJCFILE pW)
{
	EAJCTEC rc	 = AJCTEC_MBC;
	BCP		pBuf = NULL;
	int		perSJis = 0;
	int		perEuc	= 0;
	int		perUtf8 = 0;
	int		lpi 	= 0;
	UI		len = (UI)(__min(pW->FSizeA, STBA_BUFSIZE));

	do {
		if ((pW->FSizeA & 1) == 0) {
			//	UTF-16LE
			lpi = IS_TEXT_UNICODE_CONTROLS;
			IsTextUnicode(pW->pInp.bcp, len, &lpi);
			if (lpi == IS_TEXT_UNICODE_CONTROLS) {
				rc = AJCTEC_UTF_16LE;
				break;
			}
			//	UTF-16BE
			lpi = IS_TEXT_UNICODE_REVERSE_CONTROLS;
			IsTextUnicode(pW->pInp.bcp, len, &lpi);
			if (lpi == IS_TEXT_UNICODE_REVERSE_CONTROLS) {
				rc = AJCTEC_UTF_16BE;
				break;
			}
		}
		//	MBC(SJIS), EUC-J or UTF-8 `FbN
		perSJis = AjcStrIsSJisEx(pW->pInp.bcp, len);
		perEuc	= AjcStrIsEucEx (pW->pInp.bcp, len);
		perUtf8 = AjcStrIsUtf8Ex(pW->pInp.bcp, len);
		if		(perUtf8 > perSJis &&  perUtf8 > perEuc ) {
			rc = AJCTEC_UTF_8;
		}
		else if (perEuc  > perSJis &&  perEuc  > perUtf8) {
			rc = AJCTEC_EUC_J;
		}
		else {
			rc = AJCTEC_MBC;
		}
	} while(0);

	return rc;
}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	ǂݏopTu֐																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//--------------------------------------------------------------------------------------------------------------//
//	sݒ																								//
//--------------------------------------------------------------------------------------------------------------//
static	VO		SetLfCode(HAJCFILE pW)
{
	//	sݒ
	memset(pW->szLfA, 0, sizeof pW->szLfA);
	memset(pW->szLfW, 0, sizeof pW->szLfW);
	switch (pW->LfCnv) {
		case AJCFLF_NONE:														break;	//	ϊ
		case AJCFLF_LF_TO_CRLF:		pW->szLfA[0] = CC_LF;						break;	//	ke  bqCkeit@Cݎ̃ftHgj
		case AJCFLF_LF_TO_CR:		pW->szLfA[0] = CC_LF;						break;	//	ke  bq
		case AJCFLF_CR_TO_CRLF:		pW->szLfA[0] = CC_CR;						break;	//	bq  bqCke
		case AJCFLF_CR_TO_LF:		pW->szLfA[0] = CC_CR;						break;	//	bq  ke
		case AJCFLF_CRLF_TO_LF:		pW->szLfA[0] = CC_CR; pW->szLfA[1] = CC_LF;	break;	//	bqCke  keit@CǂݏõftHgj
		case AJCFLF_CRLF_TO_CR:		pW->szLfA[0] = CC_CR; pW->szLfA[1] = CC_LF;	break;	//	bqCke  bq
		case AJCFLF_LF:				pW->szLfA[0] = CC_LF;						break;	//	kesR[hƂAϊ
		case AJCFLF_CR:				pW->szLfA[0] = CC_CR;						break;	//	bqsR[hƂAϊ
		case AJCFLF_LF_CRSKIP:		pW->szLfA[0] = CC_LF;						break;	//	kesR[hƂAbq͏
		case AJCFLF_CR_LFSKIP:		pW->szLfA[0] = CC_CR;						break;	//	bqsR[hƂAke͏
	}
	pW->szLfW[0] = pW->szLfA[0];
	pW->szLfW[1] = pW->szLfA[1];
	pW->szLfW[2] = pW->szLfA[2];
	//	UTF-16(BE)̏ꍇA㉺oCg
	if (pW->tec == AJCTEC_UTF_16BE) {
		pW->szLfW[0] = (WC)AjcExcWord(pW->szLfW[0]);
		pW->szLfW[1] = (WC)AjcExcWord(pW->szLfW[1]);
	}
}
//--------------------------------------------------------------------------------------------------------------//
//	seLXgisR[h^dne܂ł̃eLXgjR[hϊăobt@Ɋi[								//
//																												//
//			F	pW		- CX^Xnh																	//
//				pBuf	- seLXgi[obt@̃AhX														//
//				lBuf	- seLXgi[obt@̃oCg^[h											//
//																												//
//	߂l	F	TRUE  : seLXgR[hϊăobt@Ɋi[											//
//				FALSE : i[obt@s																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL	GetLineA(HAJCFILE pW, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	UI		i;

	switch (pW->tec) {
		//	r|ihr t@C
		case AJCTEC_MBC:
		{	UI		lMbc[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			BCP		pMbc;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf, &lMbc[0], &lMbc[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lMbc[i] != 0) {
						pMbc = pW->pInp.bcp;
						//	s܂ł̃eLXg  obt@
						if		(lMbc[i] != 0 && lMbc[i] < lBuf) {
							//	eLXgobt@Ɋi[
							if (SetToLineBufA(pW, pMbc, lMbc[i], pBuf, lBuf)) {
								//	t@C|C^XV
								pW->pInp.bcp += lMbc[i];
								pW->FIx 	 += lMbc[i];
								rc = TRUE;
							}
						}
					}
				}
			}
			break;
		}
		//	tee|W t@C
		case AJCTEC_UTF_8:
		{	UI		lUtf8[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		lMbc;
			BCP		pMbc;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf * 6, &lUtf8[0], &lUtf8[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lUtf8[i] != 0) {
						//	UTF8 -> SJIS ϊ̃eLXgZoi`sR[hj
						if ((lMbc = AjcUtf8ToSJisEx(pW->pInp.bcp, lUtf8[i], NULL, 0)) != 0) {
							//	rihreLXg  obt@
							if (lMbc < lBuf && (pMbc = AjcTAllocA(lMbc))) {
								//	UTF8 -> SJIS ϊ
								AjcUtf8ToSJisEx(pW->pInp.bcp, lUtf8[i], pMbc, lMbc);
								//	eLXgobt@Ɋi[
								if (SetToLineBufA(pW, pMbc, lMbc, pBuf, lBuf)) {
									//	t@C|C^XV
									pW->pInp.bcp += lUtf8[i];
									pW->FIx 	 += lUtf8[i];
									rc = TRUE;
								}
								AjcTFree(pMbc);
							}
						}
					}
				}
			}
			break;
		}
		//	dtb|i t@C
		case AJCTEC_EUC_J:
		{	UI		lEuc[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		lMbc;
			BCP		pMbc;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf * 2, &lEuc[0], &lEuc[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lEuc[i] != 0) {
						//	EUC -> SJIS ϊ̃eLXgZo
						if ((lMbc = AjcEucToSJisEx(pW->pInp.bcp, lEuc[i], NULL, 0)) != 0) {
							//	rihreLXg  obt@
							if (lMbc < lBuf && (pMbc = AjcTAllocA(lMbc))) {
								//	EUC -> SJIS ϊ
								AjcEucToSJisEx(pW->pInp.bcp, lEuc[i], pMbc, lMbc);
								//	eLXgobt@Ɋi[
								if (SetToLineBufA(pW, pMbc, lMbc, pBuf, lBuf)) {
									//	t@C|C^XV
									pW->pInp.bcp += lEuc[i];
									pW->FIx 	 += lEuc[i];
									rc = TRUE;
								}
								AjcTFree(pMbc);
							}
						}
					}
				}
			}
			break;
		}
		//	tse|PUikdj t@C
		case AJCTEC_UTF_16LE:
		{	UI		lU16le[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		lMbc;
			BCP		pMbc;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFW(pW, lBuf * 2, &lU16le[0], &lU16le[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lU16le[i] != 0) {
						//	UNICODE -> SJIS ϊ̃eLXgZo
						if ((lMbc = WideCharToMultiByte(CP_ACP, 0, pW->pInp.wcp, lU16le[i], NULL, 0, NULL, NULL)) != 0) {
							//	rihreLXg  obt@
							if (lMbc < lBuf && (pMbc = AjcTAllocA(lMbc))) {
								//	UNICODE -> SJIS ϊ
								WideCharToMultiByte(CP_ACP, 0, pW->pInp.wcp, lU16le[i], pMbc, lMbc, NULL, NULL);
								//	eLXgobt@Ɋi[
								if (SetToLineBufA(pW, pMbc, lMbc, pBuf, lBuf)) {
									//	t@C|C^XV
									pW->pInp.wcp += lU16le[i];
									pW->FIx 	 += lU16le[i];
									rc = TRUE;
								}
								AjcTFree(pMbc);
							}
						}
					}
				}
			}
			break;
		}
		//	tse|PUiadj t@C
		case AJCTEC_UTF_16BE:
		{	UI		lU16be[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		j, lMbc;
			BCP		pMbc;
			WCP		pU16be, p, q;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFW(pW, lBuf * 2, &lU16be[0], &lU16be[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lU16be[i] != 0) {
						//	UNICODEobt@m
						if (pU16be = AjcTAllocW(lU16be[i])) {
							//	BE -> LE ϊ
							for (j = 0, p = pU16be, q = pW->pInp.wcp; j < lU16be[i]; j++, p++, q++) {
								*p = (WC)AjcExcWord(*q);
							}
							//	UNICODE -> SJIS ϊ̃eLXgZo
							if ((lMbc = WideCharToMultiByte(CP_ACP, 0, pU16be, lU16be[i], NULL, 0, NULL, NULL)) != 0) {
								//	rihreLXg  obt@
								if (lMbc < lBuf && (pMbc = AjcTAllocA(lMbc))) {
									//	UNICODE -> SJIS ϊ
									WideCharToMultiByte(CP_ACP, 0, pU16be, lU16be[i], pMbc, lMbc, NULL, NULL);
									//	eLXgobt@Ɋi[
									if (SetToLineBufA(pW, pMbc, lMbc, pBuf, lBuf)) {
										//	t@C|C^XV
										pW->pInp.wcp += lU16be[i];
										pW->FIx 	 += lU16be[i];
										rc = TRUE;
									}
									AjcTFree(pMbc);
								}
							}
							AjcTFree(pU16be);
						}
					}
				}
			}
			break;
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL	GetLineW(HAJCFILE pW, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	UI		i;

	switch (pW->tec) {
		//	r|ihr t@C
		case AJCTEC_MBC:
		{	UI		lMbc[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		lUni;
			WCP		pUni;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf * 2, &lMbc[0], &lMbc[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lMbc[i] != 0) {
						//	S-JIS -> UNICODE ϊ̃eLXgZo
						if ((lUni = MultiByteToWideChar(CP_ACP, 0, pW->pInp.bcp, lMbc[i], NULL, 0)) != 0) {
							//	UNICODEeLXg  obt@
							if (lUni < lBuf && (pUni = AjcTAllocW(lUni))) {
								//	S-JIS -> UNICODE ϊ
								MultiByteToWideChar(CP_ACP, 0, pW->pInp.bcp, lMbc[i], pUni, lUni);
								//	eLXgobt@Ɋi[
								if (SetToLineBufW(pW, pUni, lUni, pBuf, lBuf)) {
									//	t@C|C^XV
									pW->pInp.bcp += lMbc[i];
									pW->FIx 	 += lMbc[i];
									rc = TRUE;
								}
								AjcTFree(pUni);
							}
						}
					}
				}
			}
			break;
		}
		//	tee|W t@C
		case AJCTEC_UTF_8:
		{	UI	lUtf8[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI	lUni;
			WCP			   pUni;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf * 6, &lUtf8[0], &lUtf8[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lUtf8[i] != 0) {
						//	UTF-8 -> UNICODE ϊ̃eLXgZo
						if ((lUni = MultiByteToWideChar(CP_UTF8, 0, pW->pInp.bcp, lUtf8[i], NULL, 0)) != 0) {
							//	UNICODEeLXg  obt@
							if (lUni < lBuf && (pUni = AjcTAllocW(lUni))) {
								//	UTF-8 -> UNICODE ϊ
								MultiByteToWideChar(CP_UTF8, 0, pW->pInp.bcp, lUtf8[i], pUni, lUni);
								//	eLXgobt@Ɋi[
								if (SetToLineBufW(pW, pUni, lUni, pBuf, lBuf)) {
									//	t@C|C^XV
									pW->pInp.bcp += lUtf8[i];
									pW->FIx 	 += lUtf8[i];
									rc = TRUE;
								}
								AjcTFree(pUni);
							}
						}
					}
				}
			}
			break;
		}
		//	dtb|i t@C
		case AJCTEC_EUC_J:
		{	UI		lEuc[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			UI		lMbc, lUni;
			BCP		pMbc;
			WCP		pUni;
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFA(pW, lBuf * 2, &lEuc[0], &lEuc[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lEuc[i] != 0) {
						//	EUC -> S-JIS ϊ̃eLXg擾
						if ((lMbc = AjcEucToSJisEx(pW->pInp.bcp, lEuc[i], NULL, 0)) != 0) {
							//	S-JISobt@m
							if (pMbc = AjcTAllocA(lMbc)) {
								//	EUC -> S-JIS ϊ
								AjcEucToSJisEx(pW->pInp.bcp, lEuc[i], pMbc, lMbc);
								//	S-JIS -> UNICODE ϊ̃eLXgZo
								if ((lUni = MultiByteToWideChar(CP_ACP, 0, pMbc, lMbc, NULL, 0)) != 0) {
									//	UNICODEeLXg  obt@
									if (lUni < lBuf && (pUni = AjcTAllocW(lUni))) {
										//	S-JIS -> UNICODE ϊ
										MultiByteToWideChar(CP_ACP, 0, pMbc, lMbc, pUni, lUni);
										//	eLXgobt@Ɋi[
										if (SetToLineBufW(pW, pUni, lUni, pBuf, lBuf)) {
											//	t@C|C^XV
											pW->pInp.bcp += lEuc[i];
											pW->FIx 	 += lEuc[i];
											rc = TRUE;
										}
										AjcTFree(pUni);
									}
								}
								AjcTFree(pMbc);
							}
						}
					}
				}
			}
			break;
			}
		//	tse|PU t@C
		case AJCTEC_UTF_16LE:
		case AJCTEC_UTF_16BE:
		{	UI		lU16[2];	//	[0] : sR[h܂ł̒C[1] : 䕶܂ł̒
			//	s^dne^䕶܂ł̃eLXgZo
			if (SearchLFW(pW, lBuf, &lU16[0], &lU16[1])) {
				for (i = 0; i < 2 && !rc; i++) {
					if (lU16[i] != 0) {
						//	UNICODEeLXg  obt@
						if (lU16[i] < lBuf) {
							//	eLXgobt@Ɋi[i BE->LEϊj
							if (SetToLineBufW(pW, pW->pInp.wcp, lU16[i], pBuf, lBuf)) {
								//	t@C|C^XV
								pW->pInp.wcp += lU16[i];
								pW->FIx 	 += lU16[i];
								rc = TRUE;
							}
						}
					}
				}
			}
			break;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	sR[h^dne܂ł̃oCg^[h擾																//
//																												//
//			F	pW		- CX^Xnh																	//
//				limit	- ő匟oCg^[h															//
//				plLf	- sR[h(or EOF)܂ł̃oCg^[hi[obt@̃AhX				//
//				plCtl	- 䕶܂ł̃oCg^[hi[obt@̃AhX							//
//																												//
//	߂l	F	TRUE   : sR[h^䕶L																//
//				FALSE  : sR[h䕶																//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgt@C -------------------------------------------------------------------------------------//
static	BOOL	SearchLFA(HAJCFILE pW, UI limit, UIP plLf, UIP plCtl)
{
	UI		rc	= FALSE;
	UI		lLf;
	UI		len   = 0;
	ULL		fix	  = pW->FIx;
	BCP		pFPtr = pW->pInp.bcp;

	//	߂񏉊
	*plLf  = 0;
	*plCtl = 0;

	//	sR[h̔FLȂ΁AsR[h
	if (pW->LfCnv != AJCFLF_NONE) {
		//	sR[h̒(1`2)ݒ
		lLf = (UI)strlen(pW->szLfA);
		//	sR[h^dne
		while (fix < pW->FSizeA && len < limit) {
			//	sR[hȂ΁AsR[hZI
			if (fix + lLf <= pW->FSizeA && strncmp(pFPtr, pW->szLfA, lLf) == 0) {
				*plLf = len + lLf;
				rc = TRUE;
				break;
			}
			//	sR[hȊOȂ΁APoCgZ
			else {
				//	䕶Ȃ΁AʒuԂ
				if (*plCtl == 0 && iscntrl((UB)*pFPtr)) {
					*plCtl = len + 1;
					rc = TRUE;
				}
				//	|C^CJE^XV
				fix++;
				pFPtr++;
				len++;
			}
		}
	}
	//	sR[hFȂ΁AR[h
	else {
		while (fix < pW->FSizeA && len < limit) {
			//	R[hȂ΁AR[hZI
			if (fix + 1 <= pW->FSizeA && iscntrl((UB)*pFPtr)) {
				*plCtl = len + 1;
				rc = TRUE;
				break;
			}
			//	R[hȊOȂ΁APoCgZ
			else {
				fix++;
				pFPtr++;
				len++;
			}
		}
	}
	//	dne܂ł̒`FbN
	if (*plLf == 0 && fix == pW->FSizeA && len < limit) {
		*plLf = len;
		rc = TRUE;
	}
	return rc;
}
//----- Cht@C -------------------------------------------------------------------------------------//
static	BOOL	SearchLFW(HAJCFILE pW, UI limit, UIP plLf, UIP plCtl)
{
	UI		rc	= 0;
	UI		lLf;
	UI		len   = 0;
	ULL		fix	  = pW->FIx;
	WCP		pFPtr = pW->pInp.wcp;

	//	߂񏉊
	*plLf  = 0;
	*plCtl = 0;

	//	sR[h̔FLȂ΁AsR[h
	if (pW->LfCnv != AJCFLF_NONE) {
		//	sR[h̒(1`2)ݒ
		lLf = (UI)wcslen(pW->szLfW);
		//	sR[h^dne
		while (fix < pW->FSizeW && len < limit) {
			//	sR[hȂ΁AsR[hZI
			if (fix + lLf <= pW->FSizeW && wcsncmp(pFPtr, pW->szLfW, lLf) == 0) {
				*plLf = len + lLf;
				rc = TRUE;
				break;
			}
			//	sR[hȊOȂ΁AP[hZ
			else {
				//	䕶Ȃ΁AʒuԂ
				if (*plCtl == 0 && iswcntrl(*pFPtr)) {
					*plCtl = len + 1;
					rc = TRUE;
				}
				//	|C^CJE^XV
				fix++;
				pFPtr++;
				len++;
			}
		}
	}
	//	sR[hFȂ΁AR[h
	else {
		while (fix < pW->FSizeW && len < limit) {
			//	R[hȂ΁AR[hZI
			if (fix + 1 <= pW->FSizeW && iswcntrl(*pFPtr)) {
				*plCtl = len + 1;
				rc = TRUE;
				break;
			}
			//	R[hȊOȂ΁AP[hZ
			else {
				fix++;
				pFPtr++;
				len++;
			}
		}
	}
	//	dne܂ł̒`FbN
	if (*plLf == 0 && fix == pW->FSizeW && len < limit) {
		*plLf = len;
		rc = TRUE;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	seLXgobt@Ɋi[																					//
//																												//
//			F	pW		- CX^Xnh																	//
//				pMbc	- \[XeLXg|C^																//
//				lMbc	- \[XeLXg̃oCg^[h													//
//				pBuf	- obt@|C^																		//
//				lBuf	- obt@̃oCg^[h															//
//																												//
//	߂l	F	TRUE  : nj																					//
//				FALSE : i[obt@s																		//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL	SetToLineBufA(HAJCFILE pW, C_BCP pMbc, UI lMbc, BCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	BC		src[3] = {0};
	BC		cnv[3] = {0};
	BC		del    =  0;
	UI		lsrc, lcnv;

	switch (pW->LfCnv) {
		case AJCFLF_NONE:																		break;	//	ϊ
		case AJCFLF_LF_TO_CRLF:	src[0] = CC_LF; 				cnv[0] = CC_CR; cnv[1] = CC_LF; break;	//	ke  bqCkeit@Cݎ̃ftHgj
		case AJCFLF_LF_TO_CR:	src[0] = CC_LF; 				cnv[0] = CC_CR; 				break;	//	ke  bq
		case AJCFLF_CR_TO_CRLF:	src[0] = CC_CR; 				cnv[0] = CC_CR; cnv[1] = CC_LF; break;	//	bq  bqCke
		case AJCFLF_CR_TO_LF:	src[0] = CC_CR; 				cnv[0] = CC_LF; 				break;	//	bq  ke
		case AJCFLF_CRLF_TO_LF:	src[0] = CC_CR; src[1] = CC_LF; cnv[0] = CC_LF; 				break;	//	bqCke  keit@CǂݏõftHgj
		case AJCFLF_CRLF_TO_CR:	src[0] = CC_CR; src[1] = CC_LF; cnv[0] = CC_CR; 				break;	//	bqCke  bq
		case AJCFLF_LF:																			break;	//	kesR[hƂAϊ
		case AJCFLF_CR:																			break;	//	bqsR[hƂAϊ
		case AJCFLF_LF_CRSKIP:	del = CC_CR;													break;	//	kesR[hƂAbq͏
		case AJCFLF_CR_LFSKIP:	del = CC_LF;													break;	//	bqsR[hƂAke͏
	}
	lsrc = (UI)strlen(src);
	lcnv = (UI)strlen(cnv);

	while (lMbc > 0) {															//	c\[XeLXgH
		if (*pMbc != del) {														//		폜sR[hȊOH
			if (lsrc != 0 && lMbc >= lsrc && strncmp(pMbc, src, lsrc) == 0) {	//			\[XeLXg͕ϊvH
				if (lBuf > lcnv) {												//				obt@ɕϊR[hi[\H
					strncpy(pBuf, cnv, lcnv);									//					obt@ɕϊR[hi[
					pMbc += lsrc;												//					\[XeLXg|C^XV
					lMbc -= lsrc;												//					\[XeLXgXV
					pBuf += lcnv;												//					obt@|C^XV
					lBuf -= lcnv;												//					obt@XV
				}
				else {															//				obt@ɕϊR[hi[sH
					break;														//					Iiobt@I[o[j
				}
			}
			else {																//			\[XeLXg͕ϊsvH
				*pBuf++ = *pMbc++;												//				\[XeLXgobt@ɓ]
				lMbc--;															//				\[XeLXgXV
				lBuf--;															//				obt@XV
			}
		}
		else {																	//		폜sR[hH
			pMbc++;																//			\[XeLXg|C^XV
			lMbc--;																//			\[XeLXgXV
		}
	}
	if (lMbc == 0) {															//	S\[XeLXgobt@ɓ]ς݁H
		if (lBuf > 0) {															//		obt@ɋ󂫂H
			*pBuf++ = 0;														//			obt@ɕI[ݒ
			lBuf--;																//			obt@XV
			rc = TRUE;															//			߂lnj
		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL	SetToLineBufW(HAJCFILE pW, C_WCP pUni, UI lUni, WCP pBuf, UI lBuf)
{
	BOOL	rc = FALSE;
	WC		src[3] = {0};
	WC		cnv[3] = {0};
	WC		del    =  0;
	UI		lsrc, lcnv;

	switch (pW->LfCnv) {
		case AJCFLF_NONE:																		break;	//	ϊ
		case AJCFLF_LF_TO_CRLF:	src[0] = CC_LF; 				cnv[0] = CC_CR; cnv[1] = CC_LF; break;	//	ke  bqCkeit@Cݎ̃ftHgj
		case AJCFLF_LF_TO_CR:	src[0] = CC_LF; 				cnv[0] = CC_CR; 				break;	//	ke  bq
		case AJCFLF_CR_TO_CRLF:	src[0] = CC_CR; 				cnv[0] = CC_CR; cnv[1] = CC_LF; break;	//	bq  bqCke
		case AJCFLF_CR_TO_LF:	src[0] = CC_CR; 				cnv[0] = CC_LF; 				break;	//	bq  ke
		case AJCFLF_CRLF_TO_LF:	src[0] = CC_CR; src[1] = CC_LF; cnv[0] = CC_LF; 				break;	//	bqCke  keit@CǂݏõftHgj
		case AJCFLF_CRLF_TO_CR:	src[0] = CC_CR; src[1] = CC_LF; cnv[0] = CC_CR; 				break;	//	bqCke  bq
		case AJCFLF_LF:																			break;	//	kesR[hƂAϊ
		case AJCFLF_CR:																			break;	//	bqsR[hƂAϊ
		case AJCFLF_LF_CRSKIP:	del = CC_CR;													break;	//	kesR[hƂAbq͏
		case AJCFLF_CR_LFSKIP:	del = CC_LF;													break;	//	bqsR[hƂAke͏
	}
	lsrc = (UI)wcslen(src);
	lcnv = (UI)wcslen(cnv);

	while (lUni > 0) {															//	c\[XeLXgH
		if (*pUni != del) {														//		폜sR[hȊOH
			if (lsrc != 0 && lUni >= lsrc && wcsncmp(pUni, src, lsrc) == 0) {	//			\[XeLXg͕ϊvH
				if (lBuf > lcnv) {												//				obt@ɕϊR[hi[\H
					wcsncpy(pBuf, cnv, lcnv);									//					obt@ɕϊR[hi[
					pUni += lsrc;												//					\[XeLXg|C^XV
					lUni -= lsrc;												//					\[XeLXgXV
					pBuf += lcnv;												//					obt@|C^XV
					lBuf -= lcnv;												//					obt@XV
				}
				else {															//				obt@ɕϊR[hi[sH
					break;														//					Iiobt@I[o[j
				}
			}
			else {																//			\[XeLXg͕ϊsvH
				if (pW->tec == AJCTEC_UTF_16BE) *pBuf++ = AjcExcWord(*pUni++);	//				\[XeLXgobt@ɓ]
				else							*pBuf++ = *pUni++;
				lUni--;															//				\[XeLXgXV
				lBuf--;															//				obt@XV
			}
		}
		else {																	//		폜sR[hH
			pUni++;																//			\[XeLXg|C^XV
			lUni--;																//			\[XeLXgXV
		}
	}
	if (lUni == 0) {															//	S\[XeLXgobt@ɓ]ς݁H
		if (lBuf > 0) {															//		obt@ɋ󂫂H
			*pBuf++ = 0;														//			obt@ɕI[ݒ
			lBuf--;																//			obt@XV
			rc = TRUE;															//			߂lnj
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	s`FbN	Ë݂ʒusR[hȂ΂sqtdԂB												//
//					E̎Aobt@ɋ󂫂ΉsR[hobt@Ɋi[At@C|C^i߂		//
//																												//
//			F	pW		- CX^Xnh																	//
//				pTxt	- ̓eLXg																			//
//				lTxt	- ̓eLXg̒ioCg^j												//
//				pLfInfo	- o͂si[obt@													//
//																												//
//	߂l	F	P`QFsF	iFs̃oCg^j									//
//							pLfInfo->stl - ϊs̃oCg^iOŉsFj			//
//								OFsFAϊ邱Ƃ											//
//								OF̉s͓ǂݔ΂Ƃ										//
//							pLfInfo->str - ϊs													//
//				O	  FsF	isȊO̕j															//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	UI	CheckLFA(HAJCFILE pW, C_BCP pTxt, ULL lTxt, PLFINFO pLfInfo)
{
	UI		rc = 0;
	UB		c1, c2;

	memset(pLfInfo, 0, sizeof(LFINFO));

	if (lTxt >= 1) {

		//	eLXg擪̕R[hݒ
		c1 = *pTxt;
		if (lTxt >= 2) c2 = *(pTxt + 1);
		else		   c2 = 0;
		//	sR[hϊ
		switch (pW->LfCnv) {
			case AJCFLF_NONE:												//	ϊ
				rc = 0;
				break;

			case AJCFLF_LF_TO_CRLF:											//	ke  bqCkeit@Cݎ̃ftHgj
				if (c1 == CC_LF) {											//	keH
					pLfInfo->stl	 = 2;									//		ϊ񒷁 Q
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//		ϊ	 bqCke
					pLfInfo->strA[1] = CC_LF;	pLfInfo->strW[1] = CC_LF;	//		E
					rc = 1;													//		FsR[hP
				}
				break;

			case AJCFLF_LF_TO_CR:											//	ke  bq
				if (c1 == CC_LF) {											//	keH
					pLfInfo->stl	 = 1;									//		ϊ񒷁 P
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//		ϊ	 bq
					rc = 1;													//		FsR[hP
				}
				break;

			case AJCFLF_CR_TO_CRLF:											//	bq  bqCke
				if (c1 == CC_CR) {											//	bqH
					pLfInfo->stl	 = 2;									//		ϊ񒷁 P
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//		ϊ	 bqCke
					pLfInfo->strA[1] = CC_LF;	pLfInfo->strW[1] = CC_LF;	//		E
					rc = 1;													//		FsR[hP
				}
				break;

			case AJCFLF_CR_TO_LF:											//	bq  ke
				if (c1 == CC_CR) {											//	bqH
					pLfInfo->stl	 = 1;									//		ϊ񒷁 P
					pLfInfo->strA[0] = CC_LF;	pLfInfo->strW[0] = CC_LF;	//		ϊ	 ke
					rc = 1;													//		FsR[hP
				}
				break;

			case AJCFLF_CRLF_TO_LF:											//	bqCke  keit@CǂݏõftHgj
				if (c1 == CC_CR && c2 == CC_LF) {							//	bqCkeH
					pLfInfo->stl	 = 1;									//		ϊ񒷁 P
					pLfInfo->strA[0] = CC_LF;	pLfInfo->strW[0] = CC_LF;	//		ϊ	 ke
					rc = 2;													//		FsR[hQ
				}
				break;

			case AJCFLF_CRLF_TO_CR:											//	bqCke  bq
				if (c1 == CC_CR && c2 == CC_LF) {							//	bqCkeH
					pLfInfo->stl	 = 1;									//		ϊ񒷁 P
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//		ϊ	 bq
					rc = 2;													//		FsR[hQ
				}
				break;

			case AJCFLF_LF:													//	kesR[hƂAϊ
				if (c1 == CC_LF) {											//		keH
					rc = 1;													//			FsR[hP
					pLfInfo->stl	 = 1;									//			ϊ񒷁 P
					pLfInfo->strA[0] = CC_LF;	pLfInfo->strW[0] = CC_LF;	//			ϊ	 ke
				}
				break;

			case AJCFLF_CR:													//	bqsR[hƂAϊ
				if (c1 == CC_CR) {											//		bqH
					pLfInfo->stl	 = 1;									//			ϊ񒷁 P
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//			ϊ	 ke
					rc = 1;													//			FsR[hP
				}
				break;

			case AJCFLF_LF_CRSKIP:											//	kesR[hƂAbq͏
				if		(c1 == CC_CR) {										//		bqH
					rc = 1;													//			FsR[hP
				}
				else if (c1 == CC_LF) {										//		keH
					pLfInfo->stl	 = 1;									//			ϊ񒷁 P
					pLfInfo->strA[0] = CC_LF;	pLfInfo->strW[0] = CC_LF;	//			ϊ	 ke
					rc = 1;													//			FsR[hP
				}
				break;

			case AJCFLF_CR_LFSKIP:											//	bqsR[hƂAke͏
				if		(c1 == CC_CR) {										//		bqH
					pLfInfo->stl	 = 1;									//			ϊ񒷁 P
					pLfInfo->strA[0] = CC_CR;	pLfInfo->strW[0] = CC_CR;	//			ϊ	 ke
					rc = 1;													//			FsR[hP
				}
				if (c1 == CC_LF) {											//		keH
					rc = 1;													//			FsR[hP
				}
				break;

		}
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	UI	CheckLFW(HAJCFILE pW, C_WCP pTxt, ULL lTxt, PLFINFO pLfInfo, BOOL fBE)
{
	UI		rc = 0;
	UW		c1, c2;
	BC		bc[2];

	memset(pLfInfo, 0, sizeof(LFINFO));

	if (lTxt >= 1) {
		//	eLXg擪̕R[hݒ
		c1 = *pTxt;
		if (lTxt >= 2) c2 = *(pTxt + 1);
		else		   c2 = 0;

		//	GfBAϊ
		if (fBE) {
			c1 = (WC)AjcExcWord(c1);
			c2 = (WC)AjcExcWord(c2);
		}
		//	sR[hϊ
		if (pW->LfCnv == AJCFLF_CRLF_TO_LF || pW->LfCnv == AJCFLF_CRLF_TO_CR) {
			if (c1 == CC_CR && c2 == CC_LF) {
				bc[0] = (BC)c1;
				bc[1] = (BC)c2;
				rc = CheckLFA(pW, bc, 2, pLfInfo);
			}
		}
		else {
			if (c1 == CC_CR || c1 == CC_LF) {
				bc[0] = (BC)c1;
				rc = CheckLFA(pW, bc, 1, pLfInfo);
			}
		}
		//	UNICODE(BigEndian)Ȃ΁AsGfBAϊ
		if (fBE) {
			pLfInfo->strW[0] = (WC)AjcExcWord((UW)pLfInfo->strW[0]);
			pLfInfo->strW[1] = (WC)AjcExcWord((UW)pLfInfo->strW[1]);
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	oCgt@CPǂݏoi}`oCg̏ꍇ́AoCgǂݏoj							//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				bfl		-	őǂݏooCgiobt@󂫃oCgj										//
//				pfLF	-	stÕobt@AhX												//
//																												//
//	߂l	F	O FǂݏõoCg																	//
//				O Fdne^G[																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI		ReadCharFromByteFile(HAJCFILE pW, BC buf[8], UI bfl, BOOL *pfLF)
{
	UI		rc	= 0;		//	߂liǂݏõoCgj
	UI		lf;				//	s̃oCg
	LFINFO	lfInf;			//	s

	//	stO
	*pfLF = FALSE;

	while (pW->FIx < pW->FSizeA) {
		//	keȂ΁Akei[Iiobt@t͓ǂݏoȂŏIj
		if (lf = CheckLFA(pW, pW->pInp.bcp, pW->FSizeA - pW->FIx, &lfInf)) {
			if (lfInf.stl <= bfl) {							//	sobt@Ɋi[\H
				pW->pInp.bcp += lf;							//		t@C|C^XV
				pW->FIx 	 += lf;							//		t@CCfNXXV
				if (lfInf.stl == 0) {						//		ǂݔ΂ibq^kejH
					continue;								//			ǂݔ΂Čp
				}
				else {										//		LȉsH
					strncpy(buf, lfInf.strA, lfInf.stl);	//			s߂ɐݒ
					rc	  = lfInf.stl;						//			߂ls
					*pfLF = TRUE;							//			s̎|AtOݒ
					break;									//			I
				}
			}
			else break;										//	obt@tȂΏI
		}
		//	̃oCgCobt@Ɋi[
		switch (pW->tec) {
			case AJCTEC_MBC:
				rc = AjcStrChkMbcLen (pW->pInp.bcp, (UI)(pW->FSizeA - pW->FIx));
				break;

			case AJCTEC_UTF_8:
				rc = AjcStrChkUtf8Len(pW->pInp.bcp, (UI)(pW->FSizeA - pW->FIx));
				break;

			case AJCTEC_EUC_J:
				rc = AjcStrChkEucLen (pW->pInp.bcp, (UI)(pW->FSizeA - pW->FIx));
				break;
		}
		//	i[Ct@C|C^XV
		if (rc != 0) {										//	dneȊOH
			strncpy(buf, pW->pInp.bcp, rc);					//		i[
			pW->pInp.bcp += rc;								//		t@C|C^XV
			pW->FIx 	 += rc;								//		t@CCfNXXV
		}
		else {												//	dne^t@CI[͔[oCgH
			pW->FIx 	 = pW->FSizeA;
		}
		break;												//	I
	}
	//	AJCFLF_LF_CRSKIP/AJCFLF_CR_LFSKIP̏ꍇA㑱̏sǂݔ΂
	if (pW->LfCnv == AJCFLF_LF_CRSKIP || pW->LfCnv == AJCFLF_CR_LFSKIP) {
		BC		cSkip;
		if (pW->LfCnv == AJCFLF_LF_CRSKIP) cSkip = 0x0D;
		else							   cSkip = 0x0A;
		while (pW->FIx < pW->FSizeA && *pW->pInp.bcp == cSkip) {
			pW->FIx++;
			pW->pInp.bcp++;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	tmhbncdt@CPǂݏoiTQ[gyȀꍇ́A[hǂݏoj					//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				buf		-	ǂݏoi[obt@													//
//				bfl		-	őǂݏo[hiobt@󂫃[hj										//
//				pfLF	-	stÕobt@AhX												//
//																												//
//	߂l	F	O Fǂݏõ[hiP`Qj														//
//				O Fdne^G[																			//
//--------------------------------------------------------------------------------------------------------------//
static	UI		ReadCharFromUnicodeFile(HAJCFILE pW, WC buf[8], UI bfl, BOOL *pfLF)
{
	UI		rc	= 0;		//	߂liǂݏõoCgj
	UI		lf;				//	s̃oCg
	LFINFO	lfInf;			//	s

	//	stO
	*pfLF = FALSE;

	while (pW->FIx < pW->FSizeA) {
		//	keȂ΁Akei[Iiobt@t͓ǂݏoȂŏIj
		if (lf = CheckLFW(pW, pW->pInp.wcp, pW->FSizeW - pW->FIx, &lfInf, pW->tec == AJCTEC_UTF_16BE)) {
			if (lfInf.stl <= bfl) {							//	sobt@Ɋi[\H
				pW->pInp.wcp += lf;							//		t@C|C^XV
				pW->FIx 	 += lf;							//		t@CCfNXXV
				if (lfInf.stl == 0) {						//		ǂݔ΂ibq^kejH
					continue;								//			ǂݔ΂Čp
				}
				else {										//		LȉsH
					wcsncpy(buf, lfInf.strW, lfInf.stl);	//			s߂ɐݒ
					rc	  = lfInf.stl;						//			߂ls
					*pfLF = TRUE;							//			s̎|AtOݒ
					break;									//			I
				}
			}
			else break;										//	obt@tȂΏI
		}
		//	̃[hCobt@Ɋi[
		switch (pW->tec) {
			case AJCTEC_UTF_16LE:
				rc = AjcStrChkU16LeLen(pW->pInp.wcp, (UI)(pW->FSizeW - pW->FIx));
				break;

			case AJCTEC_UTF_16BE:
				rc = AjcStrChkU16BeLen(pW->pInp.wcp, (UI)(pW->FSizeW - pW->FIx));
				break;
		}
		//	i[Ct@C|C^XV
		if (rc != 0) {										//	dneȊOH
			wcsncpy(buf, pW->pInp.wcp, rc);					//		i[
			pW->pInp.wcp += rc;								//		t@C|C^XV
			pW->FIx 	 += rc;								//		t@CCfNXXV
		}
		else {												//	dne^t@CI[͔[oCgH
			pW->FIx 	 = pW->FSizeW;
		}
		break;												//	I
	}
	//	AJCFLF_LF_CRSKIP/AJCFLF_CR_LFSKIP̏ꍇA㑱̏sǂݔ΂
	if (pW->LfCnv == AJCFLF_LF_CRSKIP || pW->LfCnv == AJCFLF_CR_LFSKIP) {
		WC		cSkip;
		if (pW->LfCnv == AJCFLF_LF_CRSKIP) cSkip = 0x000D;
		else							   cSkip = 0x000A;
		if (pW->tec == AJCTEC_UTF_16BE) {
			cSkip = (WC)AjcExcWord((UW)cSkip);
		}
		while (pW->FIx < pW->FSizeW && *pW->pInp.wcp == cSkip) {
			pW->FIx++;
			pW->pInp.bcp++;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ǂݏooCgobt@Ɋi[																		//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pInp	-	ǂݏooCg																//
//				lInp	-	ǂݏooCg̃oCg														//
//				pBuf	-	obt@|C^																	//
//				lBuf	-	obt@TCYiobt@̋oCg^[hj									//
//																												//
//	߂l	F	O Fobt@Ɋi[oCg^														//
//				O Fobt@t																				//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgobt@Ɋi[ -------------------------------------------------------------------------------//
static	UI	SetByteCharToBufA(HAJCFILE pW, C_BCP pInp, UI lInp, BCP pBuf, UI lBuf)
{
	UI	rc = 0;

	switch (pW->tec) {
		case AJCTEC_MBC:
			if (lBuf >= lInp) {
				memcpy(pBuf, pInp, lInp);
				rc = lInp;
			}
			break;

		case AJCTEC_UTF_8:
		{	UI	lMbc;
			//	UTF-8  SJIS ϊobt@Ɋi[
			if ((lMbc = AjcUtf8ToSJisEx(pInp, lInp, NULL, 0)) != 0) {
				if (lBuf >= lMbc) {
					AjcUtf8ToSJisEx(pInp, lInp, pBuf, lMbc);
					rc = lMbc;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = '?';
				rc	  = 1;
			}
			break;
		}
		case AJCTEC_EUC_J:
		{	UI	lMbc;
			//	EUC  SJIS ϊobt@Ɋi[
			if ((lMbc = AjcEucToSJisEx(pInp, lInp, NULL, 0)) != 0) {
				if (lBuf >= lMbc) {
					AjcEucToSJisEx(pInp, lInp, pBuf, lMbc);
					rc = lMbc;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = '?';
				rc	  = 1;
			}
			break;
		}
	}
	return rc;
}
//----- Chobt@Ɋi[ -------------------------------------------------------------------------------//
static	UI	SetByteCharToBufW(HAJCFILE pW, C_BCP pInp, UI lInp, WCP pBuf, UI lBuf)
{
	UI	rc = 0;

	switch (pW->tec) {
		case AJCTEC_MBC:
		{	UI	lUni;
			//	MBC  UNICODE ϊobt@Ɋi[
			if ((lUni = MultiByteToWideChar(CP_ACP, 0, pInp, lInp, NULL, 0)) != 0) {
				if (lBuf >= lUni) {
					MultiByteToWideChar(CP_ACP, 0, pInp, lInp, pBuf, lUni);
					rc = lUni;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = L'?';
				rc	  = 1;
			}
			break;
		}
		case AJCTEC_UTF_8:
		{	UI	lUni;
			//	UTF-8  UNICODE ϊobt@Ɋi[Cobt@tȂΏI
			if ((lUni = MultiByteToWideChar(CP_UTF8, 0, pInp, lInp, NULL, 0)) != 0) {
				if (lBuf >= lUni) {
					MultiByteToWideChar(CP_UTF8, 0, pInp, lInp, pBuf, lUni);
					rc = lUni;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = L'?';
				rc	  = 1;
			}
			break;
		}
		case AJCTEC_EUC_J:
		{	UI	lMbc;
			UI	lUni;
			BC	cMbc[8];
			//	EUC  SJIS ϊobt@Ɋi[
			if ((lMbc = AjcEucToSJisEx(pInp, lInp, cMbc, AJCTSIZE(cMbc))) != 0) {
				if ((lUni = MultiByteToWideChar(CP_ACP, 0, cMbc, lMbc, NULL, 0)) != 0) {
					if (lBuf >= lUni) {
						MultiByteToWideChar(CP_ACP, 0, cMbc, lMbc, pBuf, lUni);
						rc = lUni;
					}
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = L'?';
				rc	  = 1;
			}
			break;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	ǂݏoChobt@Ɋi[																		//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pInp	-	ǂݏooCg																//
//				lInp	-	ǂݏooCg̃oCg														//
//				pBuf	-	obt@|C^																	//
//				lBuf	-	obt@TCYiobt@̋oCg^[hj									//
//																												//
//	߂l	F	O Fobt@Ɋi[oCg^														//
//				O Fobt@t																				//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgobt@Ɋi[ -------------------------------------------------------------------------------//
static	UI	SetUnicodeCharToBufA(HAJCFILE pW, C_WCP pInp, UI lInp, BCP pBuf, UI lBuf)
{
	UI	rc = 0;

	switch (pW->tec) {
		case AJCTEC_UTF_16LE:
		{	UI	lMbc;
			//	UNICODE(LE)  SJIS ϊobt@Ɋi[
			if ((lMbc = WideCharToMultiByte(CP_ACP, 0, pInp, lInp, NULL, 0, NULL, NULL)) != 0) {
				if (lBuf >= lMbc) {
					WideCharToMultiByte(CP_ACP, 0, pInp, lInp, pBuf, lMbc, NULL, NULL);
					rc = lMbc;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = '?';
				rc	  = 1;
			}
			break;
		}
		case AJCTEC_UTF_16BE:
		{	UI	lMbc;
			//	UNICODE(BE)  SJIS ϊobt@Ɋi[
			if ((lMbc = RevedWideCharToMultiByte(pInp, lInp, NULL, 0)) != 0) {
				if (lBuf >= lMbc) {
					RevedWideCharToMultiByte(pInp, lInp, pBuf, lMbc);
					rc = lMbc;
				}
			}
			//	ϊśA'?' i[
			else if (lBuf >= 1) {
				*pBuf = '?';
				rc	  = 1;
			}
			break;
		}
	}
	return rc;
}
//----- Chobt@Ɋi[ -------------------------------------------------------------------------------//
static	UI	SetUnicodeCharToBufW(HAJCFILE pW, C_WCP pInp, UI lInp, WCP pBuf, UI lBuf)
{
	UI	rc = 0;

	switch (pW->tec) {
		case AJCTEC_UTF_16LE:
		{
			//	UNICODE(LE)obt@Ɋi[
			if (lBuf >= lInp) {
				wcsncpy(pBuf, pInp, lInp);
				rc = lInp;
			}
			break;
		}
		case AJCTEC_UTF_16BE:
		{
			//	UNICODE(BE)  UNICODE(LE) ϊobt@Ɋi[
			if (lBuf >= lInp) {
				UI		i;
				for (i = 0; i < lInp; i++) {
					*pBuf++ = (WC)AjcExcWord(*pInp++);
				}
				rc = lInp;
			}
			break;
		}
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//	obt@P[V(ixBuf)ɑΉt@C|C^擾iAjcFGetC()ɂt@CǂݏoʒuZoj	//
//																												//
//	@	F	pW		-	eLXgt@CANZXnh													//
//				pFIx	-	t@CP[Vʒui[obt@̃AhX								//
//																												//
//	߂l	F	obt@P[V(ixBuf)ɑΉt@C|C^											//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgf[^ -------------------------------------------------------------------------------------------//
static	VOP		GetFilePtrByBufA(HAJCFILE pW, ULLP pFIx)
{
	VOP		rc = NULL;
	UI		ix = pW->ixBuf;

	//	oCg}`oCg擪łꍇ́APoCg߂
	if (ix >= 1 && MAjcMbsBTypeA(pW->buf.mbc, ix - 1) == _MBC_LEAD) {
		ix--;
	}

	//	oCgt@CGR[hϊۂ̃oCgt@CʒuZo
	switch (pW->tec) {
		case AJCTEC_MBC:
			*pFIx = pW->BufFIx + ix;
			rc = pW->pInpTop.bcp + *pFIx;
			break;
		case AJCTEC_UTF_8:
			*pFIx = pW->BufFIx + AjcMbcToUtf8Ex(pW->buf.mbc, ix, NULL, 0);
			rc = pW->pInpTop.bcp + *pFIx;
			break;
		case AJCTEC_EUC_J:
			*pFIx = pW->BufFIx + AjcSJisToEucEx(pW->buf.mbc, ix, NULL, 0);
			rc = pW->pInpTop.bcp + *pFIx;
			break;
		case AJCTEC_UTF_16LE:
		case AJCTEC_UTF_16BE:
			*pFIx = pW->BufFIx + MultiByteToWideChar(CP_ACP, 0, pW->buf.mbc, ix, NULL, 0);
			rc = pW->pInpTop.wcp + *pFIx;
			break;
	}
	return rc;
}
//----- Chf[^ -------------------------------------------------------------------------------------------//
static	VOP		GetFilePtrByBufW(HAJCFILE pW, ULLP pFIx)
{
	VOP		rc = NULL;
	UI		ix = pW->ixBuf;

	//	[hTQ[gyA擪łꍇ́AP[h߂
	if (ix >= 1 && MAjcIsLeadW(pW->buf.uni[ix - 1])) {
		ix--;
	}

	//	Cht@CGR[hϊۂ̃oCgt@CʒuZo
	switch (pW->tec) {
		case AJCTEC_MBC:
			*pFIx = pW->BufFIx + WideCharToMultiByte(CP_ACP , 0, pW->buf.uni, ix, NULL, 0, NULL, NULL);
			rc = pW->pInpTop.bcp + *pFIx;
			break;
		case AJCTEC_UTF_8:
			*pFIx = pW->BufFIx + WideCharToMultiByte(CP_UTF8, 0, pW->buf.uni, ix, NULL, 0, NULL, NULL);
			rc = pW->pInpTop.bcp + *pFIx;
			break;
		case AJCTEC_EUC_J:
		{	UI		lTmp;
			BCP		pTmp;
			lTmp = WideCharToMultiByte(CP_ACP, 0, pW->buf.uni, ix, NULL, 0, NULL, NULL);
			if (lTmp != 0 && (pTmp = malloc(lTmp))) {
				WideCharToMultiByte(CP_ACP, 0, pW->buf.uni, ix, pTmp, lTmp, NULL, NULL);
				*pFIx = pW->BufFIx + AjcSJisToEucEx(pTmp, lTmp, NULL, 0);
				rc = pW->pInpTop.bcp + *pFIx;
				free(pTmp);
			}
			else {
				//	[Nmەs\́AɃobt@擪Ƃ
				*pFIx = pW->BufFIx;
				rc = pW->pInpTop.bcp + *pFIx;
			}
			break;
		}
		case AJCTEC_UTF_16LE:
		case AJCTEC_UTF_16BE:
			*pFIx = pW->BufFIx + ix;
			rc = pW->pInpTop.wcp + *pFIx;
			break;
	}
	return rc;
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	񏑂ݗpTu֐																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	obt@Ƀf[^i[																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCgf[^ -------------------------------------------------------------------------------------------//
static	BOOL	PutDataA(HAJCFILE pW, C_BCP pDat, UI lDat)
{
	BOOL	rc = TRUE;
	UI		rem = AJCTF_MAX_BUFA - pW->ixBuf;
	UI		len;
	UL		bytes;

	while (lDat != 0) {
		len = __min(lDat, rem);
		memcpy(&pW->buf.mbc[pW->ixBuf], pDat, len);
		pW->ixBuf += len;
		pDat	  += len;
		lDat	  -= len;
		rem 	  -= len;
		if (rem == 0) {
			if (WriteFile(pW->hFile, pW->buf.mbc, sizeof(pW->buf.mbc), &bytes, NULL) != 0 && bytes == sizeof(pW->buf.mbc)) {
				pW->ixBuf = 0;
				rem 	  = AJCTF_MAX_BUFA;
			}
			else {
				rc = FALSE;
				break;
			}
		}
	}
	pW->BufBytes = pW->ixBuf;
	return rc;
}
//----- Chf[^ -------------------------------------------------------------------------------------------//
static	BOOL	PutDataW(HAJCFILE pW, C_WCP pDat, UI lDat)
{
	BOOL	rc = TRUE;
	UI		rem = AJCTF_MAX_BUFW - pW->ixBuf;
	UI		len;
	UL		bytes;

	while (lDat != 0) {
		len = __min(lDat, rem);
		memcpy(&pW->buf.uni[pW->ixBuf], pDat, len * 2);
		pW->ixBuf += len;
		pDat	  += len;
		lDat	  -= len;
		rem 	  -= len;
		if (rem == 0) {
			if (WriteFile(pW->hFile, pW->buf.mbc, sizeof(pW->buf.uni), &bytes, NULL) != 0 && bytes == sizeof(pW->buf.uni)) {
				pW->ixBuf = 0;
				rem 	  = AJCTF_MAX_BUFW;
			}
			else {
				rc = FALSE;
				break;
			}
		}
	}
	pW->BufBytes = pW->ixBuf * 2;
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	obt@tbV																							//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	BOOL	FlushBuf(HAJCFILE pW)
{
	BOOL	rc = TRUE;
	UL		bytes;

	if (pW->ixBuf != 0) {
		if (!(WriteFile(pW->hFile, pW->buf.mbc, pW->BufBytes, &bytes, NULL) != 0 && bytes == pW->BufBytes)) {
			rc = FALSE;
		}
		pW->ixBuf	 = 0;
		pW->BufBytes = 0;
	}
	return rc;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	anlo																									//
//																												//
//--------------------------------------------------------------------------------------------------------------//
static	VO	WriteBOM(HAJCFILE pW)
{
	UL		bytes;

	if (pW->fBomOut) {
		switch (pW->tec) {
			case AJCTEC_UTF_8:		WriteFile(pW->hFile, (VOP)bom_utf8	 , sizeof bom_utf8	 , &bytes, NULL);	break;
			case AJCTEC_UTF_16LE:	WriteFile(pW->hFile, (VOP)bom_utf16le, sizeof bom_utf16le, &bytes, NULL);	break;
			case AJCTEC_UTF_16BE:	WriteFile(pW->hFile, (VOP)bom_utf16be, sizeof bom_utf16be, &bytes, NULL);	break;
		}
		pW->fBomOut = FALSE;
	}
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	labt@C																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL		WriteMbcA  (HAJCFILE pW, C_BCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	BCP		pTmp = NULL;
	C_BCP	pMbc;
	UI		lMbc;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenA(pTxt, lTxt);
		//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	eLXg𓮓Iobt@ɐ؂ւ
			if (pTmp = AjcTAllocA(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				strncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΂Ȃ΁Aϊobt@Ɋi[
			if (lf = CheckLFA(pW, pTxt, lTxt, &lfInf)) {
				rc = PutDataA(pW, lfInf.strA, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iscntrl((UB)*pTxt)) {
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && *pTxt == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && *pTxt == CC_LF))) {
					rc = PutDataA(pW, pTxt, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	MBCCeLXg[oCgȂΑޔďI
			if ((icl = AjcStrChkMbcLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UB)*pTxt;
				break;
			}
			//	R[h
			for (pMbc = pTxt, lMbc = 0; lMbc < lTxt && !iscntrl((UB)*pMbc); pMbc++, lMbc++);
			//	R[hȂꍇAŏI[oCgݒ
			if (lMbc >= lTxt || !iscntrl((UB)*pMbc)) {
				AJCMBCINFO mbi;
				if (AjcStrChkMbcPart(pTxt, lTxt - 1, &mbi)) lMbc = lTxt - (mbi.len - (mbi.ix + 1));
				else										lMbc = 1;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			rc	  = PutDataA(pW, pTxt, lMbc);
			pTxt += lMbc;
			lTxt -= lMbc;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL		WriteMbcW  (HAJCFILE pW, C_WCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	WCP		pTmp = NULL;
	C_WCP	pUni;
	BCP		pMbc;
	UI		lUni, lMbc;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenW(pTxt, lTxt);
		//	O̔[[hƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
			if (pTmp = AjcTAllocW(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				wcsncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFW(pW, pTxt, lTxt, &lfInf, FALSE)) {
				if (!PutDataA(pW, lfInf.strA, lfInf.stl)) {
					rc = FALSE;
				}
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iswcntrl(*pTxt)) {
				BC		bc = (BC)*pTxt;
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && bc == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && bc == CC_LF))) {
					if (!PutDataA(pW, &bc, 1)) {
						rc = FALSE;
					}
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	UNICODECeLXg[[hȂΑޔďI
			if ((icl = AjcStrChkU16LeLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UW)*pTxt;
				break;
			}
			//	R[h
			for (pUni = pTxt, lUni = 0; lUni < lTxt && !iswcntrl(*pUni); pUni++, lUni++);
			//	R[hȂꍇAŏI[[h[hݒ
			if (lUni >= lTxt || !iswcntrl(*pUni)) {
				if (MAjcIsLeadW(*(pTxt + (lTxt - 1)))) lUni = lTxt - 1;
				else								   lUni = lTxt;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lMbc = WideCharToMultiByte(CP_ACP, 0, pTxt, lUni, NULL, 0, NULL, NULL)) != 0) {
				if (pMbc = AjcTAllocA(lMbc)) {
					WideCharToMultiByte(CP_ACP, 0, pTxt, lUni, pMbc, lMbc, NULL, NULL);
					if (!PutDataA(pW, pMbc, lMbc)) {
						rc = FALSE;
					}
					pTxt += lUni;
					lTxt -= lUni;
					AjcTFree(pMbc);
				}
				else rc = FALSE;
			}
			else rc = FALSE;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	tse|Wt@C																					//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL		WriteUtf8A (HAJCFILE pW, C_BCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	SJIS̃oCg
	LFINFO	lfInf;			//	s
	BCP		pTmp = NULL;	//	eLXg؂ւobt@
	C_BCP	pMbc;
	BCP		pUtf8;
	UI		lMbc, lUtf8;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenA(pTxt, lTxt);
		//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	eLXg𓮓Iobt@ɐ؂ւ
			if (pTmp = AjcTAllocA(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				strncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFA(pW, pTxt, lTxt, &lfInf)) {
				rc = PutDataA(pW, lfInf.strA, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iscntrl((UB)*pTxt)) {
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && *pTxt == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && *pTxt == CC_LF))) {
					rc = PutDataA(pW, pTxt, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	MBCCeLXg[oCgȂΑޔďI
			if ((icl = AjcStrChkMbcLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UB)*pTxt;
				break;
			}
			//	R[h
			for (pMbc = pTxt, lMbc = 0; lMbc < lTxt && !iscntrl((UB)*pMbc); pMbc++, lMbc++);
			//	R[hȂꍇAŏI[oCgݒ
			if (lMbc >= lTxt || !iscntrl((UB)*pMbc)) {
				AJCMBCINFO mbi;
				if (AjcStrChkMbcPart(pTxt, lTxt - 1, &mbi)) lMbc = lTxt - (mbi.len - (mbi.ix + 1));
				else										lMbc = 1;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lUtf8 = AjcMbcToUtf8Ex(pTxt, lMbc, NULL, 0)) != 0) {
				if (pUtf8 = AjcTAllocA(lUtf8)) {
					AjcMbcToUtf8Ex(pTxt, lMbc, pUtf8, lUtf8);
					rc = PutDataA(pW, pUtf8, lUtf8);
					pTxt += lMbc;
					lTxt -= lMbc;
					AjcTFree(pUtf8);
				}
				else rc = FALSE;
			}
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL		WriteUtf8W (HAJCFILE pW, C_WCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	WCP		pTmp = NULL;
	C_WCP	pUni;
	BCP		pUtf8;
	UI		lUni, lUtf8;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenW(pTxt, lTxt);
		//	O̔[[hƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
			if (pTmp = AjcTAllocW(1 + lTxt + 1)) {
				*pTmp = (WC)pW->SvOutC;
				wcsncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFW(pW, pTxt, lTxt, &lfInf, FALSE)) {
				rc = PutDataA(pW, lfInf.strA, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iswcntrl(*pTxt)) {
				BC		bc = (BC)*pTxt;
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && bc == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && bc == CC_LF))) {
					rc = PutDataA(pW, &bc, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	UNICODECeLXg[[hȂΑޔďI
			if ((icl = AjcStrChkU16LeLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UW)*pTxt;
				break;
			}
			//	R[h
			for (pUni = pTxt, lUni = 0; lUni < lTxt && !iswcntrl(*pUni); pUni++, lUni++);
			//	R[hȂꍇAŏI[[h[hݒ
			if (lUni >= lTxt || !iswcntrl(*pUni)) {
				if (MAjcIsLeadW(*(pTxt + (lTxt - 1)))) lUni = lTxt - 1;
				else								   lUni = lTxt;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lUtf8 = WideCharToMultiByte(CP_UTF8, 0, pTxt, lUni, NULL, 0, NULL, NULL)) != 0) {
				if (pUtf8 = AjcTAllocA(lUtf8)) {
					WideCharToMultiByte(CP_UTF8, 0, pTxt, lUni, pUtf8, lUtf8, NULL, NULL);
					rc = PutDataA(pW, pUtf8, lUtf8);
					pTxt += lUni;
					lTxt -= lUni;
					AjcTFree(pUtf8);
				}
				else rc = FALSE;
			}
			else rc = FALSE;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	dtbt@C																						//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL		WriteEucA  (HAJCFILE pW, C_BCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	SJIS̃oCg
	LFINFO	lfInf;			//	s
	BCP		pTmp = NULL;	//	eLXg؂ւobt@
	C_BCP	pMbc;
	BCP		pEuc;
	UI		lMbc, lEuc;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenA(pTxt, lTxt);
		//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	eLXg𓮓Iobt@ɐ؂ւ
			if (pTmp = AjcTAllocA(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				strncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFA(pW, pTxt, lTxt, &lfInf)) {
				rc = PutDataA(pW, lfInf.strA, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iscntrl((UB)*pTxt)) {
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && *pTxt == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && *pTxt == CC_LF))) {
					rc = PutDataA(pW, pTxt, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	MBCCeLXg[oCgȂΑޔďI
			if ((icl = AjcStrChkMbcLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UB)*pTxt;
				break;
			}
			//	R[h
			for (pMbc = pTxt, lMbc = 0; lMbc < lTxt && !iscntrl((UB)*pMbc); pMbc++, lMbc++);
			//	R[hȂꍇAŏI[oCgݒ
			if (lMbc >= lTxt || !iscntrl((UB)*pMbc)) {
				AJCMBCINFO mbi;
				if (AjcStrChkMbcPart(pTxt, lTxt - 1, &mbi)) lMbc = lTxt - (mbi.len - (mbi.ix + 1));
				else										lMbc = 1;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lEuc = AjcSJisToEucEx(pTxt, icl, NULL, 0)) != 0) {
				if (pEuc = AjcTAllocA(lEuc)) {
					AjcSJisToEucEx(pTxt, lMbc, pEuc, lEuc);
					rc = PutDataA(pW, pEuc, lEuc);
					pTxt += lMbc;
					lTxt -= lMbc;
					AjcTFree(pEuc);
				}
				else rc = FALSE;
			}
			else rc = FALSE;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL		WriteEucW  (HAJCFILE pW, C_WCP pTxt, UI lTxt)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	WCP		pTmp = NULL;
	C_WCP	pUni;
	BCP		pMbc;
	BCP		pEuc;
	UI		lUni, lMbc, lEuc;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenW(pTxt, lTxt);
		//	O̔[[hƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
			if (pTmp = AjcTAllocW(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				wcsncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFW(pW, pTxt, lTxt, &lfInf, FALSE)) {
				rc = PutDataA(pW, lfInf.strA, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iswcntrl(*pTxt)) {
				BC		bc = (BC)*pTxt;
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && bc == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && bc == CC_LF))) {
					rc = PutDataA(pW, &bc, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	UNICODECeLXg[[hȂΑޔďI
			if ((icl = AjcStrChkU16LeLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UW)*pTxt;
				break;
			}
			//	R[h
			for (pUni = pTxt, lUni = 0; lUni < lTxt && !iswcntrl(*pUni); pUni++, lUni++);
			//	R[hȂꍇAŏI[[h[hݒ
			if (lUni >= lTxt || !iswcntrl(*pUni)) {
				if (MAjcIsLeadW(*(pTxt + (lTxt - 1)))) lUni = lTxt - 1;
				else								   lUni = lTxt;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lMbc = WideCharToMultiByte(CP_ACP, 0, pTxt, lUni, NULL, 0, NULL, NULL)) != 0) {
				if (pMbc = AjcTAllocA(lMbc)) {
					WideCharToMultiByte(CP_ACP, 0, pTxt, lUni, pMbc, lMbc, NULL, NULL);
					if ((lEuc = AjcSJisToEucEx(pMbc, lMbc, NULL, 0)) != 0) {
						if (pEuc = AjcTAllocA(lEuc)) {
							AjcSJisToEucEx(pMbc, lMbc, pEuc, lEuc);
							rc = PutDataA(pW, pEuc, lEuc);
							pTxt += lUni;
							lTxt -= lUni;
							AjcTFree(pEuc);
						}
						else rc = FALSE;
					}
					else rc = FALSE;
					AjcTFree(pMbc);
				}
				else rc = FALSE;
			}
			else rc = FALSE;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}

//--------------------------------------------------------------------------------------------------------------//
//																												//
//	tmhbncdt@C																				//
//																												//
//--------------------------------------------------------------------------------------------------------------//
//----- oCg ---------------------------------------------------------------------------------------------//
static	BOOL		WriteUniA (HAJCFILE pW, C_BCP pTxt, UI lTxt, BOOL fBE)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	BCP		pTmp = NULL;
	C_BCP	pMbc;
	WCP		pUni;
	UI		lMbc, lUni;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenA(pTxt, lTxt);
		//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	eLXg𓮓Iobt@ɐ؂ւ
			if (pTmp = AjcTAllocA(1 + lTxt + 1)) {
				*pTmp = (BC)pW->SvOutC;
				strncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFA(pW, pTxt, lTxt, &lfInf)) {
				if (fBE) {
					UI		i;
					for (i = 0; i < lfInf.stl; i++) {
						lfInf.strW[i] = (WC)AjcExcWord((UW)lfInf.strW[i]);
					}
				}
				rc = PutDataW(pW, lfInf.strW, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iscntrl((UB)*pTxt)) {
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && *pTxt == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && *pTxt == CC_LF))) {
					WC		wc = ((fBE) ? ((WC)AjcExcWord((UW)*pTxt)) : ((WC)*pTxt));
					rc = PutDataW(pW, &wc, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	MBCCeLXg[oCgȂΑޔďI
			if ((icl = AjcStrChkMbcLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UB)*pTxt;
				break;
			}
			//	R[h
			for (pMbc = pTxt, lMbc = 0; lMbc < lTxt && !iscntrl((UB)*pMbc); pMbc++, lMbc++);
			//	R[hȂꍇAŏI[oCgݒ
			if (lMbc >= lTxt || !iscntrl((UB)*pMbc)) {
				AJCMBCINFO mbi;
				if (AjcStrChkMbcPart(pTxt, lTxt - 1, &mbi)) lMbc = lTxt - (mbi.len - (mbi.ix + 1));
				else										lMbc = 1;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			if ((lUni = MultiByteToWideChar(CP_ACP, 0, pTxt, lMbc, NULL, 0)) != 0) {
				if (pUni = AjcTAllocW(lUni)) {
					MultiByteToWideChar(CP_ACP, 0, pTxt, lMbc, pUni, lUni);
					if (fBE) {
						UI	i;
						for (i = 0; i < lUni; i++) {
							pUni[i] = (WC)AjcExcWord((UW)pUni[i]);
						}
					}
					rc = PutDataW(pW, pUni, lUni);
					pTxt += lMbc;
					lTxt -= lMbc;
					AjcTFree(pUni);
				}
				else rc = FALSE;
		}
			else rc = FALSE;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}
//----- Ch ---------------------------------------------------------------------------------------------//
static	BOOL		WriteUniW (HAJCFILE pW, C_WCP pTxt, UI lTxt, BOOL fBE)
{
	BOOL	rc = TRUE;
	UI		lf;				//	eLXg̉s
	UI		icl;			//	MBC̃oCg
	LFINFO	lfInf;			//	s
	WCP		pTmp = NULL;
	C_WCP	pUni;
	UI		lUni;
	UI		lMax = lTxt;	//	[v}~i[vɂ͂ȂȂnYAÔ߂ɗ}~j
	UI		lCnt = 0;		//	[v}~JE^

	if (lTxt != 0 && *pTxt != 0) {
		//	eLXgݒ^␳
		lTxt = AjcStrAdjustLenW(pTxt, lTxt);
		//	O̔[[hƃeLXg𓮓Iobt@Ɋi[
		if (pW->SvOutC != 0) {
			//	O̔[oCgƃeLXg𓮓Iobt@Ɋi[
			if (pTmp = AjcTAllocW(1 + lTxt + 1)) {
				*pTmp = (WC)pW->SvOutC;
				wcsncpy(pTmp + 1, pTxt, lTxt);
				*(pTmp + (1 + lTxt)) = 0;
				//	eLXg|C^؂ւ
				pTxt = pTmp;
				lTxt++;
			}
			else rc = FALSE;
			pW->SvOutC = 0;
		}
		while (rc == TRUE && lCnt++ <= lMax && lTxt != 0 && *pTxt != 0) {
			//	sȂ΁Aϊobt@Ɋi[
			if (lf = CheckLFW(pW, pTxt, lTxt, &lfInf, FALSE)) {
				if (fBE) {
					UI		i;
					for (i = 0; i < lfInf.stl; i++) {
						lfInf.strW[i] = (WC)AjcExcWord((UW)lfInf.strW[i]);
					}
				}
				rc = PutDataW(pW, lfInf.strW, lfInf.stl);
				pTxt += lf;
				lTxt -= lf;
				continue;	//	š㑱񏈗
			}
			//	R[hȂ΁AYR[hobt@Ɋi[
			else if (iswcntrl(*pTxt)) {
				WC	wc;
				if (!((pW->LfCnv == AJCFLF_LF_CRSKIP && *pTxt == CC_CR) || (pW->LfCnv == AJCFLF_CR_LFSKIP && *pTxt == CC_LF))) {
					if (fBE) wc = (WC)AjcExcWord((UW)*pTxt);
					else	 wc = *pTxt;
					rc = PutDataW(pW, &wc, 1);
				}
				pTxt++;
				lTxt--;
				continue;	//	R[ȟ㑱񏈗
			}
			//	UNICODECeLXg[[hȂΑޔďI
			if ((icl = AjcStrChkU16LeLen(pTxt, lTxt)) == 0) {
				//	o̓f[^I[[oCg
				pW->SvOutC = (UW)*pTxt;
				break;
			}
			//	R[h
			for (pUni = pTxt, lUni = 0; lUni < lTxt && !iswcntrl(*pUni); pUni++, lUni++);
			//	R[hȂꍇAŏI[[h[hݒ
			if (lUni >= lTxt || !iswcntrl(*pUni)) {
				if (MAjcIsLeadW(*(pTxt + (lTxt - 1)))) lUni = lTxt - 1;
				else								   lUni = lTxt;
			}
			//	R[h̒O܂Ł^ŏI[oCgobt@Ɋi[
			//	UNICODE(LE)obt@Ɋi[
			if (!fBE) {
				rc = PutDataW(pW, pTxt, lUni);
			}
			//	UNICODE(BE)obt@Ɋi[
			else {
				UI	i;
				WC	be;
				for (i = 0; i < lUni; i++) {
					be = (WC)AjcExcWord((UW)pTxt[i]);
					rc = PutDataW(pW, &be, 1);
				}
			}
			pTxt += lUni;
			lTxt -= lUni;
		}
		//	Iobt@
		if (pTmp != NULL) free(pTmp);
	}
	return rc;
}

