using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;


//==============================================================================================================//
//																												//
//	̃W[Ŏgp鋤ʒ`																			//
//																												//
//==============================================================================================================//
namespace CAjrCustCtrl
{
	//----------------------------------------------------------------------------------------------------------//
	//	萔																									//
	//----------------------------------------------------------------------------------------------------------//
	//----- eLXgỏ͎E[^[ -------------------------------------------------------------------------//
	public static class Txo {
		public const int Right	= 0x1FFF2000;
		public const int Bottom = 0x1FFF6000;
		public const int Center = 0x1FFFA000;
	}
	//----------------------------------------------------------------------------------------------------------//
	//	\́^萔																							//
	//----------------------------------------------------------------------------------------------------------//
	//-----  -------------------------------------------------------------------------------------------//
	public enum ELangId : int
	{
		English = 0, Japanese = 0x411
	}
	//----- QcxNg ---------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC2DVEC {
		public AJC2DVEC(double x, double y)
		{
			this.x = x;
			this.y = y;
		}
		public double x, y;
	}
	//----- QcCxNgin_ƕxNgj------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC2DLVEC {
		public AJC2DLVEC(AJC2DVEC p, AJC2DVEC v)
		{
			this.p.x = p.x;	this.v.x = v.x;
			this.p.y = p.y;	this.v.y = v.y;
		}
		public AJC2DVEC p, v;
	}
	//----- RcxNg ---------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DVEC
	{
		public AJC3DVEC(double x, double y, double z)
		{
			this.x = x;
			this.y = y;
			this.z = z;
		}
		public double x, y, z;
	}
	//----- RcCxNgin_ƕxNgj------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DLVEC
	{
		public AJC3DLVEC(AJC3DVEC p, AJC3DVEC v)
		{
			this.p.x = p.x;	this.v.x = v.x;
			this.p.y = p.y;	this.v.y = v.y;
			this.p.z = p.z;	this.v.z = v.z;
		}
		public AJC3DVEC p, v;
	}
	//----- RcC|Cgin_ƏI_j-------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DLINE
	{
		public AJC3DLINE(AJC3DVEC p1, AJC3DVEC p2)
		{
			this.p1.x = p1.x;	this.p2.x = p2.x;
			this.p1.y = p1.y;	this.p2.y = p2.y;
			this.p1.z = p1.z;	this.p2.z = p2.z;
		}
		public AJC3DVEC p1, p2;
	}
	//----- RcOp` -------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DTRI
	{
		public AJC3DTRI(AJC3DVEC p1, AJC3DVEC p2, AJC3DVEC p3)
		{
			this.p1.x = p1.x;	this.p1.y = p1.y;	this.p1.z = p1.z;
			this.p2.x = p2.x;	this.p2.y = p2.y;	this.p2.z = p2.z;
			this.p3.x = p3.x;	this.p3.y = p3.y;	this.p3.z = p3.z;
		}
		public AJC3DVEC p1, p2, p3;
	}
	//----- Rcs -------------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DMAT
	{
		public AJC3DMAT(double ini)
		{
			this.m = new double[3,3];
			this.m[0,0] = ini;	this.m[0,1] = ini;	this.m[0,2] = ini;	
			this.m[1,0] = ini;	this.m[1,1] = ini;	this.m[1,2] = ini;	
			this.m[2,0] = ini;	this.m[2,1] = ini;	this.m[2,2] = ini;	
		}
		public AJC3DMAT(double v00, double v01, double v02, double v10, double v11, double v12, double v20, double v21, double v22)
		{
			this.m = new double[3,3];
			this.m[0,0] = v00;	this.m[0,1] = v01;	this.m[0,2] = v02;	
			this.m[1,0] = v10;	this.m[1,1] = v11;	this.m[1,2] = v12;	
			this.m[2,0] = v20;	this.m[2,1] = v21;	this.m[2,2] = v22;	
		}
		public double[,]	m;
	}
	//----- Rc~̏ ---------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DCIRINFO
	{
		public AJC3DLINE	lt1, lt2;			//	~ɓڂQ̒
		public AJC3DLINE	lc1, lc2;			//	ڐ̒_̐
		public AJC3DLVEC	lvc;				//	~̒SƖ@
		public double		cr;					//	~̔a
	}
	//----- Rc̏ ---------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJC3DSPHINFO {
		public AJC3DCIRINFO	cif1, cif2;			//	ɓڂQ̉~
		public AJC3DLINE	ls1 , ls2;			//	ډ~S狅Sւ̒
		public AJC3DVEC		sc;					//	̒S
		public double		sr;					//	̔a
	}
	//----- Rc^Qcʕ\̉^c̎ -------------------------------------------------------------//
	public enum EAJCPLANEAXIS {
		XP,										//	w
		YP,										//	x V 
		ZP,										//	y V 
		XM,										//	w~
		YM,										//	x V 
		ZM,										//	y V 
	}
	//----- Rc^QceLXg`惂[h -----------------------------------------------------------------------//
	public enum EAJCTXOMD {
		RIGHT			,						//	_̉E
		LEFT			,						//	 V 
		CENTER			,						//	 V 
		BELLOW_RIGHT	,						//	_̉̉E
		BELLOW_LEFT		,						//	  V	
		BELLOW_CENTER	,						//	  V	
		ABOVE_RIGHT		,						//	_̏̉E
		ABOVE_LEFT		,						//	  V	
		ABOVE_CENTER	,						//	  V	
	}
	//----- R\[Av̏InhE[`ɓn萔 ---------------------------------------------//
	public enum EAJCEXITTYPE
	{
		CTRL_C_EVENT		= 0,
		CTRL_BREAK_EVENT	= 1,
		CTRL_CLOSE_EVENT	= 2,
		CTRL_LOGOFF_EVENT	= 5,
		CTRL_SHUTDOWN_EVENT = 6
	}

	//----- ʒu -------------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJCPOINT {
		public int	x;
		public int	y;
	}
	//----- ` -------------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJCRECT {
		public int	left;
		public int	top;
		public int	right;
		public int	bottom;
	}
	//----- TCY -----------------------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJCSIZE {
		public int	cx;
		public int	cy;
	}
	//----------------------------------------------------------------------------------------------------------//
	//	eLXgt@C GR[h																				//
	//----------------------------------------------------------------------------------------------------------//
	//----- eLXgGR[h ---------------------------------------------------------------------------------//
	public enum ETextEncode : int
	{
		TEC_MBC			= 0,		//	}`oCg
		TEC_UTF_8		= 1,		//	tse|W
		TEC_EUC_J		= 2,		//	dtbi{j
		TEC_UTF_16LE	= 3,		//	tse|PUkd
		TEC_UTF_16BE	= 4,		//	tse|PUad
		TEC_AUTO		= 9,		//	`tsnî͎ݗLj
	}
	//----- anlóiݗpj----------------------------------------------------------------------------//
	public enum EBomMode : int
	{
		NOT_WRITE_BOM	= 0,		//	anl܂Ȃ
		WRITE_BOM		= 1,		//	anl
	}
	//----------------------------------------------------------------------------------------------------------//
	//	eLXgt@C sR[hϊ[h																	//
	//----------------------------------------------------------------------------------------------------------//
	public enum ETextLfConv : int
	{
		NONE			= 0	,		//	ϊ
		LF_TO_CRLF			,		//	ke  bqCkeit@Cݎ̃ftHgj
		LF_TO_CR			,		//	ke  bq
		CR_TO_CRLF			,		//	bq  bqCke
		CR_TO_LF			,		//	bq  ke
		CRLF_TO_LF			,		//	bqCke  keit@CǂݏõftHgj
		CRLF_TO_CR			,		//	bqCke  bq
		LF					,		//	keŉsCϊ
		CR					,		//	bqŉsCϊ
		LF_CRSKIP			,		//	keŉsCbq
		CR_LFSKIP			,		//	bqŉsCke
	}

	//----------------------------------------------------------------------------------------------------------//
	//	Qc^RcOtBbN \́^萔																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- vbgʒm -----------------------------------------------------------------------------------//
	public struct PlotInfo
	{
		public int		ix;
		public AJC3DVEC	v;
	}
	//----- 2D / 3D [h ---------------------------------------------------------------------------------//
	public enum EDIMMODE : int
	{
		MODE_2D	= 2,
		MODE_3D = 3
	}
	//----------------------------------------------------------------------------------------------------------//
	//	_Ot 萔																							//
	//----------------------------------------------------------------------------------------------------------//
	//----- ̑ -------------------------------------------------------------------------------------------//
	public enum EBarLineStyle : int
	{
		Solid		= 0,		//	
		Dash		= 1,		//	-------
		Dot			= 2,		//	.......
		DashDot		= 3,		//	_._._._
		DashDotDot	= 4,		//	_.._.._
		NullLine	= 5,		//	
		InsideFrame = 6			//	
	}
	//----------------------------------------------------------------------------------------------------------//
	//	bvRpC 萔																				//
	//----------------------------------------------------------------------------------------------------------//
	//----- vvZXRg -----------------------------------------------------------------------//
	public enum EPpcComItem : int {
		DEFINE		= 0x0001,			//	#define
		UNDEF		= 0x0002,			//	#undef
		INCLUDE		= 0x0004,			//	#include
		IFDEF		= 0x0008,			//	#ifdef
		IFNDEF		= 0x0010,			//	#ifdef
		IF			= 0x0020,			//	#if
		ELIF		= 0x0040,			//	#ifndef
		ELSE		= 0x0080,			//	#else
		ENDIF		= 0x0100,			//	#endif
		OTHERS		= 0x0200,			//	̑i#pragmaj

		COND		= (IFDEF | IFNDEF | IF | ELIF | ELSE | ENDIF),
		ALL			= (COND  | DEFINE | UNDEF),
	}
	//----- IvVtO -----------------------------------------------------------------------------------//
	public enum EPpcOption : int {
		NONE			= 0x0000,					//	IvV
		AUTOSRH			= 0x0001,					//	CN[ht@CtO
		ONCE			= 0x0002,					//	CN[ht@CP񂾂ǂݏotO
		GENALL			= 0x0004,					//	񐶐iRpCU̕jt@Co͂
		AUTOSRH_ONCE	= (AUTOSRH | ONCE  ),
		ONCE_GENALL		= (ONCE    | GENALL),
		AUTOSRH_GENALL	= (AUTOSRH | GENALL),
		ALL 			= (AUTOSRH | ONCE | GENALL),
	}
	//----- vRpC ---------------------------------------------------------------------------------//
	public enum EPpcResult : int {
		OK			= 0	,			//	nj
		NOFILE			,			//	t@C
		MEMERR			,			//	G[
		STOP			,			//	~
		NOTOKEN			,			//	g[N
		PARAM			,			//	p^G[
		OUTFILE		= 99,			//	o̓t@Cs
	}
	//----- ʒmR[h -----------------------------------------------------------------------------------------//
	public enum EPpcNtc : int {
		FILE_LNO		= 1	,		//	t@CCsԍʒm							"t@C"		s				lXgliO`j
		SRH_START		,			//	CN[ht@CJnʒm				"Inct@C"		"tH_"		|
		SRH_DIR			,			//	CN[ht@C̃tH_ʒm		"tH_pX"		|					|
		SRH_END			,			//	CN[ht@CIʒm				"Inct@C"		|					|
		OPTSYM			,			//	vvZXpIvVV{ʒm			PCAJCPPCTKNNODE		|					|
		MACDEF			,			//	}N`ʒm									PCAJCPPCTKNNODE		|					|
		MACREF			,			//	}NQƒʒm									PCAJCPPCTKNNODE		PCAJCPPCMACINFO		|
		OUTLOOP			,			//	g[NXg[t@C֏o̓[v		|					|					|
		SRCTEC			,			//	\[Xt@C̃GR[hʒm					"t@CpX"		GR[h			anl
//		TOKEN			,			//	\[Xǂݏog[Nʒm				g[NR[h		"g[N"	|
	}
	//----- G[R[h ---------------------------------------------------------------------------------------//
	public enum EPpcErr {
		//--- ʃG[ -----------//
		ERROR_OK			= 0	,	//												|					|					|
		ERROR_SRC_OPEN			,	//	\[Xt@CI[vł܂				"t@CpX"		|					|
		ERROR_INC_OPEN			,	//	INCLUDEt@CI[vł܂				"t@CpX"		s				"IncludepX"
		ERROR_NO_SYMBOL			,	//	#ifdef/#ifndefŃV{w肳Ă܂	"t@CpX"		s				|
		ERROR_COND_NOTCLS		,	//	(#if`#endif)N[YĂ܂		"t@CpX"		s(=1Œ)		|
		ERROR_COND_DEEP			,	//	(#if`#endif)̃lXg[܂			"t@CpX"		s				|
		ERROR_NOT_IN_IF			,	//	Ήu#if / #ifdef / #ifndefv܂	"t@CpX"		s				|
		ERROR_ELIF_IN_ELSE		,	//	u#elsevɁu#elifv͋Lqł܂		"t@CpX"		s				|
		ERROR_ELSE_IN_ELSE		,	//	u#elsevɁu#elsev͋Lqł܂		"t@CpX"		s				|
		//--- defined --------------//
		DEFERR_INVALID	= 1000	,	//	defined̍\								"t@CpX"		s				|
		DEFERR_NEED_LP			,	//	defined'̌ɍ '(' Kvł				"t@CpX"		s				|
		DEFERR_NEED_SYMBOL		,	//	defined'ŃV{w肳Ă܂			"t@CpX"		s				|
		DEFERR_NEED_RP			,	//	V{̎ɉE ')' Kvł				"t@CpX"		s				"V{"
		//--- MACRO ----------------//
		MACERR_NEED_LP	= 2000	,	//	}ŇɍʂKvł					"t@CpX"		s				"}N"
		MACERR_NEED_RP			,	//	̌ɉEʂKvł					"t@CpX"		s				""
		MACERR_NEED_RP_C			,	//	̌ɉEʂJ}Kvł			"t@CpX"		s				""
		MACERR_MULTDEF			,	//	}Nd`									"t@CpX"		s				"}N"
		MACERR_INV_NAME			,	//	sȃ}Nł								"t@CpX"		s				|
		MACERR_NO_NAME			,	//	}N܂							"t@CpX"		s				|
		MACERR_NEST_OVER			,	//	}NWJlXgI[o[						|					|					|
		MACERR_ARG_LACK			,	//	}N̈Ȃ						"t@CpX"		s				"}N"
		MACERR_ARG_OVER			,	//	}N̈							"t@CpX"		s				"}N"
		//--- INCLUDE --------------//
		INCERR_NO_FILE	= 3000	,	//	Include t@Cw肳Ă܂			"t@CpX"		s				|
		INCERR_INV_FILE			,	//	Include t@C̋Lqsł				"t@CpX"		s				|
		INCERR_NOTCLS			,	//	Include t@Č '>' ܂		"t@CpX"		s				|
		INCERR_NEST_OVER			,	//	Include t@C̃lXgI[o[				"t@CpX"		s				|
		INCERR_NOT_FOUND			,	//	Include t@C܂				"t@CpX"		s				"Includet@C"
		//--- ]G[ -------//
		SCLERR_INVSYL	= 5000	,	//	Ȍ										"t@CpX"		s				""
		SCLERR_DIVZERO			,	//	[Z										"t@CpX"		s				|
		SCLERR_NOTCLS			,	//	ʂĂȂ							"t@CpX"		s				|
		SCLERR_EXPRESSION		,	//	sȐ\									"t@CpX"		s				"sȌ"
		SCLERR_EOL				,	//	\rŏIĂ					"t@CpX"		s				|
		SCLERR_OVERNEST			,	//	\̃lXgI[o[						"t@CpX"		s				|
		//--- 蓖Ďs ---//
		ERROR_MEMALLOC	= 9999		//	蓖Ďs								|					|					|
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 bꎚ啪 萔																					//
	//----------------------------------------------------------------------------------------------------------//
	//----- @\tO -----------------------------------------------------------------------------------------//
	public enum ECtkOpt : uint {
		//	Bit 7 - 0
		CPLUSPLUS		=	0x00000001	,		//	b{{̃g[N܂߂
		INCSPACE		=	0x00000002	,		//	󔒁^s^Rgg[NɊ܂߂
		INCSYM_DOLLAR	=	0x00000004	,		//	V{̉pƂăh}[N($)܂߂
		INCSYM_ATMARK	=	0x00000008	,		//	V{̉pƂăAbg}[N(@)܂߂	
		INCSYM_MBSTR	=	0x00000010	,		//	V{̉pƂă}`oCg܂߂
		APOST_NOESC		=	0x00000020	,		//	A|XgtB(')ň͂܂ꂽ́AGXP[X(\)FȂ
		DOTSYMBOL		=	0x00000040	,		//	V{{Dot(.){P̃V{Ƃ݂Ȃ(Ex. P3.12)
		ASMHEX			=	0x00000080	,		//	AZuL@16iiH, ex 0FFH)

		//	Bit 31-24
		LBF_1K			=	0x01000000	,		//	eLXgt@Cs̓ǂݏoobt@TCY QKB
		LBF_2K			=	0x02000000	,		//			V								   SKB
		LBF_4K			=	0x04000000	,		//			V								   WKB
		LBF_8K			=	0x08000000	,		//			V								   16KB
		LBF_16K			=	0x10000000	,		//			V								   32KB
		LBF_32K			=	0x20000000	,		//			V								   64KB
		LBF_64K			=	0x40000000	,		//			V								  128KB
		LBF_128K		=	0x80000000	,		//			V								  256KB
	}
	//----- ^u ---------------------------------------------------------------------------------------------//
	public enum ECtkTabWidth {
		TABW_2	=  2,
		TABW_4	=  4,
		TABW_8	=  8,
		TABW_16	=  16,
	}
	//----- g[NʃtO ---------------------------------------------------------------------------------//
	public enum ECtkFlg {
		PREPRO			=	0x0080,				//	vvZX
		PPTOP			=	0x0040,				//	vvZX̐擪g[Nij
		MACNAME			=	0x0020,				//	}N
		MACWITHARG		=	0x0010,				//	t̃}N
		MACARG			=	0x0008,				//	}N' ( EEE ) '
		MACBODY			=	0x0004,				//	}N{fB
		NXTSPC			=	0x0002,				//	g[N̎ɋ󔒂tO
		WIDECHAR		=	0x0001,				//	ChiL'X' / L"XXX"jtO
	}

	//----- G[R[h ---------------------------------------------------------------------------------------//
	public enum ECtkError {
		OK				 		=	0		,	//	nj
		NULLPTR					=	0x8000	,	//	mtkk|C^w肳ꂽ
		ZEROSIZE				=	0x4000	,	//	obt@TCY[
		MEMALLOC				=	0x2000	,	//	蓖Ďs
		INVALID_OCTALNUMBER		=	0x1000	,	//	sȂWi
		INVALID_HEXADECIMAL		=	0x0800	,	//	sȂPUi
		INVALID_REALNUMBER		=	0x0400	,	//	sȎ\
		INVALID_SUFFIX			=	0x0200	,	//	sȃTtBbNX
		INVALID_DELIMITER		=	0x0100	,	//	sȃf~^
		LFINSTR					=	0x0080	,	//	񒆂ɉs܂܂Ă
		BUFOVER					=	0x0040	,	//	g[Nobt@I[o[
		EOFINCOMMENT			=	0x0020	,	//	Rgɂdneoit@CŃRgĂȂj
	}

	//----- g[NʃR[h ---------------------------------------------------------------------------------//
	public enum ECtkKnd {
		USRSYM					=	0x0100	,	//	[UV{
		RSVSYM					=	0x0200	,	//	\
		VALUE					=	0x0400	,	//	l萔
		STRING					=	0x0800	,	//	
		PATHNAME				=	0x1000	,	//	t@CpXi#includê)
		DELIMIT					=	0x2000	,	//	f~^
		SPACE					=	0x4000	,	//	󔒁^s^Rg^spLij
		NEXT					=	0x8000	,	//	[U`p
	}

	//----- l萔̃TtBbNXER[h ---------------------------------------------------------------------//
	public enum ECtkSuf {
		SUF_NONE	=	0	,		//	TtBbNXȂ
		SUF_L				,		//	L
		SUF_UL				,		//	UL / LU
		SUF_LL				,		//	LL
		SUF_ULL				,		//	ULL
		SUF_FLOAT			,		//	F
		SUF_DOUBLE			,		//	D
		SUF_LDOUBLE					//	L
	}

	//----- g[NR[h -------------------------------------------------------------------------------------//
	public enum ECtkCode {
		EOF			= 0							,	//	End Of File

		USR_NAME	= ECtkKnd.USRSYM			,	//	[U`

		RSV_ASM		= ECtkKnd.RSVSYM			,	//	asm
		RSV_AUTO								,	//	auto
		RSV_BREAK								,	//	break
		RSV_CASE								,	//	case
		RSV_CATCH								,	//	catch		iC++j
		RSV_CHAR								,	//	char
		RSV_CLASS								,	//	class		iC++j
		RSV_CONST								,	//	const
		RSV_CONCAST								,	//	const_cast	iC++j
		RSV_CONTINUE							,	//	continue
		RSV_DEFAULT								,	//	default
		RSV_DEFINE								,	//	define		(vvZbTj
		RSV_DEFINED								,	//	defined		(vvZbTj
		RSV_DELETE								,	//	delete		iC++j
		RSV_DO									,	//	do
		RSV_DOUBLE								,	//	double
		RSV_DYNCAST								,	//	dynamic_castiC++j
		RSV_ELIF								,	//	elif		(vvZbTj
		RSV_ELSE								,	//	else		(vvZbTpj
		RSV_ENDIF								,	//	endif		(vvZbTj
		RSV_ENUM								,	//	enum
		RSV_EXTERN								,	//	extern
		RSV_FLOAT								,	//	float
		RSV_FOR									,	//	for
		RSV_FRIEND								,	//	friend		iC++j
		RSV_GOTO								,	//	goto
		RSV_IF									,	//	if			(vvZbTpj
		RSV_IFDEF								,	//	ifdef		(vvZbTj
		RSV_IFNDEF								,	//	ifndef		(vvZbTj
		RSV_INCLUDE								,	//	include		(vvZbTj
		RSV_INLINE								,	//	inline
		RSV_INT									,	//	int
		RSV_LONG								,	//	long
		RSV_NEW									,	//	new			iC++j
		RSV_OPERATOR							,	//	operator	iC++j
		RSV_PRAGMA								,	//	pragma		(vvZbTj
		RSV_PRIVATE								,	//	private		iC++j
		RSV_PROTECTED							,	//	protected	iC++j
		RSV_PUBLIC								,	//	public		iC++j
		RSV_REGISTER							,	//	register
		RSV_REICAST								,	//	reinterpret_castiC++j
		RSV_RETURN								,	//	return
		RSV_SHORT								,	//	short
		RSV_SIGNED								,	//	signed
		RSV_SIZEOF								,	//	sizeof
		RSV_STATIC								,	//	static
		RSV_STACAST								,	//	static_cast	iC++j
		RSV_STRUCT								,	//	struct
		RSV_SWITCH								,	//	switch
		RSV_TEMPLATE							,	//	template	iC++j
		RSV_THIS								,	//	this		iC++j
		RSV_THROW								,	//	tnrow		iC++j
		RSV_TRY									,	//	try			iC++j
		RSV_TYPEDEF								,	//	typedef
		RSV_UNDEF								,	//	undef
		RSV_UNION								,	//	union
		RSV_UNSIGNED							,	//	unsigned
		RSV_VIRTUAL								,	//	virtual		iC++j
		RSV_VOID								,	//	void
		RSV_VOLATILE							,	//	volatile
		RSV_WCHAR_T								,	//	wchar_t
		RSV_WHILE								,	//	while


		VAL_DECIMAL	= ECtkKnd.VALUE				,	//	nnn	
		VAL_HEXA								,	//	0xhhh
		VAL_OCTAL								,	//	0nnn
		VAL_REAL								,	//	nn.mm / nnnE[+-]mm
		VAL_INVALID								,	//	sSȐl\iG[j

		VAL_HEXA_H								,	//	hhhHiAZuL@j


		STR_QUOTE	= ECtkKnd.STRING			,	//	"..."
		STR_APOST								,	//	'...'
		STR_NEXT								,	//	̑̕萔


		PATHNAME	= ECtkKnd.PATHNAME			,	//	#includẽwb_t@CpX

		DLM_LSPART	= ECtkKnd.DELIMIT			,	//	(
		DLM_LMPART								,	//	{
		DLM_LLPART								,	//	[
		DLM_RSPART								,	//	)
		DLM_RMPART								,	//	}
		DLM_RLPART								,	//	]

		DLM_SCOPE								,	//	::		(C++)
		DLM_IDDOT								,	//	.*		(C++)
		DLM_IDARROW								,	//	->*		(C++)

		DLM_LAND								,	//	&&
		DLM_LOR									,	//	||

		DLM_ARROW								,	//	->
		DLM_QUEST								,	//	?
		DLM_COLON								,	//	:
		DLM_SEMICOL								,	//	;
		DLM_COMMA								,	//	,
		DLM_VARG								,	//	...	
		DLM_DOT									,	//	.

		DLM_SHREQ								,	//	>>=	
		DLM_SHLEQ								,	//	<<=	
		DLM_SHR									,	//	>>
		DLM_SHL									,	//	<<

		DLM_EQEQ								,	//	==
		DLM_NOTEQ								,	//	!=
		DLM_LOEQ								,	//	<=
		DLM_HIEQ								,	//	>=
		DLM_LO									,	//	<
		DLM_HI									,	//	>

		DLM_PLUSEQ								,	//	+=
		DLM_MINUSEQ								,	//	-=
		DLM_MULTEQ								,	//	*=
		DLM_DIVEQ								,	//	/=
		DLM_MODEQ								,	//	%=
		DLM_ANDEQ								,	//	&=
		DLM_OREQ								,	//	|=
		DLM_XOREQ								,	//	^=

		DLM_SHARP2								,	//	##
		DLM_PLUS2								,	//	++
		DLM_MINUS2								,	//	--

		DLM_SHARP								,	//	#
		DLM_PLUS								,	//	+
		DLM_MINUS								,	//	-
		DLM_MULT								,	//	*
		DLM_DIV									,	//	/
		DLM_MOD									,	//	%
		DLM_AND									,	//	&
		DLM_OR									,	//	|
		DLM_XOR									,	//	^
		DLM_EQ									,	//	=
		DLM_NOT									,	//	~
		DLM_LNOT								,	//	!
		DLM_UNKNOWN								,	//	`̃f~^
		DLM_NEXT								,	//	̑̃f~^

		SPACE		= ECtkKnd.SPACE				,	//	󔒁^^u
		EOL										,	//	s
		COMMENT									,	//	Rgi^EEE^j
		LINECOMMENT								,	//	Rgi^^EEEj
		LINECONT								,	//	spLij
		NEXTSPACE								,	//	̑̋
	}
	//----------------------------------------------------------------------------------------------------------//
	//	t@C 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- t@C ---------------------------------------------------------------------------------------//
	public enum EFileAtt
	{
		_A_ARCH		= 0x20	,		//	A[JCut@C
		_A_SUBDIR	= 0x10	,		//	TufBNg
		_A_SYSTEM	= 0x04	,		//	VXet@C
		_A_HIDDEN	= 0x02	,		//	Bt@C
		_A_RDONLY	= 0x01	,		//	ǂݏopt@C
		_A_ALL		= 0x37	,		//	L̑S
	}
	//----------------------------------------------------------------------------------------------------------//
	//	ėpW[ 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- WindowsI[h ----------------------------------------------------------------------------------//
	public enum EExitWindows 
	{
		EWX_LOGOFF		= 0,		//	OIt
		EWX_SHUTDOWN	= 1,		//	Vbg_E
		EWX_REBOOT		= 2,		//	u[g
		EWX_FORCE		= 4,		//	vZXI
		EWX_POWEROFF	= 8,		//	p[It
	}
	//----- tH_Rs[ʒm ---------------------------------------------------------------------------------//
	public enum ENtcDirCopy
	{
		SUCCESS		= 0,
		FAILURE		= 1,
		EXIST		= 2,
	}
	//----- t@CRs[ʒm ---------------------------------------------------------------------------------//
	public enum ENtcFileCopy
	{
		SUCCESS		= 0,
		FAILURE		= 1,
		EXIST		= 2,
	}

	//----------------------------------------------------------------------------------------------------------//
	//	VAʐM 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- rbos[h -----------------------------------------------------------------------------------//
	public enum EScpMode
	{
		NotificationByEvent	= 0,		//	Cxgʒm	itH[Avj
		WaitingForEvent		= 1			//	Cxg҂󂯂iR\[Avj
	}
	//----- ʐM\[X ---------------------------------------------------------------------------------------//
	public enum ESelPort {
		SEL_COMPORT		= 0,
		SEL_MAILSLOT	= 1,
		SEL_SOCKET		= 2
	}
	//----- rbo|[g -----------------------------------------------------------------------------------//
	public enum EScpPortState
	{
		Closed		= 0,				//	N[Y
		Opened		= 1,				//	I[v
		OpenFailure	= 2,				//	I[vs
		PortChanged	= 3,				//	|[gԍω
		PortNumber	= 3,
		MySlotFail	= 4,				//	[Xbgs
		TxFailure	= 5					//	Ms
	}
	//----- rbo`Nf[^̒ʒm[h -------------------------------------------------------------------//
	public enum EScpChunkMode
	{
		BinaryData		= 0x01,			//	oCiE`Nʒm
		TextData		= 0x02,			//	eLXgE`Nʒm
		Both			= 0x03,			//	
	}
	//----- rbof[^rbg -------------------------------------------------------------------------------//
	public enum EScpDataBits
	{
		DataBit_Default	= 0,			//	݂̐ݒl
		DataBit_7		= 7,			//	Vrbg
		DataBit_8		= 8				//	Wrbg
	}
	//----- rbopeBrbg -------------------------------------------------------------------------------//
	public enum EScpParity
	{
		DefaultParity	= 0		,		//	݂̐ݒl
		NoParity		= 'N'	,		//	peBȂ
		OddParity		= 'O'	,		//	peB
		EvenParity		= 'E'	,		//	peB
	}
	//----- rboXgbvrbg -------------------------------------------------------------------------------//
	public enum EScpStopBit
	{
		StopBit_Default	= 0		,		//	݂̐ݒl
		StopBit_1		= 1		,		//	Prbg
		StopBit_2		= 2				//	Qrbg
	}
	//----- rboCxgR[h -------------------------------------------------------------------------------//
	public enum EScpEvt
	{
		EV_NOEVENT		= 0		,			//	Cxg҂^CAEg
		EV_PORTSTATE	= 0x8000,			//	|[gԒʒm
		EV_RXCHUNK		= 0x4000,			//	`Nf[^Mʒm
		EV_RXTEXT		= 0x2000,			//	eLXgMʒm
		EV_RXESC		= 0x1000,			//	drbR[hMʒm
		EV_RXCTRL		= 0x0800,			//	R[hMʒm
		EV_RXPKT		= 0x0400,			//	pPbgf[^Mʒm
		EV_TXEMPTY		= 0x0200,			//	M
		EV_RXNOPKT		= 0x0100,			//	pPbgOeLXgʒm

		EV_ERR			= 0x0080,			//	G[ʒm
	//	EV_BREAK		= 0x0040,			//	BREAKoʒm
		EV_RING			= 0x0020,			//	RINGωʒm
		EV_RLSD			= 0x0010,			//	RLSDωʒm
		EV_DSR			= 0x0008,			//	DSRωʒm
		EV_CTS			= 0x0004,			//	CTSωʒm

		EV_RXWORD14		= 0x0002,			//	oCgyAɂ郏[h(14Bitl)Mʒm
		EV_INVCHUNK		= 0x0001,			//	s`NeLXgMʒm

		EV_SSEP			= (EV_RXTEXT	| EV_RXESC | EV_RXCTRL | EV_RXPKT),
		EV_DEFAULT_EVT	= (EV_SSEP		| EV_DSR   | EV_CTS),
		EV_DEFAULT_POST = (EV_PORTSTATE | EV_DEFAULT_EVT),

		EV_ALL			= ( EV_PORTSTATE |
							EV_RXCHUNK	 |
							EV_RXTEXT	 |
							EV_RXESC	 |
							EV_RXCTRL	 |
							EV_RXPKT	 |
							EV_TXEMPTY	 |
							EV_RXNOPKT	 |
							EV_ERR		 |
						//	EV_BREAK	 |
							EV_RING		 |
							EV_RLSD		 |
							EV_DSR		 |
							EV_CTS		 |
							EV_RXWORD14	 |
							EV_INVCHUNK
						  )
	}
	//----- G[R[h ---------------------------------------------------------------------------------------//
	public enum EScpErr
	{
		CE_RXOVER	= 0x0001,		//	ML[I[ot[
		CE_OVERRUN	= 0x0002,		//	I[o[G[o
		CE_RXPARITY	= 0x0004,		//	peBG[o
		CE_FRAME	= 0x0008,		//	t[~OG[o
		CE_BREAK	= 0x0010,		//	u[NMo
		CE_TXFULL	= 0x0100,		//	ML[t
		CE_IOE		= 0x0400,		//	foCXANZXI/OG[o
		
		RXERR		= 0x10000,		//	MG[
		TXERR		= 0x20000		//	MG[
	}
	//----- MeLXgR[h ---------------------------------------------------------------------------------//
	public enum EScpRxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	F
	}
	//----- MeLXgR[h ---------------------------------------------------------------------------------//
	public enum EScpTxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	MeLXgR[hɍ킹
	}
	//----- oCgyAM ---------------------------------------------------------------------------------//
	public enum EScpByteSeq
	{
		HIGH_BYTE_FIRST = 0,				//	High byte first
		LOW_BYTE_FIRST	= 1	,				//	Low byte first
	}

	//----------------------------------------------------------------------------------------------------------//
	//	\PbgT[o 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- rrus[h -----------------------------------------------------------------------------------//
	public enum ESsvMode
	{
		NotificationByEvent	= 0,		//	Cxgʒm
		WaitingForEvent		= 1			//	Cxg҂󂯂
	}
	//----- rru`Nf[^̒ʒm[h -------------------------------------------------------------------//
	public enum ESsvChunkMode
	{
		BinaryData		= 0x01,			//	oCiE`Nʒm
		TextData		= 0x02,			//	eLXgE`Nʒm
		Both			= 0x03,			//	
	}
	//----- rruCxgR[h -------------------------------------------------------------------------------//
	public enum ESsvEvt
	{
		EV_NOEVENT		= 0,				//	Cxg

		EV_RXTEXT		= 0x00000001,		//	eLXgf[^ʒm
		EV_RXESC		= 0x00000002,		//	drbR[hf[^ʒm
		EV_RXPKT		= 0x00000004,		//	pPbgf[^ʒm
		EV_RXCTRL		= 0x00000008,		//	R[hʒm
		EV_RXNOPKT		= 0x00000010,		//	pPbgOeLXgf[^
		
		EV_RXCHUNK		= 0x00000100,		//	`Nf[^Mʒm
		EV_INVCHUNK		= 0x00000200,		//	s`NeLXgMʒm
		EV_TXEMPTY		= 0x00000400,		//	Mʒm
		EV_CONNECT		= 0x00000800,		//	ڑʒm
		EV_DISCONNECT	= 0x00001000,		//	ؒfʒm
		EV_START		= 0x00002000,		//	T[oJnʒm
		EV_STOP			= 0x00004000,		//	T[oIʒm
		EV_RXERR		= 0x00010000,		//	MG[ʒm
		EV_TXERR		= 0x00020000,		//	MG[ʒm
		EV_ERR			= 0x08000000,		//	G[ʒm

		EV_SSEP			= (EV_RXTEXT  | EV_RXESC	  | EV_RXCTRL  | EV_RXPKT),
		EV_COMM			= (EV_RXCHUNK | EV_INVCHUNK   | EV_TXEMPTY),
		EV_GENERAL		= (EV_CONNECT | EV_DISCONNECT | EV_START   | EV_STOP),
		EV_ERRS			= (EV_RXERR   | EV_TXERR	  | EV_ERR),
		EV_CLIENT		= (EV_SSEP	  | EV_COMM 	  | EV_CONNECT | EV_DISCONNECT | EV_RXERR | EV_TXERR),
		EV_DEFAULT		= (EV_SSEP	  | EV_COMM 	  | EV_GENERAL | EV_ERRS),
		EV_ALL			= (EV_SSEP	  | EV_COMM 	  | EV_GENERAL | EV_ERRS | EV_RXNOPKT)
	}
	//----- G[R[h ---------------------------------------------------------------------------------------//
	public enum ESsvErrorCode {
		ERR_CREEVT			=  10,		//	IʒmpCxgIuWFNgs
		ERR_SOCKET			=  20,		//	ڑvҋ@p\Pbgs(socket)
		ERR_BIND			=  30,		//	oChsibindtj
		ERR_LISTEN			=  40,		//	LISTENs(listen)
		ERR_ACCEPT			=  50,		//	ACCEPTsiacceptj
		ERR_ADDRINFO		=  60,		//	AhX擾sigetaddrinfoj
		ERR_SOCKOPT			=  70,		//	\PbgIvVݒ莸s(setsockopt)
		ERR_THREADPOWCTRL	=  80,		//	dXbhJns
		ERR_THREADLISTEN	=  90,		//	ڑҋ@XbhJns
		ERR_THREADCLIENT	= 100,		//	NCAgʐMXbhJns
		ERR_CRESSEP			= 110,		//	Xg[CX^Xs
		ERR_CREMBXTXD		= 120,		//	Mf[^p[{bNXs
		ERR_TIMEOUT			= 130,		//	T[oI^CAEg
		ERR_CRETHREADWORK	= 140,		//	NCAgXbhp[Nmێs
		ERR_CONNOVER		= 150,		//	NCAgڑI[o[
		ERR_CREIXMAP		= 160,		//	CfNX蓖ėp}bve[us
	}
	//----- MeLXgR[h -----------------------------------------------------------------------------//
	public enum ESsvRxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	F
	}
	//----- MeLXgR[h -----------------------------------------------------------------------------//
	public enum ESsvTxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	MeLXgR[hɍ킹
	}
	//----- AhXt@~ -----------------------------------------------------------------------------------//
	public enum ESsvFamily
	{
		INET			= 0x02,				//	IPV4
		INET6			= 0x17,				//	IPV6
	}
	//----- T[oIvV -----------------------------------------------------------------------------------//
	public enum ESsvServOpt
	{
		NOOPT				= 0,			//	IvV
		SUP_SLEEP			= 0x01,			//	X[v}~
		SUP_DISPOFF			= 0x02,			//	fBXvBOFF}~
		SUP_ALL				= 0x03,			//	X[vfBXvBOFF}~
	}

	//----------------------------------------------------------------------------------------------------------//
	//	\PbgNCAg 萔																				//
	//----------------------------------------------------------------------------------------------------------//
	//----- rbss[h -----------------------------------------------------------------------------------//
	public enum ESctMode
	{
		NotificationByEvent	= 0,		//	Cxgʒm
		WaitingForEvent		= 1			//	Cxg҂󂯂
	}
	//----- rbs`Nf[^̈ -------------------------------------------------------------------------//
	public enum ESctChunkMode
	{
		BinaryData		= 0x01,			//	oCiE`Nʒm
		TextData		= 0x02,			//	eLXgE`Nʒm
		Both			= 0x03,			//	
	}
	//----- rbsCxgR[h -------------------------------------------------------------------------------//
	public enum ESctEvt
	{
		EV_NOEVENT		= 0,				//	Cxg

		EV_RXTEXT		= 0x00000001,		//	eLXgf[^ʒm
		EV_RXESC		= 0x00000002,		//	drbR[hf[^ʒm
		EV_RXPKT		= 0x00000004,		//	pPbgf[^ʒm
		EV_RXCTRL		= 0x00000008,		//	R[hʒm
		EV_RXNOPKT		= 0x00000010,		//	pPbgOeLXgf[^

		EV_RXCHUNK		= 0x00000100,		//	`Nf[^Mʒm
		EV_INVCHUNK		= 0x00000200,		//	s`NeLXgMʒm
		EV_TXEMPTY		= 0x00000400,		//	Mʒm
		EV_CONNECT		= 0x00000800,		//	ڑʒm
		EV_DISCONNECT	= 0x00001000,		//	ؒfʒm
		EV_CNFAIL		= 0x00002000,		//	ڑsʒm

		EV_RXERR		= 0x00010000,		//	MG[ʒm
		EV_TXERR		= 0x00020000,		//	MG[ʒm
		EV_ERR			= 0x08000000,		//	G[ʒm

		EV_SSEP			= (EV_RXTEXT  | EV_RXESC	  | EV_RXCTRL  | EV_RXPKT),
		EV_COMM			= (EV_RXCHUNK | EV_INVCHUNK   | EV_TXEMPTY),
		EV_GENERAL		= (EV_CONNECT | EV_DISCONNECT | EV_CNFAIL),
		EV_ERRS			= (EV_RXERR   | EV_TXERR	  | EV_ERR),
		EV_CLIENT		= (EV_SSEP	  | EV_COMM 	  | EV_CONNECT | EV_DISCONNECT | EV_RXERR | EV_TXERR),
		EV_DEFAULT		= (EV_SSEP	  | EV_COMM 	  | EV_GENERAL | EV_ERRS),
		EV_ALL			= (EV_SSEP	  | EV_COMM 	  | EV_GENERAL | EV_ERRS | EV_RXNOPKT)
	}
	//----- G[R[h ---------------------------------------------------------------------------------------//
	public enum ESctErrorCode {
		ERR_CREEVT		=	 10	,			//	IʒmpCxgIuWFNgs
		ERR_SOCKET		=	 20	,			//	ڑvҋ@p\Pbgs(socket)
		ERR_ADDRINFO	=	 30	,			//	AhX擾sigetaddrinfoj
		ERR_SOCKOPT		=	 40	,			//	\PbgIvVݒ莸s(setsockopt)
		ERR_SUBTHREAD	=	 50	,			//	NCAgʐMTuXbhJns
		ERR_CRESSEP		=	 60	,			//	Xg[CX^Xs
		ERR_CREMBXTXD	=	 70	,			//	Mf[^p[{bNXs
		ERR_TIMEOUT		=	 80	,			//	TuXbhI^CAEg
	}
	//-----  -------------------------------------------------------------------------------------------//
	public enum ESctState {
		DISCONNECT		= 0	,				//	ؒf
		CONNECTING		= 1	,				//	ڑ
		CONNECT			= 2	,				//	ڑ
		DISCONNECTING	= 3	,				//	ؒf
	}
	//----- MeLXgR[h -----------------------------------------------------------------------------//
	public enum ESctRxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	F
	}
	//----- MeLXgR[h -----------------------------------------------------------------------------//
	public enum ESctTxTextCode
	{
		SJIS			= 1	,				//	r|ihr
		EUC				= 2	,				//	dtb
		UTF8			= 3	,				//	tse|W
		AUTO			= 9	,				//	MeLXgR[hɍ킹
	}
	//----- AhXt@~ -----------------------------------------------------------------------------------//
	public enum ESctFamily
	{
		INET			= 0x02,				//	IPV4
		INET6			= 0x17,				//	IPV6
	}


	//----------------------------------------------------------------------------------------------------------//
	//	 v[ 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- rp^ ---------------------------------------------------------------------------------//
	public enum ESplComp {
		RECOGNIZE_WIDTH	= 0,		//	p召ʂ
		IGNORE_WIDTH	= 1,		//	p召ʂȂ
		ALPHABETIC		= 2,		//	ꎞ̂݉p召ʂ
	}

	//----- 񌟍p^ -----------------------------------------------------------------------------//
	public enum ESplInStr {
		MATCHFIRST		= 1	,		//	擪ƈv
		INCLUDING			,		//	܂
	}

	//----- ǂݏo -----------------------------------------------------------------------------------//
	public enum ESplSeq {
		Ascending		= 0,		//	( false )
		Descending		= 1,		//	~( true	)
	}
	//----------------------------------------------------------------------------------------------------------//
	//	^C`[g 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- ̑ -------------------------------------------------------------------------------------------//
	public enum ETchLineStyle
	{
		Solid		= 0,		//	
		Dash		= 1,		//	-------
		Dot			= 2,		//	.......
		DashDot		= 3,		//	_._._._
		DashDotDot	= 4,		//	_.._.._
		NullLine	= 5,		//	
		InsideFrame = 6			//	
	}
	//----- g`ԕ\ -----------------------------------------------------------------------------------//
	public enum ETchIpKind
	{
		Window		= 0,		//	ECh\f[^
		All 		= 1,		//	Sf[^
		Latest 		= 2			//	ŐVf[^
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 usPOO 萔																						//
	//----------------------------------------------------------------------------------------------------------//
	public enum EVthVKey
	{
		VK_CLEAR				= 0x0C,		//	NumLock-Off̃eL[́uTv
		VK_RETURN				= 0x0D,
		VK_SHIFT				= 0x10,
		VK_CONTROL				= 0x11,
		VK_MENU					= 0x12,		//	Alt
		VK_PAUSE				= 0x13,
		VK_CAPITAL				= 0x14,
		VK_KANA					= 0x15,
		VK_JUNJA				= 0x17,
		VK_FINAL				= 0x18,
		VK_KANJI				= 0x19,
		VK_ESCAPE				= 0x1B,		//	Esc
		VK_CONVERT				= 0x1C,		//	ϊ
		VK_NOCONVERT			= 0x1D,		//	ϊ
		VK_ACCEPT				= 0x1E,		//	Accept
		VK_MODECHANGE			= 0x1F,		//	ModeChange
		VK_PRIOR				= 0x21,		//	PageUp
		VK_NEXT					= 0x22,		//	PageDown
		VK_END					= 0x23,		//	End
		VK_HOME					= 0x24,		//	Home
		VK_LEFT					= 0x25,		//	
		VK_UP					= 0x26,		//	
		VK_RIGHT				= 0x27,		//	
		VK_DOWN					= 0x28,		//	
		VK_SELECT				= 0x29,		//	SEL
		VK_PRINT				= 0x2A,		//	Print
		VK_EXECUTE				= 0x2B,		//	Execute
		VK_SNAPSHOT				= 0x2C,		//	Print screen
		VK_INSERT				= 0x2D,		//	Insert
		VK_DELETE				= 0x2E,		//	Delete
		VK_HELP					= 0x2F,		//	Help
		VK_LWIN					= 0x5B,		//	Windows
		VK_RWIN					= 0x5C,		//	EWindows
		VK_APPS					= 0x5D,		//	AvP[V
		VK_SLEEP				= 0x5F,
		VK_NUMPAD0				= 0x60,
		VK_NUMPAD1				= 0x61,
		VK_NUMPAD2				= 0x62,
		VK_NUMPAD3				= 0x63,
		VK_NUMPAD4				= 0x64,
		VK_NUMPAD5				= 0x65,
		VK_NUMPAD6				= 0x66,
		VK_NUMPAD7				= 0x67,
		VK_NUMPAD8				= 0x68,
		VK_NUMPAD9				= 0x69,
		VK_MULTIPLY				= 0x6A,
		VK_ADD					= 0x6B,
		VK_SEPARATOR			= 0x6C,
		VK_SUBTRACT				= 0x6D,
		VK_DECIMAL				= 0x6E,
		VK_DIVIDE				= 0x6F,
		VK_F1					= 0x70,		//	F1	
		VK_F2					= 0x71,		//	F2	
		VK_F3					= 0x72,		//	F3	
		VK_F4					= 0x73,		//	F4	
		VK_F5					= 0x74,		//	F5	
		VK_F6					= 0x75,		//	F6	
		VK_F7					= 0x76,		//	F7	
		VK_F8					= 0x77,		//	F8	
		VK_F9					= 0x78,		//	F9	
		VK_F10					= 0x79,		//	F10	
		VK_F11					= 0x7A,		//	F11	
		VK_F12					= 0x7B,		//	F2	
		VK_F13					= 0x7C,		//	F13	
		VK_F14					= 0x7D,		//	F14	
		VK_F15					= 0x7E,		//	F15	
		VK_F16					= 0x7F,		//	F16	
		VK_F17					= 0x80,		//	F17	
		VK_F18					= 0x81,		//	F18	
		VK_F19					= 0x82,		//	F19	
		VK_F20					= 0x83,		//	F20	
		VK_F21					= 0x84,		//	F21	
		VK_F22					= 0x85,		//	F22	
		VK_F23					= 0x86,		//	F23	
		VK_F24					= 0x87,		//	F24	
		VK_NUMLOCK				= 0x90,		//	NumLock
		VK_SCROLL				= 0x91,		//	ScrollLock
		VK_OEM_FJ_JISHO			= 0x92,		// 'Dictionary' key
		VK_OEM_FJ_MASSHOU		= 0x93,		// 'Unregister word' key
		VK_OEM_FJ_TOUROKU		= 0x94,		// 'Register word' key
		VK_OEM_FJ_LOYA			= 0x95,		// 'Left OYAYUBI' key
		VK_OEM_FJ_ROYA			= 0x96,		// 'Right OYAYUBI' key
		VK_LSHIFT				= 0xA0,
		VK_RSHIFT				= 0xA1,
		VK_LCONTROL				= 0xA2,
		VK_RCONTROL				= 0xA3,
		VK_LMENU				= 0xA4,
		VK_RMENU				= 0xA5,
		VK_BROWSER_BACK			= 0xA6,
		VK_BROWSER_FORWARD		= 0xA7,
		VK_BROWSER_REFRESH		= 0xA8,
		VK_BROWSER_STOP			= 0xA9,
		VK_BROWSER_SEARCH		= 0xAA,
		VK_BROWSER_FAVORITES	= 0xAB,
		VK_BROWSER_HOME			= 0xAC,
		VK_VOLUME_MUTE			= 0xAD,
		VK_VOLUME_DOWN			= 0xAE,
		VK_VOLUME_UP			= 0xAF,
		VK_MEDIA_NEXT_TRACK		= 0xB0,
		VK_MEDIA_PREV_TRACK		= 0xB1,
		VK_MEDIA_STOP			= 0xB2,
		VK_MEDIA_PLAY_PAUSE		= 0xB3,
		VK_LAUNCH_MAIL			= 0xB4,
		VK_LAUNCH_MEDIA_SELECT	= 0xB5,
		VK_LAUNCH_APP1			= 0xB6,
		VK_LAUNCH_APP2			= 0xB7,
		VK_OEM_RESET			= 0xE9,
		VK_OEM_JUMP				= 0xEA,
		VK_OEM_PA1				= 0xEB,
		VK_OEM_PA2				= 0xEC,
		VK_OEM_PA3				= 0xED,
		VK_OEM_WSCTRL			= 0xEE,
		VK_OEM_CUSEL			= 0xEF,
		VK_OEM_ATTN				= 0xF0,
		VK_OEM_FINISH			= 0xF1,
		VK_OEM_COPY				= 0xF2,
		VK_OEM_AUTO				= 0xF3,
		VK_OEM_ENLW				= 0xF4,
		VK_OEM_BACKTAB			= 0xF5,
		VK_ATTN					= 0xF6,
		VK_CRSEL				= 0xF7,
		VK_EXSEL				= 0xF8,
		VK_EREOF				= 0xF9,
		VK_PLAY					= 0xFA,
		VK_ZOOM					= 0xFB,
		VK_NONAME				= 0xFC,
		VK_PA1					= 0xFD,
		VK_OEM_CLEAR			= 0xFE,
	}

	//----------------------------------------------------------------------------------------------------------//
	//	 WXgANZX																						//
	//----------------------------------------------------------------------------------------------------------//
	//----- WXggbvL[iWXgnCuj------------------------------------------------------------//
	public enum EAjcHKey : uint
	{
		CLASSES_ROOT				=	(0x80000000),
		CURRENT_USER				=	(0x80000001),
		LOCAL_MACHINE				=	(0x80000002),
		USERS						=	(0x80000003),
		PERFORMANCE_DATA			=	(0x80000004),
		PERFORMANCE_TEXT			=	(0x80000050),
		PERFORMANCE_NLSTEXT 		=	(0x80000060),
		CURRENT_CONFIG				=	(0x80000005),
		DYN_DATA					=	(0x80000006),
		CURRENT_USER_LOCAL_SETTINGS =	(0x80000007),
	}
	//----- WXg^Cv -----------------------------------------------------------------------------------//
	public enum ERegType
	{
		NONE						= 	0 ,		//	̌^Ȃl
		SZ							= 	1 ,		//	l
		EXPAND_SZ					= 	2 ,		//	WJ\ȕl
		BINARY 						= 	3 ,		//	oCil
		DWORD						= 	4 ,		//	RQrbgligGfBAj
		DWORD_BIG_ENDIAN			= 	5 ,		//	RQrbglirbOGfBAj
		LINK						= 	6 ,		//	V{bNNl
		MULTI_SZ					= 	7 ,		//	̕l
		RESOURCE_LIST			 	= 	8 ,		//	\[X}bvl
		FULL_RESOURCE_DESCRIPTOR 	= 	9 ,		//	n[hEFA\[XXgl
		RESOURCE_REQUIREMENTS_LIST	=  10 ,		//	lXgꂽA̔zl
		QWORD						=  11 ,		//	USrbgligGfBAj
	}
	//----- vt@CL^		 ---------------------------------------------------------------------------//
	public enum EProfileDev
	{
		INIFILE						= 0,		//	INIt@C
		REGISTORY					= 1	,		//	WXg
	}
	//----- WXg݃[h ---------------------------------------------------------------------------//
	public enum ERegRecMode
	{
		NON_VOLATILE				= 0,		//	iIȃWXgL[
		VOLATILE					= 1	,		//	ꎞIȃWXgL[
	}

	//----------------------------------------------------------------------------------------------------------//
	//	 R\[																								//
	//----------------------------------------------------------------------------------------------------------//
	public enum ECInGetLineOpt {
		NONE		= 0,	//	KCh\
		F1GUIDE		= 1,	//	蒼f[^ʒu\
		SHOWREDO	= 2,	//	QƃeLXgf[^ʒu\
		SHOWPREV	= 4,	//	͂eLXg\
		SHOWTEXT	= 8,	
		ALL			= (F1GUIDE | SHOWREDO | SHOWPREV | SHOWTEXT)
	}

	//----------------------------------------------------------------------------------------------------------//
	//	 c[`bv																							//
	//----------------------------------------------------------------------------------------------------------//
	//----- }EXJ[\ړ ---------------------------------------------------------------------------------//
	public enum ETipCurMove {
		CENTER		= 0,	//	Sֈړ
		LU			= 1,	//	ֈړ
		RU			= 2,	//	Eֈړ
		LD			= 3,	//	ֈړ
		RD			= 4,	//	Eֈړ
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 ECh																							//
	//----------------------------------------------------------------------------------------------------------//
	//----- hbv ---------------------------------------------------------------------------------------//
	public enum EDropMode {
		DIR				= 0x0001,			//	fBNg
		FILE			= 0x0002,			//	t@C
		BOTH			= (DIR | FILE),		//	fBNgƃt@C
		CONNECT			= 0x0004,			//	SڂZ~R(;)ŘA
		NOERRTIP		= 0x1000			//	ړĨIuWFNgifBNg^t@Cjhbv
											//	ȂꍇG[`bv\Ȃ
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 SRg[̃Z[u^[h IvV																//
	//----------------------------------------------------------------------------------------------------------//
	//----- Z[uIvV -----------------------------------------------------------------------------------//
	public enum ESaveAllOpt : int {
		NoOption		= 0			,		//	w薳
		ExcReadOnlyText	= 0x0001	,		//	ǂݏopeLXgO
	}
	//----- [hIvV -----------------------------------------------------------------------------------//
	public enum ELoadAllOpt : int {
		NoOption		= 0			,		//	w薳
		RbtClickEvent	= 0x0001	,		//	WI{^Click()Cxg
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 tH_\Rs[ IvV																			//
	//----------------------------------------------------------------------------------------------------------//
	public enum EFscOpt : int
	{
		NONE			= 0,		//	IvV
		SAMETIME		= 0x01,		//	VK쐬tH_̃^CX^vRs[Ɠɂ
		FORCETIME		= 0x02,		//	VK쐬tH_ƊtH_̃^CX^vRs[Ɠɂ
		MAKETOP			= 0x10,		//	]tH_̓]̐擪tH_Ƃč쐬
		ALLOWEXIST		= 0x20,		//	tH_݂ĂG[ƂȂ
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 t@CQRs[ IvV																			//
	//----------------------------------------------------------------------------------------------------------//
	public enum ECpyfOpt : int
	{
		NONE			= 0,		//	IvV
		CREATEALWAYS	= 0x01,		//	Ƀt@C݂ꍇA㏑
		AJCCPF_WILDEXC	= 0x02,		//	ChJ[hɈvt@CO
	}
	//----------------------------------------------------------------------------------------------------------//
	//	 t@CˍXg IvV																		//
	//----------------------------------------------------------------------------------------------------------//
	public enum EFmlOpt : int
	{
		BOTH			= 0,		//	˂XgɃt@CƃfBNg܂߂
		NOFILE			= 0x01,		//	˂XgɃt@C܂߂Ȃ
		NODIR			= 0x02,		//	˂XgɃfBNg܂߂Ȃ
	}

	//----------------------------------------------------------------------------------------------------------//
	//	 ʃf[^																							//
	//----------------------------------------------------------------------------------------------------------//
	//----- ʃf[^p^ -----------------------------------------------------------------------------//
	[StructLayout(LayoutKind.Sequential, Pack=1)]
	public struct AJCSPD_PARAM {
		public double			cent_x;				//	S(x)
		public double			cent_y;				//	S(y)
		public double			cent_z;				//	S(z)
		public double			radius;				//	a
		public double			noise;				//	ǎ덷i}j
		public double			xrot;				//	]̂w]pxEőliO`őlmxnj
		public double			yrot;				//	]̂x]pxEőliO`őlmxnj
		public double			pitch;				//	vbg_̉]pxEőliO`őlmxnj
	}

	//----------------------------------------------------------------------------------------------------------//
	//	 Qc^RcOtBbNER[obN^Cv																//
	//----------------------------------------------------------------------------------------------------------//
	//----- t@Chbvʒm -------------------------------------------------------------------------------//
	public delegate void G3dCbkFileDrop(int n);
	public class		 G3dArgFileDrop : EventArgs {public int n;}
	public delegate void G3dEvtFileDrop(object sender, G3dArgFileDrop e);

	//----- tH_hbvʒm -------------------------------------------------------------------------------//
	public delegate void G3dCbkDirDrop(int n);
	public class		 G3dArgDirDrop : EventArgs {public int n;}
	public delegate void G3dEvtDirDrop(object sender, G3dArgDirDrop e);

	//----- ENbNʒm -------------------------------------------------------------------------------------//
	public delegate void G3dCbkRClick(int x, int y, [MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 G3dArgRClick : EventArgs {public int x, y; public bool shift, ctrl;}
	public delegate void G3dEvtRClick(object sender, G3dArgRClick e);

	//----- vbgXgʒm ---------------------------------------------------------------------------------//
	public delegate void G3dCbkPltLst(int max, int num, IntPtr pItem);
	public class		 G3dArgPltLst : EventArgs {public int max, num; public PlotInfo[] p;}
	public delegate void G3dEvtPltLst(object sender, G3dArgPltLst e);

	//----------------------------------------------------------------------------------------------------------//
	//	 _OtER[obN^Cv																			//
	//----------------------------------------------------------------------------------------------------------//
	//----- Wωʒm -------------------------------------------------------------------------------------//
	public delegate void BarCbkRangeChanged(double low, double high);
	public class		 BarArgRangeChanged : EventArgs { public double low, high;}
	public delegate void BarEvtRangeChanged(object sender, BarArgRangeChanged e);

	//--- XN[ʒuωʒm -------------------------------------------------------------------------------//
	public delegate void BarCbkNtcScrollPos(int pos);
	public class		 BarArgNtcScrollPos : EventArgs { public int pos;}
	public delegate void BarEvtNtcScrollPos(object sender, BarArgNtcScrollPos e);

	//----- t@Chbvʒm -------------------------------------------------------------------------------//
	public delegate void BarCbkFileDrop(int n);
	public class		 BarArgFileDrop : EventArgs {public int n;}
	public delegate void BarEvtFileDrop(object sender, BarArgFileDrop e);

	//----- tH_hbvʒm -------------------------------------------------------------------------------//
	public delegate void BarCbkDirDrop(int n);
	public class		 BarArgDirDrop : EventArgs {public int n;}
	public delegate void BarEvtDirDrop(object sender, BarArgDirDrop e);

	//----- ENbNʒm -------------------------------------------------------------------------------------//
	public delegate void BarCbkRClick(int x, int y, [MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 BarArgRClick : EventArgs {public int x, y; public bool shift, ctrl;}
	public delegate void BarEvtRClick(object sender, BarArgRClick e);

	//----------------------------------------------------------------------------------------------------------//
	//	 bvRpC R[obN^Cv																//
	//----------------------------------------------------------------------------------------------------------//
	//----- ꂩ̃Cxgʒm -------------------------------------------------------------------------//
	public delegate void   PpcCbkNtcAnyEvt(EPpcNtc EvtId);
	public class		   PpcArgNtcAnyEvt : EventArgs {public EPpcNtc EvtId;}
	public delegate void   PpcEvtNtcAnyEvt(object sender, PpcArgNtcAnyEvt e);

	//----- ݏ̃t@CCsԍʒm -----------------------------------------------------------------//
	public delegate void   PpcCbkNtcFileLno([MarshalAs(UnmanagedType.LPWStr)]string FileName, int lno, int nest);
	public class		   PpcArgNtcFileLno : EventArgs {public string FileName; public int lno; public int nest;}
	public delegate void   PpcEvtNtcFileLno(object sender, PpcArgNtcFileLno e);

	//----- CN[ht@CJnʒm	-----------------------------------------------------------------//
	public delegate void   PpcCbkNtcSrhStart([MarshalAs(UnmanagedType.LPWStr)]string IncName, [MarshalAs(UnmanagedType.LPWStr)]string TopPath);
	public class		   PpcArgNtcSrhStart : EventArgs {public string IncName; public string TopPath;}
	public delegate void   PpcEvtNtcSrhStart(object sender, PpcArgNtcSrhStart e);

	//----- CN[ht@CtH_ʒm ----------------------------------------------------------------//
	public delegate void   PpcCbkNtcSrhDir([MarshalAs(UnmanagedType.LPWStr)]string IncName, [MarshalAs(UnmanagedType.LPWStr)]string DirPath);
	public class		   PpcArgNtcSrhDir : EventArgs {public string IncName; public string DirPath;}
	public delegate void   PpcEvtNtcSrhDir(object sender, PpcArgNtcSrhDir e);

	//----- CN[ht@CIʒm 	-----------------------------------------------------------------//
	public delegate void   PpcCbkNtcSrhEnd([MarshalAs(UnmanagedType.LPWStr)]string IncName, [MarshalAs(UnmanagedType.Bool)]bool fFind);
	public class		   PpcArgNtcSrhEnd : EventArgs {public string IncName; public bool fFind;}
	public delegate void   PpcEvtNtcSrhEnd(object sender, PpcArgNtcSrhEnd e);

	//----- vvZXpIvVV{ʒm ---------------------------------------------------------------//
	public delegate void   PpcCbkNtcOptSym([MarshalAs(UnmanagedType.LPWStr)]string FilePath, int lno, [MarshalAs(UnmanagedType.LPWStr)]string OptSym);
	public class		   PpcArgNtcOptSym : EventArgs {public string FilePath; public int lno; public string OptSym;}
	public delegate void   PpcEvtNtcOptSym(object sender, PpcArgNtcOptSym e);

	//----- }N`ʒm -------------------------------------------------------------------------------------//
	public delegate void   PpcCbkNtcMacDef([MarshalAs(UnmanagedType.LPWStr)]string FilePath, int lno, [MarshalAs(UnmanagedType.LPWStr)]string MacName);
	public class		   PpcArgNtcMacDef : EventArgs {public string FilePath; public int lno; public string MacName;}
	public delegate void   PpcEvtNtcMacDef(object sender, PpcArgNtcMacDef e);

	//----- }NQƒʒm -------------------------------------------------------------------------------------//
	public delegate void   PpcCbkNtcMacRef([MarshalAs(UnmanagedType.LPWStr)]string FilePath, int lno, [MarshalAs(UnmanagedType.LPWStr)]string MacName);
	public class		   PpcArgNtcMacRef : EventArgs {public string FilePath; public int lno; public string MacName;}
	public delegate void   PpcEvtNtcMacRef(object sender, PpcArgNtcMacRef e);

	//----- g[NXg[t@C֏o͒ʒm -----------------------------------------------------------//
	public delegate void   PpcCbkNtcOutput();
	public class		   PpcArgNtcOutput : EventArgs {public int dummy;}
	public delegate void   PpcEvtNtcOutput(object sender, PpcArgNtcOutput e);

	//----- G[ʒm -----------------------------------------------------------------------------------------//
	public delegate void   PpcCbkNtcError(EPpcErr err, [MarshalAs(UnmanagedType.LPWStr)]string FilePath, int lno, [MarshalAs(UnmanagedType.LPWStr)]string param);
	public class		   PpcArgNtcError : EventArgs {public EPpcErr err; public string FilePath; public int lno; public string param;}
	public delegate void   PpcEvtNtcError(object sender, PpcArgNtcError e);

	//----- \[Xt@CGR[hʒm -----------------------------------------------------------------------//
	public delegate void   PpcCbkNtcSrcTec([MarshalAs(UnmanagedType.LPWStr)]string FilePath, ETextEncode tec, EBomMode bom);
	public class		   PpcArgNtcSrcTec : EventArgs {public string FilePath; public ETextEncode tec; public EBomMode bom;}
	public delegate void   PpcEvtNtcSrcTec(object sender, PpcArgNtcSrcTec e);

	//----------------------------------------------------------------------------------------------------------//
	//	 bꎚ啪 R[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- Psǂݏo ---------------------------------------------------------------------------------------//
	public delegate bool   CtkCbkGetS(IntPtr pBuf, int lBuf, IntPtr cbp);
	public class		   CtkArgGetS : EventArgs {public IntPtr pBuf; public int lBuf; public IntPtr cbp;}
	public delegate bool   CtkEvtGetS(object sender, CtkArgGetS e);

	//----------------------------------------------------------------------------------------------------------//
	//	 t@C R[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- t@C^}CRs[^ ---------------------------------------------------------------------//
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FsrCbkFindFile(int nest, [MarshalAs(UnmanagedType.LPWStr)]string PathName,
										   [MarshalAs(UnmanagedType.LPWStr)]string FileName, EFileAtt FileAtt, uint FTime, IntPtr cbp);
	public class FsrArgFindFile : EventArgs {
				public int		nest;
				public string	PathName;
				public string	FileName;
				public EFileAtt FileAtt;
				public uint		FTime;
				public IntPtr	cbp;
	}
	public delegate bool FsrEvtFindFile(object sender, FsrArgFindFile e);

	//----------------------------------------------------------------------------------------------------------//
	//	 t@C^tH_ R[obN^Cv																//
	//----------------------------------------------------------------------------------------------------------//
	//----- tH_Rs[ -------------------------------------------------------------------------------------//
	//	tH_Rs[ʒʒm
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FopCbkScpNtc([MarshalAs(UnmanagedType.LPWStr)]string DirFrom, [MarshalAs(UnmanagedType.LPWStr)]string DirTo, ENtcDirCopy ntc, IntPtr cbp);
	//	tH_Rs[ہ^̕ύX₢킹
	[return: MarshalAs(UnmanagedType.LPWStr)]
	public delegate string FopCbkScpQry([MarshalAs(UnmanagedType.LPWStr)]string DirFront, [MarshalAs(UnmanagedType.LPWStr)]string DirNew, IntPtr cbp);

	//----- t@CRs[ -------------------------------------------------------------------------------------//
	//	t@CRs[ʒʒm
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FopCbkFcpNtc([MarshalAs(UnmanagedType.LPWStr)]string FileFrom, [MarshalAs(UnmanagedType.LPWStr)]string FileTo, ENtcFileCopy ntc, IntPtr cbp);
	//	t@CRs[ہ^̕ύX₢킹
	[return: MarshalAs(UnmanagedType.LPWStr)]
	public delegate string FopCbkFcpQry([MarshalAs(UnmanagedType.LPWStr)]string FileFrom, [MarshalAs(UnmanagedType.LPWStr)]string FileTo,
										[MarshalAs(UnmanagedType.LPWStr)]string FileName, ref EFileAtt att, IntPtr cbp);
	//	t@Cis󋵒ʒm
	[return: MarshalAs(UnmanagedType.LPWStr)]
	public delegate string FopCbkFcpPgs(long FileSize, long Copied, IntPtr cbp);

	//----- tH_^t@C폜 -----------------------------------------------------------------------------//
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FopCbkRmvDir([MarshalAs(UnmanagedType.LPWStr)]string PathName, uint ntc, IntPtr cbp);

	//----- ˍXg -----------------------------------------------------------------------------------//
	//	t@Cʒm
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FopCbkFmlQuery(int id, [MarshalAs(UnmanagedType.LPWStr)]string path, System.IO.FileAttributes att, [MarshalAs(UnmanagedType.Bool)] ref	bool fDiscard, IntPtr cbp);
	//	񋓒ʒm
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool FopCbkFmlEnum ([MarshalAs(UnmanagedType.Bool)] bool fValid1, uint utc1, System.IO.FileAttributes att1, long size1, 
											[MarshalAs(UnmanagedType.LPWStr)]string path1, [MarshalAs(UnmanagedType.LPWStr)]string name1, [MarshalAs(UnmanagedType.LPWStr)]string tail1, 
										[MarshalAs(UnmanagedType.Bool)] bool fValid2, uint utc2, System.IO.FileAttributes att2, long size2,
											[MarshalAs(UnmanagedType.LPWStr)]string path2, [MarshalAs(UnmanagedType.LPWStr)]string name2, [MarshalAs(UnmanagedType.LPWStr)]string tail2, 
										IntPtr cbp);

	//----------------------------------------------------------------------------------------------------------//
	//	 lCeBuANZX R[obN^Cv																	//
	//----------------------------------------------------------------------------------------------------------//
	//----- G[ ---------------------------------------------------------------------------------------//
	public delegate void BinCbkOutOfMemory([MarshalAs(UnmanagedType.LPWStr)]string FileName, int lno, [MarshalAs(UnmanagedType.LPWStr)] string Version, IntPtr cbp);

	//----------------------------------------------------------------------------------------------------------//
	//	 ĺER[obN^Cv																			//
	//----------------------------------------------------------------------------------------------------------//
	//----- lωʒm -------------------------------------------------------------------------------------//
	public delegate void IvCbkNtcIntValue(int value);
	public class		 IvArgNtcIntValue : EventArgs { public int value;}
	public delegate void IvEvtNtcIntValue(object sender, IvArgNtcIntValue e);

	//----- lωʒm -------------------------------------------------------------------------------------//
	public delegate void IvCbkNtcRealValue(double value);
	public class		 IvArgNtcRealValue : EventArgs { public double value;}
	public delegate void IvEvtNtcRealValue(object sender, IvArgNtcRealValue e);

	//----- ENbNʒm -------------------------------------------------------------------------------------//
	public delegate void IvCbkNtcRClick(int x, int y, [MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 IvArgNtcRClick : EventArgs { public int x, y; public bool shift, ctrl;}
	public delegate void IvEvtNtcRClick(object sender, IvArgNtcRClick e);

	//----------------------------------------------------------------------------------------------------------//
	//	 VAʐMER[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- |[gԒʒm -------------------------------------------------------------------------------------//
	public delegate void ScpCbkPortState(EScpPortState state, [MarshalAs(UnmanagedType.LPWStr)]string name);
	public class		 ScpArgPortState : EventArgs { public EScpPortState state; public string name;}
	public delegate void ScpEvtPortState(object sender, ScpArgPortState e);

	//----- `NeLXgMʒm ---------------------------------------------------------------------------//
	public delegate void ScpCbkRxChunkTxt([MarshalAs(UnmanagedType.LPWStr)]string chunk);
	public class		 ScpArgRxChunkTxt : EventArgs { public string text;}
	public delegate void ScpEvtRxChunkTxt(object sender, ScpArgRxChunkTxt e);

	//----- `NoCiMʒm ---------------------------------------------------------------------------//
	unsafe public delegate void ScpCbkRxChunkBin(void *p, int len);
	unsafe public class 		ScpArgRxChunkBin : EventArgs {public Byte[] bin;}
	unsafe public delegate void ScpEvtRxChunkBin(object sender, ScpArgRxChunkBin e);

	//----- eLXgMʒm -----------------------------------------------------------------------------------//
	public delegate void ScpCbkRxText([MarshalAs(UnmanagedType.LPWStr)]string text);
	public class		 ScpArgRxText : EventArgs { public string text;}
	public delegate void ScpEvtRxText(object sender, ScpArgRxText e);

	//----- drbMʒm -------------------------------------------------------------------------------------//
	public delegate void ScpCbkRxEsc([MarshalAs(UnmanagedType.LPWStr)]string esc);
	public class		 ScpArgRxEsc : EventArgs { public string esc;}
	public delegate void ScpEvtRxEsc(object sender, ScpArgRxEsc e);

	//----- R[hMʒm ---------------------------------------------------------------------------------//
	public delegate void ScpCbkRxCtrl(char ctrl);
	public class		 ScpArgRxCtrl : EventArgs { public char ctrl;}
	public delegate void ScpEvtRxCtrl(object sender, ScpArgRxCtrl e);

	//----- pPbgMʒm -----------------------------------------------------------------------------------//
	unsafe public delegate void ScpCbkRxPacket(void *p, int len);
	unsafe public class 		ScpArgRxPacket : EventArgs {public Byte[] bin;}
	unsafe public delegate void ScpEvtRxPacket(object sender, ScpArgRxPacket e);

	//----- Mʒm ---------------------------------------------------------------------------------------//
	public delegate void ScpCbkTxEmpty();
	public delegate void ScpEvtTxEmpty(object sender, EventArgs e);

	//----- pPbgOf[^Mʒm ---------------------------------------------------------------------------//
	public delegate void ScpCbkRxNoPkt([MarshalAs(UnmanagedType.LPWStr)]string text);
	public class		 ScpArgRxNoPkt: EventArgs {public string text;}
	public delegate void ScpEvtRxNoPkt(object sender, ScpArgRxNoPkt e);

	//----- oCgyAɂ郏[h(14Bitl)Mʒm ------------------------------------------------------------//
	public delegate void ScpCbkRxWord14(int data);
	public class		 ScpArgRxWord14: EventArgs {public int data;}
	public delegate void ScpEvtRxWord14(object sender, ScpArgRxWord14 e);

	//----- s`NeLXgMʒm ----------------------------------------------------------------------//
	unsafe public delegate void ScpCbkRxInvChunk(void *p, int len);
	unsafe public class 		ScpArgRxInvChunk : EventArgs {public Byte[] bin;}
	unsafe public delegate void ScpEvtRxInvChunk(object sender, ScpArgRxInvChunk e);

	//----- G[ʒm -----------------------------------------------------------------------------------------//
	public delegate void ScpCbkError(int err);
	public class		 ScpArgError : EventArgs {public EScpErr err;}
	public delegate void ScpEvtError(object sender, ScpArgError e);

	//----- u[Noʒm -----------------------------------------------------------------------------------//
	public delegate void ScpCbkNtcBreak();
	public delegate void ScpEvtNtcBreak(object sender, EventArgs e);

	//----- RINGoʒm ---------------------------------------------------------------------------------------//
	public delegate void ScpCbkNtcRING(bool cts, bool dsr, bool rlsd, bool ring);
	public class		 ScpArgNtcRING : EventArgs {public bool cts, dsr, rlsd, ring;}
	public delegate void ScpEvtNtcRING(object sender, ScpArgNtcRING e);

	//----- RLSDoʒm ---------------------------------------------------------------------------------------//
	public delegate void ScpCbkNtcRLSD(bool cts, bool dsr, bool rlsd, bool ring);
	public class		 ScpArgNtcRLSD : EventArgs {public bool cts, dsr, rlsd, ring;}
	public delegate void ScpEvtNtcRLSD(object sender, ScpArgNtcRLSD e);

	//----- DSRoʒm ----------------------------------------------------------------------------------------//
	public delegate void ScpCbkNtcDSR(bool cts, bool dsr, bool rlsd, bool ring);
	public class		 ScpArgNtcDSR : EventArgs {public bool cts, dsr, rlsd, ring;}
	public delegate void ScpEvtNtcDSR(object sender, ScpArgNtcDSR e);

	//----- CTSoʒm ----------------------------------------------------------------------------------------//
	public delegate void ScpCbkNtcCTS(bool cts, bool dsr, bool rlsd, bool ring);
	public class		 ScpArgNtcCTS : EventArgs {public bool cts, dsr, rlsd, ring;}
	public delegate void ScpEvtNtcCTS(object sender, ScpArgNtcCTS e);

	//----------------------------------------------------------------------------------------------------------//
	//	 \PbgT[oER[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- eLXgMʒm -----------------------------------------------------------------------------------//
	public delegate void SsvCbkRxText(IntPtr hClient, [MarshalAs(UnmanagedType.LPWStr)]string text);
	public class		 SsvArgRxText : EventArgs	{public IntPtr hClient; public string text;}
	public delegate void SsvEvtRxText(object sender, SsvArgRxText e);

	//----- drbMʒm -------------------------------------------------------------------------------------//
	public delegate void SsvCbkRxEsc(IntPtr hClient, [MarshalAs(UnmanagedType.LPWStr)]string esc);
	public class		 SsvArgRxEsc : EventArgs 	{public IntPtr hClient; public string esc;}
	public delegate void SsvEvtRxEsc(object sender, SsvArgRxEsc e);

	//----- R[hMʒm ---------------------------------------------------------------------------------//
	public delegate void SsvCbkRxCtrl(IntPtr hClient, char ctrl);
	public class		 SsvArgRxCtrl : EventArgs 	{public IntPtr hClient; public char ctrl;}
	public delegate void SsvEvtRxCtrl(object sender, SsvArgRxCtrl e);

	//----- pPbgMʒm -----------------------------------------------------------------------------------//
	unsafe public delegate void SsvCbkRxPacket(IntPtr hClient, void *p, int len);
	unsafe public class SsvArgRxPacket : EventArgs	{public IntPtr hClient; public Byte[] bin;}
	unsafe public delegate void SsvEvtRxPacket(object sender, SsvArgRxPacket e);

	//----- pPbgOeLXgMʒm -------------------------------------------------------------------------//
	public delegate void SsvCbkRxNoPkt(IntPtr hClient, [MarshalAs(UnmanagedType.LPWStr)]string text);
	public class	 SsvArgRxNoPkt: EventArgs	{public IntPtr hClient; public string text;}
	public delegate void SsvEvtRxNoPkt(object sender, SsvArgRxNoPkt e);

	//----- Mʒm ---------------------------------------------------------------------------------------//
	public delegate void SsvCbkTxEmpty(IntPtr hClient);
	public class		SsvArgTxEmpty: EventArgs	{public IntPtr hClient;}
	public delegate void SsvEvtTxEmpty(object sender, SsvArgTxEmpty e);

	//----- `NeLXgMʒm ---------------------------------------------------------------------------//
	public delegate void SsvCbkRxChunkTxt(IntPtr hClient, [MarshalAs(UnmanagedType.LPWStr)]string chunk);
	public class		 SsvArgRxChunkTxt : EventArgs {public IntPtr hClient; public string text;}
	public delegate void SsvEvtRxChunkTxt(object sender, SsvArgRxChunkTxt e);

	//----- `NoCiMʒm ---------------------------------------------------------------------------//
	unsafe public delegate void SsvCbkRxChunkBin(IntPtr hClient, void *p, int len);
	unsafe public class 		SsvArgRxChunkBin : EventArgs {public IntPtr hClient; public Byte[] bin;}
	unsafe public delegate void SsvEvtRxChunkBin(object sender, SsvArgRxChunkBin e);

	//----- s`NeLXgMʒm ----------------------------------------------------------------------//
	unsafe public delegate void SsvCbkRxInvChunk(IntPtr hClient, void *p, int len);
	unsafe public class 		SsvArgRxInvChunk : EventArgs {public IntPtr hClient; public Byte[] bin;}
	unsafe public delegate void SsvEvtRxInvChunk(object sender, SsvArgRxInvChunk e);

	//----- ڑʒm--------------------------------------------------------------------------------------------//
	public delegate void SsvCbkConnect(IntPtr hClient);
	public class		 SsvArgConnect : EventArgs	  {public IntPtr hClient;}
	public delegate void SsvEvtConnect(object sender, SsvArgConnect e);

	//----- ؒfʒm--------------------------------------------------------------------------------------------//
	public delegate void SsvCbkDisconnect(IntPtr hClient);
	public class		 SsvArgDisconnect : EventArgs {public IntPtr hClient;}
	public delegate void SsvEvtDisconnect(object sender, SsvArgDisconnect e);

	//----- T[oJnʒm--------------------------------------------------------------------------------------//
	public delegate void SsvCbkStart();
	public class		 SsvArgStart : EventArgs {public IntPtr dummy;}
	public delegate void SsvEvtStart(object sender, SsvArgStart e);

	//----- T[o~ʒm--------------------------------------------------------------------------------------//
	public delegate void SsvCbkStop();
	public class		 SsvArgStop : EventArgs {public IntPtr dummy;}
	public delegate void SsvEvtStop(object sender, SsvArgStop e);

	//----- MG[ʒm -------------------------------------------------------------------------------------//
	public delegate void SsvCbkRecvError(IntPtr hClient, [MarshalAs(UnmanagedType.Bool)]bool overlapped);
	public class		 SsvArgRecvError : EventArgs 			{public IntPtr hClient; public bool overlapped;}
	public delegate void SsvEvtRecvError(object sender, SsvArgRecvError e);

	//----- MG[ʒm -------------------------------------------------------------------------------------//
	public delegate void SsvCbkSendError(IntPtr hClient, [MarshalAs(UnmanagedType.Bool)]bool overlapped);
	public class		 SsvArgSendError : EventArgs 			{public IntPtr hClient; public bool overlapped;}
	public delegate void SsvEvtSendError(object sender, SsvArgSendError e);

	//----- ̑̃G[ʒm ---------------------------------------------------------------------------------//
	public delegate void SsvCbkGeneralError(ESsvErrorCode ErrorCode);
	public class		 SsvArgGeneralError : EventArgs	{public ESsvErrorCode ErrorCode;}
	public delegate void SsvEvtGeneralError(object sender, SsvArgGeneralError e);

	//----- NCAg񋓒ʒm -------------------------------------------------------------------------------//
	public delegate bool SsvCbkEnumClients(IntPtr pC, IntPtr cbp);
	public class		 SsvArgEnumClients : EventArgs	{public IntPtr hClient; public IntPtr param;}
	public delegate bool SsvEvtEnumClients(object sender, SsvArgEnumClients e);

	//----------------------------------------------------------------------------------------------------------//
	//	 \PbgNCAgER[obN^Cv																//
	//----------------------------------------------------------------------------------------------------------//
	//----- eLXgMʒm -----------------------------------------------------------------------------------//
	public delegate void SctCbkRxText([MarshalAs(UnmanagedType.LPWStr)]string text);
	public class		 SctArgRxText : EventArgs	{public string text;}
	public delegate void SctEvtRxText(object sender, SctArgRxText e);

	//----- drbMʒm -------------------------------------------------------------------------------------//
	public delegate void SctCbkRxEsc([MarshalAs(UnmanagedType.LPWStr)]string esc);
	public class		 SctArgRxEsc : EventArgs 	{public string esc;}
	public delegate void SctEvtRxEsc(object sender, SctArgRxEsc e);

	//----- R[hMʒm ---------------------------------------------------------------------------------//
	public delegate void SctCbkRxCtrl(char ctrl);
	public class		 SctArgRxCtrl : EventArgs 	{public char ctrl;}
	public delegate void SctEvtRxCtrl(object sender, SctArgRxCtrl e);

	//----- pPbgMʒm -----------------------------------------------------------------------------------//
	unsafe public delegate void SctCbkRxPacket(void *p, int len);
	unsafe public class SctArgRxPacket : EventArgs	{public Byte[] bin;}
	unsafe public delegate void SctEvtRxPacket(object sender, SctArgRxPacket e);

	//----- pPbgOeLXgMʒm -------------------------------------------------------------------------//
	public delegate void SctCbkRxNoPkt([MarshalAs(UnmanagedType.LPWStr)]string text);
	public class	 SctArgRxNoPkt: EventArgs	{public string text;}
	public delegate void SctEvtRxNoPkt(object sender, SctArgRxNoPkt e);

	//----- Mʒm ---------------------------------------------------------------------------------------//
	public delegate void SctCbkTxEmpty();
	public delegate void SctEvtTxEmpty(object sender, EventArgs e);

	//----- `NeLXgMʒm ---------------------------------------------------------------------------//
	public delegate void SctCbkRxChunkTxt([MarshalAs(UnmanagedType.LPWStr)]string chunk);
	public class		 SctArgRxChunkTxt : EventArgs {public string text;}
	public delegate void SctEvtRxChunkTxt(object sender, SctArgRxChunkTxt e);

	//----- `NoCiMʒm ---------------------------------------------------------------------------//
	unsafe public delegate void SctCbkRxChunkBin(void *p, int len);
	unsafe public class 		SctArgRxChunkBin : EventArgs {public Byte[] bin;}
	unsafe public delegate void SctEvtRxChunkBin(object sender, SctArgRxChunkBin e);

	//----- s`NeLXgMʒm ----------------------------------------------------------------------//
	unsafe public delegate void SctCbkRxInvChunk(void *p, int len);
	unsafe public class 		SctArgRxInvChunk : EventArgs {public Byte[] bin;}
	unsafe public delegate void SctEvtRxInvChunk(object sender, SctArgRxInvChunk e);

	//----- ڑʒm--------------------------------------------------------------------------------------------//
	public delegate void SctCbkConnect();
	public delegate void SctEvtConnect(object sender, EventArgs e);

	//----- ؒfʒm--------------------------------------------------------------------------------------------//
	public delegate void SctCbkDisconnect();
	public delegate void SctEvtDisconnect(object sender, EventArgs e);

	//----- ڑsʒm ---------------------------------------------------------------------------------------//
	public delegate void SctCbkCnFail(int err);
	public class		 SctArgCnFail : EventArgs 			{public int err;}
	public delegate void SctEvtCnFail(object sender, SctArgCnFail e);

	//----- MG[ʒm -------------------------------------------------------------------------------------//
	public delegate void SctCbkRecvError([MarshalAs(UnmanagedType.Bool)]bool overlapped);
	public class		 SctArgRecvError : EventArgs 			{public bool overlapped;}
	public delegate void SctEvtRecvError(object sender, SctArgRecvError e);

	//----- MG[ʒm -------------------------------------------------------------------------------------//
	public delegate void SctCbkSendError([MarshalAs(UnmanagedType.Bool)]bool overlapped);
	public class		 SctArgSendError : EventArgs 			{public bool overlapped;}
	public delegate void SctEvtSendError(object sender, SctArgSendError e);

	//----- ̑̃G[ʒm ---------------------------------------------------------------------------------//
	public delegate void SctCbkGeneralError(ESctErrorCode ErrorCode);
	public class		 SctArgGeneralError : EventArgs	{public ESctErrorCode ErrorCode;}
	public delegate void SctEvtGeneralError(object sender, SctArgGeneralError e);

	//----------------------------------------------------------------------------------------------------------//
	//	 v[ R[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- ʒm -----------------------------------------------------------------------------------------//
	public delegate bool SplCbkNtcStr([MarshalAs(UnmanagedType.LPWStr)]string str, IntPtr cbp);
	public class		 SplArgNtcStr : EventArgs { public string str; public IntPtr cbp;}
	public delegate bool SplEvtNtcStr(object sender, SplArgNtcStr e);

	//----------------------------------------------------------------------------------------------------------//
	//	 ^C`[gER[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- Wωʒm -------------------------------------------------------------------------------------//
	public delegate void TchCbkRangeChanged(double low, double high);
	public class		 TchArgRangeChanged : EventArgs { public double low, high;}
	public delegate void TchEvtRangeChanged(object sender, TchArgRangeChanged e);

	//--- XN[ʒuωʒm -------------------------------------------------------------------------------//
	public delegate void TchCbkNtcScrollPos(int pos);
	public class		 TchArgNtcScrollPos : EventArgs { public int pos;}
	public delegate void TchEvtNtcScrollPos(object sender, TchArgNtcScrollPos e);

	//----- t@Chbvʒm -------------------------------------------------------------------------------//
	public delegate void TchCbkFileDrop(int n);
	public class		 TchArgFileDrop : EventArgs {public int n;}
	public delegate void TchEvtFileDrop(object sender, TchArgFileDrop e);

	//----- tH_hbvʒm -------------------------------------------------------------------------------//
	public delegate void TchCbkDirDrop(int n);
	public class		 TchArgDirDrop : EventArgs {public int n;}
	public delegate void TchEvtDirDrop(object sender, TchArgDirDrop e);

	//----- ENbNʒm -------------------------------------------------------------------------------------//
	public delegate void TchCbkRClick(int x, int y, [MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 TchArgRClick : EventArgs {public int x, y; public bool shift, ctrl;}
	public delegate void TchEvtRClick(object sender, TchArgRClick e);

	//----------------------------------------------------------------------------------------------------------//
	//	 usPOOR[obN^Cv																			//
	//----------------------------------------------------------------------------------------------------------//
	//----- _uNbNʒm ---------------------------------------------------------------------------------//
	public delegate void VthCbkNtcDblClk([MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 VthArgDblClk : EventArgs {public bool shift, ctrl;}
	public delegate void VthEvtNtcDblClk(object sender, VthArgDblClk e);

	//----- L[͒ʒm ---------------------------------------------------------------------------------------//
	public delegate void VthCbkNtcKeyIn(int key, int rep);
	public class		 VthArgNtcKeyIn : EventArgs {public int key; public int rep;}
	public delegate void VthEvtNtcKeyIn(object sender, VthArgNtcKeyIn e);

	//----- gL[ʒm -----------------------------------------------------------------------------------//
	public delegate void VthCbkNtcVKeyIn(EVthVKey key, int rep);
	public class		 VthArgNtcVKeyIn : EventArgs {public EVthVKey vkey; public int rep;}
	public delegate void VthEvtNtcVKeyIn(object sender, VthArgNtcVKeyIn e);

	//----- gL[ʒm -----------------------------------------------------------------------------------//
	public delegate void VthCbkNtcVKeyOut(EVthVKey key);
	public class		 VthArgNtcVKeyOut : EventArgs {public EVthVKey vkey;}
	public delegate void VthEvtNtcVKeyOut(object sender, VthArgNtcVKeyOut e);

	//----- t@Chbvʒm -------------------------------------------------------------------------------//
	public delegate void VthCbkFileDrop(int n);
	public class		 VthArgFileDrop : EventArgs {public int n;}
	public delegate void VthEvtFileDrop(object sender, VthArgFileDrop e);

	//----- tH_hbvʒm -------------------------------------------------------------------------------//
	public delegate void VthCbkDirDrop(int n);
	public class		 VthArgDirDrop : EventArgs {public int n;}
	public delegate void VthEvtDirDrop(object sender, VthArgDirDrop e);

	//----- TCYωʒm ---------------------------------------------------------------------------------//
	public delegate void VthCbkCharInfo(int LineHeight);
	public class		 VthArgCharInfo : EventArgs {public int LineHeight;}
	public delegate void VthEvtCharInfo(object sender, VthArgCharInfo e);

	//----- ENbNʒm -------------------------------------------------------------------------------------//
	public delegate void VthCbkRClick(int x, int y, [MarshalAs(UnmanagedType.Bool)] bool shift, [MarshalAs(UnmanagedType.Bool)] bool ctrl);
	public class		 VthArgRClick : EventArgs {public int x, y; public bool shift, ctrl;}
	public delegate void VthEvtRClick(object sender, VthArgRClick e);

	//----------------------------------------------------------------------------------------------------------//
	//	 sbR[obN^Cv																		//
	//----------------------------------------------------------------------------------------------------------//
	//----- `bveLXg擾v -----------------------------------------------------------------------------//
	[return: MarshalAs(UnmanagedType.LPWStr)]
	public delegate string			TipCbkNeedText(IntPtr hwnd, IntPtr cbp);

	//----- }EXJ[\ʒu̔v -----------------------------------------------------------------------//
	[return: MarshalAs(UnmanagedType.Bool)]
	public delegate bool			TipCbkChkPoint(IntPtr hwnd, ref AJCPOINT ptClient, IntPtr cbp);

	//----------------------------------------------------------------------------------------------------------//
	//	 R\[ R[obN^Cv																			//
	//----------------------------------------------------------------------------------------------------------//
	//----- seLXgʒmij------------------------------------------------------------------------//
	public delegate void	ConCbkNtcStr(int argc, [MarshalAs(UnmanagedType.LPWStr)]string argv, ConCbkNtcArgs cbp);

	//----- seLXgʒmiXgj------------------------------------------------------------------------//
	public delegate void	ConCbkNtcArgs(int argc, string[] argv);

	//----------------------------------------------------------------------------------------------------------//
	//	O																									//
	//----------------------------------------------------------------------------------------------------------//

	//	t@CI[vG[
	[Serializable()]
	public class FileOpenFailureException : System.Exception
	{
		public	  FileOpenFailureException() : base() { }
		public	  FileOpenFailureException(string message) : base(message) { }
		public	  FileOpenFailureException(string message, System.Exception inner) : base(message, inner) { }
		protected FileOpenFailureException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}
	//	t@CG[
	[Serializable()]
	public class FileCreationFailureException : System.Exception
	{
		public	  FileCreationFailureException() : base() { }
		public	  FileCreationFailureException(string message) : base(message) { }
		public	  FileCreationFailureException(string message, System.Exception inner) : base(message, inner) { }
		protected FileCreationFailureException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}
	//	t@CN[YG[
	[Serializable()]
	public class FileCloseFailureException : System.Exception
	{
		public	  FileCloseFailureException() : base() { }
		public	  FileCloseFailureException(string message) : base(message) { }
		public	  FileCloseFailureException(string message, System.Exception inner) : base(message, inner) { }
		protected FileCloseFailureException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}
	//	t@CANZXG[
	[Serializable()]
	public class FileAccessFailureException : System.Exception
	{
		public	  FileAccessFailureException() : base() { }
		public	  FileAccessFailureException(string message) : base(message) { }
		public	  FileAccessFailureException(string message, System.Exception inner) : base(message, inner) { }
		protected FileAccessFailureException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}
	//	o^s
	[Serializable()]
	public class RegistrationFailureException : System.Exception
	{
		public	  RegistrationFailureException() : base() { }
		public	  RegistrationFailureException(string message) : base(message) { }
		public	  RegistrationFailureException(string message, System.Exception inner) : base(message, inner) { }
		protected RegistrationFailureException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}
	//	Zbgs
	[Serializable()]
	public class ResetFailedException : System.Exception
	{
		public	  ResetFailedException() : base() { }
		public	  ResetFailedException(string message) : base(message) { }
		public	  ResetFailedException(string message, System.Exception inner) : base(message, inner) { }
		protected ResetFailedException(System.Runtime.Serialization.SerializationInfo info,
						System.Runtime.Serialization.StreamingContext context) : base(info, context) { }
	}

}
