using System;
using System.ComponentModel;
using System.Drawing;
using System.Collections.Generic;
using System.Diagnostics;
using System.Text;
using System.Runtime.InteropServices;
using AjaraInit;

namespace CAjrCustCtrl
{
	//----------------------------------------------------------------------------------------------------------//
	[ToolboxBitmap(typeof(CAjrSerialComPort), "CAjrSerialComPort.bmp")]
	public partial class CAjrSerialComPort : Component
	{
		//----- Oւ̃Cxg -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that the communication port has changed.")]
		public event ScpEvtPortState		OnPortState ;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify incoming chunk text in real time.")]
		public event ScpEvtRxChunkTxt		OnRxChunkTxt;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify incoming chunk binary data in real time.")]
		public event ScpEvtRxChunkBin		OnRxChunkBin;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify the received text data.")]
		public event ScpEvtRxText			OnRxText	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies the received escape sequence.")]
		public event ScpEvtRxEsc			OnRxEsc 	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify the received control code.")]
		public event ScpEvtRxCtrl			OnRxCtrl	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify the received packet data.")]
		public event ScpEvtRxPacket			OnRxPacket	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notify the completion of transmission.")]
		public event ScpEvtTxEmpty			OnTxEmpty	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies the part of the received data other than the packet.")]
		public event ScpEvtRxNoPkt			OnRxNoPkt	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies the 14-bit value extracted from the received 2 bytes.")]
		public event ScpEvtRxWord14			OnRxWord14	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that invalid text chunk data has been received.")]
		public event ScpEvtRxInvChunk		OnRxInvChunk;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that an error has been detected.")]
		public event ScpEvtError			OnError 	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that the RING signal has changed.")]
		public event ScpEvtNtcRING			OnNtcRING	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that the RLSD signal has changed.")]
		public event ScpEvtNtcRLSD			OnNtcRLSD	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that the DSR signal has changed.")]
		public event ScpEvtNtcDSR			OnNtcDSR	;

		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Notifies that the CTS signal has changed.")]
		public event ScpEvtNtcCTS			OnNtcCTS	;

		private	ScpCbkPortState 		m_ScpCbkPortState;
		private	ScpCbkRxChunkTxt		m_ScpCbkRxChunkTxt;
		private	ScpCbkRxChunkBin		m_ScpCbkRxChunkBin;
		private	ScpCbkRxText			m_ScpCbkRxText;
		private	ScpCbkRxEsc 			m_ScpCbkRxEsc;
		private	ScpCbkRxCtrl			m_ScpCbkRxCtrl;
		private	ScpCbkRxPacket			m_ScpCbkRxPacket;
		private	ScpCbkTxEmpty			m_ScpCbkTxEmpty;
		private	ScpCbkRxNoPkt			m_ScpCbkRxNoPkt;
		private	ScpCbkRxWord14			m_ScpCbkRxWord14;
		private	ScpCbkRxInvChunk		m_ScpCbkRxInvChunk;
		private	ScpCbkError 			m_ScpCbkError;
		private	ScpCbkNtcRING			m_ScpCbkNtcRING;
		private	ScpCbkNtcRLSD			m_ScpCbkNtcRLSD;
		private	ScpCbkNtcDSR			m_ScpCbkNtcDSR;
		private	ScpCbkNtcCTS			m_ScpCbkNtcCTS;

		//----- Rei[htO ---------------------------------------------------------------------------//
		private	bool			m_fContainer = true;
		//----- s[h ---------------------------------------------------------------------------------//
		private EScpMode		m_ScpMode	= EScpMode.NotificationByEvent;	//	s[h
		private EScpChunkMode	m_ChunkMode	= EScpChunkMode.BinaryData;		//	`N
		//----- [N -----------------------------------------------------------------------------------------//
		private IntPtr			m_hScp;
		private string			m_ProfileSect=	"SerialPortSect";
		private	int				m_STX		 =	0x02;
		private	int				m_ETX		 =	0x03;
		private	int				m_DLE		 =	0x10;
		private	int				m_PktTimeout =	3000;
		private EScpRxTextCode	m_RxTextCode =	EScpRxTextCode.SJIS;
		private EScpTxTextCode	m_TxTextCode =	EScpTxTextCode.SJIS;

		//----- RXgN^iPj ---------------------------------------------------------------------------//
		unsafe public CAjrSerialComPort()
		{
			InitializeComponent();

			m_fContainer = false;							//	R\[[h

			CAjrInit.Init();								//	Cu

			SubCreateSerialComPort();						//	VAʐMCX^X
		}

		//----- RXgN^iQj ---------------------------------------------------------------------------//
		unsafe public CAjrSerialComPort(IContainer container)
		{
			container.Add(this);

			InitializeComponent();

			m_fContainer = true;							//	Rei[h

			CAjrInit.Init();								//	Cu

			SubCreateSerialComPort();						//	VAʐMCX^X

			this.Disposed  += OnUnloadMyControl;			//	ICxgݒ

		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		unsafe void SubCreateSerialComPort()
		{
			m_ScpCbkPortState		= new ScpCbkPortState		(cbScpPortState		);
			m_ScpCbkRxChunkTxt		= new ScpCbkRxChunkTxt		(cbScpRxChunkTxt	);
			m_ScpCbkRxChunkBin		= new ScpCbkRxChunkBin		(cbScpRxChunkBin	);
			m_ScpCbkRxText			= new ScpCbkRxText			(cbScpRxText 		);
			m_ScpCbkRxEsc			= new ScpCbkRxEsc			(cbScpRxEsc			);
			m_ScpCbkRxCtrl			= new ScpCbkRxCtrl			(cbScpRxCtrl 		);
			m_ScpCbkRxPacket		= new ScpCbkRxPacket		(cbScpRxPacket		);
			m_ScpCbkTxEmpty 		= new ScpCbkTxEmpty			(cbScpTxEmpty		);
			m_ScpCbkRxNoPkt 		= new ScpCbkRxNoPkt			(cbScpRxNoPkt		);
			m_ScpCbkRxWord14 		= new ScpCbkRxWord14		(cbScpRxWord14		);
			m_ScpCbkRxInvChunk 		= new ScpCbkRxInvChunk		(cbScpRxInvChunk	);
			m_ScpCbkError			= new ScpCbkError			(cbScpError			);
			m_ScpCbkNtcRING 		= new ScpCbkNtcRING			(cbScpNtcRING		);
			m_ScpCbkNtcRLSD 		= new ScpCbkNtcRLSD			(cbScpNtcRLSD		);
			m_ScpCbkNtcDSR			= new ScpCbkNtcDSR			(cbScpNtcDSR 		);
			m_ScpCbkNtcCTS			= new ScpCbkNtcCTS			(cbScpNtcCTS 		);

			m_hScp 	= CAjrApi.AjcScpCreateForMSIL(	m_ScpCbkPortState	,
													m_ScpCbkRxChunkTxt	,
													m_ScpCbkRxChunkBin	,
													m_ScpCbkRxText		,
													m_ScpCbkRxEsc		,
													m_ScpCbkRxCtrl		,
													m_ScpCbkRxPacket	,
													m_ScpCbkTxEmpty 	,
													m_ScpCbkRxNoPkt 	,
													m_ScpCbkRxWord14 	,
													m_ScpCbkRxInvChunk 	,
													m_ScpCbkError		,
													m_ScpCbkNtcRING 	,
													m_ScpCbkNtcRLSD 	,
													m_ScpCbkNtcDSR		,
													m_ScpCbkNtcCTS		);
		}
		//----- I ---------------------------------------------------------------------------------------//
		private void OnUnloadMyControl(object sender, EventArgs e)
		{
			CAjrApi.AjcScpDeleteForMSIL(m_hScp);
		}
		//------------------------------------------------------------------------------------------------------//
		//	vpeB																							//
		//------------------------------------------------------------------------------------------------------//
		//	VAʐMi_ProfileSection, _ScpModeMySlotNameZbgꂽ_ŁAVAʐM̏sj
		private bool m_fProfSect = false;		//	vt@CZNVݒσtO
		private bool m_fScpMode  = false;		//	[hl				ݒσtO
		private bool m_fMySlot	 = false;		//	Xbg			ݒσtO
		private bool m_fRmtHost  = false;		//	zXg			ݒσtO
		private bool m_fRmtSlot  = false;		//	Xbg			ݒσtO
		private bool m_fInited	 = false;		//	σtO

		private void InitScp2()
		{
			if (!m_fInited) {													//	H
				if (m_fProfSect && m_fScpMode && m_fMySlot &&					//		elݒρH
								   m_fRmtHost && m_fRmtSlot) {
					CAjrApi.AjcScpLoadParamFromProfile(m_hScp, m_ProfileSect);	//			vt@Cǂݏo(ʐMp^)
					CAjrApi.AjcScpCreateMySlotForMSIL(m_hScp);					//			[Xbg(G[mňÖِ)
					if (m_ScpMode == EScpMode.NotificationByEvent) {			//			tH[AvH
						CAjrApi.AjcScpSetModeForMSIL(m_hScp, true);				//				s[hݒiOnXXXCxggpj
					}
					else {														//			R\[AvH
						CAjrApi.AjcScpSetModeForMSIL(m_hScp, false);			//				s[hݒiWaitEvent()gpj
					}
					m_fInited = true;											//		   uρv
				}
			}
		}
		//----- vt@CZNV -------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Profile section which records a set value" +
										   "(This property can be set only at designing)")]
		public string _ProfileSection {
			set {m_ProfileSect = value;
				 CAjrApi.AjcScpSetProfileSectForMSIL(m_hScp, value);	//	vt@CZNVݒ
				 m_fProfSect   = true;									// uvt@CZNVݒρv
				 InitScp2();											//	rboQ
			}
			get {return CAjrApi.AjcScpGetProfileSectForMSIL(m_hScp);}
		}
		//----- s[h -------------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Event reception mode" +
										   "(This property can be set only at designing)")]
		public EScpMode _ScpMode {
			set {m_ScpMode	= value;				//	[hlݒ
				 m_fScpMode = true;					// u[hlݒρv
				 InitScp2();						//	rboQ
			}
			get {return m_ScpMode;}
		}
		//----- Xbg -----------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Default local mail slot name")]
		public string MySlotName {
			set {CAjrApi.AjcScpSetMySlotForMSIL(m_hScp, value);		//	Xbgݒ
				 m_fMySlot = true;									// uXbgݒρv
				 InitScp2();										//	rboQ
			}
			get {return CAjrApi.AjcScpGetMySlotForMSIL(m_hScp);}
		}
		//----- Rs[^ -----------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Default remote computer name (When blank, it is a local computer)")]
		public string RemoteComputerName {
			set {CAjrApi.AjcScpSetRmtHostForMSIL(m_hScp, value);	//	zXgݒ
				 m_fRmtHost = true;									// uzXgݒρv
				 InitScp2();										//	rboQ
			}
			get {return CAjrApi.AjcScpGetRmtHostForMSIL(m_hScp);}
		}
		//----- Xbg ---------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Default remote mail slot name")]
		public string RemoteSlotName {
			set {CAjrApi.AjcScpSetRmtSlotForMSIL(m_hScp, value);	//	Xbgݒ
				 m_fRmtSlot = true;									// uXbgݒρv
				 InitScp2();										//	rboQ
			}
			get {return CAjrApi.AjcScpGetRmtSlotForMSIL(m_hScp);}
		}
		//----- rbo`Nf[^̈ ---------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Kind of reception chunk data" +
										   "(This property can be set only at designing)")]
		public EScpChunkMode ChunkMode {
			set {CAjrApi.AjcScpSetChunkMode(m_hScp, m_ChunkMode = value);}
			get {return m_ChunkMode;}
		}
		//----- pPbg擪R[h(STX) ------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Packet starting code value (STX)")]
		public int STX {
			set {m_STX = (int)value;  CAjrApi.AjcScpSetPktCtrlCode(m_hScp, m_STX, 0, 0);}
			get {return (int)m_STX; }
		}
		//----- pPbgR[h(ETX) ------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Packer ending code value (ETX)")]
		public int ETX {
			set {m_ETX = (int)value;  CAjrApi.AjcScpSetPktCtrlCode(m_hScp, 0, m_ETX, 0);}
			get {return (int)m_ETX; }
		}
		//----- pPbgߐoCgR[h(DLE) --------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Packet transparent control code (DLE)")]
		public int DLE {
			set {m_DLE = (int)value;  CAjrApi.AjcScpSetPktCtrlCode(m_hScp, 0, 0, m_DLE);}
			get {return (int)m_DLE; }
		}
		//----- pPbgM^CAEg^C} -----------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Packet reception timeout [ms]")]
		public int PktTimeout {
			set {m_PktTimeout = (int)value;  CAjrApi.AjcScpSetPktTimeout(m_hScp, m_PktTimeout);}
			get {return (int)m_PktTimeout; }
		}
		//----- MeLXg̕R[h -----------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Received text code")]
		public EScpRxTextCode RxTextCode {
			set {m_RxTextCode = value;	CAjrApi.AjcScpSetRxTextCode(m_hScp, m_RxTextCode);
										CAjrApi.AjcScpSetTxTextCode(m_hScp, m_TxTextCode);}
			get {return m_RxTextCode; }
		}
		//----- ۂ̎MeLXg̕R[hiAUTO͎ۂ̎MR[hj----------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Received actual text code")]
		public EScpRxTextCode ActualRxTextCode {
			get {return CAjrApi.AjcScpGetActualRxTextCode(m_hScp);}
		}
		//----- MeLXg̕R[h -----------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Sending Text code")]
		public EScpTxTextCode TxTextCode {
			set {m_TxTextCode = value;	CAjrApi.AjcScpSetRxTextCode(m_hScp, m_RxTextCode);
										CAjrApi.AjcScpSetTxTextCode(m_hScp, m_TxTextCode);}
			get {return m_TxTextCode; }
		}
		//----- ۂ̑MeLXg̕R[hiAUTO͎MR[hj----------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Sending actual text code")]
		public EScpTxTextCode ActualTxTextCode {
			get {return CAjrApi.AjcScpGetActualTxTextCode(m_hScp);}
		}
		//----- [Xbg -----------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("My mail-slot creation status")]
		public bool IsCreatedMySlot {
			get {return CAjrApi.AjcScpMySlotIsCreated(m_hScp); }
		}

		//----- |[gI[vԏ -------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Communication port open status")]
		public bool IsOpened {
			get {return CAjrApi.AjcScpIsOpened(m_hScp) != 0 ? true : false;}
		}

		//----- ݒ肳ĂʐM|[gԍ -------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Communication port number")]
		public int PortNo {
			get {return (int)CAjrApi.AjcScpGetSelectedPort(m_hScp);}
		}

		//----- oCgyA̎M ---------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrSerialCommunication")]
		[System.ComponentModel.Description("Receive order of byte pair upon reception of word (14 bit value)")]
		public EScpByteSeq ByteSeq {
			set {CAjrApi.AjcScpSetByteSeqRxWord14(m_hScp, value);}
			get {return (EScpByteSeq)CAjrApi.AjcScpGetByteSeqRxWord14(m_hScp);}
		}

		//------------------------------------------------------------------------------------------------------//
		//	\bh																							//
		//------------------------------------------------------------------------------------------------------//
		//----- rbo -----------------------------------------------------------------------------------//
		private bool m_ScpInited = false;
		public void Init()
		{
			if (!m_ScpInited) {
				//	OnXXXXXCxg`ɏ]ACxg}XNݒ
				if (m_fContainer) {
					SetEvtMaskByEvent();
				}
				//	tOς
				m_ScpInited = true;
			}
		}
		//----- ʐM|[gI[v -----------------------------------------------------------------------------//
		public bool Open()
		{
			return CAjrApi.AjcScpOpenDefault(m_hScp);
		}
		//- - -  ŏ̒ʐM\[Xw肵ăI[v - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public bool Open(ESelPort sel)
		{
			return CAjrApi.AjcScpOpenSelect(m_hScp, (int)sel);
		}
		//- - - bnl|[g I[v - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public bool Open(int PortNo, int rate, EScpDataBits DataBits, EScpParity Parity, EScpStopBit StopBit)
		{
			return CAjrApi.AjcScpOpen(m_hScp, (int)PortNo, (int)rate, (int)DataBits, (int)Parity, (int)StopBit);
		}
		//- - - [Xbg I[v - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public bool Open(string RemoteHostName, string RemoteSlotName)
		{
			return CAjrApi.AjcScpOpenSlot(m_hScp, RemoteHostName, RemoteSlotName);
		}
		//- - - \Pbg(TCP/IP) I[v - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public bool Open(string ServName, uint ServPortNo)
		{
			return CAjrApi.AjcScpOpenSock(m_hScp, ServName, ServPortNo);
		}
		//----- ʐM|[gN[Y -----------------------------------------------------------------------------//
		public void Close()
		{
			CAjrApi.AjcScpClose(m_hScp);
		}
		//----- oCgM -------------------------------------------------------------------------------------//
		public void SendByte(int ByteCode)
		{
			CAjrApi.AjcScpSendChar(m_hScp, (byte)ByteCode);
		}
		//----- PM -------------------------------------------------------------------------------------//
		public void SendChar(char Character)
		{
			CAjrApi.AjcScpSendChar(m_hScp, (ushort)Character);
		}
		//----- PSrbg[hlioCgyAjMCLow Byte First -------------------------------------------//
		public void SendWord14LF(int data)
		{
			CAjrApi.AjcScpSendWord14LF(m_hScp, data);
		}
		//----- PSrbg[hlioCgyAjMCHigh Byte First ------------------------------------------//
		public void SendWord14HF(int data)
		{
			CAjrApi.AjcScpSendWord14HF(m_hScp, data);
		}
		//----- eLXgM -----------------------------------------------------------------------------------//
		public void SendText(string text)
		{
			CAjrApi.AjcScpSendText(m_hScp, text, (int)text.Length);
		}
		//----- oCiM -----------------------------------------------------------------------------------//
		public void SendBinary(Byte[] bin)
		{
			CAjrApi.AjcScpSendBinData(m_hScp, bin);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SendBinary(IntPtr p, int len)
		{
			CAjrApi.AjcScpSendBinData(m_hScp, p, len);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		unsafe public void SendBinary(void *p, int len)
		{
			CAjrApi.AjcScpSendBinData(m_hScp, p, len);
		}
		//----- pPbgM -----------------------------------------------------------------------------------//
		public int SendPacket(Byte[] bin)
		{
			int		rc = 0;
			if (bin != null) {
				rc = CAjrApi.AjcScpSendPacket(m_hScp, bin);
			}
			else {
				rc = CAjrApi.AjcScpSendPacket(m_hScp, (IntPtr)0, 0);
			}
			return rc;
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public int SendPacket(IntPtr p, int len)
		{
			return CAjrApi.AjcScpSendPacket(m_hScp, p, len);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		unsafe public int SendPacket(void* p, int len)
		{
			return CAjrApi.AjcScpSendPacket(m_hScp, p, len);
		}
		//----- u[NMo^~ -------------------------------------------------------------------------//
		public void SendBreak(bool fActive)
		{
			CAjrApi.AjcScpSendBreak(m_hScp, fActive);
		}
		//----- csqMݒ ---------------------------------------------------------------------------------//
		public void SetDTR(bool fActive)
		{
			CAjrApi.AjcScpSetDTR(m_hScp, fActive);
		}
		//----- qsrMݒ ---------------------------------------------------------------------------------//
		public void SetRTS(bool fActive)
		{
			CAjrApi.AjcScpSetRTS(m_hScp, fActive);
		}
		//----- crqM擾 ---------------------------------------------------------------------------------//
		public bool GetDSR()
		{
			bool	rc = false;
			if ((CAjrApi.AjcScpGetSigState(m_hScp) & 0x0020) != 0) {
				rc = true;
			}
			return rc;
		}
		//----- bsrM擾 ---------------------------------------------------------------------------------//
		public bool GetCTS()
		{
			bool	rc = false;
			if ((CAjrApi.AjcScpGetSigState(m_hScp) & 0x0010) != 0) {
				rc = true;
			}
			return rc;
		}
		//----- qkrcM擾 -------------------------------------------------------------------------------//
		public bool GetRLSD()
		{
			bool	rc = false;
			if ((CAjrApi.AjcScpGetSigState(m_hScp) & 0x0080) != 0) {
				rc = true;
			}
			return rc;
		}
		//----- qhmfM擾 -------------------------------------------------------------------------------//
		public bool GetRING()
		{
			bool	rc = false;
			if ((CAjrApi.AjcScpGetSigState(m_hScp) & 0x0040) != 0) {
				rc = true;
			}
			return rc;
		}
		//----- Mσf[^f[^j -------------------------------------------------------------------------//
		public void PurgeRx()
		{
			CAjrApi.AjcScpPurgeRecvData(m_hScp);
		}
		//----- M҂f[^f[^j -----------------------------------------------------------------------//
		public void PurgeTx()
		{
			CAjrApi.AjcScpPurgeSendData(m_hScp);
		}
		//----- Mf[^j -------------------------------------------------------------------------------//
		public void Purge()
		{
			CAjrApi.AjcScpPurgeAllData(m_hScp);
		}
		//----- _CAOɂʐMp^ݒ ---------------------------------------------------------------//
		public void SetParamByDialog()
		{
			CAjrApi.AjcScpDlgParamEasy(m_hScp, (IntPtr)0);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SetParamByDialog(IntPtr hOwner)
		{
			CAjrApi.AjcScpDlgParamEasy(m_hScp, hOwner);
		}
		//----- _CAOɂڍׂȒʐMp^ݒ ---------------------------------------------------------//
		public void SetDetailParamByDialog()
		{
			CAjrApi.AjcScpDlgParamDetail(m_hScp, (IntPtr)0);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SetDetailParamByDialog(IntPtr hOwner)
		{
			CAjrApi.AjcScpDlgParamDetail(m_hScp, hOwner);
		}
		//----- ʐMp^ݒ_CAOɂbnl|[gC[XbgC\PbgʐM̑I^֎~ -----//
		public void EnablePortSelectionInDialog(bool fEnableComPort, bool fEnableMailSlot, bool fEnableSocket)
		{
			CAjrApi.AjcScpEnablePortSelectionEx(m_hScp, fEnableComPort, fEnableMailSlot, fEnableSocket);
		}
		//----- Cxg҂ -----------------------------------------------------------------------------------//
		public EScpEvt WaitEvent(out Object EvtData, int msWaitTime)
		{
			IntPtr	wParam = (IntPtr)0;
			IntPtr	lParam = (IntPtr)0;
			IntPtr	pDat;
			int	len, param;
			EScpEvt	evt = (EScpEvt)0;

			//	o͏񏉊
			EvtData = null;

			if (CAjrApi.AjcScpWaitEvent(m_hScp, ref wParam, ref lParam, msWaitTime)) {
				CAjrApi.AjcScpGetEventData(m_hScp, lParam, out pDat, out len, out param);	//	Cxgf[^擾

				evt = (EScpEvt)wParam;

				//----- |[gI[vԒʒm ---------------------------------------------------------------//
				if ((evt & EScpEvt.EV_PORTSTATE) != 0) {
					EvtData = param;
				}
				//----- `Nf[^Mʒm ---------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXCHUNK) != 0) {
					if (param == 0) {
						Byte[] BArr = new Byte[len];
						CAjrApi.AjcMemCopy(ref BArr[0], pDat, len);
						EvtData = BArr;
					}
					else {
						StringBuilder s = new StringBuilder(len + 1);
						CAjrApi.AjcWStrCopy(s, pDat);
						EvtData = s.ToString();
					}
   	   	   	 	}
				//----- eLXgMʒm ---------------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXTEXT) != 0) {
					StringBuilder s = new StringBuilder(len + 1);
					CAjrApi.AjcWStrCopy(s, pDat);
					EvtData = s.ToString();
				}
				//----- drbR[hMʒm -----------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXESC) != 0) {
					StringBuilder s = new StringBuilder(len + 1);
					CAjrApi.AjcWStrCopy(s, pDat);
					EvtData = s.ToString();
				}
				//----- R[hMʒm -------------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXCTRL) != 0) {
					EvtData = CAjrApi.AjcMemPeekUW(pDat);
				}
				//----- pPbgf[^Mʒm ---------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXPKT) != 0) {
					Byte[] BArr = new Byte[len];
					CAjrApi.AjcMemCopy(ref BArr[0], pDat, len);
					EvtData = BArr;
				}
				//----- pPbgOf[^Mʒm -------------------------------------------------------------//
				else if ((evt & EScpEvt.EV_RXNOPKT) != 0) {
					StringBuilder s = new StringBuilder(len + 1);
					CAjrApi.AjcWStrCopy(s, pDat);
					EvtData = s.ToString();
				}
				//----- oCgyAɂ郏[h(14BitljMʒm ---------------------------------------------//
				else if ((evt & EScpEvt.EV_RXWORD14) != 0) {
					EvtData = CAjrApi.AjcMemPeekUW(pDat);
				}
				//----- ̑ -------------------------------------------------------------------------------//
				else  {
					EvtData = param;
				}

				CAjrApi.AjcScpRelEventData(m_hScp, lParam);					//	Cxgf[^J
			}
			return evt;
		}
		//----- Cxg}XNݒ -----------------------------------------------------------------------------//
		public void SetEvtMask(EScpEvt evt)
		{
			if (m_ScpMode == EScpMode.WaitingForEvent) {	//	R\[AvH
				CAjrApi.AjcScpSetEvtMask(m_hScp, (int)evt);
			}
		}
		//----- Cxg}XN擾 -----------------------------------------------------------------------------//
		public EScpEvt GetEvtMask()
		{
			EScpEvt	rc = 0;
			rc = (EScpEvt)CAjrApi.AjcScpGetEvtMask(m_hScp);
			return rc;
		}
		//----- |[gpX擾 -------------------------------------------------------------------------------//
		public string GetPortPathName()
		{
			return CAjrApi.AjcScpGetPortPathNameForMSIL(m_hScp);
		}
		//----- |[g擾 -----------------------------------------------------------------------------------//
		public string GetPortName()
		{
			return CAjrApi.AjcScpGetPortNameForMSIL(m_hScp);
		}
		//----- bnl|[gfoCX擾 ---------------------------------------------------------------------//
		public string GetPortDevName(string ComPortName)
		{
			return CAjrApi.AjcScpGetPortDevName(ComPortName);
		}
		//----- [XbgpX擾 ---------------------------------------------------------------------//
		public string GetMySlotPathName()
		{
			return CAjrApi.AjcScpGetMySlotPathNameForMSIL(m_hScp);
		}
		//----- [Xbg ---------------------------------------------------------------------------//
		public bool CreateMySlot()
		{
			return CAjrApi.AjcScpCreateMySlot(m_hScp);
		}
		//----- [Xbg ---------------------------------------------------------------------------//
		public void DeleteMySlot()
		{
			CAjrApi.AjcScpDeleteMySlot(m_hScp);
		}
		//----- [Xbgݒ -----------------------------------------------------------------------//
		public void SetMailSlotNames(string MySlot, string RmtHost, string RmtSlot)
		{
			CAjrApi.AjcScpSetMailSlotNames(m_hScp, MySlot, RmtHost, RmtSlot);
		}
		//----- [Xbg̒ʐMx -------------------------------------------------------------------//
		public void SetMailSlotSpeedLimit(bool fLimit, int KBps)
		{
			CAjrApi.AjcScpSetTxSpeedLimit(m_hScp, fLimit , KBps);
		}
		//----- rbo -------------------------------------------------------------------------------------//
		public void Delete() {
			CAjrApi.AjcScpDeleteForMSIL(m_hScp);
		}
		//------------------------------------------------------------------------------------------------------//
		//	Tu֐																						//
		//------------------------------------------------------------------------------------------------------//
		//----- SetEvtMaskByEvent		   ---------------------------------------------------------------------//
		private bool SetEvtMaskByEvent()
		{
			bool	rc;
			EScpEvt	evt = 0;

			if (OnPortState		 != null) evt |= EScpEvt.EV_PORTSTATE;		//	|[gԒʒm
			if (OnRxChunkTxt	 != null) evt |= EScpEvt.EV_RXCHUNK;		//	`NeLXgMʒm
			if (OnRxChunkBin	 != null) evt |= EScpEvt.EV_RXCHUNK;		//	`NoCiMʒm
			if (OnRxText		 != null) evt |= EScpEvt.EV_RXTEXT;			//	eLXgMʒm
			if (OnRxEsc 		 != null) evt |= EScpEvt.EV_RXESC;			//	drbMʒm
			if (OnRxCtrl		 != null) evt |= EScpEvt.EV_RXCTRL;			//	R[hMʒm
			if (OnRxPacket		 != null) evt |= EScpEvt.EV_RXPKT;			//	pPbgMʒm
			if (OnTxEmpty		 != null) evt |= EScpEvt.EV_TXEMPTY;		//	Mʒm
			if (OnRxNoPkt		 != null) evt |= EScpEvt.EV_RXNOPKT;		//	pPbgOeLXgMʒm
			if (OnRxWord14		 != null) evt |= EScpEvt.EV_RXWORD14;		//	oCgyAɂ郏[h(14Bitl)Mʒm
			if (OnRxInvChunk	 != null) evt |= EScpEvt.EV_INVCHUNK;		//	s`NeLXgMʒm
			if (OnError	 		 != null) evt |= EScpEvt.EV_ERR;			//	G[ʒm
			if (OnNtcRING		 != null) evt |= EScpEvt.EV_RING;			//	RINGωʒm
			if (OnNtcRLSD		 != null) evt |= EScpEvt.EV_RLSD;			//	RLSDωʒm
			if (OnNtcDSR		 != null) evt |= EScpEvt.EV_DSR;			//	DSRωʒm
			if (OnNtcCTS		 != null) evt |= EScpEvt.EV_CTS;			//	CTSωʒm

			rc = CAjrApi.AjcScpSetEvtMask(m_hScp, (int)evt);

			return rc;
		}
		//------------------------------------------------------------------------------------------------------//
		//	R[obN																						//
		//------------------------------------------------------------------------------------------------------//
		//----- R[obN֐i|[gԒʒmj--------------------------------------------------------------//
		private void cbScpPortState(EScpPortState state, string name)
		{
			if (OnPortState != null) {
				ScpArgPortState eva = new ScpArgPortState();
				eva.state = state;
				eva.name  = name;
				OnPortState(this, eva);
			}
		}
		//----- R[obN֐ieLXg`NMʒmj----------------------------------------------------//
		private void cbScpRxChunkTxt(string text)
		{
			if (OnRxChunkTxt != null) {
				ScpArgRxChunkTxt eva = new ScpArgRxChunkTxt();
				eva.text = text;
				OnRxChunkTxt(this, eva);
			}
		}
		//----- R[obN֐ioCi`NMʒmj----------------------------------------------------//
		unsafe private void cbScpRxChunkBin(void *p, int len)
		{
			if (OnRxChunkBin != null && len != 0) {
				ScpArgRxChunkBin eva = new ScpArgRxChunkBin();
				eva.bin = new Byte[len];
				fixed (void *pBArr = &eva.bin[0]) {
					CAjrApi.AjcMemCopy(pBArr, p, len);
				}
				OnRxChunkBin(this, eva);
			}
		}
		//----- R[obN֐ieLXgMʒmj------------------------------------------------------------//
		private void cbScpRxText(string text)
		{
			if (OnRxText != null) {
				ScpArgRxText eva = new ScpArgRxText();
				eva.text  = text;
				OnRxText(this, eva);
			}
		}
		//----- R[obN֐idrbMʒmj--------------------------------------------------------------//
		private void cbScpRxEsc(string esc)
		{
			if (OnRxEsc != null) {
				ScpArgRxEsc eva = new ScpArgRxEsc();
				eva.esc  = esc;
				OnRxEsc(this, eva);
			}
		}
		//----- R[obN֐iR[hMʒmj----------------------------------------------------------//
		private void cbScpRxCtrl(char ctrl)
		{
			if (OnRxCtrl != null) {
				ScpArgRxCtrl eva = new ScpArgRxCtrl();
				eva.ctrl  = ctrl;
				OnRxCtrl(this, eva);
			}
		}
		//----- R[obN֐ipPbgMʒmj------------------------------------------------------------//
		unsafe private void cbScpRxPacket(void *p, int len)
		{
			if (OnRxPacket != null) {
				ScpArgRxPacket eva = new ScpArgRxPacket();
				if (len != 0) {
					eva.bin	= new Byte[len];
					fixed (void *pBArr = &eva.bin[0]) {
						CAjrApi.AjcMemCopy(pBArr, p, len);
					}
				}
				else {
					eva.bin = null;
				}
				OnRxPacket(this, eva);
			}
		}
		//----- R[obN֐iMʒmj----------------------------------------------------------------//
		private void cbScpTxEmpty()
		{
			if (OnTxEmpty != null) {
				EventArgs eva = new EventArgs();
				OnTxEmpty(this, eva);
			}
		}
		//----- R[obN֐ipPbgOeLXgMʒmj--------------------------------------------------//
		private void cbScpRxNoPkt(string text)
		{
			if (OnRxNoPkt != null) {
				ScpArgRxNoPkt eva = new ScpArgRxNoPkt();
				eva.text  = text;
				OnRxNoPkt(this, eva);
			}
		}
		//----- R[obN֐ioCgyAɂ郏[h(14BitljMʒmj------------------------------------//
		private void cbScpRxWord14(int data)
		{
			if (OnRxWord14 != null) {
				ScpArgRxWord14 eva = new ScpArgRxWord14();
				eva.data  = data;
				OnRxWord14(this, eva);
			}
		}
		//----- R[obN֐is`NeLXgMʒmj------------------------------------------------//
		unsafe private void cbScpRxInvChunk(void *p, int len)
		{
			if (OnRxInvChunk != null) {
				ScpArgRxInvChunk eva = new ScpArgRxInvChunk();
				eva.bin = new Byte[len];
				fixed (void *pBArr = &eva.bin[0]) {
					CAjrApi.AjcMemCopy(pBArr, p, len);
				}
				OnRxInvChunk(this, eva);
			}

		}
		//----- R[obN֐iG[ʒmj------------------------------------------------------------------//
		private void cbScpError(int err)
		{
			if (OnError != null) {
				ScpArgError eva = new ScpArgError();
				eva.err = (EScpErr)err;
				OnError(this, eva);
			}
		}
		//----- R[obN֐iRINGωʒmj----------------------------------------------------------------//
		private void cbScpNtcRING(bool cts, bool dsr,bool rlsd, bool ring)
		{
			if (OnNtcRING != null) {
				ScpArgNtcRING eva = new ScpArgNtcRING();
				eva.cts  = cts;
				eva.dsr  = dsr;
				eva.rlsd = rlsd;
				eva.ring = ring;
				OnNtcRING(this, eva);
			}
		}
		//----- R[obN֐iRLSDωʒmj----------------------------------------------------------------//
		private void cbScpNtcRLSD(bool cts, bool dsr,bool rlsd, bool ring)
		{
			if (OnNtcRLSD != null) {
				ScpArgNtcRLSD eva = new ScpArgNtcRLSD();
				eva.cts  = cts;
				eva.dsr  = dsr;
				eva.rlsd = rlsd;
				eva.ring = ring;
				OnNtcRLSD(this, eva);
			}
		}
		//----- R[obN֐iDSRωʒmj-----------------------------------------------------------------//
		private void cbScpNtcDSR(bool cts, bool dsr,bool rlsd, bool ring)
		{
			if (OnNtcDSR != null) {
				ScpArgNtcDSR eva = new ScpArgNtcDSR();
				eva.cts  = cts;
				eva.dsr  = dsr;
				eva.rlsd = rlsd;
				eva.ring = ring;
				OnNtcDSR(this, eva);
			}
		}
		//----- R[obN֐iCTSωʒmj-----------------------------------------------------------------//
		private void cbScpNtcCTS(bool cts, bool dsr,bool rlsd, bool ring)
		{
			if (OnNtcCTS != null) {
				ScpArgNtcCTS eva = new ScpArgNtcCTS();
				eva.cts  = cts;
				eva.dsr  = dsr;
				eva.rlsd = rlsd;
				eva.ring = ring;
				OnNtcCTS(this, eva);
			}
		}
	}
}
