using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Drawing.Design;
using System.Windows.Forms.Design;
using AjaraInit;

namespace CAjrCustCtrl
{
	//----------------------------------------------------------------------------------------------------------//
	[ToolboxBitmap(typeof(CAjrVT100), "CAjrVT100.bmp")]
	public partial class CAjrVT100 : UserControl
	{
		//----- Oւ̃Cxg -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Occurs when double-clicked.")]
		public event VthEvtNtcDblClk OnNtcDblClk;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Notifies the key input.")]
		public event VthEvtNtcKeyIn  OnNtcKeyIn;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Notifies the press vartual key.")]
		public event VthEvtNtcVKeyIn OnNtcVKeyIn;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Notifies the release vartual key.")]
		public event VthEvtNtcVKeyOut OnNtcVKeyOut;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Occurs when dropping files.")]
		public event VthEvtFileDrop  OnFileDrop;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Occurs when dropping directories.")]
		public event VthEvtDirDrop	 OnDirDrop;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Notifies that the font or size has changed and the character information has changed.")]
		public event VthEvtCharInfo  OnCharInfo;

		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Occurs when Shift/Ctrl + right-clicked.")]
		public event VthEvtRClick 	 OnRClick;

		private VthCbkNtcDblClk		m_VthCbkNtcDblClk;
		private VthCbkNtcKeyIn		m_VthCbkNtcKeyIn;
		private VthCbkNtcVKeyIn		m_VthCbkNtcVKeyIn;
		private VthCbkNtcVKeyOut	m_VthCbkNtcVKeyOut;
		private VthCbkFileDrop		m_VthCbkFileDrop;
		private VthCbkDirDrop		m_VthCbkDirDrop;
		private VthCbkCharInfo		m_VthCbkCharInfo;
		private VthCbkRClick		m_VthCbkRClick;

		//----- vpeBl ------------------------------//
		private string		m_TitleText			= "";
		private bool		m_ToolTipShowAlways = true;
		private	bool		m_EnablePopupMenu	= true;
		private string		m_Font				= "P: FN=lr SVbN, LF=12/0/0/0/0/0/0/0/128/3/2/1/49; 1; 0x8031,lr SVbN; 0x8032,MS UI Gothic";
		private bool		m_ShowDummyData		= true;
		private string		m_TipText			= "";
		private	bool		m_FirstResize		= true;
		private	bool		m_LFActInPopupMenu	= true;

		//----- VRamHeight, MaxLines  -------------//
		private	bool		m_Fixed_VRamHeight_And_MaxLines = false;
		private	int			m_SvVRamHeight = -1;
		private	int			m_SvMaxLines   = -1;

		//----- [N -----------------------------------------------------------------------------------------//
		private IntPtr		m_hCtrl;

		//----- RXgN^ ---------------------------------------------------------------------------------//
		public CAjrVT100()
		{
			InitializeComponent();

			//	Cu
			CAjrInit.Init();

			//	Rg[ECh
			m_VthCbkNtcDblClk	= new VthCbkNtcDblClk (cbVthNtcDblClk );
			m_VthCbkNtcKeyIn	= new VthCbkNtcKeyIn  (cbVthNtcKeyIn  );
			m_VthCbkNtcVKeyIn	= new VthCbkNtcVKeyIn (cbVthNtcVKeyIn );
			m_VthCbkNtcVKeyOut	= new VthCbkNtcVKeyOut(cbVthNtcVKeyOut);
			m_VthCbkFileDrop	= new VthCbkFileDrop  (cbVthFileDrop  );
			m_VthCbkDirDrop	 	= new VthCbkDirDrop	  (cbVthDirDrop	  );
			m_VthCbkCharInfo	= new VthCbkCharInfo  (cbVthCharInfo  );
			m_VthCbkRClick		= new VthCbkRClick	  (cbVthRClick	  );

			m_hCtrl = CAjrApi.AjcVthCreateForMSIL(this.Handle, m_VthCbkNtcDblClk ,
															   m_VthCbkNtcKeyIn	 ,
															   m_VthCbkNtcVKeyIn ,
															   m_VthCbkNtcVKeyOut,
															   m_VthCbkFileDrop	 ,
															   m_VthCbkDirDrop	 ,
															   m_VthCbkCharInfo	 ,
															   m_VthCbkRClick	 );

			//	tHgݒ
			FontVt100 = m_Font;
		}
		//------------------------------------------------------------------------------------------------------//
		//	Rg[Cxg																			//
		//------------------------------------------------------------------------------------------------------//
		//----- ݒ ---------------------------------------------------------------------------------------//
		private void CAjrVT100_Load(object sender, EventArgs e)
		{
		}
		//----- Rg[ETCYύX -----------------------------------------------------------------------//
		private void CAjrVT100_Resize(object sender, EventArgs e)
		{
			//	݂̂̏
			if (m_FirstResize) {
				m_FirstResize = false;
				//	fUC[h_~[f[^\
				if (this.DesignMode) GenDummyData();
				//	ftHgtHgݒiŝ݁j
				else CAjrApi.AjcVthSetDefFont(m_hCtrl, this.Font.ToHfont());
				//	vpeBޔ
				CAjrApi.AjcVthSaveIniPropForMSIL(m_hCtrl);
			}
			//	Rg[̃TCYݒ
			CAjrApi.AjcVthSetProp_WndSize(m_hCtrl, (int)this.Size.Width, (int)this.Size.Height);
		}
		//------------------------------------------------------------------------------------------------------//
		//	VRamHeight, MaxLines ̋	íAVRamHeight, MaxLines̏Őݒ肷邱Ƃۏ؂j		//
		//------------------------------------------------------------------------------------------------------//
		private bool IsFixed_VRamHeight_And_MaxLines()
		{
			bool	rc = false;
			if (!m_Fixed_VRamHeight_And_MaxLines) {
				if (m_SvVRamHeight != -1 && m_SvMaxLines != -1) {
					CAjrApi.AjcVthSetProp_VramH   (m_hCtrl, m_SvVRamHeight);
					CAjrApi.AjcVthSetProp_MaxLines(m_hCtrl, m_SvMaxLines  );
					if (this.DesignMode) GenDummyData();
					m_Fixed_VRamHeight_And_MaxLines = true;
				}
			}
			else rc = true;

			return rc;
		}

		//------------------------------------------------------------------------------------------------------//
		//	vpeB																							//
		//------------------------------------------------------------------------------------------------------//
		//----- FontvpeBB ---------------------------------------------------------------------------//
		private Font vfontInit = new Font("MS UI Gothic", 9);
		[Browsable(false)]
		public override Font Font
		{
			set { base.Font = vfontInit; }
			get { return vfontInit; }
		}
		//----- AllowDropvpeBB ----------------------------------------------------------------------//
		private bool AllowDropInit = false;
		[Browsable(false)]
		public override bool AllowDrop
		{
			set { base.AllowDrop = AllowDropInit; }
			get { return AllowDropInit; }
		}
		//----- EnabledvpeBύX ------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Enable / Disable the control")]
		public new bool Enabled
		{
			set {	if (base.Enabled == value) base.Enabled = !value;
					base.Enabled = value;
					CAjrApi.AjcEnableCtrlsInWnd(this.Handle, value);
				}
			get {	return base.Enabled;  }
		}
		//----- fUC̃_~[f[^\^\ -----------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Dummy data is shown at designing")]
		public bool ShowDummyData {
			set {m_ShowDummyData = value; if (this.DesignMode) GenDummyData();}
			get {return m_ShowDummyData;}
		}
		//----- Ǝ̃tHgvpeB -----------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[Description("Font")]
		[Editor(typeof(FontVt100Editor), typeof(System.Drawing.Design.UITypeEditor))]
		public string FontVt100
		{
			set {
				m_Font = value;
				CAjrApi.AjcVthSetProp_Font(m_hCtrl, m_Font);
			}
			get {
				return m_Font;
			}
		}

		//----- uq`l 		(VramW) --------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Digits of VRAM width")]
		public int VRamWidth {
			set {CAjrApi.AjcVthSetProp_VramW(m_hCtrl, (int)value); if (this.DesignMode) GenDummyData();}
			get {return (int)CAjrApi.AjcVthGetProp_VramW(m_hCtrl);}
		}
		//----- uq`ls		(VramH) --------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Lines of VRAM height")]
		public int VRamHeight {
			set {
					m_SvVRamHeight = value;
					if (IsFixed_VRamHeight_And_MaxLines()) {
						CAjrApi.AjcVthSetProp_VramH(m_hCtrl, value);
						if (this.DesignMode) GenDummyData();
					}
			}
			get {
					int		rc;
					if (!m_Fixed_VRamHeight_And_MaxLines) rc = m_SvVRamHeight;
					else								  rc = CAjrApi.AjcVthGetProp_VramH(m_hCtrl);
					return rc;
			}
		}
		//----- Lbg̍	(CaretH) -------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Caret height")]
		public int CaretHeight {
			set {CAjrApi.AjcVthSetProp_CaretH(m_hCtrl, (int)value);}
			get {return (int)CAjrApi.AjcVthGetProp_CaretH(m_hCtrl);}
		}
		//----- Lbg\^\ -------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Caret display")]
		public bool ShowCaret {
			set {CAjrApi.AjcVthShowCaret(m_hCtrl, value);}
		}
		//----- ős			(MaxLines) -----------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Buffering lines(Values less than VRamHeight cannot be set)")]
		public int MaxLines {
			set {
					m_SvMaxLines = value;
					if (IsFixed_VRamHeight_And_MaxLines()) {
						CAjrApi.AjcVthSetProp_MaxLines(m_hCtrl, value);
						if (this.DesignMode) GenDummyData();
					}
			}
			get {
					int		rc;
					if (!m_Fixed_VRamHeight_And_MaxLines) rc = m_SvMaxLines;
					else								  rc = CAjrApi.AjcVthGetProp_MaxLines(m_hCtrl);
					return rc;
			}
		}
		//----- ^uEXLbv	(TabStep) ------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Width of TAB")]
		public int TabStep {
			set {CAjrApi.AjcVthSetProp_TabStep(m_hCtrl, (int)value);}
			get {return (int)CAjrApi.AjcVthGetProp_TabStep(m_hCtrl);}
		}
		//----- sԃXy[X		(LSpace) -------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("line spacing pixels")]
		public int LineSpace {
			set {CAjrApi.AjcVthSetProp_LSpace(m_hCtrl, (int)value);}
			get {return (int)CAjrApi.AjcVthGetProp_LSpace(m_hCtrl);}
		}
		//----- ꎞۗTCY		(PendSize) -----------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Data buffering size (bytes)")]
		public int PendingBufferSize {
			set {CAjrApi.AjcVthSetProp_PendSize(m_hCtrl, (int)value);}
			get {return (int)CAjrApi.AjcVthGetProp_PendSize(m_hCtrl);}
		}
		//----- ̕			(CharWidth) ----------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Charcter width (Pixels)")]
		public int CharWidth {
			get {return (int)CAjrApi.AjcVthGetProp_CharWidth(m_hCtrl);}
		}
		//----- ̍			(CharHeight) ---------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Charcter height (Pixels)")]
		public int CharHeight {
			get {return (int)CAjrApi.AjcVthGetProp_CharHeight(m_hCtrl);}
		}
		//----- s̍			(LineHeight) ---------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Line height (Pixels)")]
		public int LineHeight {
			get {return (int)CAjrApi.AjcVthGetProp_LineHeight(m_hCtrl);}
		}
		//----- F -----------------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Text color (Palette number(0-7))")]
		public int ForegroundColor
		{
			set {CAjrApi.AjcVthSetColor(m_hCtrl, (int)value); if (this.DesignMode) GenDummyData();}
			get {return (int)CAjrApi.AjcVthGetColor(m_hCtrl);}
		}
		//----- wiF -------------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Text background color (Palette number(0-7))")]
		public int BackgroundColor
		{
			set {CAjrApi.AjcVthSetBkColor(m_hCtrl, (int)value); if (this.DesignMode) GenDummyData();}
			get {return (int)CAjrApi.AjcVthGetBkColor(m_hCtrl);}
		}
		//----- ECh̔wiF -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Window background color (Palette number(0-7))")]
		public int WndBkColor
		{
			set {CAjrApi.AjcVthSetWndBkColor(m_hCtrl, (int)value); if (this.DesignMode) GenDummyData();}
			get {return (int)CAjrApi.AjcVthGetWndBkColor(m_hCtrl);}
		}
		//----- t@CCtH_ hbv̋^֎~ --------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Allow derop the file/folder")]
		public bool AcceptFiles
		{
			set {CAjrApi.AjcVthSetProp_AcceptFiles(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetProp_AcceptFiles(m_hCtrl);}
		}
		//----- |bvAbvj[̋^֎~ --------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Enable popup menu by right click")]
		public bool EnablePopupMenu {
			set {m_EnablePopupMenu = value; CAjrApi.AjcVthEnablePopupMenu(m_hCtrl, value);}
			get {return m_EnablePopupMenu;}
		}
		//----- c[`bv\ ---------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Tooltip display condition. If false is set, the tooltip will not be displayed when inactive.")]
		public bool ToolTipShowAlways
		{
			set {
				m_ToolTipShowAlways = value;
				CAjrApi.AjcVthSetTipShowAlways(m_hCtrl, m_ToolTipShowAlways);
			}
			get {
				return m_ToolTipShowAlways;
			}
		}
		//----- t@Co̓Rg[\^\(AJCVTHS_LOGFILE	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("File output control display")]
		public bool EnableLogFile {
			set {CAjrApi.AjcVthSetSty_LOGFILE(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_LOGFILE(m_hCtrl);}
		}
		//----- Œsb`							(AJCVTHS_FIXEDPITCH	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Display characters at a fixed pitch. (Only when fixed pitch font is set)")]
		public bool FixedPitch
		{
			set {CAjrApi.AjcVthSetSty_FIXEDPITCH(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_FIXEDPITCH(m_hCtrl);}
		}
		//----- \							(AJCVTHS_FAST		) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Executes drawing processing at high speed. Text color and background color cannot be set.")]
		public bool Fast
		{
			set {CAjrApi.AjcVthSetSty_FAST(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_FAST(m_hCtrl);}
		}
		//----- ʃNA[{^				(AJCVTHS_NOCLSBTN	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Allow screen clear button.")]
		public bool EnableClsBtn
		{
			set {CAjrApi.AjcVthSetSty_NOCLSBTN(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOCLSBTN(m_hCtrl);}
		}
		//----- tHgŒ						(AJCVTHS_FIXEDFONT	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Font to fixed. (Don't include font settings in pop-up menus)")]
		public bool FixedFont
		{
			set {CAjrApi.AjcVthSetSty_FIXEDFONT(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_FIXEDFONT(m_hCtrl);}
		}
		//----- sŒ						(AJCVTHS_FIXEDLF	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Line feed action to fixed. (No L/F setting items in popup menu)")]
		public bool FixedLF
		{
			set {CAjrApi.AjcVthSetSty_FIXEDLF(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_FIXEDLF(m_hCtrl);}
		}
		//----- cXN[o[\^\		(AJCVTHS_NOVSCROLL	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Show vertical scrollbar.")]
		public bool ShowVScroll
		{
			set {CAjrApi.AjcVthSetSty_NOVSCROLL(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOVSCROLL(m_hCtrl);}
		}
		//----- XN[o[\^\		(AJCVTHS_NOHSCROLL	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Show horizontal scrollbar.")]
		public bool ShowHScroll
		{
			set {CAjrApi.AjcVthSetSty_NOHSCROLL(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOHSCROLL(m_hCtrl);}
		}
		//----- XN[̋^֎~			(AJCVTHS_NOSCRL		) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Enable auto scroll (It is scrolled to the end for each drawing)")]
		public bool EnableAutoScroll {
			set {CAjrApi.AjcVthSetSty_NOSCRL(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOSCRL(m_hCtrl);}
		}
		//----- Rg[Og̔\^\		(AJCVTHS_NOBORDER	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Outer frame display")]
		public bool ShowBorder {
			set {CAjrApi.AjcVthSetSty_NOBORDER(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOBORDER(m_hCtrl);}
		}
		//----- XN[AEg̋^֎~		(AJCVTHS_NOSCRLOUT	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Enable scroll out")]
		public bool EnableScrollOut {
			set {CAjrApi.AjcVthSetSty_NOSCRLOUT(m_hCtrl, !value);}
			get {return !CAjrApi.AjcVthGetSty_NOSCRLOUT(m_hCtrl);}
		}
		//----- bqŉs							(AJCVTHS_CRCTRL		) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Line feed by C/R(0x0D)")]
		public bool LineFeedByCR {
			set {CAjrApi.AjcVthSetSty_CRCTRL(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_CRCTRL(m_hCtrl);}
		}
		//----- keŉs							(AJCVTHS_LFCTRL		) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Line feed by L/F(0x0A)")]
		public bool LineFeedByLF {
			set {CAjrApi.AjcVthSetSty_LFCTRL(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_LFCTRL(m_hCtrl);}
		}
		//----- uq`lƂ̗̑̈敪			(AJCVTHS_SEPARATE	) --------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Distinguishes between the display of VRAM / Buffering data (Displays scrolled out line darkly)")]
		public bool Separate {
			set {CAjrApi.AjcVthSetSty_SEPARATE(m_hCtrl, value);}
			get {return CAjrApi.AjcVthGetSty_SEPARATE(m_hCtrl);}
		}
		//----- c[`bveLXg ---------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Tool tip text of this control")]
		public string ToolTipText
		{
			set	{
					if (this.DesignMode) m_TipText = value;
					else {
				 		StringBuilder s = new StringBuilder(2048);
				 		CAjrApi.AjcVthGetTipTextForMSIL(m_hCtrl, s, (int)s.Capacity);
						if (value != s.ToString()) {
							CAjrApi.AjcVthSetTipTextForMSIL(m_hCtrl, value);
							CAjrApi.AjcVthSetTipShowAlways(m_hCtrl, m_ToolTipShowAlways);
						}
					}
				}
			get	{
					string rc = "";
					if (this.DesignMode) rc = m_TipText;
					else {
				 		StringBuilder s = new StringBuilder(2048);
				 		CAjrApi.AjcVthGetTipTextForMSIL(m_hCtrl, s, (int)s.Capacity);
				 		return s.ToString();
				 	}
				 	return rc;
				}
		}
		//----- obt@Ɋi[Ăs -------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Line count")]
		public int LineCount
		{
			get {return (int)CAjrApi.AjcVthGetLineCount(m_hCtrl);}
		}
		//----- XN[ʒu -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Horizontal scroll position")]
		public int ScrollPosH
		{
			set {CAjrApi.AjcVthSetHScrollPos(m_hCtrl, value);}
			get {return (int)CAjrApi.AjcVthGetHScrollPos(m_hCtrl);}
		}
		//----- cXN[ʒu -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Vartical scroll position")]
		public int ScrollPosV
		{
			set {CAjrApi.AjcVthSetVScrollPos(m_hCtrl, value);}
			get {return (int)CAjrApi.AjcVthGetVScrollPos(m_hCtrl);}
		}
		//----- \EChs -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Window height(Lines)")]
		public int WndHeight
		{
			get {return (int)CAjrApi.AjcVthGetProp_WndHeight(m_hCtrl);}
		}
		//----- \ECh -------------------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Window width(Chars)")]
		public int WndWidth
		{
			get {return (int)CAjrApi.AjcVthGetProp_WndWidth(m_hCtrl);}
		}
		//----- J[\sʒuiobt@̈ʒuj--------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Cursor position in buffer")]
		public int CursouLine
		{
			get {	int		line, pos;
					CAjrApi.AjcVthGetCursorPosInfo(m_hCtrl, out line, out pos);
					return line;
				}
		}
		//----- J[\ʒuiobt@̕ʒuj ---------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Cursor position in buffer")]
		public int CursorPos
		{
			get {	int		line, pos;
					CAjrApi.AjcVthGetCursorPosInfo(m_hCtrl, out line, out pos);
					return pos;
				}
		}
		//----- s̐ݒ|bvAbvj[Ɋ܂߂^܂߂Ȃ -----------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Include 'Line feed action' in pop-up menu")]
		public bool LFActInPopupMenu
		{
			set {m_LFActInPopupMenu = value;
				 CAjrApi.AjcVthSetLFActInPopupMenu(m_hCtrl, value);}
			get {return m_LFActInPopupMenu;}
		}
		//----- ^CgeLXgvpeB ---------------------------------------------------------------------//
		[System.ComponentModel.Category("AjrVT100")]
		[System.ComponentModel.Description("Title text. It is displayed in the upper right corner of the control.")]
		public string TitleText
		{
			set { m_TitleText = value;
				  SetTitleText(m_TitleText);}
			get { return m_TitleText; }
		}
		//------------------------------------------------------------------------------------------------------//
		//	\bh																							//
		//------------------------------------------------------------------------------------------------------//
		//----- Focus()\bhύX --------------------------------------------------------------------------//
		public new bool Focus()
		{
			bool rc;
			rc = CAjrApi.AjcVthSetFocus(m_hCtrl);
			return rc;
		}
		//----- PoCg` -----------------------------------------------------------------------------------//
		public void PutByte(int c)
		{
			CAjrApi.AjcVthPutChar(m_hCtrl, (byte)c);
		}
		//----- P` -------------------------------------------------------------------------------------//
		public void PutChar(int c)
		{
			CAjrApi.AjcVthPutChar(m_hCtrl, (ushort)c);
		}
		//----- ` -------------------------------------------------------------------------------------//
		public void PutText(string text)
		{
			CAjrApi.AjcVthPutText(m_hCtrl, text, -1);
		}
		//----- ` -------------------------------------------------------------------------------------//
		public void PutText(string text, int len)
		{
			CAjrApi.AjcVthPutText(m_hCtrl, text, len);
		}
		//----- ` ---------------------------------------------------------------------------------//
		public void PutFormat(string format, params object[] args)
		{
			CAjrApi.AjcVthPutText(m_hCtrl, CAjrApi.MakeFormatString(format, args), -1);
		}
		//----- ^CX^v` -----------------------------------------------------------------------------//
		public void PrintTimeStamp()
		{
			CAjrApi.AjcVthTimeStamp(m_hCtrl);
		}
		//----- PUi_v` -------------------------------------------------------------------------------//
		public void PrintHexDump(Byte[] bin)
		{
			CAjrApi.AjcVthHexDump(m_hCtrl, bin);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void PrintHexDump(IntPtr pData, int lData)
		{
			CAjrApi.AjcVthHexDump(m_hCtrl, pData, lData);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		unsafe public void PrintHexDump(void *pData, int lData)
		{
			CAjrApi.AjcVthHexDump(m_hCtrl, pData, lData);
		}
		//----- J[\ʒuݒ -------------------------------------------------------------------------------//
		public void Locate(int line, int col)
		{
			CAjrApi.AjcVthLocate(m_hCtrl, (int)line, (int)col);
		}
		//----- \Fݒ				(rgb[]) ----------------------------------------------------------------//
		public void SetPaletteColor(int ix, Color color) {
			int r = color.R;
			int g = color.G;
			int b = color.B;
			CAjrApi.AjcVthSetProp_rgb(m_hCtrl, (int)ix, (int)(r | (g << 8) | (b << 16)));
		}
		//----- \F擾				(rgb[]) ----------------------------------------------------------------//
		public Color GetPaletteColor(int ix) {
			int rgb = CAjrApi.AjcVthGetProp_rgb(m_hCtrl, (int)ix);
			Color c = Color.FromArgb((int)(rgb & 0xFF), (int)((rgb >> 8) & 0xFF), (int)((rgb >> 16) & 0xFF));

			return c;
		}
		//----- eLXgI -------------------------------------------------------------------------------//
		public void Select(int slp, int scp, int elp, int ecp)
		{
			CAjrApi.AjcVthSelect(m_hCtrl, slp, scp, elp, ecp);
		}
		//----- SeLXgI ---------------------------------------------------------------------------------//
		public void SelectAll()
		{
			CAjrApi.AjcVthSelectAll(m_hCtrl);
		}
		//----- IeLXgNbv{[hփRs[ -----------------------------------------------------------//
		public void Copy()
		{
			CAjrApi.AjcVthCopyText(m_hCtrl);
		}
		//----- SeLXg NA[ ----------------------------------------------------------------------------//
		public void Purge()
		{
			CAjrApi.AjcVthClearAllText(m_hCtrl);
		}
		//----- hbvꂽt@C擾 -------------------------------------------------------------------//
		public string GetDroppedFile()
		{
			return CAjrApi.AjcVthGetDroppedFile(m_hCtrl);
		}
		//----- hbvꂽfBNg擾 ---------------------------------------------------------------//
		public string GetDroppedDir()
		{
			return CAjrApi.AjcVthGetDroppedDir(m_hCtrl);
		}
		//----- ^CgeLXg̕\ -------------------------------------------------------------------------//
		public void SetTitleText(string TitleText)
		{
			m_TitleText = TitleText;
			CAjrApi.AjcVthSetTitleText(m_hCtrl, TitleText, Color.Empty, Color.Empty, (Font)null);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SetTitleText(string TitleText, Color TextColor)
		{
			m_TitleText = TitleText;
			CAjrApi.AjcVthSetTitleText(m_hCtrl, TitleText, TextColor, Color.Empty, null);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SetTitleText(string TitleText, Color TextColor, Color BackColor)
		{
			m_TitleText = TitleText;
			CAjrApi.AjcVthSetTitleText(m_hCtrl, TitleText, TextColor, BackColor, null);
		}
		//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - //
		public void SetTitleText(string TitleText, Color TextColor, Color BackColor, Font TextFont)
		{
			m_TitleText = TitleText;
			CAjrApi.AjcVthSetTitleText(m_hCtrl, TitleText, TextColor, BackColor, TextFont);
		}
		//----- vt@CփvpeB ---------------------------------------------------------------//
		public void SaveToProfile(string section)
		{
			CAjrApi.AjcVthSaveProp(m_hCtrl, section);
		}
		//----- vt@CvpeBǂݏo -------------------------------------------------------------//
		public void LoadFromProfile(string section)
		{
			CAjrApi.AjcVthLoadProp(m_hCtrl, section, (IntPtr)0);
		}
		//----- vt@CփtHg񏑂 -------------------------------------------------------------//
		public void SavePermInfoToProfile()
		{
			CAjrApi.AjcVthSavePermInfo(m_hCtrl);
		}
		//----- vt@CtHgǂݏo -----------------------------------------------------------//
		public void LoadPermInfoFromProfile(string section)
		{
			CAjrApi.AjcVthLoadPermInfo(m_hCtrl, section, this.Name);
		}
		//----- seLXg擾 ---------------------------------------------------------------------------------//
		public string GetLineText(int pos)
		{
			int		vw = VRamWidth + 1;
			StringBuilder s = new StringBuilder(vw);
			CAjrApi.AjcVthGetLineText(m_hCtrl, pos, s, vw);
			return s.ToString();
		}
		//----- _uNbNseLXg擾 -------------------------------------------------------------------//
		public string GetDblCkickedLineText()
		{
			int len = 0;

			len = CAjrApi.AjcVthGetDblClickedLine(m_hCtrl);
			StringBuilder s = new StringBuilder((int)len);
			CAjrApi.AjcVthGetDblClickedLine(m_hCtrl, s, len);

			return s.ToString();
		}
		//----- _uNbNsʒu擾 -----------------------------------------------------------------------//
		public int GetDblCkickedLinePos()
		{
			int		line, pos;
			CAjrApi.AjcVthGetDblClickedLineEx(m_hCtrl, out line, out pos);
			return line;
		}
		//----- 񌟍 -------------------------------------------------------------------------------//
		public int SearchBelow(string str, char delimiter)
		{
			return 	CAjrApi.AjcVthSearchBelow(m_hCtrl, str, (int)delimiter);
		}
		//----- 񌟍 -------------------------------------------------------------------------------//
		public int SearchAbove(string str, char delimiter)
		{
			return CAjrApi.AjcVthSearchAbove(m_hCtrl, str, (int)delimiter);
		}
		//----- \~^ĊJ ---------------------------------------------------------------------------------//
		public void Pause(bool fPause)
		{
			CAjrApi.AjcVthPause(m_hCtrl, fPause);
		}
		//----- tHgݒ -----------------------------------------------------------------------------------//
		public void SetFont(Font font)
		{
			CAjrApi.AjcVthSetFontForMSIL(m_hCtrl, font.ToHfont());
		}
		//----- tHg擾 -----------------------------------------------------------------------------------//
		public Font GetFont()
		{
			IntPtr	hFont = CAjrApi.AjcVthGetFontForMSIL(m_hCtrl);
			Font font = Font.FromHfont(hFont);
			return font;
		}
		//------------------------------------------------------------------------------------------------------//
		//	fUC̃_~[f[^																		//
		//------------------------------------------------------------------------------------------------------//
		private void GenDummyData()
		{
			if (this.DesignMode) {
				this.Purge();
				if (m_ShowDummyData) {
					this.PutText("ABCDEFGHIJKLMNOPQRSTUVWXYZ\r\n");
					this.PutText("0123456789\r\n");
					if (CAjrApi.AjcGetLangId() == ELangId.Japanese) {
						this.PutText("\n");
						this.PutText("usPOOG~[VECh\n");
						this.PutText("Cӂ̃TCYŃXN[ݒ肵AO\Ɏgp܂B\n");
						this.PutText("J[\ʒuw肵āAOtBJɕ`悷邱Ƃł܂B\n");
					}
				}
			}
		}
		//------------------------------------------------------------------------------------------------------//
		//	R[obN																						//
		//------------------------------------------------------------------------------------------------------//
		//----- R[obN֐i_uNbNʒmj----------------------------------------------------------//
		private void cbVthNtcDblClk(bool shift, bool ctrl)
		{
			VthArgDblClk eva = new VthArgDblClk();
			eva.shift = shift;
			eva.ctrl  = ctrl;
			if (OnNtcDblClk != null) {
				OnNtcDblClk(this, eva);
			}
		}
		//----- R[obN֐iL[͒ʒmj----------------------------------------------------------------//
		private void cbVthNtcKeyIn(int key, int rep)
		{
			VthArgNtcKeyIn eva = new VthArgNtcKeyIn();
			eva.key = key;
			eva.rep = rep;
			if (OnNtcKeyIn != null) {
				OnNtcKeyIn(this, eva);
			}
		}
		//----- R[obN֐igL[ʒm, int RepCntj------------------------------------------------//
		private void cbVthNtcVKeyIn(EVthVKey vkey, int rep)
		{
			VthArgNtcVKeyIn eva = new VthArgNtcVKeyIn();
			eva.vkey = vkey;
			eva.rep  = rep;
			if (OnNtcVKeyIn != null) {
				OnNtcVKeyIn(this, eva);
			}
		}
		//----- R[obN֐igL[ʒmj------------------------------------------------------------//
		private void cbVthNtcVKeyOut(EVthVKey vkey)
		{
			VthArgNtcVKeyOut eva = new VthArgNtcVKeyOut();
			eva.vkey = vkey;
			if (OnNtcVKeyOut != null) {
				OnNtcVKeyOut(this, eva);
			}
		}
		//----- R[obN֐it@Chbvʒmj--------------------------------------------------------//
		private void cbVthFileDrop(int n)
		{
			VthArgFileDrop eva = new VthArgFileDrop();
			eva.n = n;
			if (OnFileDrop != null) {
				OnFileDrop(this, eva);
			}
		}
		//----- R[obN֐itH_hbvʒmj--------------------------------------------------------//
		private void cbVthDirDrop(int n)
		{
			VthArgDirDrop eva = new VthArgDirDrop();
			eva.n = n;
			if (OnDirDrop != null) {
				OnDirDrop(this, eva);
			}
		}
		//----- R[obN֐iTCYωʒmj----------------------------------------------------------//
		private void cbVthCharInfo(int LineHeight)
		{
			VthArgCharInfo eva = new VthArgCharInfo();
			eva.LineHeight = LineHeight;
			if (OnCharInfo != null) {
				OnCharInfo(this, eva);
			}
		}
		//----- R[obN֐iENbNʒmj--------------------------------------------------------------//
		private void cbVthRClick(int x, int y, bool shift, bool ctrl)
		{
			VthArgRClick eva = new VthArgRClick();
			eva.x	  = x;
			eva.y	  = y;
			eva.shift = shift;
			eva.ctrl  = ctrl;
			if (OnRClick != null) {
				OnRClick(this, eva);
			}
		}
	}

	//==========================================================================================================//
	//	FontVt100vpeBEGfB^																			//
	//==========================================================================================================//
	internal class FontVt100Editor : UITypeEditor
	{
		//----- RXgN^ ---------------------------------------------------------------------------------//
		public FontVt100Editor()
		{
		}
		//----- vpeBGfB^ƂāA[_\tH[gp鎖ʒm -------------------------------//
		public override UITypeEditorEditStyle GetEditStyle(ITypeDescriptorContext context)
		{
			return UITypeEditorEditStyle.Modal;
		}
		//----- ƎtHgݒ -------------------------------------------------------------------------------//
		public override object EditValue(ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService editorService = null;

			//----- MSDN UI ^GfB^[̎ ɊÂLq
			if (provider != null) {
				editorService = provider.GetService(typeof(IWindowsFormsEditorService)) as IWindowsFormsEditorService;
			}

			//----- MSDN UI ^GfB^[̎ ɊÂLq
			if (editorService == null) {
				return value;
			}
			
			//----- tHg\擾 ---------------------------------------------------------------------//
			string s;
			s = CAjrApi.AjcVthGetProp_Font((string)value);
			return s;
		}
	}
}
