#include	<AjxCpp.h>

using namespace AjxControl;


//--------------------------------------------------------------------------------------------------------------//
//																												//
//	RXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxFile::CAjxFile(BOOL fUnicode) 
{
	m_BufLen   = 1024;
	m_hFile    = NULL;
	m_fUnicode = fUnicode;
}
//--------------------------------------------------------------------------------------------------------------//
//																												//
//	fXgN^																								//
//																												//
//--------------------------------------------------------------------------------------------------------------//
CAjxFile::~CAjxFile()
{
	if (m_hFile != NULL) {
		AjcFClose(m_hFile);
	}
}

//----- eLXgt@C -----------------------------------------------------------------------------------//
//	̓eLXgt@CI[v(ASCII)
BOOL		CAjxFile::FOpen	(C_BCP pPath, EAJCTEC tec)
{
	BOOL	rc = FALSE;
	if (m_hFile == NULL) {
		rc = ((m_hFile = AjcFOpenA(pPath, tec)) != NULL);
	}
	return rc;
}
//	̓eLXgt@CI[v(UNICODE)
BOOL		CAjxFile::FOpen	(C_WCP pPath, EAJCTEC tec)
{
	BOOL	rc = FALSE;
	if (m_hFile == NULL) {
		rc = ((m_hFile = AjcFOpenW(pPath, tec)) != NULL);
	}
	return rc;
}
//	I[vσt@C̃nhgpăCX^X
BOOL		CAjxFile::FAttachOpened(HANDLE hFile, EAJCTEC tec)
{
	BOOL	rc = FALSE;
	if (m_hFile == NULL) {
		rc = ((m_hFile = AjcFAttachOpened(hFile, tec)) != NULL);
	}
	return rc;
}

//	(ASCII)
BCP			CAjxFile::FGetS	(BCP pBuf, UI lBuf)
{
	return AjcFGetSA(m_hFile, pBuf, lBuf);
}
//	(UNICODE)
WCP			CAjxFile::FGetS	(WCP pBuf, UI lBuf)
{
	return AjcFGetSW(m_hFile, pBuf, lBuf);
}
//	P(UNICODE/ASCIIp)
UI			CAjxFile::FGetC()
{
	UI	rc = 0;
	if (m_fUnicode) rc = (UI)FGetCW();
	else			rc = (UI)FGetCA();
	return rc;
}
//	P(ASCII)
BC			CAjxFile::FGetCA()
{
	return AjcFGetCA(m_hFile);
}
//	P(UNICODE)
WC			CAjxFile::FGetCW()
{
	return AjcFGetCW(m_hFile);
}
//	t@Cǂݏo|Cgޔ(UNICODE/ASCIIp)
ULL			CAjxFile::FSavePoint()
{
	ULL		rc;
	if (m_fUnicode) rc = AjcFSavePointW(m_hFile);
	else			rc = AjcFSavePointA(m_hFile);
	return rc;
}
//	t@Cǂݏo|Cg
BOOL		CAjxFile::FRecvPoint()
{
	return AjcFRecvPoint(m_hFile);
}
//	̓t@Ĉdne`FbN
BOOL		CAjxFile::FEof	()
{
	return AjcFEof(m_hFile);
}


//----- eLXgt@Co -----------------------------------------------------------------------------------//
//	o̓eLXgt@C(ASCII)
BOOL		CAjxFile::FCreate	(C_BCP pPath, EAJCTEC tec, BOOL fBOM)
{
	return ((m_hFile = AjcFCreateA(pPath, tec, fBOM)) != NULL);
}
//	o̓eLXgt@C(UNICODE)
BOOL		CAjxFile::FCreate	(C_WCP pPath, EAJCTEC tec, BOOL fBOM)
{
	return ((m_hFile = AjcFCreateW(pPath, tec, fBOM)) != NULL);
}
//	σt@C̃nhgpăCX^X
BOOL		CAjxFile::FAttachCreated(HANDLE hFile, EAJCTEC tec, BOOL fBOM)
{
	BOOL	rc = FALSE;
	if (m_hFile == NULL) {
		rc = ((m_hFile = AjcFAttachCreated(hFile, tec, fBOM)) != NULL);
	}
	return rc;
}

//	o(ASCII)
BOOL		CAjxFile::FPutS	(C_BCP pText, UI lText)
{
	return AjcFPutSA(m_hFile, pText, lText);
}
//	o(UNICODE)
BOOL		CAjxFile::FPutS	(C_WCP pText, UI lText)
{
	return AjcFPutSW(m_hFile, pText, lText);
}
//	Po(ASCII)
BOOL		CAjxFile::FPutC(BC c)
{
	return AjcFPutCA(m_hFile, c);
}
//	Po(UNICODE)
BOOL		CAjxFile::FPutC	(WC c)
{
	return AjcFPutCW(m_hFile, c);
}
//	o(ASCII)
BOOL		CAjxFile::FPrintF	(C_BCP pFmt, ...)
{
	int		rc = 0;
	va_list vls;

	//	o
	va_start(vls, pFmt);
	rc = AjcFVPrintFA(m_hFile, pFmt, vls);
	va_end	(vls);
	return rc;
}
//	o(UNICODE)
BOOL		CAjxFile::FPrintF	(C_WCP pFmt, ...)
{
	BOOL	rc = FALSE;
	va_list vls;

	//	o
	va_start(vls, pFmt);
	rc = AjcFVPrintFW(m_hFile, pFmt, vls);
	va_end	(vls);
	return rc;
}

//	o(όp^̃|C^w, ASCII)
BOOL		CAjxFile::FVPrintF	(C_BCP pFmt, va_list vls)
{
	int		rc = 0;

	AjcFVPrintFA(m_hFile, pFmt, vls);
	return rc;
}
//	o(όp^̃|C^w, UNICODE)
BOOL		CAjxFile::FVPrintF	(C_WCP pFmt, va_list vls)
{
	int		rc = 0;

	AjcFVPrintFW(m_hFile, pFmt, vls);
	return rc;
}

//----- ̑ -------------------------------------------------------------------------------------------------//
//	eLXgt@CN[Y
BOOL		CAjxFile::FClose	()
{
	BOOL	rc = FALSE;

	if (m_hFile != NULL) {
		rc = AjcFClose(m_hFile);
		m_hFile = NULL;
	}
	return rc;
}
//	eLXgt@CN[YȂŃCX^X	
BOOL		CAjxFile::FDetach()
{
	BOOL	rc = FALSE;
	if (AjcFDetach(m_hFile)) {
		m_hFile = NULL;
		rc = TRUE;
	}
	return rc;
}

//	eLXgGR[hʎ擾
EAJCTEC		CAjxFile::FGetTec	()
{
	return AjcFGetTec(m_hFile);
}
//	̓t@ĈanlL̎擾
BOOL		CAjxFile::FGetBOM()
{
	return AjcFGetBOM(m_hFile);
}
//	t@CI[v^Ԃ`FbN
BOOL		CAjxFile::FIsActive()
{
	return (m_hFile != NULL);
}
//	o̓[h擾
BOOL		CAjxFile::FIsModeInput()
{
	return AjcFIsModeInput(m_hFile);
}
//	obt@ݒ
BOOL		CAjxFile::FSetFmtLen	(UI len)
{
	BOOL	rc = FALSE;
	rc = AjcFSetFmtLen(m_hFile, len);
	return rc;
}
//	t@Cnh擾
HANDLE		CAjxFile::FGetFileHandle()
{
	return AjcFGetFileHandle(m_hFile);
}
