#ifndef	AJCDEF_H_
#define	AJCDEF_H_
/****************************************************************************************************************/

//==============================================================================================================//
//																												//
//	{^Cv`																								//
//																												//
//==============================================================================================================//
#ifndef	AJC_DEFINED_BASICTYPE

typedef		void				VO;			/*	VOID															*/

typedef		signed	 char		SB;			/*	@Wrbg itj										*/
typedef		unsigned char		UB;			/*	@@V@@@@ iȂj										*/
typedef		signed	 short		SW;			/*	PUrbg itj										*/
typedef		unsigned short		UW;			/*	@@V@@@@ iȂj										*/
typedef		signed	 long		SL;			/*	RQrbg itj										*/
typedef		unsigned long		UL;			/*	@@V@@@@ iȂj										*/
typedef		signed	 int		SI;			/*	PUrbgȏ̐ itj								*/
typedef		unsigned int		UI;			/*	@@V@@@@ @@@iȂj								*/
typedef		char				BC;			/*	oCg														*/
typedef		wchar_t				WC;			/*	Ch														*/

typedef signed	 __int64		SLL;
typedef	unsigned __int64		ULL;

/*----- SX / UX : |C^li[\ȃrbg̐ ---------------------------------------------------------*/
#if _MSC_VER <= 1200
		typedef signed	 int		SX;
		typedef	unsigned int		UX;
#else
	#ifdef _WIN64
		typedef signed	 __int64	SX;
		typedef	unsigned __int64	UX;
	#else
		typedef _W64 signed   int	SX;
		typedef _W64 unsigned int	UX;
	#endif
#endif

/*----- P O I N T E R ------------------------------------------------------------------------------------------*/
typedef		VO	*VOP;
typedef		SB	*SBP;
typedef		UB	*UBP;
typedef		SW	*SWP;
typedef		UW	*UWP;
typedef		SL	*SLP;
typedef		UL	*ULP;
typedef		SI	*SIP;
typedef		UI	*UIP;
typedef		SX	*SXP;
typedef		UX	*UXP;
typedef		BC	*BCP;
typedef		WC	*WCP;

typedef signed	 __int64	*	SLLP;
typedef	unsigned __int64	*	ULLP;

/*----- C O N S T	P O I N T E R ------------------------------------------------------------------------------*/
typedef		const VO	*	C_VOP;
typedef		const SB	*	C_SBP;
typedef		const UB	*	C_UBP;
typedef		const SW	*	C_SWP;
typedef		const UW	*	C_UWP;
typedef		const SL	*	C_SLP;
typedef		const UL	*	C_ULP;
typedef		const SI	*	C_SIP;
typedef		const UI	*	C_UIP;
typedef		const SX	*	C_SXP;
typedef		const UX	*	C_UXP;
typedef		const BC	*	C_BCP;
typedef		const WC	*	C_WCP;

typedef const signed   __int64	*	C_SLLP;
typedef	const unsigned __int64	*	C_ULLP;

/*----- T E X T ------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	typedef WC			  UT;
	typedef WC		  *   UTP;
	typedef const WC  * C_UTP;
#else
	typedef BC			  UT;
	typedef BC		  *   UTP;
	typedef const BC  * C_UTP;
#endif

#endif	// AJC_DEFINED_BASICTYPE

/*----- f -------------------------------------------------------------------------------------------------*/
typedef struct {
	double re;		//	
	double im;		//	
} AJCCOMPLEX, *PAJCCOMPLEX;
typedef const AJCCOMPLEX *PCAJCCOMPLEX;

/*----- WinMain / wWinMain -------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcMain		wmain
	#define	AjcWinMain	wWinMain
#else
	#define	AjcMain		 main
	#define	AjcWinMain	 WinMain
#endif

//==============================================================================================================//
//																												//
//	ckkC^tF[X`																					//
//																												//
//==============================================================================================================//
#ifdef	AJC_DLL
	#ifdef __cplusplus
		#define AJCEXPORT extern "C" __declspec ( dllexport )
	#else
		#define AJCEXPORT			 __declspec ( dllexport )
	#endif
#else
	#ifdef __cplusplus
		#define AJCEXPORT extern "C" __declspec ( dllimport )
	#else
		#define AJCEXPORT			 __declspec ( dllimport )
	#endif
#endif
//==============================================================================================================//
//																												//
//	UNICODE  _UNICODE																							//
//																												//
//==============================================================================================================//
#ifdef UNICODE
	#ifdef _MBCS
		#undef _MBCS
	#endif
	#ifndef _UNICODE
		#define	_UNICODE
	#endif
#endif
//==============================================================================================================//
//																												//
//	GR[h																								//
//																												//
//==============================================================================================================//
typedef enum {
	AJCTEC_MBC			= 0	,		//	}`oCg
	AJCTEC_UTF_8		= 1	,		//	tse|W
	AJCTEC_EUC_J		= 2,		//	dtbi{j
	AJCTEC_UTF_16LE		= 3,		//	tse|PUkd
	AJCTEC_UTF_16BE		= 4,		//	tse|PUad
	AJCTEC_AUTO			= 9,		//	ݒ
	AJCTEC_ERROR		= 99,		//	G[
} EAJCTEC, *PEAJCTEC;

#define	MAJCTEC_VALID(V)	((V) == AJCTEC_MBC || (V) == AJCTEC_UTF_8 || (V) == AJCTEC_EUC_J || (V) == AJCTEC_UTF_16LE || (V) == AJCTEC_UTF_16BE || (V) == AJCTEC_AUTO)

//==============================================================================================================//
//																												//
//	r[h																							//
//																												//
//==============================================================================================================//
typedef enum {
	AJCCMP_RECOGNIZE_WIDTH	= 0,	//	p̑召ʂ
	AJCCMP_IGNORE_WIDTH		= 1,	//	p̑召ʂȂ
	AJCCMP_ALPHABETIC		= 2,	//	ꕶ̏ꍇ̂݉p̑召ʂiAt@xbgɕԂ悤ɔrj
} EAJCCMPMODE, *PEAJCCMPMODE;

//==============================================================================================================//
//																												//
//	IvV̍}N																						//
//																												//
//==============================================================================================================//
#define		AJCOPT1(PREFIX, P1)									(PREFIX##P1)
#define		AJCOPT2(PREFIX, P1, P2)								(PREFIX##P1 | PREFIX##P2)
#define		AJCOPT3(PREFIX, P1, P2, P3)							(PREFIX##P1 | PREFIX##P2 | PREFIX##P3)
#define		AJCOPT4(PREFIX, P1, P2, P3, P4)						(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4)
#define		AJCOPT5(PREFIX, P1, P2, P3, P4, P5)					(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4 | PREFIX##P5)
#define		AJCOPT6(PREFIX, P1, P2, P3, P4, P5, P6)				(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4 | PREFIX##P5 | PREFIX##P6)
#define		AJCOPT7(PREFIX, P1, P2, P3, P4, P5, P6, P7)			(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4 | PREFIX##P5 | PREFIX##P6 | PREFIX##P7)
#define		AJCOPT8(PREFIX, P1, P2, P3, P4, P5, P6, P7, P8)		(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4 | PREFIX##P5 | PREFIX##P6 | PREFIX##P7 | PREFIX##P8)
#define		AJCOPT9(PREFIX, P1, P2, P3, P4, P5, P6, P7, P8, P9)	(PREFIX##P1 | PREFIX##P2 | PREFIX##P3 | PREFIX##P4 | PREFIX##P5 | PREFIX##P6 | PREFIX##P7 | PREFIX##P8 | PREFIX##P9)

//==============================================================================================================//
//																												//
//	USrbgWindows@݊}N																				//
//																												//
//==============================================================================================================//
#if  _MSC_VER >= 1300
//--------------------------------------------------------------------------------------------------------------//
//	For Visual Studio .NET																						//
//--------------------------------------------------------------------------------------------------------------//
#ifdef	_WIN64
	#define	MAjcSetWindowLong(_HWND_, _IDX_, _VAL_)	((LONG_PTR)AjcSetWindowLongPtr(_HWND_, _IDX_, (LONG_PTR)(_VAL_)))
	#define	MAjcGetWindowLong(_HWND_, _IDX_)		((LONG_PTR)AjcGetWindowLongPtr(_HWND_, _IDX_))
	#define	MAjcSetClassLong(_HWND_, _IDX_, _VAL_)	((LONG_PTR)AjcSetClassLongPtr(_HWND_, _IDX_, (LONG_PTR)(_VAL_)))
	#define	MAjcGetClassLong(_HWND_, _IDX_)			((LONG_PTR)AjcGetClassLongPtr(_HWND_, _IDX_))

	#define	GCL_HBRBACKGROUND	GCLP_HBRBACKGROUND	
	#define	GCL_HCURSOR			GCLP_HCURSOR		
	#define	GCL_HICON			GCLP_HICON			
	#define	GCL_HICONSM			GCLP_HICOMSM		
	#define	GCL_HMODULE			GCLP_HMODULE		
	#define	GCL_MENUNAME		GCLP_MENUNAME		
	#define	GCL_WNDPROC			GCLP_WNDPROC		

	#define	GWL_WNDPROC			GWLP_WNDPROC	
	#define	GWL_HWNDPARENT		GWLP_HWNDPARENT	
	#define	GWL_USERDATA		GWLP_USERDATA	
	#define	GWL_HINSTANCE		GWLP_HINSTANCE	
	#define	DWL_DLGPROC			DWLP_DLGPROC	
	#define	DWL_MSGRESULT		DWLP_MSGRESULT	
	#define	DWL_USER			DWLP_USER		

#else
	#define	MAjcSetWindowLong(_HWND_, _IDX_, _VAL_)	((LONG_PTR)AjcSetWindowLongPtr(_HWND_, _IDX_, (LONG)((_W64 LONG)(_VAL_))))
	#define	MAjcGetWindowLong(_HWND_, _IDX_)		((LONG_PTR)AjcGetWindowLongPtr(_HWND_, _IDX_))
	#define	MAjcSetClassLong(_HWND_, _IDX_, _VAL_)	((LONG_PTR)AjcSetClassLongPtr(_HWND_, _IDX_, (LONG)((_W64 LONG)(_VAL_))))
	#define	MAjcGetClassLong(_HWND_, _IDX_)			((LONG_PTR)AjcGetClassLongPtr(_HWND_, _IDX_))
#endif

#else	// _MSC_VER >= 1300
//--------------------------------------------------------------------------------------------------------------//
//	For Visual Studio 6.0																						//
//--------------------------------------------------------------------------------------------------------------//
#ifndef	GCLP_HBRBACKGROUND
	#define	GCLP_HBRBACKGROUND		GCL_HBRBACKGROUND
	#define	GCLP_HCURSOR			GCL_HCURSOR
	#define	GCLP_HICON				GCL_HICON
	#define	GCLP_HICOMSM			GCL_HICONSM
	#define	GCLP_HMODULE			GCL_HMODULE
	#define	GCLP_MENUNAME			GCL_MENUNAME
	#define	GCLP_WNDPROC			GCL_WNDPROC

	#define	GWLP_WNDPROC			GWL_WNDPROC
	#define	GWLP_HWNDPARENT			GWL_HWNDPARENT
	#define	GWLP_ID					GWL_ID
	#define	GWLP_USERDATA			GWL_USERDATA
	#define	GWLP_HINSTANCE			GWL_HINSTANCE
	#define	DWLP_DLGPROC			DWL_DLGPROC
	#define	DWLP_MSGRESULT			DWL_MSGRESULT
	#define	DWLP_USER				DWL_USER

	#define	MAjcSetWindowLong(_HWND_, _IDX_, _VAL_)	SetWindowLong(_HWND_, _IDX_, (LONG)(_VAL_))
	#define	MAjcGetWindowLong(_HWND_, _IDX_)		GetWindowLong(_HWND_, _IDX_)
	#define	MAjcSetClassLong(_HWND_, _IDX_, _VAL_)	SetClassLong(_HWND_, _IDX_, (LONG)(_VAL_))
	#define	MAjcGetClassLong(_HWND_, _IDX_)			GetClassLong(_HWND_, _IDX_))
#endif
#endif	// _MSC_VER >= 1300

/****************************************************************************************************************/
#endif
