#ifndef	AJCSOCKCLIENT_H_
#define	AJCSOCKCLIENT_H_
/****************************************************************************************************************/
/*--------------------------------------------------------------------------------------------------------------*/
/*	tmhbncd^`rbhh																					*/
/*--------------------------------------------------------------------------------------------------------------*/
#ifdef	UNICODE
	#define	AjcSctConnect			AjcSctConnectW
	#define	AjcSctSendChar			AjcSctSendCharW
	#define	AjcSctSendText			AjcSctSendTextW
	#define	AjcSctSendTextF			AjcSctSendTextFW
	#define	AjcSctGetIpAddrStr		AjcSctGetIpAddrStrW

	#define	AJCSCTADIF				AJCSCTADIFW
	#define	PAJCSCTADIF				PAJCSCTADIFW
	#define	PCAJCSCTADIF			PCAJCSCTADIFW
#else
	#define	AjcSctConnect			AjcSctConnectA
	#define	AjcSctSendChar			AjcSctSendCharA
	#define	AjcSctSendText			AjcSctSendTextA
	#define	AjcSctSendTextF			AjcSctSendTextFA
	#define	AjcSctGetIpAddrStr		AjcSctGetIpAddrStrA

	#define	AJCSCTADIF				AJCSCTADIFA
	#define	PAJCSCTADIF				PAJCSCTADIFA
	#define	PCAJCSCTADIF			PCAJCSCTADIFA
#endif


//	CxgR[h
#define	AJCSCT_EV_RXTEXT		AJCSSEP_EV_TXT				//	eLXgf[^ʒm		0x01
#define	AJCSCT_EV_RXESC			AJCSSEP_EV_ESC				//	drbR[hf[^ʒm	0x02
#define	AJCSCT_EV_RXPKT			AJCSSEP_EV_PKT				//	pPbgf[^ʒm		0x04
#define	AJCSCT_EV_RXCTRL		AJCSSEP_EV_CTRL				//	R[hʒm			0x08
#define	AJCSCT_EV_RXNOPKT		AJCSSEP_EV_NOPKT			//	pPbgOeLXg		0x10

#define	AJCSCT_EV_RXCHUNK		0x00000100					//	`Nf[^Mʒm
#define	AJCSCT_EV_INVCHUNK		0x00000200					//	s`NeLXgMʒm
#define	AJCSCT_EV_TXEMPTY		0x00000400					//	Mʒm
#define	AJCSCT_EV_CONNECT		0x00000800					//	ڑʒm
#define	AJCSCT_EV_DISCONNECT	0x00001000					//	ؒfʒm
#define	AJCSCT_EV_CNFAIL		0x00002000					//	ڑsʒm

#define	AJCSCT_EV_RXERR			0x00010000					//	MG[ʒm
#define	AJCSCT_EV_TXERR			0x00020000					//	MG[ʒm
#define	AJCSCT_EV_ERR			0x08000000					//	̑̃G[ʒm

#define	AJCSCT_EV_SSEP			(AJCSCT_EV_RXTEXT  | AJCSCT_EV_RXESC	  | AJCSCT_EV_RXCTRL  | AJCSCT_EV_RXPKT | AJCSCT_EV_RXNOPKT)
#define	AJCSCT_EV_COMM			(AJCSCT_EV_RXCHUNK | AJCSCT_EV_INVCHUNK   | AJCSCT_EV_TXEMPTY					)
#define	AJCSCT_EV_GENERAL		(AJCSCT_EV_CONNECT | AJCSCT_EV_DISCONNECT | AJCSCT_EV_CNFAIL					)
#define	AJCSCT_EV_ERRS			(AJCSCT_EV_RXERR   | AJCSCT_EV_TXERR	  | AJCSCT_EV_ERR						)
#define	AJCSCT_EV_ALL			(AJCSCT_EV_SSEP    | AJCSCT_EV_COMM 	  | AJCSCT_EV_GENERAL | AJCSCT_EV_ERRS	)

//	G[R[h
#define	AJCSCT_ERR_CREEVT			 10			//	IʒmpCxgIuWFNgs
#define	AJCSCT_ERR_SOCKET			 20			//	ڑvҋ@p\Pbgs(socket)
#define	AJCSCT_ERR_ADDRINFO			 30			//	AhX擾sigetaddrinfoj
#define	AJCSCT_ERR_SOCKOPT			 40			//	\PbgIvVݒ莸s(setsockopt)
#define	AJCSCT_ERR_SUBTHREAD		 50			//	NCAgʐMTuXbhJns
#define	AJCSCT_ERR_CRESSEP			 60			//	Xg[CX^Xs
#define	AJCSCT_ERR_CREMBXTXD		 70			//	Mf[^p[{bNXs
#define	AJCSCT_ERR_TIMEOUT			 80			//	TuXbhI^CAEg

//	
typedef enum {
	AJCSCT_DISCONNECT			= 0	,			//	ؒf
	AJCSCT_CONNECTING			= 1	,			//	ڑ
	AJCSCT_CONNECT				= 2	,			//	ڑ
	AJCSCT_DISCONNECTING		= 3	,			//	ؒf
} AJCSCT_STATE;

//	eLXgER[h
typedef enum {
	AJCSCT_TXT_SJIS		=	AJCMBC_SJIS	,		//	Vtgihr(=1)
	AJCSCT_TXT_EUC		=	AJCMBC_EUC	,		//	dtb@@@(=2)
	AJCSCT_TXT_UTF8		=	AJCMBC_UTF8	,		//	tse|W@(=3)
	AJCSCT_TXT_AUTO		=	9			,		//	ʁ@@
} AJCSCT_TEXTCODE;

//	Mobt@TCY
#define	AJCSCTMAX_RXBUF	1024
#define	AJCSCTMAX_TXBUF	1024

//	`NEf[^E[h
typedef enum {
	AJCSCT_CM_BIN	=	0x01	,				//	oCi`N
	AJCSCT_CM_TEXT	=	0x02	,				//	eLXg`N
	AJCSCT_CM_BOTH	=	0x03	,				//	
} AJCSCT_CHUNKMODE;

//	AhXXg[W
typedef union {
	struct sockaddr_in		sain;
	struct sockaddr_in6		sain6;
	struct sockaddr_storage storage;
} AJCSCTSAIN, *PAJCSCTSAIN;
typedef const AJCSCTSAIN *PCAJCSCTSAIN;

//	CX^X[N
typedef struct {
	UI					InstID;								//	CX^Xʂhc
	BOOL				fConnected;							//	ڑtO
	BOOL				fEnding;							//	ؒftO
	BOOL				fExit;								//	ʐMXbhItO
	AJCSCT_STATE		State;								//	

	//	CX^X[N
	UI					EvtMask;							//	ʒmCxg}XN
	AJCSCT_CHUNKMODE	ChunkMode;							//	`Nf[^ʒm[h
	AJCSCT_TEXTCODE		RxTxtCode;							//	MeLXgR[h
	AJCSCT_TEXTCODE		TxTxtCode;							//	MeLXgR[h
	UI					PktTimeout;							//	pPbgM^CAEg[ms]
	UB					stx, etx, dle;						//	pPbgF邽߂̐R[h
	UB					dummy;
	HAJCSSEP			hSsep;								//	Xg[CX^X
	HAJCFMBX			hFMbxNtc;							//	[U`oւ̃Cxgʒmp[{bNXnh
	HAJCVMBX			hVMbxTxD;							//	Mf[^E[{bNXnh

	//	ʐMJn[N
	BOOL				fUnicode;							//	UNICODEtO
	HWND				hWndNtc;							//	CxgʒmpEChnh
	UI					MsgNtc;								//	CxgʒmbZ[WR[h
	int					AddressFamily;						//	AhXt@~
	WCP					pServ;								//	T[o
	WCP					pPort;								//	|[g^T[rXւ̃|C^
	SOCKET				hSock;								//	TCP/IPXg[\Pbg
	HANDLE				hThread;							//	ʐMXbhnh
	UL					idThread;							//	ʐMXbhhc

	BOOL				fTxBusy;							//	MoptO
	BC					SvSndA, dmy1;						//	eLXgM̑SpPoCgڑޔobt@
	WC					SvSndW;								//	eLXgM̃TQ[gPڑޔobt@

	UI					ixRxb;								//	Mobt@󕔕̃CfNXiO̔[}`oCgj
	UB					RxBuf[AJCSCTMAX_RXBUF + 8];			//	Mf[^obt@if[^{r}`oCg(1`5)j{I[(0x00)j
	UB					RxBin[AJCSCTMAX_RXBUF];				//	oCiMobt@

	UI					ixNpk;								//	pPbgOobt@󕔕̃CfNXiO̔[}`oCgj
	BC					NpBuf[AJCSCTMAX_RXBUF + 8];			//	pPbgOobt@if[^{r}`oCg(1`5)j{I[(0x00)j

	//----- MSILT|[gp ----------------------------------------------------//
	HWND	hWndForMsil;						//	MSILp_~[EChnh

} AJCSCT, *HAJCSCT;
typedef const AJCSCT *PCAJCSCT;


//	vg^Cv
AJCEXPORT	HAJCSCT	 		WINAPI	AjcSctCreate				(VO);
AJCEXPORT	BOOL			WINAPI	AjcSctDelete				(HAJCSCT hSct);

AJCEXPORT	BOOL			WINAPI	AjcSctConnectA				(HAJCSCT hSct, C_BCP pServ, C_BCP pPort, int AddressFamily, HWND hWndNtc, UI WndMsgNtc);
AJCEXPORT	BOOL			WINAPI	AjcSctConnectW				(HAJCSCT hSct, C_WCP pServ, C_WCP pPort, int AddressFamily, HWND hWndNtc, UI WndMsgNtc);

AJCEXPORT	BOOL			WINAPI	AjcSctDisconnect			(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctDisconnectEx			(HAJCSCT hSct, UI msTimeout);

AJCEXPORT	AJCSCT_STATE	WINAPI	AjcSctGetState				(HAJCSCT hSct);

AJCEXPORT	BOOL			WINAPI	AjcSctSetChunkMode			(HAJCSCT hSct,	AJCSCT_CHUNKMODE ChunkMode);
AJCEXPORT	AJCSCT_CHUNKMODE WINAPI	AjcSctGetChunkMode			(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctSetEvtMask			(HAJCSCT hSct, UI EvtMsk);
AJCEXPORT	UI		 		WINAPI	AjcSctGetEvtMask			(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctSetRxTextCode			(HAJCSCT hSct, AJCSCT_TEXTCODE code);
AJCEXPORT	AJCSCT_TEXTCODE	WINAPI	AjcSctGetRxTextCode			(HAJCSCT hSct);
AJCEXPORT	AJCSCT_TEXTCODE	WINAPI	AjcSctGetActualRxTextCode	(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctSetTxTextCode			(HAJCSCT hSct, AJCSCT_TEXTCODE code);
AJCEXPORT	AJCSCT_TEXTCODE	WINAPI	AjcSctGetTxTextCode			(HAJCSCT hSct);
AJCEXPORT	AJCSCT_TEXTCODE	WINAPI	AjcSctGetActualTxTextCode	(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctWaitEvent				(HAJCSCT hSct, WPARAM *pwParam, LPARAM *plParam, UI msTime);
AJCEXPORT	BOOL			WINAPI	AjcSctGetEventData			(HAJCSCT hSct, LPARAM lParam, VOP *ppDat, UIP plDat, UIP pParam);
AJCEXPORT	BOOL			WINAPI	AjcSctRelEventData			(HAJCSCT hSct, LPARAM lParam);
AJCEXPORT	BOOL			WINAPI	AjcSctSetPktCtrlCode		(HAJCSCT hSct, UI stx, UI etx, UI dle);
AJCEXPORT	BOOL			WINAPI	AjcSctGetPktCtrlCode		(HAJCSCT hSct, UIP pStx, UIP pEtx, UIP pDle);
AJCEXPORT	BOOL			WINAPI	AjcSctSetPktTimeout			(HAJCSCT hSct, UI msTime);
AJCEXPORT	BOOL			WINAPI	AjcSctGetPktTimeout			(HAJCSCT hSct, UIP pMsTime);

AJCEXPORT	BOOL			WINAPI	AjcSctSendCharA				(HAJCSCT hSct, BC code);
AJCEXPORT	BOOL			WINAPI	AjcSctSendCharW				(HAJCSCT hSct, WC code);

AJCEXPORT	BOOL			WINAPI	AjcSctSendTextA				(HAJCSCT hSct, C_BCP pTxt, UI lTxt);
AJCEXPORT	BOOL			WINAPI	AjcSctSendTextW				(HAJCSCT hSct, C_WCP pTxt, UI lTxt);

AJCEXPORT	BOOL			WINAPI	AjcSctSendTextFA			(HAJCSCT hSct, C_BCP pFmt, ...);
AJCEXPORT	BOOL			WINAPI	AjcSctSendTextFW			(HAJCSCT hSct, C_WCP pFmt, ...);

AJCEXPORT	BOOL			WINAPI	AjcSctSendBinData			(HAJCSCT hSct, C_VOP pDat, UI lDat);
AJCEXPORT	UI				WINAPI	AjcSctSendPacket			(HAJCSCT hSct, C_VOP pPkt, UI lPkt);

AJCEXPORT	BOOL			WINAPI	AjcSctPurgeRecvData			(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctPurgeSendData			(HAJCSCT hSct);
AJCEXPORT	BOOL			WINAPI	AjcSctPurgeAllData			(HAJCSCT hSct);

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//																												//
//	lrhkpT|[gR[h																					//
//																												//
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++//
//----- Rg[ECh -------------------------------------------------------------------------------//
AJCEXPORT HAJCSCT WINAPI AjcSctCreateForMSIL(	VO	 (CALLBACK *cbRxText		)(C_WCP text),
												VO	 (CALLBACK *cbRxEsc			)(C_WCP text),
												VO	 (CALLBACK *cbRxCtrl		)(int	ctrl),
												VO	 (CALLBACK *cbRxPacket		)(C_VOP pData, int lData),
												VO	 (CALLBACK *cbRxNoPkt		)(C_WCP text),
												VO	 (CALLBACK *cbTxEmpty		)(VO),
												VO	 (CALLBACK *cbRxChunkTxt	)(C_WCP text),
												VO	 (CALLBACK *cbRxChunkBin	)(C_VOP pData, int lData),
												VO	 (CALLBACK *cbRxInvChunk	)(C_VOP pData, int lData),
												VO	 (CALLBACK *cbConnect		)(VO),
												VO	 (CALLBACK *cbDisconnect	)(VO),
												VO	 (CALLBACK *cbCnFail		)(int err),
												VO	 (CALLBACK *cbRecvError		)(BOOL fOverlapped),
												VO	 (CALLBACK *cbSendError		)(BOOL fOverlapped),
												VO	 (CALLBACK *cbGeneralError	)(UI ErrCode));
//----- ʐMJn ---------------------------------------------------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcSctConnectForMSIL(HAJCSCT hSct, C_WCP pServ, C_WCP pPort, int AddressFamily, BOOL fOnEvent);
//----- I -----------------------------------------------------------------------------------------------//
AJCEXPORT BOOL WINAPI AjcSctDeleteForMSIL(HAJCSCT hSct);



/****************************************************************************************************************/
#endif
